# $Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## Copyright (C) 2005-2009 Grard Deneux
## gerard.deneux@free.fr mardi 7 juillet 2009, 17:59:51 (UTC+0200)

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper, traceback
    from com.sun.star.task import XJobExecutor
    from com.sun.star.drawing.CircleKind import ARC
except ImportError, e:
    print "arcjob : probleme d'import", e
#======================================================
# a class to draw an arc of circle from center and radius
# une classe pour tracer arc de cercle depuis le centre
#======================================================
class ArcJob(unohelper.Base, XJobExecutor):
    """Trace un arc de cercle depuis le centre
    Draws an arc of circle from center"""
    def __init__(self, ctx):
        self.ctx = ctx
    ## *********************
    ## Called from GUI
    ## *********************
    def trigger(self, args):
        import fr.free.deneux.gerard.cadooo.cadooojob
        import fr.free.deneux.gerard.cadooo.msgl10n
        import fr.free.deneux.gerard.cadooo.shapedraw
        import fr.free.deneux.gerard.cadooo.shapekeyhandler
        import fr.free.deneux.gerard.cadooo.shapemousehandler
        xCadoooJob = fr.free.deneux.gerard.cadooo.cadooojob.CadoooJob(self.ctx)
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n(self.ctx)
        aEnv = {}
        aEnv['UNOTYPE'] = "EllipseShape"
        aEnv['ENTITYPE'] = "ARC"
        aEnv['STEPS'] = 4
        aEnv['MODE'] = ('CREATE', 'RADIUS', 'STARTANGLE', 'ENDANGLE')
        aEnv['CIRCLEKIND'] = ARC
        aEnv['DRAWJOB'] = fr.free.deneux.gerard.cadooo.shapedraw.ShapeDraw(self.ctx)
        aEnv['KEYHANDLER'] = fr.free.deneux.gerard.cadooo.shapekeyhandler.ShapeKeyHandler(self.ctx)
        aEnv['MOUSEHANDLER'] = fr.free.deneux.gerard.cadooo.shapemousehandler.ShapeMouseHandler(self.ctx)
        aEnv['EXTPOSSIZE'] = None
        aTextList = ("a0", "a1", "a2", "a3", "a4")
        aEnv['COMMENT'] = xMsgL10n.getText(aTextList)
        try:
            aEnv.update(xCadoooJob.runCadooo(aEnv))
        except:
            traceback.print_exc()
# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(ArcJob,                                 # UNO object class
                                         "fr.free.deneux.gerard.cadooo.Arc", # implemenation name
                                         ("fr.free.cadooo.Arc",),)    # list of implemented services
