# 	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## areajob samedi 4 avril 2009, 14:34:04 (UTC+0200)
## last modification lundi 20 avril 2009, 11:15:39 (UTC+0200)
## Copyright (C) 2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************

try:
    import traceback, unohelper
    from com.sun.star.task import XJobExecutor
except ImportError:
    print "import impossible de traceback"

##
## class that do the job
##
class AreaJob(unohelper.Base, XJobExecutor):
    """Calcul d'aire
    Area calculation"""
    def __init__(self, ctx):
	self.ctx = ctx
    ##
    ## this function is called from within the menu or toolbox button in OpenOffice
    ## fonction appelee par le menu ou le bouton de la barre d'outils dans OpenOffice
    ##
    def trigger(self, args):
        import fr.free.deneux.gerard.cadooo.cadooojob
        import fr.free.deneux.gerard.cadooo.msgl10n
        import fr.free.deneux.gerard.cadooo.areadraw
        import fr.free.deneux.gerard.cadooo.areakeyhandler
        import fr.free.deneux.gerard.cadooo.areamousehandler
        import fr.free.deneux.gerard.cadooo.joinpossize
        aEnv = {}
        aEnv['UNOTYPE'] = None
        aEnv['ENTITYPE'] = None
        aEnv['STEPS'] = 4
        aEnv['MODE'] = ('AREA', 'SELECT', 'SET', 'CALCUL')
        aEnv['AREACOORDS'] = None
        aEnv['AREASHAPE'] = None
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
        sTextList = tuple(["area%d" % i for i in (0,1,2,3,4)])
        aEnv['COMMENT'] = xMsgL10n.getText(sTextList)
        aEnv['STAGE'] = 0
        aEnv['DRAWJOB'] = fr.free.deneux.gerard.cadooo.areadraw.AreaDraw(self.ctx)
        aEnv['KEYHANDLER'] = fr.free.deneux.gerard.cadooo.areakeyhandler.AreaKeyHandler(self.ctx)
        aEnv['MOUSEHANDLER'] = fr.free.deneux.gerard.cadooo.areamousehandler.AreaMouseHandler(self.ctx)
        aEnv['EXTPOSSIZE'] = fr.free.deneux.gerard.cadooo.joinpossize.JoinPosSize(self.ctx)
        # init needed to use join features
        aEnv['EDITMODE'] = False
        aEnv['SELECTEDLIST'] = [None, None]
        for i in ('DIRECT', 'FILLET', 'CHAMFER'):
            for j in ('LINE2LINE', 'LINE2ARC', 'ARC2ARC'):
                aEnv['%s%sJOINSHAPE' % (i, j)] = None
        aEnv['JOINCOORDS'] = None
        aEnv['JOINVISIBLE'] = False
        aEnv['JOINKIND'] = "DIRECT"
        aEnv['JOINTYPE'] = None
        aEnv['JOINDATA'] = (None, None)
        try:
            xCadoooJob = fr.free.deneux.gerard.cadooo.cadooojob.CadoooJob( self.ctx)
            aEnv.update(xCadoooJob.runCadooo(aEnv))
        except:
            traceback.print_exc()
# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(AreaJob,                                 # UNO object class
                                         "fr.free.deneux.gerard.cadooo.Area", # implemenation name
                                         ("fr.free.cadooo.Area",),)    # list of implemented services
