#  	
# -*- coding: latin-1 -*-
## ********************************************************************************
## cadooounlock mercredi 2 janvier 2008, 16:31:05 (UTC+0100)
## Copyright (C) 2008 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper
    from com.sun.star.task import XJobExecutor
    from com.sun.star.registry import InvalidRegistryException
    from com.sun.star.script import CannotConvertException
except ImportError:
    print "probleme d'import"
#=========================================================
# a class to unlock commands after an abnormal termination
# une classe pour dverrouiller les commands aprs un arrt brutal
#======================================================
class UnlockJob(unohelper.Base, XJobExecutor):
    """Dverrouille les commandes
    Unlock commands"""
    def __init__(self, ctx):
        self.ctx = ctx
        self.smgr = self.ctx.ServiceManager
    #=======================
    # Called by the GUI
    #=======================
    def trigger(self, args):
        try:
            from fr.free.deneux.gerard.cadooo.msgl10n import MsgL10n
            from fr.free.deneux.gerard.cadooo.messagebox import MessageBox
            xMessage = MessageBox(self.ctx)
            xMsgL10n = MsgL10n(self.ctx)
            aRegistry = self.smgr.createInstanceWithContext("com.sun.star.registry.SimpleRegistry", self.ctx)
            xPathSettings = self.smgr.createInstanceWithContext("com.sun.star.util.PathSettings", self.ctx)
            aURL = xPathSettings.UserConfig + "/cadooo.rdb"
            aRegistry.open(aURL, False, False)
        except InvalidRegistryException, e:
            aText = ("u0",)
            ret = xMessage.execute(xMsgL10n.getText(aText)[0], "errorbox")
            return
        aRootKey = aRegistry.getRootKey()
        aCrashKey = aRootKey.openKey("CRASHED")
        if aCrashKey is None:
            aCrashKey = aRootKey.createKey("CRASHED")
            aCrashKey.setLongValue(0)
        aCrashFlag = aCrashKey.getLongValue()
        aLogKey = aRootKey.openKey("LOG")
        if aLogKey is None:
            aLogKey = aRootKey.createKey("LOG")
            aLogKey.setStringValue("")
        elif aCrashFlag:
            aText = ("u5",)
            ret = xMessage.execute(xMsgL10n.getText(aText)[0] + "\nVERSION 1.1.1\n" + aLogKey.getStringValue(), "errorbox")
            aCrashKey.setLongValue(0)
            aLogKey.setStringValue("")
        # if Cadooo already running => exit
        # else => locking new command
        aLockKey = aRootKey.openKey("LOCKED")
        if aLockKey is None:
            aText = ("u1",)
            ret = xMessage.execute(xMsgL10n.getText(aText)[0], "errorbox")
            aRegistry.close()
            return
        if aLockKey.getLongValue() == 0:
            aText = ("u2",)
            ret = xMessage.execute(xMsgL10n.getText(aText)[0], "messbox")
            aRegistry.close()
            return
        aText = ("u3",)
        ret = xMessage.execute(xMsgL10n.getText(aText)[0], "warningbox")
        aLockKey.setLongValue(0)
        aRegistry.close()
        aText = ("u4",)
        ret = xMessage.execute(xMsgL10n.getText(aText)[0], "infobox")
        return
# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(UnlockJob,                                 # UNO object class
                                         "fr.free.deneux.gerard.cadooo.Unlock", # implemenation name
                                         ("fr.free.cadooo.Unlock",),)    # list of implemented services
