#
# -*- coding: latin-1 -*-
## ********************************************************************************
## circle3p mar jan 18 19:06:37 CET 2005
## Copyright (C) 2005-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper
    from com.sun.star.task import XJobExecutor
    from com.sun.star.drawing.CircleKind import FULL
    import traceback
except ImportError:
    print "probleme d'import"
#======================================================
# a class to draw a cricle from tree points
# une classe pour tracer un cercle passant par 3 points
#======================================================
class Circle3PJob(unohelper.Base, XJobExecutor):
    """Trace un cercle passant par 3 points
    Draws a circle from 3 points"""
    def __init__(self, ctx):
        self.ctx = ctx
        self.smgr = self.ctx.ServiceManager
    ## *********************
    ## Called from GUI
    ## *********************
    def trigger(self, args):
        import fr.free.deneux.gerard.cadooo.cadooojob
        import fr.free.deneux.gerard.cadooo.msgl10n
        import fr.free.deneux.gerard.cadooo.shapedraw
        import fr.free.deneux.gerard.cadooo.shapekeyhandler
        import fr.free.deneux.gerard.cadooo.shapemousehandler
        xCadoooJob = fr.free.deneux.gerard.cadooo.cadooojob.CadoooJob(self.ctx)
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n(self.ctx)
        aEnv = {}
        aEnv['UNOTYPE'] = "EllipseShape"
        aEnv['ENTITYPE'] = "CIRCLE"
        aEnv['STEPS'] = 3
        aEnv['MODE'] = ('CREATE', 'DIAMETER', '3RDPOINT')
        aEnv['CIRCLEKIND'] = FULL
        aEnv['DRAWJOB'] = fr.free.deneux.gerard.cadooo.shapedraw.ShapeDraw(self.ctx)
        aEnv['KEYHANDLER'] = fr.free.deneux.gerard.cadooo.shapekeyhandler.ShapeKeyHandler(self.ctx)
        aEnv['MOUSEHANDLER'] = fr.free.deneux.gerard.cadooo.shapemousehandler.ShapeMouseHandler(self.ctx)
        aEnv['EXTPOSSIZE'] = None
        aTextList = ("c3p0", "c3p1", "c3p2", "c3p3")
        aEnv['COMMENT'] = xMsgL10n.getText(aTextList)
        aEnv.update(xCadoooJob.runCadooo(aEnv))
# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(Circle3PJob,                                 # UNO object class
                                         "fr.free.deneux.gerard.cadooo.Circle3P", # implemenation name
                                         ("fr.free.cadooo.Circle3P",),)    # list of implemented services
