# 	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## dimjob mar fv 13 14:50:27 CET 2007
## Copyright (C) 2007-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper
    from com.sun.star.task import XJobExecutor
    import traceback
except ImportError:
    print "probleme d'import"
#================================================
# a class to dimension
# une classe pour coter
#================================================
class DimJob(unohelper.Base, XJobExecutor):
    """dessine une cote
    Draws a dimension"""
    def __init__(self, ctx):
        self.ctx = ctx
    #=======================
    # Called by the GUI
    #=======================
    def trigger(self, args):
        import fr.free.deneux.gerard.cadooo.cadooojob
        import fr.free.deneux.gerard.cadooo.msgl10n
        import fr.free.deneux.gerard.cadooo.dimdraw
        import fr.free.deneux.gerard.cadooo.dimkeyhandler
        import fr.free.deneux.gerard.cadooo.dimmousehandler
        import fr.free.deneux.gerard.cadooo.dimpossize
        xCadoooJob = fr.free.deneux.gerard.cadooo.cadooojob.CadoooJob(self.ctx)
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n(self.ctx)
        aEnv = {}
        aEnv['UNOTYPE'] = "MeasureShape"
        aEnv['ENTITYPE'] = "MEASURE"
        aEnv['STEPS'] = 2
        aEnv['MODE'] = ('DIM', 'VERTEX')
        aEnv['DIMMODE'] = True
        aEnv['DIMLIST'] = [None, None]
        aEnv['DIMTYPE'] = "---"
        aEnv['LINEARDIMSHAPE'] = None
        aEnv['ANGULARDIMSHAPE'] = None
        aEnv['RADIALDIMSHAPE'] = None
        aEnv['DIAMETRALDIMSHAPE'] = None
        aEnv['DIMCOORDS'] = None
        aEnv['DIMVISIBLE'] = False
        aEnv['DRAWJOB'] = fr.free.deneux.gerard.cadooo.dimdraw.DimDraw(self.ctx)
        aEnv['KEYHANDLER'] = fr.free.deneux.gerard.cadooo.dimkeyhandler.DimKeyHandler(self.ctx)
        aEnv['MOUSEHANDLER'] = fr.free.deneux.gerard.cadooo.dimmousehandler.DimMouseHandler(self.ctx)
        aEnv['EXTPOSSIZE'] = fr.free.deneux.gerard.cadooo.dimpossize.DimPosSize(self.ctx)
        sTextList = ("dim0",)
        aEnv['COMMENT'] = xMsgL10n.getText(sTextList)
        try:
            aEnv.update(xCadoooJob.runCadooo(aEnv))
        except:
            traceback.print_exc()
# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(DimJob,                                 # UNO object class
                                         "fr.free.deneux.gerard.cadooo.Dimension", # implemenation name
                                         ("fr.free.cadooo.Dimension",),)    # list of implemented services
