# 	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## joinjob jeu mar  8 13:55:33 CET 2007
## Copyright (C) 2007-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper
    from com.sun.star.task import XJobExecutor
    from com.sun.star.drawing.CircleKind import ARC
    import traceback
except ImportError:
    print "probleme d'import"
#================================================
# a class to join two entities
# une classe pour joindre deux entits
#================================================
class JoinJob(unohelper.Base, XJobExecutor):
    """joindre deux entits
    join two entities"""
    def __init__(self, ctx):
        self.ctx = ctx
    #=======================
    # Called by the GUI
    #=======================
    def trigger(self, args):
        import fr.free.deneux.gerard.cadooo.cadooojob
        import fr.free.deneux.gerard.cadooo.msgl10n
        import fr.free.deneux.gerard.cadooo.joindraw
        import fr.free.deneux.gerard.cadooo.joinkeyhandler
        import fr.free.deneux.gerard.cadooo.joinmousehandler
        import fr.free.deneux.gerard.cadooo.joinpossize
        xCadoooJob = fr.free.deneux.gerard.cadooo.cadooojob.CadoooJob(self.ctx)
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n(self.ctx)
        aEnv = {}
        aEnv['UNOTYPE'] = None
        aEnv['ENTITYPE'] = None
        aEnv['STEPS'] = 1
        aEnv['MODE'] = ('JOIN', )
        aEnv['CIRCLEKIND'] = ARC
        aEnv['EDITMODE'] = True
        aEnv['SELECTEDLIST'] = [None, None]
        for i in ('DIRECT', 'FILLET', 'CHAMFER'):
            for j in ('LINE2LINE', 'LINE2ARC', 'ARC2ARC'):
                aEnv['%s%sJOINSHAPE' % (i, j)] = None
        aEnv['JOINCOORDS'] = None
        aEnv['JOINVISIBLE'] = False
        aEnv['JOINKIND'] = "DIRECT"
        aEnv['JOINTYPE'] = None
        aEnv['JOINDATA'] = [None, None]
        aEnv['DRAWJOB'] = fr.free.deneux.gerard.cadooo.joindraw.JoinDraw(self.ctx)
        aEnv['KEYHANDLER'] = fr.free.deneux.gerard.cadooo.joinkeyhandler.JoinKeyHandler(self.ctx)
        aEnv['MOUSEHANDLER'] = fr.free.deneux.gerard.cadooo.joinmousehandler.JoinMouseHandler(self.ctx)
        aEnv['EXTPOSSIZE'] = fr.free.deneux.gerard.cadooo.joinpossize.JoinPosSize(self.ctx)
        sTextList = ("j0",)
        aEnv['COMMENT'] = xMsgL10n.getText(sTextList)
        try:
            aEnv.update(xCadoooJob.runCadooo(aEnv))
        except:
            traceback.print_exc()
# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(JoinJob,                                 # UNO object class
                                         "fr.free.deneux.gerard.cadooo.Join", # implemenation name
                                         ("fr.free.cadooo.Join",),)    # list of implemented services
