#
# -*- coding: latin-1 -*-
## ********************************************************************************
## linejob mar jan 11 20:05:11 CET 2005
## Copyright (C) 2004-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper
    from com.sun.star.task import XJobExecutor
    import traceback
except ImportError:
    print "probleme d'import"
#======================================================
# a class to draw a line
# une classe pour tracer un segment
#======================================================
class LineJob(unohelper.Base, XJobExecutor):
    """Trace un segment rectiligne
    Draws a line"""
    def __init__(self, ctx):
        self.ctx = ctx
        self.smgr = self.ctx.ServiceManager
    #=======================
    # Called by the GUI
    #=======================
    def trigger(self, args):
        try:
            import fr.free.deneux.gerard.cadooo.cadooojob
            import fr.free.deneux.gerard.cadooo.msgl10n
            import fr.free.deneux.gerard.cadooo.shapedraw
            import fr.free.deneux.gerard.cadooo.shapekeyhandler
            import fr.free.deneux.gerard.cadooo.shapemousehandler
            xCadoooJob = fr.free.deneux.gerard.cadooo.cadooojob.CadoooJob(self.ctx)
            xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n(self.ctx)
            aEnv = {}
            aEnv['UNOTYPE'] = "LineShape"
            aEnv['ENTITYPE'] = "LINE"
            aEnv['STEPS'] = 2
            aEnv['MODE'] = ('CREATE', 'VERTEX')
            aEnv['DRAWJOB'] = fr.free.deneux.gerard.cadooo.shapedraw.ShapeDraw(self.ctx)
            aEnv['KEYHANDLER'] = fr.free.deneux.gerard.cadooo.shapekeyhandler.ShapeKeyHandler(self.ctx)
            aEnv['MOUSEHANDLER'] = fr.free.deneux.gerard.cadooo.shapemousehandler.ShapeMouseHandler(self.ctx)
            aEnv['EXTPOSSIZE'] = None
            aTextList = ("l0", "l1", "l2")
            aEnv['COMMENT'] = xMsgL10n.getText(aTextList)
            aEnv.update(xCadoooJob.runCadooo(aEnv))
        except:
            traceback.print_exc()
# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(LineJob,                                 # UNO object class
                                         "fr.free.deneux.gerard.cadooo.Line", # implemenation name
                                         ("fr.free.cadooo.Line",),)    # list of implemented services
