#	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## 
## Copyright (C) 2005-2009 Grard Deneux lundi 2 mars 2009, 17:36:43 (UTC+0100)
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper
    from com.sun.star.task import XJobExecutor
    import math, traceback
except ImportError:
    print "probleme d'import"
# ===========================================
# Decalage d'entites
# Entities offset
# EDITMODE ENTITYPE MODE COMMENT OFFSET
# ===========================================
class OffsetJob(unohelper.Base, XJobExecutor):
    """Drawing Entities offset
    Decalage d'entites de dessin"""
    def __init__(self, ctx):
        self.ctx = ctx
        self.smgr = self.ctx.ServiceManager
    #=======================
    # Called by the GUI
    #=======================
    def trigger(self, args):
        try:
            import fr.free.deneux.gerard.cadooo.cadooojob
            import fr.free.deneux.gerard.cadooo.msgl10n
            import fr.free.deneux.gerard.cadooo.offsetdraw
            import fr.free.deneux.gerard.cadooo.offsetkeyhandler
            import fr.free.deneux.gerard.cadooo.offsetmousehandler
        except:
            traceback.print_exc()
        xCadoooJob = fr.free.deneux.gerard.cadooo.cadooojob.CadoooJob(self.ctx)
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n(self.ctx)
        aEnv = {}
        aEnv['ENTITYPE'] = None
        aEnv['MODE'] = ('OFFSET',)
        aTextList = ("o0",)
        aEnv['COMMENT'] = xMsgL10n.getText(aTextList)
        aEnv['DRAWJOB'] = fr.free.deneux.gerard.cadooo.offsetdraw.OffsetDraw(self.ctx)
        try:
            aEnv['KEYHANDLER'] = fr.free.deneux.gerard.cadooo.offsetkeyhandler.OffsetKeyHandler(self.ctx)
            aEnv['MOUSEHANDLER'] = fr.free.deneux.gerard.cadooo.offsetmousehandler.OffsetMouseHandler(self.ctx)
            aEnv['EXTPOSSIZE'] = None
            aEnv['OFFSET'] = None
            aEnv.update(xCadoooJob.runCadooo(aEnv))
        except:
            traceback.print_exc()
# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(OffsetJob,                                 # UNO object class
                                         "fr.free.deneux.gerard.cadooo.Offset", # implemenation name
                                         ("fr.free.cadooo.Offset",),)    # list of implemented services
