#	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## areadraw vendredi 3 juillet 2009, 20:10:31 (UTC+0200)

## Copyright (C) 2009 Gerard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, math, time
    import locale
    from types import *
    from com.sun.star.drawing.CircleKind import FULL, SECTION, CUT, ARC
    from com.sun.star.sheet.CellInsertMode import DOWN
except ImportError:
    print "probleme d'import"
bDebug = False
#======================================================
# a class to compute area
# une classe pour calculer une aire
#======================================================
class AreaDraw():
    """Calul une aire dlimite par des entits
    Compute an area delimited with entities"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.compute
        import fr.free.deneux.gerard.cadooo.questionbox
        import fr.free.deneux.gerard.cadooo.messagebox
        import fr.free.deneux.gerard.cadooo.msgl10n
        import fr.free.deneux.gerard.cadooo.joindraw
        import fr.free.deneux.gerard.cadooo.entityposize
        self.ctx = ctx
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute( self.ctx)
        self.xQuestion = fr.free.deneux.gerard.cadooo.questionbox.QuestionBox( self.ctx)
        self.xMessage = fr.free.deneux.gerard.cadooo.messagebox.MessageBox( self.ctx)
        self.xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
        self.xJoinDraw = fr.free.deneux.gerard.cadooo.joindraw.JoinDraw( self.ctx)
        sTextList = tuple(["area%d" % i for i in (0, 3, 5, 6, 7, 8)]) + tuple(["gp%d" % i for i in (0, 1, 2, 3, 4, 5, 6, 7, 10)]) + ('ucs1', 'st0', 'd5', 'a1', 'a2', 'a3', 'a4')
        self.aText = dict(zip(sTextList, self.xMsgL10n.getText(sTextList)))
        self.xEntityPosSize = fr.free.deneux.gerard.cadooo.entityposize.EntityPosSize( self.ctx)
        self.bRedraw = False
    # ==============================
    def execute(self, aArgs):
        self.aEnv = {}
        self.aEnv.update(aArgs)
        # ------------------
        # treating selection
        # ------------------
        if self.aEnv['STAGE'] == 0:
            sText = "%s %s" % (self.aEnv['COMMENT'][0], self.aEnv['COMMENT'][self.aEnv['STAGE']+1])
            self.aEnv['STATUSBARCONTROL']['INFOCTRL'].setText(sText)
            if not self.aEnv['CONTOURLIST'] is None:
                nID = None
                bClosedAreaIn = False
                aAreaCoords = []
                aContour = []
                for aSeg in self.aEnv['CONTOURLIST']:
                    if nID != aSeg[0]:
                        if bClosedAreaIn:
                            break
                        aGroupShape = self.aEnv['CONTROLLER'].getCurrentPage()
                        if len(aSeg[0]) > 1:
                            for i in aSeg[0][:-1]:
                                aGroupShape = aGroupShape.getByIndex(i)
                        aShape = aGroupShape.getByIndex(aSeg[0][-1])
                        sType = aShape.getShapeType().split('.')[-1]
                        nID = aSeg[0]
                    if sType in ("PolyPolygonShape", "RectangleShape") or aSeg[1] in ("CircleShape", "EllipseShape"):
                        aContour.append(aSeg)
                        if not bClosedAreaIn:
                            bClosedAreaIn = True
                        if aSeg[1] == "LineShape":
                            if sType in ("RectangleShape",) and aShape.CornerRadius:
                                aAreaCoords.append({'JOINTYPE':"ARC2LINE", 'XA':aSeg[2]['X'], 'YA':aSeg[2]['Y'], 'XB':aSeg[3]['X'], 'YB':aSeg[3]['Y']})
                            else:
                                aAreaCoords.append({'JOINTYPE':"LINE2LINE", 'XA':aSeg[2]['X'], 'YA':aSeg[2]['Y'], 'XB':aSeg[3]['X'], 'YB':aSeg[3]['Y']})
                        else:
                            if aSeg[1] in ('CircleShape', 'EllipseShape'):
                                aAreaCoords.append({'JOINTYPE':"ARC2ARC"})
                                nISA, nIEA = 5, 6
                                aAreaCoords[-1]['SA'] = "A"
                            else:
                                aAreaCoords.append({'JOINTYPE':"LINE2ARC"})
                                nISA, nIEA = 6, 5
                                aAreaCoords[-1]['SA'] = "B"
                            aAreaCoords[-1]['XC'] = aSeg[2]['X']
                            aAreaCoords[-1]['YC'] = aSeg[2]['Y']
                            aPoint = self.xCompute.getPointOnEllipse( None, aSeg[nISA], aSeg[2], aSeg[3], aSeg[4])[0]
                            aAreaCoords[-1]['XA'] = aPoint['X']
                            aAreaCoords[-1]['YA'] = aPoint['Y']
                            aPoint = self.xCompute.getPointOnEllipse( None, aSeg[nIEA], aSeg[2], aSeg[3], aSeg[4])[0]
                            aAreaCoords[-1]['XB'] = aPoint['X']
                            aAreaCoords[-1]['YB'] = aPoint['Y']
                            aPoint = self.xCompute.getPointOnEllipse( None, 0.00, aSeg[2], aSeg[3], aSeg[4])[0]
                            aAreaCoords[-1]['XR1'] = aPoint['X']
                            aAreaCoords[-1]['YR1'] = aPoint['Y']
                            aPoint = self.xCompute.getPointOnEllipse( None, math.pi/2, aSeg[2], aSeg[3], aSeg[4])[0]
                            aAreaCoords[-1]['XR2'] = aPoint['X']
                            aAreaCoords[-1]['YR2'] = aPoint['Y']
                if bClosedAreaIn:
                    self.aEnv['AREACOORDS'] = [c for c in aAreaCoords]
                    if len(aContour) > 1:
                        aContour.insert(0, aContour.pop(-1))
                    self.aEnv['CONTOURLIST'] = [c for c in aContour]
                    self.aEnv['STAGE'] = 3
                    return self.aEnv
                del aAreaCoords
                del aContour
                self.aEnv['SELECTEDLIST'] = [self.aEnv['CONTOURLIST'][-1], None]
            # info selecting contour
            self.xMessage.execute(self.aText["area6"], "infobox")
            self.aEnv['STAGE'] = 1
            self.aEnv['AREACOORDS'] = True
            return self.aEnv
        # -----------------
        # selecting contour
        # -----------------
        elif self.aEnv['STAGE'] == 1:
            if not self.aEnv['CONTOURLIST'] is None:
                nNbSeg = len(self.aEnv['CONTOURLIST'])
            else:
                nNbSeg = 0
            if self.bRedraw:
                self.xJoinDraw.bRedraw = True
                self.bRedraw = False
            self.aEnv.update(self.xJoinDraw.execute(self.aEnv))
            sJoinText = self.aEnv['STATUSBARCONTROL']['INFOCTRL'].getText()
            sText = "%s %s %d" % (sJoinText, self.aEnv['COMMENT'][self.aEnv['STAGE']+1], nNbSeg)
            if bDebug:
                if nNbSeg > 0:
                    sText = sText + " %s" % self.aEnv['CONTOURLIST'][-1][1]
            self.aEnv['STATUSBARCONTROL']['INFOCTRL'].setText(sText)
            return self.aEnv
        # ----------------
        # defining contour
        # ----------------
        elif self.aEnv['STAGE'] == 2:
            nNbSeg = len(self.aEnv['CONTOURLIST'])
            if self.bRedraw:
                self.xJoinDraw.bRedraw = True
                self.bRedraw = False
            self.aEnv.update(self.xJoinDraw.execute(self.aEnv))
            sJoinText = self.aEnv['STATUSBARCONTROL']['INFOCTRL'].getText()
            sText = "%s %s %d" % (sJoinText, self.aEnv['COMMENT'][self.aEnv['STAGE']+1], nNbSeg)
            if bDebug:
                if type(self.aEnv['AREACOORDS']) is TupleType:
                    sText = sText + " ==> %r" % self.aEnv['AREACOORDS'][-1]
            self.aEnv['STATUSBARCONTROL']['INFOCTRL'].setText(sText)
            return self.aEnv
        # -----------------------
        # calculus
        # -----------------------
        elif self.aEnv['STAGE'] == 3:
            sText = "%s %s" % (self.aEnv['COMMENT'][0], self.aEnv['COMMENT'][self.aEnv['STAGE']+1])
            self.aEnv['STATUSBARCONTROL']['INFOCTRL'].setText(sText)
            aCenterCoord = {'X':0, 'Y':0}
            self.aEnv['GROUPSHAPE'] = self.aEnv['MODEL'].createInstance("com.sun.star.drawing.GroupShape")
            self.aEnv['CONTROLLER'].CurrentPage.add(self.aEnv['GROUPSHAPE'])
            # +++++++++++++++++++++++++++++++++++
            if len(self.aEnv['CONTOURLIST']) == 1:
                self.xJoinDraw.xEntitySpot.setEntityEnvAndCoord(sMode="AREA", sType=self.aEnv['CONTOURLIST'][0][1], areaShape=self.aEnv['AREACOORDS'][0])
                self.aEnv.update(self.xJoinDraw.xEntitySpot.aEntityEnvAndCoord)
                if not self.aEnv['COORDS'] is None:
                    self.aEnv['SHAPESTATUS'] = "transient"
                    aPosSizeParm = self.aEnv.fromkeys(self.aEnv['POSSIZEPARM'])
                    for aKey in aPosSizeParm.iterkeys():
                        aPosSizeParm[aKey] = self.aEnv[aKey]
                    self.aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                    self.aEnv['SHAPE'] = None
                nArea = math.pi * self.aEnv['CONTOURLIST'][0][3]['Width'] * self.aEnv['CONTOURLIST'][0][3]['Height']
                aCenterCoord = self.aEnv['CONTOURLIST'][0][2]
                nNbV = 1
            else:
                nArea = 0
                nNbV = 0
                aTypeList = self.aEnv['CONTOURLIST'][1:] + [self.aEnv['CONTOURLIST'][0],]
                for (aBorder, aSeg) in zip(aTypeList, self.aEnv['AREACOORDS']):
                    #self.xMessage.execute("%s \n %s" % (aBorder[1], aSeg), "infobox")
                    self.xJoinDraw.xEntitySpot.setEntityEnvAndCoord(sMode="AREA", sType=aBorder[1], areaShape=aSeg)
                    self.aEnv.update(self.xJoinDraw.xEntitySpot.aEntityEnvAndCoord)
                    if not self.aEnv['COORDS'] is None:
                        self.aEnv['SHAPESTATUS'] = "transient"
                        aPosSizeParm = self.aEnv.fromkeys(self.aEnv['POSSIZEPARM'])
                        for aKey in aPosSizeParm.iterkeys():
                            aPosSizeParm[aKey] = self.aEnv[aKey]
                        self.aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                        self.aEnv['SHAPE'] = None
                    aCenterCoord['X'] = aCenterCoord['X'] + aSeg['XA']
                    aCenterCoord['Y'] = aCenterCoord['Y'] + aSeg['YA']
                    nNbV += 1
                    if aSeg['JOINTYPE'] in ("LINE2ARC", "ARC2ARC"):
                        aCenterCoord['X'] = aCenterCoord['X'] + aSeg['XC']
                        aCenterCoord['Y'] = aCenterCoord['Y'] + aSeg['YC']
                        nNbV += 1
                        nArea = nArea + (aSeg['XA'] * aSeg['YC'] - aSeg['YA'] * aSeg['XC'] + aSeg['XC'] * aSeg['YB'] - aSeg['YC'] * aSeg['XB']) / 2
                        nR1, fAngle1 = self.xCompute.toPolarCoord( {'X':aSeg['XC'], 'Y':aSeg['YC']}, {'X':aSeg['XA'], 'Y':aSeg['YA']})
                        nR2, fAngle2 = self.xCompute.toPolarCoord( {'X':aSeg['XC'], 'Y':aSeg['YC']}, {'X':aSeg['XB'], 'Y':aSeg['YB']})
                        if aBorder[1] == "ArcEllipseShape":
                            nArea = nArea + self.xCompute.getArcEllipseArea(aBorder[3]['Width'], aBorder[3]['Height'], fAngle1, fAngle2, aSeg['SA'])
                        else:
                            if aSeg['SA'] == "A":
                                if fAngle1 > fAngle2:
                                    fAngle2 = fAngle2 + 2 * math.pi
                                nArea = nArea - (fAngle2 - fAngle1) * nR1 * nR2 / 2
                            else:
                                if fAngle2 > fAngle1:
                                    fAngle1 = fAngle1 + 2 * math.pi
                                nArea = nArea + (fAngle1 - fAngle2) * nR1 * nR2 / 2
                            #self.showDebugMsg("Area = %.4f\nType = %s" % (nArea, aSeg['SA']))
                    else:
                        nArea = nArea + (aSeg['XA'] * aSeg['YB'] - aSeg['YA'] * aSeg['XB']) / 2
            aCenterCoord['X'] = aCenterCoord['X'] / nNbV
            aCenterCoord['Y'] = aCenterCoord['Y'] / nNbV
            sArea = self.xCompute.transform2UserSqUnit( float(nArea), self.aEnv['UNITS'], self.aEnv['UNITSRATIO'], self.aEnv['MEASUREUNIT'], self.aEnv['DRAWSCALE'])
            aTextShape = self.aEnv['MODEL'].createInstance("com.sun.star.drawing.TextShape")
            aPoint = uno.createUnoStruct("com.sun.star.awt.Point")
            aSize = uno.createUnoStruct("com.sun.star.awt.Size")
            aSize.Width = 200 * (len(sArea) + 1)
            aSize.Height = 350
            aPoint.X, aPoint.Y = aCenterCoord['X'] - aSize.Width / 2, aCenterCoord['Y'] - aSize.Height / 2
            aTextShape.setPosition(aPoint)
            aTextShape.setSize(aSize)
            self.aEnv['GROUPSHAPE'].add(aTextShape)
            aTextShape.TextAutoGrowWidth = True
            aTextCursor = aTextShape.createTextCursor()
            aTextShape.insertString(aTextCursor, sArea, False)
            aTextShape.CharHeight = self.aEnv['CHARHEIGHT']
            # /////////////////////////////////////////////
            # do you want to keep the contour ?
            ret = self.xQuestion.execute(self.aText["area7"])
            self.aEnv['STEP'] = 0
            self.aEnv['COORDS'] = None
            if ret:
                for i in range(self.aEnv['GROUPSHAPE'].getCount()):
                    aShape = self.aEnv['GROUPSHAPE'].getByIndex(i)
                    aShape.LineColor = self.aEnv['STANDARDSTYLE'].LineColor
                    aShape.LineWidth = self.aEnv['STANDARDSTYLE'].LineWidth
                    aShape.Style = self.aEnv['STANDARDSTYLE']
                self.aEnv['GROUPSHAPE'].setName("area%s" % ("".join(["%d" % c for c in time.gmtime()])))
                self.aEnv['GROUPSHAPE'].Style = self.aEnv['STANDARDSTYLE']
            else:
                for i in range(self.aEnv['GROUPSHAPE'].getCount()):
                    self.aEnv['GROUPSHAPE'].remove(self.aEnv['GROUPSHAPE'].getByIndex(0))
                self.aEnv['CONTROLLER'].CurrentPage.remove(self.aEnv['GROUPSHAPE'])
            # //////////////////////////////////////////////
            # do you want to export the contour ?
            ret = self.xQuestion.execute(self.aText["area8"])
            if ret:
                import fr.free.deneux.gerard.cadooo.datacalcexport
                xCalcDataExport = fr.free.deneux.gerard.cadooo.datacalcexport.CalcDataExport( self.ctx)
                self.aEnv.update(xCalcDataExport.execute(self.aEnv))
                if not self.aEnv['CALCCOMP'] is None:
                    aSheet = self.aEnv['CALCCOMP'].getSheets().getByName(self.aEnv['SHEET'])
                    aSheet.IsVisible = True
                    aCursor = aSheet.createCursor()
                    aCursorAddress = aCursor.getRangeAddress()
                    aTargetRangeAddress = uno.createUnoStruct("com.sun.star.table.CellRangeAddress")
                    aTargetRangeAddress.Sheet = aCursorAddress.Sheet
                    aTargetRangeAddress.StartColumn = aCursorAddress.StartColumn
                    aTargetRangeAddress.StartRow = aCursorAddress.StartRow
                    aTargetRangeAddress.EndColumn = aCursorAddress.StartColumn + 11
                    aTargetRangeAddress.EndRow = aCursorAddress.StartRow + 3 + len(self.aEnv['AREACOORDS'])
                    aSheet.insertCells(aTargetRangeAddress, DOWN)
                    aDataArray = []
                    sUnit = self.aEnv['UNITS'][self.aEnv['MEASUREUNIT']]
                    sX = "X (%s)" % sUnit
                    sY = "Y (%s)" % sUnit
                    aDataArray.append(tuple(["", self.aText['ucs1'], "", self.aText['st0'], "", self.aText['a1'], "", self.aText['a2'], "", self.aText['d5'], ""]))
                    aDataArray.append(tuple([self.aText['gp10'], sX, sY, sX, sY, sX, sY, "1 (%s)" % sUnit, "2 (%s)" %sUnit, "%s (rad)" % self.aText['a3'], "%s (rad)" % self.aText['a4']]))
                    if len(self.aEnv['CONTOURLIST']) == 1:
                        aDataArray.append((self.aText['gp%d' % (['LineShape', 'CircleShape', 'ArcCircleShape', 'EllipseShape', 'ArcEllipseShape'].index(self.aEnv['CONTOURLIST'][0][1]))],))
                        aTrsfmParm = self.aEnv.fromkeys(self.aEnv['INPUTDATAPARM'][1:])
                        for aKey in self.aEnv['INPUTDATAPARM'][1:]:
                            aTrsfmParm[aKey] = self.aEnv[aKey]
                        aCoord = self.xCompute.transform2UCSAndUnitAsFloat( {'X':self.aEnv['AREACOORDS'][0]['XA'],  'Y':self.aEnv['AREACOORDS'][0]['YA']}, aTrsfmParm)
                        aDataArray[-1] = aDataArray[-1] + (aCoord['X'], aCoord['Y'])
                        aCoord = self.xCompute.transform2UCSAndUnitAsFloat( {'X':self.aEnv['AREACOORDS'][0]['XB'],  'Y':self.aEnv['AREACOORDS'][0]['YB']}, aTrsfmParm)
                        aDataArray[-1] = aDataArray[-1] + (aCoord['X'], aCoord['Y'])
                        if self.aEnv['CONTOURLIST'][0][1] in ("ArcCircleShape", "ArcEllipseShape", "CircleShape", "EllipseShape"):
                            aCoord = self.xCompute.transform2UCSAndUnitAsFloat( {'X':self.aEnv['AREACOORDS'][0]['XC'],  'Y':self.aEnv['AREACOORDS'][0]['YC']}, aTrsfmParm)
                            aDataArray[-1] = aDataArray[-1] + (aCoord['X'], aCoord['Y'])
                            if self.aEnv['CONTOURLIST'][0][1] in ("ArcCircleShape", "CircleShape"):
                                aWidth = self.xCompute.transform2UserUnitAsFloat( self.aEnv['CONTOURLIST'][-1][3]['Width'], self.aEnv['UNITS'], self.aEnv['UNITSRATIO'], self.aEnv['MEASUREUNIT'], self.aEnv['DRAWSCALE'])
                                aDataArray[-1] = aDataArray[-1] + (aWidth, "")
                            else:
                                aWidth = self.xCompute.transform2UserUnitAsFloat( self.aEnv['CONTOURLIST'][-1][3]['Width'], self.aEnv['UNITS'], self.aEnv['UNITSRATIO'], self.aEnv['MEASUREUNIT'], self.aEnv['DRAWSCALE'])
                                aHeight = self.xCompute.transform2UserUnitAsFloat( self.aEnv['CONTOURLIST'][-1][3]['Height'], self.aEnv['UNITS'], self.aEnv['UNITSRATIO'], self.aEnv['MEASUREUNIT'], self.aEnv['DRAWSCALE'])
                                aDataArray[-1] = aDataArray[-1] + (aWidth, aHeight)
                            if self.aEnv['CONTOURLIST'][0][1] in ("ArcCircleShape", "ArcEllipseShape"):
                                aDataArray[-1] = aDataArray[-1] + (self.aEnv['CONTOURLIST'][-1][5], self.aEnv['CONTOURLIST'][-1][6])
                            else:
                                aDataArray[-1] = aDataArray[-1] + ("", "")
                        else:
                            aDataArray[-1] = aDataArray[-1] + ("", "", "", "", "", "")
                    else:
                        aTrsfmParm = self.aEnv.fromkeys(self.aEnv['INPUTDATAPARM'][1:])
                        for aKey in self.aEnv['INPUTDATAPARM'][1:]:
                            aTrsfmParm[aKey] = self.aEnv[aKey]
                        for aCoords, aSeg in zip(self.aEnv['AREACOORDS'], self.aEnv['CONTOURLIST'][1:] + [self.aEnv['CONTOURLIST'][0],]):
                            aDataArray.append((self.aText['gp%d' % (['LineShape', 'CircleShape', 'ArcCircleShape', 'EllipseShape', 'ArcEllipseShape'].index(aSeg[1]))],))
                            aCoord = self.xCompute.transform2UCSAndUnitAsFloat( {'X':aCoords['XA'],  'Y':aCoords['YA']}, aTrsfmParm)
                            aDataArray[-1] = aDataArray[-1] + (aCoord['X'], aCoord['Y'])
                            aCoord = self.xCompute.transform2UCSAndUnitAsFloat( {'X':aCoords['XB'],  'Y':aCoords['YB']}, aTrsfmParm)
                            aDataArray[-1] = aDataArray[-1] + (aCoord['X'], aCoord['Y'])
                            if aSeg[1] in ("ArcCircleShape", "ArcEllipseShape", "CircleShape", "EllipseShape"):
                                aCoord = self.xCompute.transform2UCSAndUnitAsFloat( {'X':aCoords['XC'],  'Y':aCoords['YC']}, aTrsfmParm)
                                aDataArray[-1] = aDataArray[-1] + (aCoord['X'], aCoord['Y'])
                                if aSeg[1] in ("ArcCircleShape", "CircleShape"):
                                    #self.showDebugMsg("\n".join(["%s" % repr(s) for s in aSeg]))
                                    aWidth = self.xCompute.transform2UserUnitAsFloat( aSeg[3]['Width'], self.aEnv['UNITS'], self.aEnv['UNITSRATIO'], self.aEnv['MEASUREUNIT'], self.aEnv['DRAWSCALE'])
                                    aDataArray[-1] = aDataArray[-1] + (aWidth, "")
                                else:
                                    aWidth = self.xCompute.transform2UserUnitAsFloat( aSeg[3]['Width'], self.aEnv['UNITS'], self.aEnv['UNITSRATIO'], self.aEnv['MEASUREUNIT'], self.aEnv['DRAWSCALE'])
                                    aHeight = self.xCompute.transform2UserUnitAsFloat( aSeg[3]['Height'], self.aEnv['UNITS'], self.aEnv['UNITSRATIO'], self.aEnv['MEASUREUNIT'], self.aEnv['DRAWSCALE'])
                                    aDataArray[-1] = aDataArray[-1] + (aWidth, aHeight)
                                if aSeg[1] in ("ArcCircleShape", "ArcEllipseShape"):
                                    fAngle1 = self.xCompute.toPolarCoord( {'X':aCoords['XC'], 'Y':aCoords['YC']}, {'X':aCoords['XA'], 'Y':aCoords['YA']})[1]
                                    fAngle2 = self.xCompute.toPolarCoord( {'X':aCoords['XC'], 'Y':aCoords['YC']}, {'X':aCoords['XB'], 'Y':aCoords['YB']})[1]
                                    if aCoords['SA'] == "A":
                                        aDataArray[-1] = aDataArray[-1] + (fAngle1, fAngle2)
                                    else:
                                        aDataArray[-1] = aDataArray[-1] + (fAngle2, fAngle1)
                                else:
                                    aDataArray[-1] = aDataArray[-1] + ("", "")
                            else:
                                aDataArray[-1] = aDataArray[-1] + ("", "", "", "", "", "")
                    aDataArray.append((self.aText['area0'], locale.atof(sArea.split(" ")[0]), "".join(sArea.split(" ")[1:]), "", "", "", "", "", "", "", ""))
                    #self.showDebugMsg("\n".join([" | ".join(l) for l in aDataArray]))
                    aRange = aCursor.getCellRangeByPosition(0, 0, 10, 2 + len(self.aEnv['AREACOORDS']))
                    aRange.setDataArray(tuple(aDataArray))
            self.aEnv['STOPJOB'] = True
            return self.aEnv
