# 	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## areakeyhandler vendredi 17 avril 2009, 15:52:12 (UTC+0200)
## last modified lundi 20 avril 2009, 15:25:00 (UTC+0200)
## Copyright (C) 2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    from types import *
    from com.sun.star.awt.KeyModifier import SHIFT
except ImportError:
    print "probleme d'import"
#===============================
# gestion des evenements clavier
# handling keyboard events
#===============================
class AreaKeyHandler():
    """gestion des evenements clavier
    handling keyboard events"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.msgl10n
        self.ctx = ctx
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
        sTextList = ("area3",)
        self.aText = dict(zip(sTextList, xMsgL10n.getText(sTextList)))
    # **********************************
    # show message wrapper
    # **********************************
    def showMsg(self, aMsg):
        if not hasattr(self, "xMessage"):
            import fr.free.deneux.gerard.cadooo.messagebox
            self.xMessage = fr.free.deneux.gerard.cadooo.messagebox.MessageBox( self.ctx)
        self.xMessage.execute(aMsg, "infobox")
        return
    # ==================================
    # actions clavier - keyboard actions
    # aNamedValues as tuple of NamedValue
    #   Name         Value
    # KEYCODE     integer
    # L2OSTATE    tuple of 5 integers (0 or 1)
    # SHAPE
    # ==================================
    def execute(self, aArgs):
        self.aEnv = {}
        self.aEnv.update(aArgs)
        lKey = self.aEnv['MAGNETKEY'].keys()
        lKey.sort()
        lJkey = self.aEnv['UCSKEY'].keys() + self.aEnv['INPUTDATAKEY'].keys()
        # ---------------------------------------------------
        if self.aEnv['KEYEVENT']['COD'] in lKey and not self.aEnv['KEYEVENT']['MOD']:
            # e,   i,   m,   p,   t => link 2 entities
            i = lKey.index(self.aEnv['KEYEVENT']['COD'])
            bKHState = list(self.aEnv['L2OSTATE'])
            bKHState[i] = not bKHState[i]
            self.aEnv['L2OSTATE'] = tuple(bKHState)
            aStatusBarCheckBox = self.aEnv['STATUSBARCONTROL'][self.aEnv['KEYEVENT']['COD']]
            if aStatusBarCheckBox.getState() != self.aEnv['L2OSTATE'][i]:
                aStatusBarCheckBox.setState(self.aEnv['L2OSTATE'][i])
        # --------------------------------------------------------------------------------------------------------------------
        elif self.aEnv['KEYEVENT']['COD'] in ('USE',) and not self.aEnv['KEYEVENT']['MOD'] and self.aEnv['STAGE'] == 1 and not self.aEnv['CONTOURLIST'] is None:
            # u => undo
            aItem = self.aEnv['CONTOURLIST'].pop()
            self.removeTempShapes()
        # ----------------------------------------------------------------------------------------------------------------
        elif self.aEnv['KEYEVENT']['COD'] in ('CAR',) and not self.aEnv['KEYEVENT']['MOD'] and self.aEnv['STAGE'] == 1 and not self.aEnv['CONTOURLIST'] is None:
            # c => close selection
            self.showMsg(self.aText['area3'])
            self.aEnv['STAGE'] = 2
            self.aEnv['SELECTEDLIST'] = [self.aEnv['CONTOURLIST'][0], self.aEnv['CONTOURLIST'][1]]
            self.removeTempShapes()
        # --------------------------------------------------------------------------------
        elif self.aEnv['KEYEVENT']['COD'] in ('ESC',) and not self.aEnv['KEYEVENT']['MOD']:
            #                                 Esc => kill job
            self.aEnv['CANCELJOB'] = True
            if self.aEnv['SHAPE']:
                aGroupShape = self.aEnv['CONTROLLER'].getCurrentPage()
                if len(self.aEnv['SPOTTEDID']) > 2:
                    for i in self.aEnv['SPOTTEDID'][:-2]:
                        aGroupShape = aGroupShape.getByIndex(i)
                aGroupShape.remove(self.aEnv['SHAPE'])
                self.aEnv['SHAPE'] = None
                self.aEnv['STEP'] = 0
                self.aEnv['COORDS'] = None
                self.aEnv['SPOTTEDID'] = None
        # -------------------------------------------------------------------------------
        elif self.aEnv['KEYEVENT']['COD'] in ('AXOCTRL',) and not self.aEnv['KEYEVENT']['MOD']:
            #                               a => axonometric mode
            self.aEnv['ORTHOMODE'] = not self.aEnv['ORTHOMODE']
            aStatusBarCheckBox = self.aEnv['STATUSBARCONTROL']['AXOCTRL']
            if aStatusBarCheckBox.getState() != self.aEnv['ORTHOMODE']:
                aStatusBarCheckBox.setState(self.aEnv['ORTHOMODE'])
        # --------------------------------------------------------------------------------
        elif self.aEnv['KEYEVENT']['COD'] in ('MULTICTRL',) and not self.aEnv['KEYEVENT']['MOD']:
            #                                * => repeat mode
            self.aEnv['REPEATMODE'] = not self.aEnv['REPEATMODE']
            aStatusBarCheckBox = self.aEnv['STATUSBARCONTROL']['MULTICTRL']
            if aStatusBarCheckBox.getState() != self.aEnv['REPEATMODE']:
                aStatusBarCheckBox.setState(self.aEnv['REPEATMODE'])
        return self.aEnv
    # *****************************************************
    # remove temporary shapes
    # *****************************************************
    def removeTempShapes(self):
        if not self.aEnv['SPOTTEDID'] is None:
            aGroupShape = self.aEnv['CONTROLLER'].getCurrentPage()
            if len(self.aEnv['SPOTTEDID']) > 2:
                for i in self.aEnv['SPOTTEDID'][:-2]:
                    aGroupShape = aGroupShape.getByIndex(i)
            aGroupShape.remove(self.aEnv['SHAPE'])
            self.aEnv['SHAPE'] = None
            self.aEnv['STEP'] = 0
            self.aEnv['COORDS'] = None
            self.aEnv['SPOTTEDID'] = None
        return