#	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## areamousehandler samedi 21 mars 2009, 15:23:26 (UTC+0100)

## Copyright (C) 2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math
except ImportError:
    print "probleme d'import"
# ///////////////////////////////////////////
# Gerer les validations d'entites
# Handle entities validation
# ///////////////////////////////////////////
class AreaMouseHandler():
    """Gere les validations d'entites
    Handles entities validation"""
    # **********************
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.questionbox
        import fr.free.deneux.gerard.cadooo.msgl10n
        import fr.free.deneux.gerard.cadooo.compute
        self.ctx = ctx
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute( self.ctx)
        self.xQuestion = fr.free.deneux.gerard.cadooo.questionbox.QuestionBox( self.ctx)
        self.xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
        sTextList = tuple(["area%d" % i for i in (3, 9, 10)])
        self.aTranslatedText = dict(zip(sTextList, self.xMsgL10n.getText(sTextList)))
    # **********************************
    # show message wrapper
    # **********************************
    def showMsg(self, aMsg):
        if not hasattr(self, "xMessage"):
            import fr.free.deneux.gerard.cadooo.messagebox
            self.xMessage = fr.free.deneux.gerard.cadooo.messagebox.MessageBox( self.ctx)
        self.xMessage.execute(aMsg, "infobox")
        return
    # **********************************
    # Handles mouse clicks
    # **********************************
    def execute(self, aArgs):
        self.aEnv = {}
        self.aEnv.update(aArgs)
        # -------------------------------------
        if self.aEnv['MOUSEEVENT'].Buttons > 1: # don't handle mouse buttons but left
            return aArgs
        # ----------------------------------------------------------------------------------------------------------------
        if self.aEnv['STAGE'] == 1 and self.aEnv['MOUSEEVENT'].ClickCount in (1, 2) and not self.aEnv['SPOTTEDSHAPE'] is None:
            aGroupShape = self.aEnv['CONTROLLER'].getCurrentPage()
            aNewSpottedId = self.aEnv['SPOTTEDSHAPE'][0] + (self.aEnv['SPOTTEDSHAPE'][-1],)
            # ........................
            if len(aNewSpottedId) > 2:
                for i in aNewSpottedId[:-2]:
                    aGroupShape = aGroupShape.getByIndex(i)
            aShape = aGroupShape.getByIndex(aNewSpottedId[-2])
            sType = aShape.getShapeType().split('.')[-1]
            sCadType = self.aEnv['SPOTTEDSHAPE'][1]
            # ......................................
            if not self.aEnv['CONTOURLIST'] is None:
                aSpottedIDList = [l[0] + (l[-1],) for l in self.aEnv['CONTOURLIST']]
                sTypeList = [t[1] for t in self.aEnv['CONTOURLIST']]
                # 000000000000000000000000000000000
                if aNewSpottedId in aSpottedIDList:
                    # 111111111111111111111111111111111111
                    if len(self.aEnv['CONTOURLIST']) == 1:
                        # 222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222
                        if sType in ("RectangleShape", "PolyPolygonShape") or sCadType in ('CircleShape', 'EllipseShape'):
                            nID = None
                            i = 1
                            self.aEnv['CONTOURLIST'] = []
                            for c in self.aEnv['SPLITTEDSHAPE']:
                                if c[1].count("Centre") != 0:
                                    if c[0] == nID:
                                        i += 1
                                    else:
                                        nID = c[0]
                                        i = 1
                                    self.aEnv['CONTOURLIST'].append(c + [i])
                            aAreaCoords = []
                            for aSeg in self.aEnv['CONTOURLIST']:
                                if aSeg[1] == "LineShape":
                                    if sType in ("RectangleShape",) and aShape.CornerRadius:
                                        aAreaCoords.append({'JOINTYPE':"ARC2LINE", 'XA':aSeg[2]['X'], 'YA':aSeg[2]['Y'], 'XB':aSeg[3]['X'], 'YB':aSeg[3]['Y']})
                                    else:
                                        aAreaCoords.append({'JOINTYPE':"LINE2LINE", 'XA':aSeg[2]['X'], 'YA':aSeg[2]['Y'], 'XB':aSeg[3]['X'], 'YB':aSeg[3]['Y']})
                                else:
                                    if sCadType in ('CircleShape', 'EllipseShape'):
                                        aAreaCoords.append({'JOINTYPE':"ARC2ARC"})
                                        nISA, nIEA = 5, 6
                                        aAreaCoords[-1]['SA'] = "A"
                                    else:
                                        aAreaCoords.append({'JOINTYPE':"LINE2ARC"})
                                        nISA, nIEA = 6, 5
                                        aAreaCoords[-1]['SA'] = "B"
                                    aAreaCoords[-1]['XC'] = aSeg[2]['X']
                                    aAreaCoords[-1]['YC'] = aSeg[2]['Y']
                                    aPoint = self.xCompute.getPointOnEllipse( None, aSeg[nISA], aSeg[2], aSeg[3], aSeg[4])[0]
                                    aAreaCoords[-1]['XA'] = aPoint['X']
                                    aAreaCoords[-1]['YA'] = aPoint['Y']
                                    aPoint = self.xCompute.getPointOnEllipse( None, aSeg[nIEA], aSeg[2], aSeg[3], aSeg[4])[0]
                                    aAreaCoords[-1]['XB'] = aPoint['X']
                                    aAreaCoords[-1]['YB'] = aPoint['Y']
                                    aPoint = self.xCompute.getPointOnEllipse( None, 0.00, aSeg[2], aSeg[3], aSeg[4])[0]
                                    aAreaCoords[-1]['XR1'] = aPoint['X']
                                    aAreaCoords[-1]['YR1'] = aPoint['Y']
                                    aPoint = self.xCompute.getPointOnEllipse( None, math.pi/2, aSeg[2], aSeg[3], aSeg[4])[0]
                                    aAreaCoords[-1]['XR2'] = aPoint['X']
                                    aAreaCoords[-1]['YR2'] = aPoint['Y']
                            self.aEnv['AREACOORDS'] = [c for c in aAreaCoords]
                            self.aEnv['STAGE'] = 3
                        self.removeTempShapes()
                        return self.aEnv
                    # 111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
                    if sTypeList.count("LineShape") >= 3 or (len(sTypeList) - sTypeList.count("LineShape")) > 0:
                        self.showMsg(self.aTranslatedText['area3'])
                        self.aEnv['STAGE'] = 2
                        self.aEnv['SELECTEDLIST'] = [self.aEnv['CONTOURLIST'][0], self.aEnv['CONTOURLIST'][1]]
                    self.removeTempShapes()
                    return self.aEnv
                else:
                    # 222222222222222222222222222222222222222222222
                    if sCadType in ('CircleShape', 'EllipseShape'):
                        # can't mixe open and closed area replace previous selection ?
                        ret = self.xQuestion.execute(self.aTranslatedText['area9'])
                        # 00000
                        if ret:
                            nID = None
                            i = 1
                            for c in self.aEnv['SPLITTEDSHAPE']:
                                if c[1].count("Centre") == 0:
                                    if c[0] == nID:
                                        i += 1
                                    else:
                                        nID = c[0]
                                        i = 1
                                    self.aEnv['CONTOURLIST'] = c + [i]
                            aAreaCoords = []
                            aAreaCoords.append({'JOINTYPE':"ARC2ARC"})
                            aAreaCoords[-1]['XC'] = self.aEnv['CONTOURLIST'][2]['X']
                            aAreaCoords[-1]['YC'] = self.aEnv['CONTOURLIST'][2]['Y']
                            aPoint = self.xCompute.getPointOnEllipse( None, self.aEnv['CONTOURLIST'][5], self.aEnv['CONTOURLIST'][2], self.aEnv['CONTOURLIST'][3], self.aEnv['CONTOURLIST'][4])[0]
                            aAreaCoords[-1]['XA'] = aPoint['X']
                            aAreaCoords[-1]['YA'] = aPoint['Y']
                            aAreaCoords[-1]['XB'] = aPoint['X']
                            aAreaCoords[-1]['YB'] = aPoint['Y']
                            aAreaCoords[-1]['XR1'] = aPoint['X']
                            aAreaCoords[-1]['YR1'] = aPoint['Y']
                            aPoint = self.xCompute.getPointOnEllipse( None, math.pi/2, self.aEnv['CONTOURLIST'][2], self.aEnv['CONTOURLIST'][3], self.aEnv['CONTOURLIST'][4])[0]
                            aAreaCoords[-1]['XR2'] = aPoint['X']
                            aAreaCoords[-1]['YR2'] = aPoint['Y']
                            aAreaCoords[-1]['SA'] = "A"
                            self.aEnv['AREACOORDS'] = [c for c in aAreaCoords]
                            self.aEnv['STAGE'] = 3
                        self.removeTempShapes()
                        return self.aEnv
                    # 22222222222222222222222222222222222222222222222222222222222222222222
                    elif sType in ("PolyLineShape", "RectangleShape", "PolyPolygonShape"):
                        # Select all chain of polyline ?
                        ret = self.xQuestion.execute(self.aTranslatedText['area10'])
                        # 33333
                        if ret:
                            # 4444444444444444444444444444444444444444444444444
                            if sType in ("RectangleShape", "PolyPolygonShape"):
                                # can't mixe open and closed area replace previous selection ?
                                ret = self.xQuestion.execute(self.aTranslatedText['area9'])
                                # 00000
                                if ret:
                                    nID = None
                                    i = 1
                                    self.aEnv['CONTOURLIST'] = []
                                    for c in self.aEnv['SPLITTEDSHAPE']:
                                        if c[1].count("Centre") == 0:
                                            if c[0] == nID:
                                                i += 1
                                            else:
                                                nID = c[0]
                                                i = 1
                                            self.aEnv['CONTOURLIST'].append(c + [i])
                                    aAreaCoords = []
                                    for aSeg in self.aEnv['CONTOURLIST']:
                                        if aSeg[1] == "LineShape":
                                            if sType in ("RectangleShape",) and aShape.CornerRadius:
                                                aAreaCoords.append({'JOINTYPE':"ARC2LINE", 'XA':aSeg[2]['X'], 'YA':aSeg[2]['Y'], 'XB':aSeg[3]['X'], 'YB':aSeg[3]['Y']})
                                            else:
                                                aAreaCoords.append({'JOINTYPE':"LINE2LINE", 'XA':aSeg[2]['X'], 'YA':aSeg[2]['Y'], 'XB':aSeg[3]['X'], 'YB':aSeg[3]['Y']})
                                        else:
                                            aAreaCoords.append({'JOINTYPE':"LINE2ARC"})
                                            aAreaCoords[-1]['XC'] = aSeg[2]['X']
                                            aAreaCoords[-1]['YC'] = aSeg[2]['Y']
                                            aPoint = self.xCompute.getPointOnEllipse( None, aSeg[6], aSeg[2], aSeg[3], aSeg[4])[0]
                                            aAreaCoords[-1]['XA'] = aPoint['X']
                                            aAreaCoords[-1]['YA'] = aPoint['Y']
                                            aPoint = self.xCompute.getPointOnEllipse( None, aSeg[5], aSeg[2], aSeg[3], aSeg[4])[0]
                                            aAreaCoords[-1]['XB'] = aPoint['X']
                                            aAreaCoords[-1]['YB'] = aPoint['Y']
                                            aPoint = self.xCompute.getPointOnEllipse( None, 0.00, aSeg[2], aSeg[3], aSeg[4])[0]
                                            aAreaCoords[-1]['XR1'] = aPoint['X']
                                            aAreaCoords[-1]['YR1'] = aPoint['Y']
                                            aPoint = self.xCompute.getPointOnEllipse( None, math.pi/2, aSeg[2], aSeg[3], aSeg[4])[0]
                                            aAreaCoords[-1]['XR2'] = aPoint['X']
                                            aAreaCoords[-1]['YR2'] = aPoint['Y']
                                            aAreaCoords[-1]['SA'] = "B"
                                    self.aEnv['AREACOORDS'] = [c for c in aAreaCoords]
                                    self.aEnv['STAGE'] = 3
                                self.removeTempShapes()
                                return self.aEnv
                            else:
                                nID = None
                                i = 1
                                aContour = []
                                for c in self.aEnv['SPLITTEDSHAPE']:
                                    if c[1].count("Centre") == 0:
                                        if c[0] == nID:
                                            i += 1
                                        else:
                                            nID = c[0]
                                            i = 1
                                        aContour.append(c + [i])
                                self.aEnv['CONTOURLIST'].extend(aContour)
                        else:
                            self.aEnv['CONTOURLIST'].append(self.aEnv['SPOTTEDSHAPE'])
                    else:
                        self.aEnv['CONTOURLIST'].append(self.aEnv['SPOTTEDSHAPE'])
                    self.removeTempShapes()
                    if self.aEnv['MOUSEEVENT'].ClickCount == 2:
                        self.showMsg(self.aTranslatedText['area3'])
                        self.aEnv['STAGE'] = 2
                        self.aEnv['SELECTEDLIST'] = [self.aEnv['CONTOURLIST'][0], self.aEnv['CONTOURLIST'][1]]
                    else:
                        self.aEnv['SELECTEDLIST'] = [self.aEnv['CONTOURLIST'][-1], None]
                    return self.aEnv
            else:
                self.aEnv['CONTOURLIST'] = []
                # 222222222222222222222222222222222222222222222
                if sCadType in ('CircleShape', 'EllipseShape'):
                    nID = None
                    i = 1
                    for c in self.aEnv['SPLITTEDSHAPE']:
                        if c[1].count("Centre") == 0:
                            if c[0] == nID:
                                i += 1
                            else:
                                nID = c[0]
                                i = 1
                            self.aEnv['CONTOURLIST'].append(c + [i])
                    aAreaCoords = []
                    aAreaCoords.append({'JOINTYPE':"ARC2ARC"})
                    aAreaCoords[-1]['XC'] = self.aEnv['CONTOURLIST'][2]['X']
                    aAreaCoords[-1]['YC'] = self.aEnv['CONTOURLIST'][2]['Y']
                    aPoint = self.xCompute.getPointOnEllipse( None, self.aEnv['CONTOURLIST'][5], self.aEnv['CONTOURLIST'][2], self.aEnv['CONTOURLIST'][3], self.aEnv['CONTOURLIST'][4])[0]
                    aAreaCoords[-1]['XA'] = aPoint['X']
                    aAreaCoords[-1]['YA'] = aPoint['Y']
                    aAreaCoords[-1]['XB'] = aPoint['X']
                    aAreaCoords[-1]['YB'] = aPoint['Y']
                    aAreaCoords[-1]['XR1'] = aPoint['X']
                    aAreaCoords[-1]['YR1'] = aPoint['Y']
                    aPoint = self.xCompute.getPointOnEllipse( None, math.pi/2, self.aEnv['CONTOURLIST'][2], self.aEnv['CONTOURLIST'][3], self.aEnv['CONTOURLIST'][4])[0]
                    aAreaCoords[-1]['XR2'] = aPoint['X']
                    aAreaCoords[-1]['YR2'] = aPoint['Y']
                    aAreaCoords[-1]['SA'] = "A"
                    self.aEnv['AREACOORDS'] = [c for c in aAreaCoords]
                # 22222222222222222222222222222222222222222222222222222222222222222222
                elif sType in ("PolyLineShape", "RectangleShape", "PolyPolygonShape"):
                    nID = None
                    i = 1
                    # Select all chain of polyline ?
                    ret = self.xQuestion.execute(self.aTranslatedText['area10'])
                    # 33333
                    if ret:
                        aAreaCoords = []
                        for c in self.aEnv['SPLITTEDSHAPE']:
                            if c[1].count("Centre") == 0:
                                if c[0] == nID:
                                    i += 1
                                else:
                                    nID = c[0]
                                    i = 1
                                self.aEnv['CONTOURLIST'].append(c + [i])
                        # 444444444444444444444444444444444444444444444444444444444444444444
                        if sType in ("RectangleShape", "PolyPolygonShape", "PolyLineShape"):
                            for aSeg in self.aEnv['CONTOURLIST']:
                                if aSeg[1] == "LineShape":
                                    if sType in ("RectangleShape",) and aShape.CornerRadius:
                                        aAreaCoords.append({'JOINTYPE':"ARC2LINE", 'XA':aSeg[2]['X'], 'YA':aSeg[2]['Y'], 'XB':aSeg[3]['X'], 'YB':aSeg[3]['Y']})
                                    else:
                                        aAreaCoords.append({'JOINTYPE':"LINE2LINE", 'XA':aSeg[2]['X'], 'YA':aSeg[2]['Y'], 'XB':aSeg[3]['X'], 'YB':aSeg[3]['Y']})
                                else:
                                    aAreaCoords.append({'JOINTYPE':"LINE2ARC"})
                                    aAreaCoords[-1]['XC'] = aSeg[2]['X']
                                    aAreaCoords[-1]['YC'] = aSeg[2]['Y']
                                    aPoint = self.xCompute.getPointOnEllipse( None, aSeg[6], aSeg[2], aSeg[3], aSeg[4])[0]
                                    aAreaCoords[-1]['XA'] = aPoint['X']
                                    aAreaCoords[-1]['YA'] = aPoint['Y']
                                    aPoint = self.xCompute.getPointOnEllipse( None, aSeg[5], aSeg[2], aSeg[3], aSeg[4])[0]
                                    aAreaCoords[-1]['XB'] = aPoint['X']
                                    aAreaCoords[-1]['YB'] = aPoint['Y']
                                    aPoint = self.xCompute.getPointOnEllipse( None, 0.00, aSeg[2], aSeg[3], aSeg[4])[0]
                                    aAreaCoords[-1]['XR1'] = aPoint['X']
                                    aAreaCoords[-1]['YR1'] = aPoint['Y']
                                    aPoint = self.xCompute.getPointOnEllipse( None, math.pi/2, aSeg[2], aSeg[3], aSeg[4])[0]
                                    aAreaCoords[-1]['XR2'] = aPoint['X']
                                    aAreaCoords[-1]['YR2'] = aPoint['Y']
                                    aAreaCoords[-1]['SA'] = "B"
                            self.aEnv['AREACOORDS'] = [c for c in aAreaCoords]
                        self.aEnv['STAGE'] = 1 + 2 * (sType in ("RectangleShape", "PolyPolygonShape", ) or sCadType in ('CircleShape', 'EllipseShape'))
                    else:
                        self.aEnv['CONTOURLIST'].append(self.aEnv['SPOTTEDSHAPE'])
                else:
                    self.aEnv['CONTOURLIST'].append(self.aEnv['SPOTTEDSHAPE'])
                self.aEnv['SELECTEDLIST'] = [self.aEnv['CONTOURLIST'][-1], None]
                self.removeTempShapes()
                return self.aEnv
        # ---------------------------
        elif self.aEnv['STAGE'] == 2:
            if not hasattr(self, "nIndx"):
                self.nIndx = 1
                self.nNbSeg = len(self.aEnv['CONTOURLIST'])
                self.aAreaCoords = []
            # ++++++++++++++++++++++++++++++++++++++
            if self.aEnv['JOINTYPE'] == "LINE2LINE":
                self.aAreaCoords.append({'JOINTYPE':"LINE2LINE", 'XA':self.aEnv['JOINCOORDS'][-2]['X'], 'YA':self.aEnv['JOINCOORDS'][-2]['Y'], 'XB':self.aEnv['JOINCOORDS'][-1]['X'], 'YB':self.aEnv['JOINCOORDS'][-1]['Y']})
            # +++++++++++++++++++++++++++++++++++++++
            elif self.aEnv['JOINTYPE'] == "LINE2ARC":
                # ................................................
                if self.aEnv['SELECTEDLIST'][0][1] == "LineShape":
                    self.aAreaCoords.append({'JOINTYPE':"LINE2ARC"})
                    self.aAreaCoords[-1]['XA'] = self.aEnv['JOINCOORDS'][1]['X']
                    self.aAreaCoords[-1]['YA'] = self.aEnv['JOINCOORDS'][1]['Y']
                    # 0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
                    if self.aEnv['JOINCOORDS'][5]['X'] == self.aEnv['JOINCOORDS'][1]['X'] and self.aEnv['JOINCOORDS'][5]['Y'] == self.aEnv['JOINCOORDS'][1]['Y']:
                        self.aAreaCoords[-1]['SA'] = "A"
                        self.aAreaCoords[-1]['XB'] = self.aEnv['JOINCOORDS'][6]['X']
                        self.aAreaCoords[-1]['YB'] = self.aEnv['JOINCOORDS'][6]['Y']
                    else:
                        self.aAreaCoords[-1]['SA'] = "B"
                        self.aAreaCoords[-1]['XB'] = self.aEnv['JOINCOORDS'][5]['X']
                        self.aAreaCoords[-1]['YB'] = self.aEnv['JOINCOORDS'][5]['Y']
                    self.aAreaCoords[-1]['XC'] = self.aEnv['JOINCOORDS'][2]['X']
                    self.aAreaCoords[-1]['YC'] = self.aEnv['JOINCOORDS'][2]['Y']
                    self.aAreaCoords[-1]['XR1'] = self.aEnv['JOINCOORDS'][3]['X']
                    self.aAreaCoords[-1]['YR1'] = self.aEnv['JOINCOORDS'][3]['Y']
                    self.aAreaCoords[-1]['XR2'] = self.aEnv['JOINCOORDS'][4]['X']
                    self.aAreaCoords[-1]['YR2'] = self.aEnv['JOINCOORDS'][4]['Y']
                else:
                    self.aAreaCoords.append({'JOINTYPE':"ARC2LINE"})
                    self.aAreaCoords[-1]['XA'] = self.aEnv['JOINCOORDS'][1]['X']
                    self.aAreaCoords[-1]['YA'] = self.aEnv['JOINCOORDS'][1]['Y']
                    self.aAreaCoords[-1]['XB'] = self.aEnv['JOINCOORDS'][0]['X']
                    self.aAreaCoords[-1]['YB'] = self.aEnv['JOINCOORDS'][0]['Y']
            else:
                self.aAreaCoords.append({'JOINTYPE':"ARC2ARC"})
                if (self.aEnv['JOINCOORDS'][-2]['X'], self.aEnv['JOINCOORDS'][-2]['Y']) in ((self.aEnv['JOINCOORDS'][5]['X'], self.aEnv['JOINCOORDS'][5]['Y']), (self.aEnv['JOINCOORDS'][6]['X'], self.aEnv['JOINCOORDS'][6]['Y'])):
                    self.aAreaCoords[-1]['SA'] = "A"
                    nI = -2
                else:
                    self.aAreaCoords[-1]['SA'] = "B"
                    nI = -1
                self.aAreaCoords[-1]['XA'] = self.aEnv['JOINCOORDS'][nI]['X']
                self.aAreaCoords[-1]['YA'] = self.aEnv['JOINCOORDS'][nI]['Y']
                self.aAreaCoords[-1]['XB'] = self.aEnv['JOINCOORDS'][-3-nI]['X']
                self.aAreaCoords[-1]['YB'] = self.aEnv['JOINCOORDS'][-3-nI]['Y']
                self.aAreaCoords[-1]['XC'] = self.aEnv['JOINCOORDS'][-5]['X']
                self.aAreaCoords[-1]['YC'] = self.aEnv['JOINCOORDS'][-5]['Y']
                self.aAreaCoords[-1]['XR1'] = self.aEnv['JOINCOORDS'][-4]['X']
                self.aAreaCoords[-1]['YR1'] = self.aEnv['JOINCOORDS'][-4]['Y']
                self.aAreaCoords[-1]['XR2'] = self.aEnv['JOINCOORDS'][-3]['X']
                self.aAreaCoords[-1]['YR2'] = self.aEnv['JOINCOORDS'][-3]['Y']
            # ++++++++++++++++++++++++++
            if self.nIndx < self.nNbSeg:
                self.aEnv['SELECTEDLIST'] = [self.aEnv['CONTOURLIST'][self.nIndx], self.aEnv['CONTOURLIST'][(self.nIndx+1) % self.nNbSeg]]
                if self.nIndx > 1:
                    self.aAreaCoords[-2]['XB'], self.aAreaCoords[-2]['YB'] = self.aAreaCoords[-1]['XA'], self.aAreaCoords[-1]['YA']
            else:
                self.aAreaCoords[-2]['XB'], self.aAreaCoords[-2]['YB'] = self.aAreaCoords[-1]['XA'], self.aAreaCoords[-1]['YA']
                self.aAreaCoords[-1]['XB'], self.aAreaCoords[-1]['YB'] = self.aAreaCoords[0]['XA'], self.aAreaCoords[0]['YA']
                self.aEnv['STAGE'] = 3
            self.nIndx += 1
            self.removeTempShapes()
            self.aEnv['AREACOORDS'] = [c for c in self.aAreaCoords]
        return self.aEnv
    # *****************************************************
    # remove temporary shapes
    # *****************************************************
    def removeTempShapes(self):
        if self.aEnv['JOINVISIBLE']:
            aShape = self.aEnv['%s%sJOINSHAPE' % (self.aEnv['JOINKIND'], self.aEnv['JOINTYPE'])]
            for i in range(aShape.getCount()):
                aShape.remove(aShape.getByIndex(0))
            self.aEnv['CONTROLLER'].getCurrentPage().remove(aShape)
            self.aEnv['JOINCOORDS'] = None
            self.aEnv['JOINVISIBLE'] = False
            self.aEnv['%s%sJOINSHAPE' % (self.aEnv['JOINKIND'], self.aEnv['JOINTYPE'])] = None
            self.aEnv['JOINTYPE'] = None
        if not self.aEnv['SPOTTEDID'] is None:
            aGroupShape = self.aEnv['CONTROLLER'].getCurrentPage()
            if len(self.aEnv['SPOTTEDID']) > 2:
                for i in self.aEnv['SPOTTEDID'][:-2]:
                    aGroupShape = aGroupShape.getByIndex(i)
            aGroupShape.remove(self.aEnv['SHAPE'])
            self.aEnv['SHAPE'] = None
            self.aEnv['STEP'] = 0
            self.aEnv['COORDS'] = None
            self.aEnv['SPOTTEDID'] = None
        return
