#	$Id$
# -*- coding: latin-1 -*-
## last modification : dimanche 28 juin 2009, 15:37:11 (UTC+0200)
## ********************************************************************************
## 
## Copyright (C) 2006-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper
    import math, StringIO
    import traceback, sys
    from com.sun.star.awt import XMouseMotionListener, XKeyHandler, XMouseClickHandler, XKeyListener
    from com.sun.star.awt import XItemListener, XMouseListener
    from com.sun.star.registry import InvalidRegistryException
    from com.sun.star.registry.RegistryValueType import NOT_DEFINED
    from com.sun.star.accessibility.AccessibleRole import SCROLL_BAR, SCROLL_PANE, DOCUMENT, PANEL
except ImportError, e:
    print "probleme d'import", e
#======================================================
# a class to draw or edit a graphical entity
# une classe pour tracer ou edite une entite graphique
#======================================================
class CadoooJob(unohelper.Base, XMouseMotionListener, XKeyHandler, XMouseClickHandler, XItemListener, XKeyListener, XMouseListener):
    """Trace ou edit une entite graphique
    Draws a graphical entity"""
    def __init__(self, ctx):
        self.ctx = ctx
        self.smgr = self.ctx.ServiceManager
        # get the central desktop object
        self.desktop = self.smgr.createInstanceWithContext( "com.sun.star.frame.Desktop",self.ctx)
    ##
    ## object inspection wrapper
    ##
    def inspectObject(self, aObject):
        if not hasattr(self, "xDiveIn"):
            from fr.free.deneux.gerard.cadooo.divein import DiveIn
            self.xDiveIn = DiveIn(self.ctx)
        ret = self.xDiveIn.execute(aObject)
    ## *********************
    ## Other init stuffs
    ## *********************
    def runCadooo(self, aArgs):
        from fr.free.deneux.gerard.cadooo.compute import Compute
        from fr.free.deneux.gerard.cadooo.msgl10n import MsgL10n
        from fr.free.deneux.gerard.cadooo.messagebox import MessageBox
        from fr.free.deneux.gerard.cadooo.statusbar import CadoooStatusBar
        from fr.free.deneux.gerard.cadooo.entityposize import EntityPosSize
        self.xCompute = Compute(self.ctx)
        xMsgL10n = MsgL10n(self.ctx)
        aListText = ("gp8", "gp9", "u5")
        self.aTranslation = xMsgL10n.getText(aListText)
        self.aEnv = {}
        self.aEnv.update(aArgs)
        # access the current draw document
        if self.desktop.ActiveFrame.ActiveFrame:
            self.aEnv['CONTROLLER'] = self.desktop.ActiveFrame.ActiveFrame.Controller
        else:
            self.aEnv['CONTROLLER'] = self.desktop.ActiveFrame.Controller
        self.aEnv['MODEL'] = self.aEnv['CONTROLLER'].Model
        self.aEnv['COMPONENTWINDOW'] = self.aEnv['CONTROLLER'].Frame.ComponentWindow
        # find the window document and scroll bars
        for win in self.aEnv['COMPONENTWINDOW'].Windows:
            for i in range(win.AccessibleContext.AccessibleChildCount):
                aChild = win.AccessibleContext.getAccessibleChild(i)
                if aChild.AccessibleContext.AccessibleRole == PANEL:
                    for j in range(aChild.AccessibleContext.AccessibleChildCount):
                        aSubChild = aChild.AccessibleContext.getAccessibleChild(j)
                        if aSubChild.AccessibleContext.AccessibleRole == SCROLL_PANE:
                            for k in range(aSubChild.AccessibleContext.AccessibleChildCount):
                                aSubSubChild = aSubChild.AccessibleContext.getAccessibleChild(k)
                                if aSubSubChild.AccessibleContext.AccessibleRole == DOCUMENT:
                                    aLocation = aSubSubChild.Location
                                    aSize = aSubSubChild.Size
                            if hasattr(aSubChild, "Windows"):
                                for w in aSubChild.Windows:
                                    nX, nY, nWidth, nHeight = aLocation.X-w.PosSize.X, aLocation.Y-w.PosSize.Y, aSize.Width-w.PosSize.Width, aSize.Height-w.PosSize.Height
                                    if w.AccessibleContext.AccessibleRole == PANEL and abs(nX) <= 2 and abs(nY) <= 2 and abs(nWidth) <= 2 and abs(nHeight) <= 2:
                                        if self.aEnv.has_key('PANEWINDOW'):
                                            if self.aEnv['PANEWINDOW'].PosSize.Width < w.PosSize.Width:
                                                self.aEnv['PANEWINDOW'] = w
                                        else:
                                            self.aEnv['PANEWINDOW'] = w
        aDocumentSettings = self.aEnv['MODEL'].createInstance("com.sun.star.drawing.DocumentSettings")
        # Common datas
        self.aEnv['VERSION'] = "1.1.3"
        self.aEnv['LOCKED'] = False # to prevent listener challenge
        self.aEnv['MOVELOCKED'] = False
        self.aEnv['KEYEVENT'] = uno.createUnoStruct("com.sun.star.awt.KeyEvent")
        self.aEnv['MOUSEEVENT'] = uno.createUnoStruct("com.sun.star.awt.MouseEvent")
        self.aEnv['L2OSTATE'] = (0, 0, 0, 0, 0) # e, i, m, p, t
        self.aEnv['VALIDLIST'] = 0
        self.aEnv['VALIDL2O'] = 0
        self.aEnv['L2OCOORD'] = {'X':0,'Y':0}
        self.aEnv['VALIDORIGIN'] = 0
        self.aEnv['ORIGINCOORD'] = {'X':0,'Y':0}
        self.aEnv['CANCELJOB'] = False
        self.aEnv['STOPJOB'] = False
        self.aEnv['REPEATMODE'] = False
        self.aEnv['ORTHOMODE'] = False
        self.aEnv['DRAWSCALE'] = float(aDocumentSettings.ScaleNumerator) / aDocumentSettings.ScaleDenominator
        self.aEnv['SCALETEXT'] = "%d : %d" % (aDocumentSettings.ScaleNumerator, aDocumentSettings.ScaleDenominator)
        self.aEnv['UNITS'] = (None, None, "mm", "cm", None, None, None, "inch", "pt", None, "m", "km", "pica", "feet", "miles")
        self.aEnv['UNITSRATIO'] = (None, None, 1e-2, 1e-3, None, None, None, 1.0/2540.0, 1.0/2540.0*72, None, 1e-5, 1e-8, 1.0/2540.0*6, 1.0/(2540.0*12), 1.0/160934400.0)
        self.aEnv['MEASUREUNIT'] = aDocumentSettings.MeasureUnit
        self.aEnv['GROUPSHAPE'] = self.aEnv['CONTROLLER'].getCurrentPage()
        self.aEnv['ZOOMVALUE'] = self.aEnv['CONTROLLER'].ZoomValue
        self.aEnv['STEP'] = 0
        self.aEnv['SHAPE'] = None
        self.aEnv['COORDS'] = None
        self.aEnv['UCS'] = None
        self.aEnv['SPOTTEDID'] = None
        self.aEnv['MAGNETSIZE'] = 16
        self.aEnv['MAGNETSHAPE'] = None
        self.aEnv['VISIBLEAREA'] = {'X':0,'Y':0, 'Width':0, 'Height':0}
        try:
            self.aEnv['STANDARDSTYLE'] = self.aEnv['MODEL'].getStyleFamilies().getByName("graphics").getByName("standard")
        except:
            self.aEnv['STANDARDSTYLE'] = None
        self.aEnv['POLICE'] = "Bitstream Vera Serif Roman"
        self.aEnv['CHARHEIGHT'] = 10.0
        self.aEnv['MAGNETCTRL'] = ("ENDCTRL", "INTERCTRL", "MIDCTRL", "PERPCTRL", "TANCTRL", "MAGNETGRPCTRL")
        self.aEnv['MAGNETKEY'] = {'ENDCTRL':516, 'INTERCTRL':520, 'MIDCTRL':524, 'PERPCTRL':527, 'TANCTRL':531} # e, i, m, p, t
        self.aEnv['CHECKBOXCTRL'] = ( "AXOCTRL", "MULTICTRL")
        self.aEnv['CHECKBOXKEY'] = {'AXOCTRL':512, 'MULTICTRL':1289} # a, *
        self.aEnv['INPUTDATAKEY'] = {'CAR':514, 'DIA':515, 'POL':522, 'LEN':523, 'RAD':529} # c, d, k, l, r
        self.aEnv['ABORTKEY'] = {'ESC':1281} # Esc
        self.aEnv['UCSKEY'] = {'DEF':515, 'USE':532}
        self.aEnv['RESERVEDKEY'] = {}
        self.aEnv['RESERVEDKEY'].update(self.aEnv['INPUTDATAKEY'])
        self.aEnv['RESERVEDKEY'].update(self.aEnv['MAGNETKEY'])
        self.aEnv['RESERVEDKEY'].update(self.aEnv['CHECKBOXKEY'])
        self.aEnv['RESERVEDKEY'].update(self.aEnv['ABORTKEY'])
        self.aEnv['RESERVEDKEY'].update(self.aEnv['UCSKEY'])
        if self.aEnv.has_key('JOINKIND'):
            self.aEnv['JOINCTRL'] = ("DIRECTCTRL", "FILLETCTRL", "CHAMFERCTRL", "JOINGRPCTRL")
            self.aEnv['JOINKEY'] = {'DIRECTCTRL':260, 'FILLETCTRL':261, 'CHAMFERCTRL':262} # 4, 5, 6
            self.aEnv['RESERVEDKEY'].update(self.aEnv['JOINKEY'])
        self.aEnv['SPOTPARM'] = ('MOUSEPARM', 'MAGNETSIZE','EDITMODE','CONTROLLER','GROUPSHAPE', 'MODE')
        for aKey in self.aEnv['SPOTPARM']:
            if not self.aEnv.has_key(aKey):
                self.aEnv[aKey] = None
        self.aEnv['POSSIZEPARM'] = ('UNOTYPE', 'MODE', 'COORDS', 'ORIGINCOORD', 'SHAPE', 'SHAPESTATUS', 'STEP', 'GROUPSHAPE', 'MODEL', 'MAGNETSIZE', 'DEVICEXSCALE', 'CIRCLEKIND', 'ENTITYPE', 'CORNERRADIUS', 'ZOOMVALUE')
        for aKey in self.aEnv['POSSIZEPARM']:
            if not self.aEnv.has_key(aKey):
                self.aEnv[aKey] = None
        self.aEnv['MOUSEPARM'] = ('ORIGINCOORD', 'VISIBLEAREA', 'MOUSEEVENT', 'DEVICEXSCALE', 'DEVICEYSCALE', 'ORTHOMODE', 'VALIDORIGIN')
        for aKey in self.aEnv['MOUSEPARM']:
            if not self.aEnv.has_key(aKey):
                self.aEnv[aKey] = None
        self.aEnv['INPUTDATAPARM'] = ('COMPONENTWINDOW', 'UNITS', 'UNITSRATIO', 'MEASUREUNIT', 'DRAWSCALE', 'UCS')
        for aKey in self.aEnv['INPUTDATAPARM']:
            if not self.aEnv.has_key(aKey):
                self.aEnv[aKey] = None
        self.setCoordTransformParams()
        # =========================================
        # access the registry - acces aux registres
        # =========================================
        self.aRegistry = self.smgr.createInstanceWithContext("com.sun.star.registry.SimpleRegistry", self.ctx)
        xPathSettings = self.smgr.createInstanceWithContext("com.sun.star.util.PathSettings", self.ctx)
        aURL = xPathSettings.UserConfig + "/cadooo.rdb"
        try:
            self.aRegistry.open(aURL, False, False)
        except InvalidRegistryException, e:
            self.aRegistry.open(aURL, False, True)
        aRootKey = self.aRegistry.getRootKey()
        # if Cadooo already running => exit
        # else => locking new command
        self.aCrashKey = aRootKey.openKey("CRASHED")
        if self.aCrashKey is None:
            self.aCrashKey = aRootKey.createKey("CRASHED")
            self.aCrashKey.setLongValue(0)
        self.aEnv['CRASHED'] = self.aCrashKey.getLongValue()
        self.aLogKey = aRootKey.openKey("LOG")
        if self.aLogKey is None:
            self.aLogKey = aRootKey.createKey("LOG")
            self.aLogKey.setStringValue("")
        self.aLockKey = aRootKey.openKey("LOCKED")
        if self.aLockKey is None:
            self.aLockKey = aRootKey.createKey("LOCKED")
        elif self.aLockKey.getLongValue():
            self.aRegistry.close()
            return aArgs
        elif self.aEnv['CRASHED']:
            xMessage = MessageBox(self.ctx)
            aText =  self.aTranslation[2] + "\nVersion " + self.aEnv['VERSION'] + "\n" + self.aLogKey.getStringValue()
            xMessage.execute(aText, "errorbox")
            self.aEnv['CRASHED'] = 0
            self.aLogKey.setStringValue("")
        self.aLockKey.setLongValue(1)
        # setting link to object state
        self.aL2OStateKey = aRootKey.openKey("L2OSTATE")
        if self.aL2OStateKey is None:
            self.aL2OStateKey = aRootKey.createKey("L2OSTATE")
            self.aL2OStateKey.setLongListValue(self.aEnv['L2OSTATE'])
        self.aEnv['L2OSTATE'] = self.aL2OStateKey.getLongListValue()
        # setting orthometric mode
        self.aOrthomodeKey = aRootKey.openKey("ORTHOMODE")
        if self.aOrthomodeKey is None:
            self.aOrthomodeKey = aRootKey.createKey("ORTHOMODE")
            self.aOrthomodeKey.setLongValue(self.aEnv['ORTHOMODE'])
        self.aEnv['ORTHOMODE'] = self.aOrthomodeKey.getLongValue()
        # setting police
        self.aPoliceKey = aRootKey.openKey("POLICE")
        if self.aPoliceKey is None:
            self.aPoliceKey = aRootKey.createKey("POLICE")
            self.aPoliceKey.setStringValue(self.aEnv['POLICE'])
        self.aEnv['POLICE'] = self.aPoliceKey.getStringValue()
        # setting char height
        self.aCharHeightKey = aRootKey.openKey("CHARHEIGHT")
        if self.aCharHeightKey is None:
            self.aCharHeightKey = aRootKey.createKey("CHARHEIGHT")
            self.aCharHeightKey.setLongValue(long(self.aEnv['CHARHEIGHT']*10))
        self.aEnv['CHARHEIGHT'] = float(self.aCharHeightKey.getLongValue()) / 10
        # setting ucs data
        self.aUcsKey = aRootKey.openKey("UCS")
        if self.aUcsKey is None:
            self.aUcsKey = aRootKey.createKey("UCS")
            self.aUcsKey.setLongListValue((self.aEnv['CONTROLLER'].CurrentPage.BorderLeft,self.aEnv['CONTROLLER'].CurrentPage.BorderTop,0,1))
        aUcs = self.aUcsKey.getLongListValue()
        self.aEnv['UCS'] = ((math.cos(math.radians(aUcs[2]/100.0)), -aUcs[3] * math.sin(math.radians(aUcs[2]/100.0)), aUcs[0]),\
                            (math.sin(math.radians(aUcs[2]/100.0)), aUcs[3] * math.cos(math.radians(aUcs[2]/100.0)), aUcs[1]),\
                            (0.0, 0.0, 1.0))
        # setting statusbar window position and size
        self.aSBWPosSizeKey = aRootKey.openKey("SBWPOSSIZE")
        if self.aSBWPosSizeKey is None:
            self.aSBWPosSizeKey = aRootKey.createKey("SBWPOSSIZE")
            self.aSBWPosSizeKey.setLongListValue((0, 0, 0, 0))
        self.aEnv['SBWPOSSIZE'] = self.aSBWPosSizeKey.getLongListValue()
        # =============================
        # create the CADOOo status bar
        # =============================
        xStatusBar = CadoooStatusBar(self.ctx)
        self.aEnv.update(xStatusBar.execute(self.aEnv))
        nEntities = self.aEnv['GROUPSHAPE'].getCount()
        # Search for ucs
        for i in range(nEntities):
            aShape = self.aEnv['GROUPSHAPE'].getByIndex(i)
            aShape.setPropertyValue("SizeProtect", True)
            aShape.setPropertyValue("MoveProtect", True)
        # 
        self.aEnv['MAGNETVISIBLE'] = False
        self.xEntityPosSize = EntityPosSize(self.ctx)
        aPosSizeParm = dict([(k, self.aEnv[k]) for k in self.aEnv['POSSIZEPARM']])
        aPosSizeParm['UNOTYPE'] = "PolyLineShape"
        aPosSizeParm['MODE'] = ('UCS', 'XAXIS', 'YAXIS')
        aPosSizeParm['COORDS'] = [[{'X': self.aEnv['UCS'][0][2], 'Y': self.aEnv['UCS'][1][2]}, {'X': self.aEnv['UCS'][0][2]+250*self.aEnv['UCS'][0][0], 'Y': self.aEnv['UCS'][1][2]+250*self.aEnv['UCS'][1][0]}],\
                   [{'X': self.aEnv['UCS'][0][2], 'Y': self.aEnv['UCS'][1][2]}, {'X': self.aEnv['UCS'][0][2]+250*self.aEnv['UCS'][0][1], 'Y': self.aEnv['UCS'][1][2]+250*self.aEnv['UCS'][1][1]}]]
        aPosSizeParm['STEP'] = 2
        aPosSizeParm.update(self.xEntityPosSize.execute(aPosSizeParm))
        if self.aEnv['STANDARDSTYLE'] is None:
            self.aEnv['STANDARDSTYLE'] = aPosSizeParm['SHAPE'].Style
        aPosSizeParm['SHAPE'].LineColor = self.aEnv['STANDARDSTYLE'].LineColor
        aPosSizeParm['SHAPE'].LineWidth = self.aEnv['STANDARDSTYLE'].LineWidth
        aPosSizeParm['SHAPE'].setName("ucs")
        self.aEnv['UCSSHAPE'] = aPosSizeParm['SHAPE']
        self.aEnv['COORDS'] = None
        sCWId = repr(self.aEnv['COMPONENTWINDOW'].ImplementationId)
        sCWId = "".join(["%02x" % ord(sCWId[p]) for p in range(len(sCWId))])
        sSBWId = repr(self.aEnv['STATUSBARWINDOW'].ImplementationId)
        sSBWId = "".join(["%02x" % ord(sSBWId[p]) for p in range(len(sSBWId))])
        self.aEnv['WINID'] = {'COMP':sCWId, 'STAT':sSBWId}
        # setting methods
        try:
            # convert shapes selection
            self.aEnv['CONTOURLIST'] = None
            from fr.free.deneux.gerard.cadooo.entitiespot import EntitieSpot
            xEntitySpot = EntitieSpot(self.ctx)
            if xEntitySpot.createEntityList(self.aEnv['CONTROLLER'], bFromSelection=True):
                self.aEnv['CONTOURLIST'] = []
                nID = None
                i = 1
                for c in xEntitySpot.aEntityList:
                    if c[1].count("Centre") == 0:
                        if c[0] == nID:
                            i += 1
                        else:
                            nID = c[0]
                            i = 1
                        self.aEnv['CONTOURLIST'].append(c + [i])
                self.aEnv['CONTROLLER'].select(None)
        except:
            f = StringIO.StringIO()
            traceback.print_exc(file=f)
            self.aEnv['CRASHED'] = 1
            self.aCrashKey.setLongValue(1)
            self.aLogKey.setStringValue(f.getvalue())
            f.close()
            self.aRegistry.close()
        else:
            self.bCoordTransformParams = False
            self.bMagListener = False
            # add item listener at the check boxes
            try:
                for aControl in self.aEnv['STATUSBARCONTROL'].itervalues():
                    aSSN = [s.split('.')[-1] for s in aControl.SupportedServiceNames]
                    if "UnoControlListBox" in aSSN or "UnoControlCheckBox" in aSSN or "UnoControlRadioButton" in aSSN:
                        aControl.addItemListener(self)
                self.aEnv['CONTROLLER'].addKeyHandler(self)
                self.aEnv['PANEWINDOW'].addMouseMotionListener(self)
                self.aEnv['CONTROLLER'].addMouseClickHandler(self)
                self.aEnv['STATUSBARWINDOW'].addKeyListener(self)
                self.aTransfParm = dict([(k, self.aEnv[k]) for k in self.aEnv['INPUTDATAPARM'][1:]])
            except:
                f = StringIO.StringIO()
                traceback.print_exc(file=f)
                self.aEnv['CRASHED'] = 1
                self.aCrashKey.setLongValue(1)
                self.aLogKey.setStringValue(f.getvalue())
                f.close()
                self.stopDrawJob()
        return self.aEnv
    #********************************
    # working on the graphical entity
    #********************************
    def mouseMoved(self, aMouseEvent):
        # esc => kill job
        if self.aEnv['CANCELJOB'] or self.aEnv['STOPJOB'] or self.aEnv['CRASHED']:
            self.stopDrawJob() 
            return
        if self.aEnv['LOCKED'] or self.aEnv['MOVELOCKED']:
            return
        else:
            self.aEnv['MOVELOCKED'] = True
        try:
            if self.aEnv['ZOOMVALUE'] != self.aEnv['CONTROLLER'].ZoomValue or not self.bCoordTransformParams:
                self.aEnv['ZOOMVALUE'] = self.aEnv['CONTROLLER'].ZoomValue
            aNewVisibleArea = self.aEnv['CONTROLLER'].VisibleArea
            if self.aEnv['VISIBLEAREA']['X'] != aNewVisibleArea.X or self.aEnv['VISIBLEAREA']['Y'] != aNewVisibleArea.Y or self.aEnv['VISIBLEAREA']['Width'] != aNewVisibleArea.Width or self.aEnv['VISIBLEAREA']['Height'] != aNewVisibleArea.Height:
                self.setCoordTransformParams()
            aWinPeer = self.aEnv['STATUSBARWINDOW']
            bWinState = aWinPeer.PosSize.X == self.aEnv['SBWPOSSIZE'][0] and aWinPeer.PosSize.Y == self.aEnv['SBWPOSSIZE'][1] and aWinPeer.PosSize.Width == self.aEnv['SBWPOSSIZE'][2] and aWinPeer.PosSize.Height == self.aEnv['SBWPOSSIZE'][3]
            if not bWinState:
                self.redrawCadoooStatusBar(True)
            aMouseParm = dict([(k, self.aEnv[k]) for k in self.aEnv['MOUSEPARM']])
            aMouseCoord = self.xCompute.transformMouseCoord(aMouseParm)
            aMouseCoord = self.xCompute.transform2UCSAndUnit(aMouseCoord, self.aTransfParm)
            aCoordCtrl = self.aEnv['STATUSBARCONTROL']['COORDCTRL']
            aCoordCtrl.setText("%s : %s ; %s X = %s , Y = %s ; %s" % (self.aTranslation[0], self.aEnv['SCALETEXT'], self.aTranslation[1], aMouseCoord['X'], aMouseCoord['Y'], self.aEnv['UNITS'][self.aEnv['MEASUREUNIT']]))
            if abs(self.aEnv['MOUSEEVENT'].X - aMouseEvent.X) <= self.aEnv['MAGNETSIZE'] and abs(self.aEnv['MOUSEEVENT'].Y - aMouseEvent.Y) <= self.aEnv['MAGNETSIZE']:
                self.aEnv['MOVELOCKED'] = False
                return
            self.aEnv['MOUSEEVENT'] = aMouseEvent
            if not self.aEnv['MAGNETSHAPE'] is None and not self.bMagListener:
                self.aEnv['MAGNETSHAPE'].addMouseListener(self)
                self.bMagListener = True
            if self.aEnv['MAGNETSHAPE'] is None and self.bMagListener:
                self.bMagListener = False
            self.aEnv.update(self.aEnv['DRAWJOB'].execute(self.aEnv))
            if self.aEnv['STEP'] and not self.aEnv['COORDS'] is None:
                aPosSizeParm = dict([(k, self.aEnv[k]) for k in self.aEnv['POSSIZEPARM']])
                self.aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
            if not self.aEnv['EXTPOSSIZE'] is None:
                if not self.aEnv['%sCOORDS' % self.aEnv['MODE'][0]] is None:
                    self.aEnv.update(self.aEnv['EXTPOSSIZE'].execute(self.aEnv))
        except:
            f = StringIO.StringIO()
            traceback.print_exc(file=f)
            self.aEnv['CRASHED'] = 1
            self.aCrashKey.setLongValue(1)
            self.aLogKey.setStringValue(f.getvalue())
            f.close()
        self.aEnv['MOVELOCKED'] = False
        return
    # **********************************
    def mouseDragged(self, aMouseEvent):
        return
    # **********************************
    def mousePressed(self, aMouseEvent):
        sId = repr(aMouseEvent.Source.ImplementationId)
        sId = "".join(["%02x" % ord(sId[p]) for p in range(len(sId))])
        aWinId = self.aEnv['WINID']
        if sId == aWinId['COMP'] or (aWinId.has_key('MAGP') and sId == aWinId['MAGP']):
            return True
        return False
    # **********************************
    def mouseReleased(self, aMouseEvent):
        sId = repr(aMouseEvent.Source.ImplementationId)
        sId = "".join(["%02x" % ord(sId[p]) for p in range(len(sId))])
        aWinId = self.aEnv['WINID']
        if sId == aWinId['COMP'] or (aWinId.has_key('MAGP') and sId == aWinId['MAGP']):
            if self.aEnv['LOCKED']:
                return True
            else:
                self.aEnv['LOCKED'] = True
            self.aEnv['MOUSEEVENT'] = aMouseEvent
            try:
                self.aEnv.update(self.aEnv['MOUSEHANDLER'].execute(self.aEnv))
            except:
                f = StringIO.StringIO()
                traceback.print_exc(file=f)
                self.aEnv['CRASHED'] = 1
                self.aCrashKey.setLongValue(1)
                self.aLogKey.setStringValue(f.getvalue())
                f.close()
            self.aEnv['LOCKED'] = False
            return True
        else:
            return False
    def mouseEntered(self, aMouseEvent):
        pass
    def mouseExited(self, aMouseEvent):
        pass
    # **********************************
    def keyPressed(self, aKeyEvent):
        sId = repr(aKeyEvent.Source.ImplementationId)
        sId = "".join(["%02x" % ord(sId[p]) for p in range(len(sId))])
        aWinId = self.aEnv['WINID']
        if (sId == aWinId['COMP'] or sId == aWinId['STAT']) and aKeyEvent.KeyCode in self.aEnv['RESERVEDKEY'].values():
            return True
        return False
    # **********************************
    def keyReleased(self, aKeyEvent):
        if not hasattr(aKeyEvent, "Source") or aKeyEvent.Source is None:
            sId = repr(self.aEnv['COMPONENTWINDOW'].ImplementationId)
            sId = "".join(["%02x" % ord(sId[p]) for p in range(len(sId))])
        else:
            sId = repr(aKeyEvent.Source.ImplementationId)
            sId = "".join(["%02x" % ord(sId[p]) for p in range(len(sId))])
        aWinId = self.aEnv['WINID']
        if (sId == aWinId['COMP'] or sId == aWinId['STAT']) and aKeyEvent.KeyCode in self.aEnv['RESERVEDKEY'].values():
            if self.aEnv['LOCKED']:
                return True
            else:
                self.aEnv['LOCKED'] = True
            try:
                aKey = self.aEnv['RESERVEDKEY'].keys()[self.aEnv['RESERVEDKEY'].values().index(aKeyEvent.KeyCode)]
                self.aEnv['KEYEVENT'] = {'COD':aKey, 'MOD':aKeyEvent.Modifiers}
                self.aEnv.update(self.aEnv['KEYHANDLER'].execute(self.aEnv))
                self.aEnv['LOCKED'] = False
            except:
                f = StringIO.StringIO()
                traceback.print_exc(file=f)
                self.aEnv['CRASHED'] = 1
                self.aCrashKey.setLongValue(1)
                self.aLogKey.setStringValue(f.getvalue())
                f.close()
            return True
        else:
            return False
    # ************************
    # Item listener
    # ************************
    def itemStateChanged(self, aItemEvent):
        if self.aEnv['LOCKED']:
            return
        else:
            self.aEnv['LOCKED'] = True
        try:
            aStatusBar = self.aEnv['STATUSBARCONTROL']
            aSSN = [s.split('.')[-1] for s in aItemEvent.Source.SupportedServiceNames]
            if "UnoControlListBox" in aSSN:
                if aStatusBar['CHARHEIGHTCTRL'].getSelectedItem() == aItemEvent.Source.getSelectedItem():
                    self.aEnv['CHARHEIGHT'] = long(aItemEvent.Source.getSelectedItem())
                else:
                    self.aEnv['POLICE'] = aItemEvent.Source.getSelectedItem()
                self.redrawCadoooStatusBar(True)
            else:
                aKeyEvent = uno.createUnoStruct("com.sun.star.awt.KeyEvent")
                for i, aKey in enumerate(self.aEnv['MAGNETCTRL'][:-1]):
                    if aStatusBar[aKey].getState() != self.aEnv['L2OSTATE'][i]:
                        aKeyEvent.KeyCode = int(self.aEnv['MAGNETKEY'][aKey])
                        break
                else:
                    if aStatusBar['AXOCTRL'].getState() != self.aEnv['ORTHOMODE']:
                        aKeyEvent.KeyCode = int(self.aEnv['CHECKBOXKEY']['AXOCTRL'])
                    elif aStatusBar['MULTICTRL'].getState() != self.aEnv['REPEATMODE']:
                        aKeyEvent.KeyCode = int(self.aEnv['CHECKBOXKEY']['MULTICTRL'])
                    elif self.aEnv.has_key('JOINKIND'):
                        if aStatusBar['DIRECTCTRL'].getState():
                            aKeyEvent.KeyCode = int(self.aEnv['JOINKEY']['DIRECTCTRL']) # NUM4
                        elif aStatusBar['FILLETCTRL'].getState():
                            aKeyEvent.KeyCode = int(self.aEnv['JOINKEY']['FILLETCTRL']) # NUM5
                        elif aStatusBar['CHAMFERCTRL'].getState():
                            aKeyEvent.KeyCode = int(self.aEnv['JOINKEY']['CHAMFERCTRL']) # NUM6
                if hasattr(aKeyEvent, "Source"):
                    aKeyEvent.Source = self.aEnv['COMPONENTWINDOW']
                self.aEnv['LOCKED'] = False
                self.keyReleased(aKeyEvent)
            self.aEnv['COMPONENTWINDOW'].setFocus()
        except:
            f = StringIO.StringIO()
            traceback.print_exc(file=f)
            self.aEnv['CRASHED'] = 1
            self.aCrashKey.setLongValue(1)
            self.aLogKey.setStringValue(f.getvalue())
            f.close()
        self.aEnv['LOCKED'] = False
        return
    # ************************************
    # coordinates tranformation parameters
    # ************************************
    def setCoordTransformParams(self):
        aNewVisibleArea = self.aEnv['CONTROLLER'].VisibleArea
        self.aEnv['DEVICEXSCALE'] = float(aNewVisibleArea.Width) / self.aEnv['PANEWINDOW'].PosSize.Width
        self.aEnv['DEVICEYSCALE'] = float(aNewVisibleArea.Height) / self.aEnv['PANEWINDOW'].PosSize.Height
        self.aEnv['BORDERCOORD'] = (self.aEnv['CONTROLLER'].CurrentPage.BorderLeft, self.aEnv['CONTROLLER'].CurrentPage.BorderTop)
        self.aEnv['VISIBLEAREA']['X'] = aNewVisibleArea.X
        self.aEnv['VISIBLEAREA']['Y'] = aNewVisibleArea.Y
        self.aEnv['VISIBLEAREA']['Width'] = aNewVisibleArea.Width
        self.aEnv['VISIBLEAREA']['Height'] = aNewVisibleArea.Height
        self.bCoordTransformParams = True
        self.aEnv['DRAWJOB'].bRedraw = True
        return
    # ************************
    # redraw cadooo status bar
    # ************************
    def redrawCadoooStatusBar(self, bForce = False):
        try:
            aWinPeer = self.aEnv['STATUSBARWINDOW']
            aDevice = aWinPeer.Toolkit.createScreenCompatibleDevice(aWinPeer.PosSize.Width, aWinPeer.PosSize.Height)
            aFontDescriptors = aDevice.getFontDescriptors()
            aFontNames = ["%s %s" % (f.Name, f.StyleName) for f in aFontDescriptors]
            if self.aEnv['POLICE'] in aFontNames:
                aFont = aDevice.getFont(aFontDescriptors[aFontNames.index(self.aEnv['POLICE'])])
            else:
                aFont = aDevice.getFont(aFontDescriptors[0])
                self.aEnv['POLICE'] = aFontNames[0]
            aWidth = []
            aStatusBar = self.aEnv['STATUSBARCONTROL']
            # +++++++++++++++++++++++++++
            # Redraw char height list box
            aControl = aStatusBar['CHARHEIGHTCTRL']
            aControl.Model.FontDescriptor = aFont.FontDescriptor
            aControl.Model.FontHeight = self.aEnv['CHARHEIGHT']
            aWidth.append(aControl.MinimumSize.Width)
            # ------------ resizing of window
            nBarHeight = aControl.MinimumSize.Height * 3
            bWinState = aWinPeer.PosSize.X == self.aEnv['SBWPOSSIZE'][0] and aWinPeer.PosSize.Y == self.aEnv['SBWPOSSIZE'][1] and aWinPeer.PosSize.Width == self.aEnv['SBWPOSSIZE'][2] and aWinPeer.PosSize.Height == self.aEnv['SBWPOSSIZE'][3]
            if bWinState and not bForce:
                return
            aRect = {'X':0, 'Y':0, 'Width':0, 'Height':0}
            aRect['X'], aRect['Y'], aRect['Width'], aRect['Height'] = aWinPeer.PosSize.X, aWinPeer.PosSize.Y, aWinPeer.PosSize.Width, aWinPeer.PosSize.Height
            aWinPeer.setPosSize(aRect['X'], aRect['Y'], aRect['Width'], aRect['Height'], 15)
            self.aEnv['SBWPOSSIZE'] = (aRect['X'], aRect['Y'], aRect['Width'], aRect['Height'])
            aPeer = aControl.getPeer()
            aPeer.setPosSize(aRect['Width']-sum(aWidth), 0, aWidth[-1], aControl.MinimumSize.Height, 15)
            # ++++++++++++++++++++++
            # redraw police list box
            aControl = aStatusBar['POLICECTRL']
            aControl.Model.FontDescriptor = aFont.FontDescriptor
            aControl.Model.FontHeight = self.aEnv['CHARHEIGHT']
            aWidth.append(aControl.MinimumSize.Width)
            aPeer = aControl.getPeer()
            aPeer.setPosSize(aRect['Width']-sum(aWidth), 0, aWidth[-1], aControl.MinimumSize.Height, 15)
            # +++++++++++++++++
            # redraw fixed text
            aControl = aStatusBar['COORDCTRL']
            aControl.Model.FontDescriptor = aFont.FontDescriptor
            aControl.Model.FontHeight = self.aEnv['CHARHEIGHT']
            aWidth.append(aControl.MinimumSize.Width)
            aPeer = aControl.getPeer()
            aPeer.setPosSize(aRect['Width']-sum(aWidth), 0, aWidth[-1], aControl.MinimumSize.Height, 15)
            # +++++++++++++++++
            # redraw fixed text
            aControl = aStatusBar['INFOCTRL']
            aControl.Model.FontDescriptor = aFont.FontDescriptor
            aControl.Model.FontHeight = self.aEnv['CHARHEIGHT']
            aPeer = aControl.getPeer()
            aPeer.setPosSize(0, 0, aRect['Width']-sum(aWidth), aControl.MinimumSize.Height, 15)
            aWidth = []
            # +++++++++++++++++++++++++++++++++++++++
            # redraw magnet check boxes and group box
            for aKey in self.aEnv['MAGNETCTRL'][:-1]:
                aControl = aStatusBar[aKey]
                aControl.Model.FontDescriptor = aFont.FontDescriptor
                aControl.Model.FontHeight = self.aEnv['CHARHEIGHT']
                aPeer = aControl.getPeer()
                aPeer.setPosSize(sum(aWidth) + 5, nBarHeight-aControl.MinimumSize.Height-2, aControl.MinimumSize.Width, aControl.MinimumSize.Height, 15)
                aWidth.append(aControl.MinimumSize.Width)
            aControl = aStatusBar[self.aEnv['MAGNETCTRL'][-1]]
            aControl.Model.FontDescriptor = aFont.FontDescriptor
            aControl.Model.FontHeight = self.aEnv['CHARHEIGHT']
            aPeer = aControl.getPeer()
            aPeer.setPosSize(0, aStatusBar['INFOCTRL'].MinimumSize.Height, sum(aWidth)+5, nBarHeight-aStatusBar['INFOCTRL'].MinimumSize.Height, 15)
            # ++++++++++++++++++++++++
            # redraw other check boxes
            for aKey in self.aEnv['CHECKBOXCTRL']:
                aControl = aStatusBar[aKey]
                aControl.Model.FontDescriptor = aFont.FontDescriptor
                aControl.Model.FontHeight = self.aEnv['CHARHEIGHT']
                aPeer = aControl.getPeer()
                aPeer.setPosSize(sum(aWidth) + 5, nBarHeight-aControl.MinimumSize.Height-2, aControl.MinimumSize.Width, aControl.MinimumSize.Height, 15)
                aWidth.append(aControl.MinimumSize.Width)
            # :::::::::::::::::::::::::::::
            if self.aEnv.has_key('JOINKIND'):
                for aKey in self.aEnv['JOINCTRL'][:-1]:
                    aControl = aStatusBar[aKey]
                    aControl.Model.FontDescriptor = aFont.FontDescriptor
                    aControl.Model.FontHeight = self.aEnv['CHARHEIGHT']
                    aPeer = aControl.getPeer()
                    aPeer.setPosSize(sum(aWidth) + 10, nBarHeight-aControl.MinimumSize.Height-2, aControl.MinimumSize.Width, aControl.MinimumSize.Height, 15)
                    aWidth.append(aControl.MinimumSize.Width)
                aControl = aStatusBar[self.aEnv['JOINCTRL'][-1]]
                aControl.Model.FontDescriptor = aFont.FontDescriptor
                aControl.Model.FontHeight = self.aEnv['CHARHEIGHT']
                aPeer = aControl.getPeer()
                aPeer.setPosSize(sum(aWidth[:-3])+5, aControl.MinimumSize.Height, sum(aWidth[-3:])+5, nBarHeight-aControl.MinimumSize.Height, 15)
            self.setCoordTransformParams()
        except:
            f = StringIO.StringIO()
            traceback.print_exc(file=f)
            self.aEnv['CRASHED'] = 1
            self.aCrashKey.setLongValue(1)
            self.aLogKey.setStringValue(f.getvalue())
            f.close()
        return
    # ************************
    # Job cleaning
    # ************************
    def stopDrawJob(self):
        self.aL2OStateKey.setLongListValue(self.aEnv['L2OSTATE'])
        self.aOrthomodeKey.setLongValue(self.aEnv['ORTHOMODE'])
        self.aPoliceKey.setStringValue(self.aEnv['POLICE'])
        self.aCharHeightKey.setLongValue(long(self.aEnv['CHARHEIGHT']*10))
        self.aLockKey.setLongValue(0)
        self.aUcsKey.setLongListValue((self.aEnv['UCS'][0][2],\
                                       self.aEnv['UCS'][1][2],\
                                       long(round(math.degrees(math.atan2(self.aEnv['UCS'][1][0], self.aEnv['UCS'][0][0])) * 100.0)),\
                                       long(round(self.aEnv['UCS'][0][0] * self.aEnv['UCS'][1][1] - self.aEnv['UCS'][1][0] * self.aEnv['UCS'][0][1]))))
        self.aSBWPosSizeKey.setLongListValue(self.aEnv['SBWPOSSIZE'])
        self.aCrashKey.setLongValue(self.aEnv['CRASHED'])
        self.aRegistry.close()
        nBarHeight = self.aEnv['STATUSBARWINDOW'].PosSize.Height
        self.aEnv['L2OSTATE'] = (0, 0, 0, 0, 0)
        self.aEnv['ENTITYPE'] = 'NONE'
        self.aEnv['VALIDORIGIN'] = 0
        self.aEnv['VALIDLIST'] = 0
        self.aEnv['GROUPSHAPE'] = self.aEnv['CONTROLLER'].getCurrentPage()
        self.aEnv['STEP'] = 0
        if not self.aEnv['MAGNETSHAPE'] is None:
            aPeer = self.aEnv['MAGNETSHAPE'].getPeer()
            aPeer.dispose()
            self.aEnv['MAGNETSHAPE'].setModel(None)
            self.aEnv['MAGNETSHAPE'] = None
        self.aEnv['MODEL'].setModified(True)
        nEntities = self.aEnv['GROUPSHAPE'].getCount()
        aUcsShape = None
        for i in range(nEntities):
            aShape = self.aEnv['GROUPSHAPE'].getByIndex(i)
            aShape.setPropertyValue("SizeProtect", False)
            aShape.setPropertyValue("MoveProtect", False)
        if not self.aEnv['UCSSHAPE'] is None:
            self.aEnv['GROUPSHAPE'].remove(self.aEnv['UCSSHAPE'])
        for aControl in self.aEnv['STATUSBARCONTROL'].itervalues():
            aPeer = aControl.getPeer()
            aSSN = [s.split('.')[-1] for s in aControl.SupportedServiceNames]
            if "UnoControlListBox" in aSSN or "UnoControlCheckBox" in aSSN or "UnoControlRadioButton" in aSSN:
                aControl.removeItemListener(self)
            aControl.setModel(None)
            aPeer.dispose()
        self.aEnv['STATUSBARCONTROL'] = None
        self.aEnv['STATUSBARWINDOW'].removeKeyListener(self)
        self.aEnv['STATUSBARWINDOW'].setVisible(False)
        self.aEnv['STATUSBARWINDOW'].dispose()
        self.desktop.Frames.remove(self.aEnv['STATUSBARFRAME'])
        self.aEnv['STATUSBARFRAME'] = None
        if self.aEnv['CANCELJOB']:
            if self.aEnv['SHAPE']:
                self.aEnv['GROUPSHAPE'].remove(self.aEnv['SHAPE'])
        elif self.aEnv['STOPJOB']:
            if not self.aEnv['SHAPE'] is None:
                self.aEnv['SHAPE'].setName("")
        self.aEnv['CONTROLLER'].removeKeyHandler(self)
        self.aEnv['PANEWINDOW'].removeMouseMotionListener(self)
        self.aEnv['CONTROLLER'].removeMouseClickHandler(self)
        self.aEnv['STATUSBARWINDOW'].removeKeyListener(self)
        return
    # XEventListener 
    def disposing(self, eventObject):
        return
