# $Id$
# -*- coding: latin-1 -*-
## last change samedi 13 juin 2009, 10:54:31 (UTC+0200)
## ********************************************************************************
## 
## Copyright (C) 2005-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    from com.sun.star.drawing.CircleKind import FULL, SECTION, CUT, ARC
    import math
except ImportError:
    print "probleme d'import"
#======================================================
# a class to cut an entity
# une classe pour couper une entit
#======================================================
class CutDraw():
    """Coupe une entite graphique
    cuts a graphical entity"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.entitiespot
        import fr.free.deneux.gerard.cadooo.compute
        import fr.free.deneux.gerard.cadooo.msgl10n
        self.ctx = ctx
        self.xEntitySpot = fr.free.deneux.gerard.cadooo.entitiespot.EntitieSpot(self.ctx)
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute(self.ctx)
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n(self.ctx)
        sTextList = tuple(["gp%d" % i for i in range(5)])
        self.sEntity = xMsgL10n.getText(sTextList)
        self.bRedraw = False
    # ==============================
    def execute(self, aNamedValues):
        self.aEnv = {}
        self.aEnv.update(aNamedValues)
        if self.bRedraw:
            self.xEntitySpot.bValidList = False
            self.bRedraw = False
        aSpotParm = dict([(k, self.aEnv[k]) for k in (self.aEnv['SPOTPARM']+self.aEnv['MOUSEPARM'])])
        self.aEnv.update(self.xEntitySpot.execute(aSpotParm))
        self.aEnv['SPOTTEDSHAPE'] = self.xEntitySpot.aSpottedShape
        self.aEnv['SPLITTEDSHAPE'] = self.xEntitySpot.aSplittedShape
        self.aEnv['BORDERLIST'] = self.xEntitySpot.aBorderList
        # +++++++++++++++++++++++++++++++++++++++
        if not self.xEntitySpot.aSpottedShape is None:
            aShape = self.aEnv['GROUPSHAPE'].getByIndex(self.xEntitySpot.aSpottedShape[0][-1])
            aType = aShape.getShapeType().split('.')[-1]
            sType = self.sEntity[["LineShape", "CircleShape", "ArcCircleShape", "EllipseShape", "ArcEllipseShape"].index(self.xEntitySpot.aSpottedShape[1])]
            # -----------------------------------------------------------------------------------------
            if self.aEnv['SPOTTEDID'] != self.xEntitySpot.aSpottedShape[0]+(self.xEntitySpot.aSpottedShape[-1],):
                self.removeTempShape()
                self.aEnv['SPOTTEDID'] = self.xEntitySpot.aSpottedShape[0][:] + (self.xEntitySpot.aSpottedShape[-1],)
                self.aEnv['COORDS'] = [[]]
                # ---------------------------------------------------
                if self.xEntitySpot.aSpottedShape[1] in ('LineShape',): # is it a line ?
                    self.aEnv['UNOTYPE'] = "LineShape"
                    self.aEnv['ENTITYPE'] = "LINE"
                    self.aEnv['STEP'] = 1
                    self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("VERTEX",)
                    # ---------------------------------------
                    if self.xEntitySpot.aBorderList['IOB']['DELTA'] >= 0: # does a in origin border exist ?
                        self.aEnv['COORDS'][0].append({'X':0, 'Y':0})
                        self.aEnv['COORDS'][0][-1]['X'] = self.xEntitySpot.aBorderList['IOB']['X']
                        self.aEnv['COORDS'][0][-1]['Y'] = self.xEntitySpot.aBorderList['IOB']['Y']
                    # ------------------------------------
                    else :
                        self.aEnv['COORDS'][0].append(self.xEntitySpot.aSpottedShape[2])
                    # ---------------------------------------
                    if self.xEntitySpot.aBorderList['IEB']['DELTA'] >= 0: # does a in end border exist ?
                        self.aEnv['COORDS'][0].append({'X':0, 'Y':0})
                        self.aEnv['COORDS'][0][-1]['X'] = self.xEntitySpot.aBorderList['IEB']['X']
                        self.aEnv['COORDS'][0][-1]['Y'] = self.xEntitySpot.aBorderList['IEB']['Y']
                    # ------------------------------------
                    else:
                        self.aEnv['COORDS'][0].append(self.xEntitySpot.aSpottedShape[3])
                # ---------------------------------------------------------------------------------------------------------
                elif self.xEntitySpot.aSpottedShape[1] in ("CircleShape", "ArcCircleShape", "EllipseShape", "ArcEllipseShape"):
                    self.aEnv['UNOTYPE'] = "EllipseShape"
                    self.aEnv['COORDS'][0].extend([{'X':0, 'Y':0} for i in range(4)])
                    self.aEnv['COORDS'][0][0]['X'] = self.xEntitySpot.aSpottedShape[2]['X']
                    self.aEnv['COORDS'][0][0]['Y'] = self.xEntitySpot.aSpottedShape[2]['Y']
                    # -------------------- arc produced ------------------------------------
                    if self.xEntitySpot.aSpottedShape[1] in ("CircleShape", "ArcCircleShape"):
                        self.aEnv['ENTITYPE'] = "ARC"
                        self.aEnv['STEP'] = 3
                        self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("RADIUS", "STARTANGLE", "ENDANGLE")
                    # arc of ellipse produced
                    else:
                        self.aEnv['ENTITYPE'] = "ELLARC"
                        self.aEnv['STEP'] = 4
                        self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("RADIUS", "RADIUS2", "STARTANGLE", "ENDANGLE")
                        self.aEnv['COORDS'][0].append({'X':0, 'Y':0})
                        aPoint = self.xCompute.getPointOnEllipse( None, math.pi/2, *self.xEntitySpot.aSpottedShape[2:5])[0]
                        self.aEnv['COORDS'][0][2]['X'] = aPoint['X']
                        self.aEnv['COORDS'][0][2]['Y'] = aPoint['Y']
                    aPoint = self.xCompute.getPointOnEllipse( None, float(0), *self.xEntitySpot.aSpottedShape[2:5])[0]
                    self.aEnv['COORDS'][0][1]['X'] = aPoint['X']
                    self.aEnv['COORDS'][0][1]['Y'] = aPoint['Y']
                    # ---------------------------------------
                    if self.xEntitySpot.aBorderList['IOB']['DELTA'] >= 0: # does a in origin border exist ?
                        self.aEnv['COORDS'][0][-2]['X'] = self.xEntitySpot.aBorderList['IOB']['X']
                        self.aEnv['COORDS'][0][-2]['Y'] = self.xEntitySpot.aBorderList['IOB']['Y']
                    # ---
                    else:
                        aPoint = self.xCompute.getPointOnEllipse( None, self.xEntitySpot.aSpottedShape[5], *self.xEntitySpot.aSpottedShape[2:5])[0]
                        self.aEnv['COORDS'][0][-2]['X'] = aPoint['X']
                        self.aEnv['COORDS'][0][-2]['Y'] = aPoint['Y']
                    # ---------------------------------------
                    if self.xEntitySpot.aBorderList['IEB']['DELTA'] >= 0: # does a in end border exist ?
                        self.aEnv['COORDS'][0][-1]['X'] = self.xEntitySpot.aBorderList['IEB']['X']
                        self.aEnv['COORDS'][0][-1]['Y'] = self.xEntitySpot.aBorderList['IEB']['Y']
                    # ---
                    else:
                        aPoint = self.xCompute.getPointOnEllipse( None, self.xEntitySpot.aSpottedShape[6], *self.xEntitySpot.aSpottedShape[2:5])[0]
                        self.aEnv['COORDS'][0][-1]['X'] = aPoint['X']
                        self.aEnv['COORDS'][0][-1]['Y'] = aPoint['Y']
                    if not aType in ("RectangleShape",) and aShape.CircleKind in (ARC, CUT, SECTION):
                        self.aEnv['CIRCLEKIND'] = aShape.CircleKind
                    else:
                        self.aEnv['CIRCLEKIND'] = ARC
            else:
                self.aEnv['STEP'] = 0
        else:
            sType = "----"
            self.aEnv['STEP'] = 0
            self.removeTempShape()
        sText = "%s ==> %s" % (self.aEnv['COMMENT'][0], sType)
        aInfoCtrl = dict(self.aEnv['STATUSBARCONTROL'])['INFOCTRL']
        aInfoCtrl.setText(sText)
        self.aEnv['SHAPESTATUS'] = "transient"
        return self.aEnv
    # ----------------------
    # remove temporary shape
    # ----------------------
    def removeTempShape(self):
        if not self.aEnv['SHAPE'] is None:
            aGroupShape = self.aEnv['CONTROLLER'].CurrentPage
            if len(self.aEnv['SPOTTEDID']) > 2:
                for i in self.aEnv['SPOTTEDID'][:-2]:
                    aGroupShape = aGroupShape.getByIndex(i)
            aGroupShape.remove(self.aEnv['SHAPE'])
            self.aEnv['SHAPE'] = None
            self.aEnv['SPOTTEDID'] = None
        return
