#	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## 
## Copyright (C) 2006-2009 Grard Deneux lundi 2 mars 2009, 18:01:57 (UTC+0100)
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math, uno
    from com.sun.star.awt.KeyModifier import SHIFT
except ImportError:
    print "probleme d'import"
#===============================
# gestion des evenements clavier
# handling keyboard events
#===============================
class CutKeyHandler():
    """gestion des evenements clavier
    handling keyboard events"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.entityposize
        import fr.free.deneux.gerard.cadooo.compute
        self.ctx = ctx
        # Datum needed by coordinates input form
        self.aCoordData = {}
        self.aCoordData["TITLE"]  = "No Title"
        self.aCoordData["FLAG"] = 0
        self.aCoordData["COMMENT"] = "No comment"
        self.aCoordData["X"] = 0
        self.aCoordData["XUNIT"] = "m"
        self.aCoordData["Y"] = 0
        self.aCoordData["YUNIT"] = "m"
        self.aCoordData["RETURN"] = False
        self.xEntityPosSize = fr.free.deneux.gerard.cadooo.entityposize.EntityPosSize( self.ctx)
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute( self.ctx)
    # ==================================
    # actions clavier - keyboard actions
    # aArgs as tuple of NamedValue
    #   Name         Value
    # KEYCODE     integer
    # DRAWSCALE
    # COORDS
    # STEP
    # DRAWSCALE
    # CANCELJOB
    # ORTHOMODE
    # SHAPE
    # ==================================
    def execute(self, aArgs):
        aEnv = {}
        aEnv.update(aArgs)
        lKey = aEnv['MAGNETKEY'].keys()
        lKey.sort()
        # ---------------------------------------------------
        if aEnv['KEYEVENT']['COD'] in lKey and not aEnv['KEYEVENT']['MOD']:
            # e,   i,   m,   p,   t => link 2 entities
            i = lKey.index(aEnv['KEYEVENT']['COD'])
            bKHState = list(aEnv['L2OSTATE'])
            bKHState[i] = not bKHState[i]
            aEnv['L2OSTATE'] = tuple(bKHState)
            aStatusBarCheckBox = aEnv['STATUSBARCONTROL'][aEnv['KEYEVENT']['COD']]
            if aStatusBarCheckBox.getState() != aEnv['L2OSTATE'][i]:
                aStatusBarCheckBox.setState(aEnv['L2OSTATE'][i])
        # ----------------------------------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('LEN',) and not aEnv['KEYEVENT']['MOD'] and aEnv['SPOTTEDSHAPE']:
            # ..............................l
            import fr.free.deneux.gerard.cadooo.msgl10n
            xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
            i = aEnv['SPOTTEDSHAPE'][0][-1]
            aShape = aEnv['GROUPSHAPE'].getByIndex(i)
            aType = aShape.getShapeType().split('.')[-1]
            aStyle = aShape.Style
            # ---------------------------------------------
            if aEnv['SPOTTEDSHAPE'][1] in ("LineShape",):
                import fr.free.deneux.gerard.cadooo.datainputbox
                sTextList = ("k0", "k1")
                aText = xMsgL10n.getText(sTextList)
                aCoords = uno.createUnoStruct("com.sun.star.awt.Point")
                nLength = self.xCompute.toPolarCoord(*aEnv['SPOTTEDSHAPE'][2:4])[0]
                xCoordInput = fr.free.deneux.gerard.cadooo.datainputbox.DataInputBox( self.ctx)
                self.aCoordData["TITLE"]  = aText[0]
                self.aCoordData["FLAG"] = 0
                self.aCoordData["COMMENT"] = aText[1]
                self.aCoordData["RETURN"] = False
                self.aCoordData["X"] = self.xCompute.transform2UserUnit(nLength, aEnv['UNITS'], aEnv['UNITSRATIO'], aEnv['MEASUREUNIT'], aEnv['DRAWSCALE'])
                aInputData = dict([(k, aEnv[k]) for k in aEnv['INPUTDATAPARM']])
                self.aCoordData.update(aInputData)
                self.aCoordData.update(xCoordInput.execute(self.aCoordData))
                # ---------------------------
                if self.aCoordData["RETURN"]:
                    nDist = self.aCoordData['X']
                    # ------
                    if nDist:
                        aEnv['GROUPSHAPE'].remove(aEnv['SHAPE'])
                        aEnv['SHAPE'] = None
                        fK = float(nLength - nDist) / nLength
                        aCoords.X = aEnv['SPOTTEDSHAPE'][2]['X'] + long(fK * (aEnv['SPOTTEDSHAPE'][3]['X'] - aEnv['SPOTTEDSHAPE'][2]['X']))
                        aCoords.Y = aEnv['SPOTTEDSHAPE'][2]['Y'] + long(fK * (aEnv['SPOTTEDSHAPE'][3]['Y'] - aEnv['SPOTTEDSHAPE'][2]['Y']))
                        # -------------------------
                        if aType in ("LineShape",):
                            aShape.PolyPolygon = ((aCoords, aShape.PolyPolygon[0][1]),)
                        # --------------------------------
                        elif aType in ("RectangleShape",):
                            i = 1
                            # ----------------------------------
                            for aSplit in aEnv['SPLITTEDSHAPE']:
                                # --------------------------
                                if aSplit[1] == "LineShape":
                                    aEnv['COORDS'] = [[{'X': 0, 'Y': 0}, {'X': 0, 'Y': 0}]]
                                    aEnv['UNOTYPE'] = "LineShape"
                                    aEnv['ENTITYPE'] = "LINE"
                                    aEnv['STEP'] = 1
                                    aEnv['MODE'] = (aEnv['MODE'][0],) + ("VERTEX",)
                                    # -----------------------------------------
                                    if i != aEnv['SPOTTEDSHAPE'][-1]: # to do ?
                                        aEnv['COORDS'][0][0]['X'], aEnv['COORDS'][0][0]['Y'] = aSplit[2]['X'], aSplit[2]['Y']
                                        aEnv['COORDS'][0][1]['X'], aEnv['COORDS'][0][1]['Y'] = aSplit[3]['X'], aSplit[3]['Y']
                                    else:
                                        aEnv['COORDS'][0][0]['X'], aEnv['COORDS'][0][0]['Y'] = aCoords.X, aCoords.Y
                                        aEnv['COORDS'][0][1]['X'], aEnv['COORDS'][0][1]['Y'] = aSplit[3]['X'], aSplit[3]['Y']
                                # ----------------------------------
                                elif aSplit[1].count("Centre") == 0:
                                    aEnv['UNOTYPE'] = "EllipseShape"
                                    aEnv['ENTITYPE'] = "ARC"
                                    aEnv['STEP'] = 3
                                    aEnv['MODE'] = (aEnv['MODE'][0],) + ("RADIUS", "STARTANGLE", "ENDANGLE")
                                    aEnv['COORDS'] = [[{'X': 0, 'Y': 0} for j in range(4)]]
                                    aEnv['COORDS'][0][0]['X'], aEnv['COORDS'][0][0]['Y'] = aSplit[2]['X'], aSplit[2]['Y']
                                    nRadius = aSplit[3]['Width']
                                    aEnv['COORDS'][0][1]['X'], aEnv['COORDS'][0][1]['Y'] = aSplit[2]['X'] + nRadius, aSplit[2]['Y']
                                    aEnv['COORDS'][0][2]['X'] = aSplit[2]['X'] + nRadius * math.cos(aSplit[5])
                                    aEnv['COORDS'][0][2]['Y'] = aSplit[2]['Y'] - nRadius * math.sin(aSplit[5])
                                    aEnv['COORDS'][0][3]['X'] = aSplit[2]['X'] + nRadius * math.cos(aSplit[6])
                                    aEnv['COORDS'][0][3]['Y'] = aSplit[2]['Y'] - nRadius * math.sin(aSplit[6])
                                # --------------------------------
                                if aSplit[1].count("Centre") == 0:
                                    aEnv['SHAPESTATUS'] = "new"
                                    aPosSizeParm = dict([(k, aEnv[k]) for k in aEnv['POSSIZEPARM']])
                                    aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                                    aEnv['SHAPE'].Style = aStyle
                                    aEnv['SHAPE'].setName("")
                                    aEnv['SHAPE'] = None
                                    i = i + 1
                            aEnv['GROUPSHAPE'].remove(aShape)
                        # --------------------------------------------------
                        elif aType in ("PolyLineShape", "PolyPolygonShape"):
                            idx = 0
                            aEnv['COORDS'] = []
                            # ------------------------------------
                            for aPolygon in aShape.PolyPolygon[:]:
                                aEnv['COORDS'].append([])
                                # ------------------------------
                                for i in range(len(aPolygon)-1):
                                    aEnv['COORDS'][-1].append({'X': 0, 'Y': 0})
                                    idx = idx + 1
                                    # ---------------------------------
                                    if aEnv['SPOTTEDSHAPE'][-1] == idx:
                                        aEnv['COORDS'][-1][-1]['X'] = aCoords.X
                                        aEnv['COORDS'][-1][-1]['Y'] = aCoords.Y
                                    else:
                                        aEnv['COORDS'][-1][-1]['X'] = aPolygon[i].X
                                        aEnv['COORDS'][-1][-1]['Y'] = aPolygon[i].Y
                                else:
                                    aEnv['COORDS'][-1].append({'X': 0, 'Y': 0})
                                    # ------------------------------------------------------------------------------
                                    if aType in ("PolyPolygonShape",) and aEnv['SPOTTEDSHAPE'][-1] == len(aPolygon):
                                        aEnv['COORDS'][-1][-1]['X'] = aCoords.X
                                        aEnv['COORDS'][-1][-1]['Y'] = aCoords.Y
                                    else:
                                        aEnv['COORDS'][-1][-1]['X'] = aPolygon[-1].X
                                        aEnv['COORDS'][-1][-1]['Y'] = aPolygon[-1].Y
                            aShapeCoords = tuple([tuple([uno.createUnoStruct("com.sun.star.awt.Point") for c in l]) for l in aEnv['COORDS']])
                            for i in range(len(aEnv['COORDS'])):
                                for j in range(len(aEnv['COORDS'][i])):
                                    aShapeCoords[i][j].X, aShapeCoords[i][j].Y = aEnv['COORDS'][i][j]['X'], aEnv['COORDS'][i][j]['Y']
                            aShape.PolyPolygon = aShapeCoords
                            aEnv['COORDS'] = None
            # ---------------------------------------------
            if aEnv['SPOTTEDSHAPE'][1] in ("ArcEllipseShape", "ArcCircleShape"):
                import fr.free.deneux.gerard.cadooo.datainputbox
                sTextList = ("k0", "k5")
                aText = xMsgL10n.getText(sTextList)
                aCoords = {'X': 0, 'Y': 0}
                xCoordInput = fr.free.deneux.gerard.cadooo.datainputbox.DataInputBox( self.ctx)
                self.aCoordData["TITLE"]  = aText[0]
                self.aCoordData["FLAG"] = 4
                self.aCoordData["COMMENT"] = aText[1]
                self.aCoordData["RETURN"] = False
                self.aCoordData["Y"] = math.degrees(self.xCompute.getPointOnEllipse( None, aEnv['SPOTTEDSHAPE'][5], *aEnv['SPOTTEDSHAPE'][2:5])[1])
                aInputData = dict([(k, aEnv[k]) for k in aEnv['INPUTDATAPARM']])
                self.aCoordData.update(aInputData)
                self.aCoordData.update(xCoordInput.execute(self.aCoordData))
                # ---------------------------
                if self.aCoordData["RETURN"]:
                    aEnv['GROUPSHAPE'].remove(aEnv['SHAPE'])
                    aEnv['SHAPE'] = None
                    fAngle = self.aCoordData["Y"]
                    aShape.CircleStartAngle = long(round(math.degrees(self.xCompute.getPointOnEllipse( fAngle, None, *aEnv['SPOTTEDSHAPE'][2:5])[1]) * 100))
            # ----------------------------
            if aEnv['REPEATMODE']: # repeat mode on ?
                aEnv['VALIDLIST'] = False
                aEnv['SHAPE'] = None
                aEnv['GROUPSHAPE'] = aEnv['CONTROLLER'].getCurrentPage()
            else:
                aEnv['STOPJOB'] = True
        # --------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('ESC',) and not aEnv['KEYEVENT']['MOD']:
            #                                 Esc => kill job
            aEnv['CANCELJOB'] = True
        # -------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('AXOCTRL',) and not aEnv['KEYEVENT']['MOD']:
            #                                  a => axonometric mode
            aEnv['ORTHOMODE'] = not aEnv['ORTHOMODE']
            aStatusBarCheckBox = aEnv['STATUSBARCONTROL']['AXOCTRL']
            if aStatusBarCheckBox.getState() != aEnv['ORTHOMODE']:
                aStatusBarCheckBox.setState(aEnv['ORTHOMODE'])
        # --------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('MULTICTRL',) and not aEnv['KEYEVENT']['MOD']:
            #                                  * => repeat mode
            aEnv['REPEATMODE'] = not aEnv['REPEATMODE']
            aStatusBarCheckBox = aEnv['STATUSBARCONTROL']['MULTICTRL']
            if aStatusBarCheckBox.getState() != aEnv['REPEATMODE']:
                aStatusBarCheckBox.setState(aEnv['REPEATMODE'])
        return aEnv
