# $Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## samedi 13 juin 2009, 11:01:32 (UTC+0200)
## Copyright (C) 2006-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math
    from types import *
    from com.sun.star.drawing.CircleKind import ARC
except ImportError:
    print "probleme d'import"
# ===================================================
# Gerer les saisies de points et validation d'entites
# Handle points inputs and entities validation
# ===================================================
class CutMouseHandler():
    """Gere les saisies de points et validation d'entite
    Handles points inputs and entities validation"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.entityposize
        import fr.free.deneux.gerard.cadooo.compute
        self.ctx = ctx
        self.xEntityPosSize = fr.free.deneux.gerard.cadooo.entityposize.EntityPosSize( self.ctx)
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute( self.ctx)
    # **********************************
    # Handles mouse clicks
    # MOUSEEVENT  struct MouseEvent
    # CANCELJOB   integer (0 or 1)
    # STEP
    # COORDS
    # REPEATMODE
    # SHAPE
    # **********************************
    def execute(self, aArgs):
        aEnv = {}
        aEnv.update(aArgs)
        nPrecis = 0
        # ----------------------------------------
        if aEnv['MOUSEEVENT'].Buttons > 1: # don't handle mouse buttons but left
            return aEnv
        # --------------------------------------------
        if aEnv['MOUSEEVENT'].ClickCount == 1: # one click ?
            # --------edit the spotted shape if one------------------
            if not aEnv['SPOTTEDSHAPE'] is None:
                i = aEnv['SPOTTEDSHAPE'][0][-1]
                aShape = aEnv['GROUPSHAPE'].getByIndex(i)
                aType = aShape.getShapeType().split('.')[-1]
                aStyle = aShape.Style
                aCoords = [{'X': 0, 'Y':0} for i in range(2)]
                aEnv['GROUPSHAPE'].remove(aEnv['SHAPE'])
                aEnv['SHAPE'] = None
                # ----------------------------------------------------------
                if aType in ("LineShape", "EllipseShape", "RectangleShape"):
                    # ---------------------------------------------------------------------------------------
                    if aEnv['SPOTTEDSHAPE'][1] in ("LineShape", "ArcCircleShape", "ArcEllipseShape"):
                        # -------------------------------------------
                        if aEnv['SPOTTEDSHAPE'][1] == "LineShape":
                            aCoords[0]['X'], aCoords[0]['Y'] = aEnv['SPOTTEDSHAPE'][2]['X'], aEnv['SPOTTEDSHAPE'][2]['Y']
                            aCoords[1]['X'], aCoords[1]['Y'] = aEnv['SPOTTEDSHAPE'][3]['X'], aEnv['SPOTTEDSHAPE'][3]['Y']
                        # ---
                        else:
                            aPoint = self.xCompute.getPointOnEllipse( None, aEnv['SPOTTEDSHAPE'][5], *aEnv['SPOTTEDSHAPE'][2:5])[0]
                            aCoords[0]['X'], aCoords[0]['Y'] = aPoint['X'], aPoint['Y']
                            aPoint = self.xCompute.getPointOnEllipse( None, aEnv['SPOTTEDSHAPE'][6], *aEnv['SPOTTEDSHAPE'][2:5])[0]
                            aCoords[1]['X'], aCoords[1]['Y'] = aPoint['X'], aPoint['Y']
                            if aType in ("RectangleShape",):
                                aEnv['CIRCLEKIND'] = ARC
                            else:
                                aEnv['CIRCLEKIND'] = aShape.CircleKind
                        # -----------------------
                        for k, i, j in (('IOB', -2, -1),('IEB', -1, -2)):
                            # ---------------------------------------
                            if aEnv['BORDERLIST'][k]['DELTA'] >= nPrecis:
                                aEnv['COORDS'][0][i]['X'], aEnv['COORDS'][0][i]['Y'] = aCoords[i]['X'], aCoords[i]['Y']
                                aEnv['COORDS'][0][j]['X'], aEnv['COORDS'][0][j]['Y'] = aEnv['BORDERLIST'][k]['X'], aEnv['BORDERLIST'][k]['Y']
                                aEnv['STEP'] = len(aEnv['COORDS'][0]) - 1
                                aEnv['SHAPESTATUS'] = "new"
                                aPosSizeParm = dict([(k, aEnv[k]) for k in aEnv['POSSIZEPARM']])
                                aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                                aEnv['SHAPE'].Style = aStyle
                                aEnv['SHAPE'].setName("")
                                aEnv['SHAPE'] = None
                    # ----------------------------------------------------------------------
                    elif aEnv['SPOTTEDSHAPE'][1] in ("CircleShape", "EllipseShape"):
                        aEnv['COORDS'][0][-1], aEnv['COORDS'][0][-2] = aEnv['COORDS'][0][-2], aEnv['COORDS'][0][-1]
                        aEnv['STEP'] = len(aEnv['COORDS'][0]) - 1
                        aEnv['SHAPESTATUS'] = "new"
                        aPosSizeParm = dict([(k, aEnv[k]) for k in aEnv['POSSIZEPARM']])
                        aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                        aEnv['SHAPE'].Style = aStyle
                        aEnv['SHAPE'].setName("")
                        aEnv['SHAPE'] = None
                    # ---------------------------
                    if aType == "RectangleShape": # Rectangle
                        i = 1
                        # -------------------------------------------------
                        for aSplit in aEnv['SPLITTEDSHAPE']:
                            # -----------------------------------------
                            if i != aEnv['SPOTTEDSHAPE'][-1] and aSplit[1].count("Centre") == 0: # to do ?
                                # -------------------------
                                if aSplit[1] == "LineShape":
                                    aEnv['UNOTYPE'] = "LineShape"
                                    aEnv['ENTITYPE'] = "LINE"
                                    aEnv['STEP'] = 1
                                    aEnv['MODE'] = (aEnv['MODE'][0],) + ("VERTEX",)
                                    aEnv['COORDS'] = [[aSplit[2], aSplit[3]]]
                                else:
                                    aEnv['UNOTYPE'] = "EllipseShape"
                                    aEnv['ENTITYPE'] = "ARC"
                                    aEnv['CIRCLEKIND'] = ARC
                                    aEnv['STEP'] = 3
                                    aEnv['MODE'] = (aEnv['MODE'][0],) + ("RADIUS", "STARTANGLE", "ENDANGLE")
                                    aEnv['COORDS'] = [[{'X': 0, 'Y': 0} for j in range(4)]]
                                    aEnv['COORDS'][0][0]['X'], aEnv['COORDS'][0][0]['Y'] = aSplit[2]['X'], aSplit[2]['Y']
                                    nRadius = aSplit[3]['Width']
                                    aEnv['COORDS'][0][1]['X'], aEnv['COORDS'][0][1]['Y'] = aSplit[2]['X'] + nRadius, aSplit[2]['Y']
                                    aEnv['COORDS'][0][2]['X'] = aSplit[2]['X'] + nRadius * math.cos(aSplit[5])
                                    aEnv['COORDS'][0][2]['Y'] = aSplit[2]['Y'] - nRadius * math.sin(aSplit[5])
                                    aEnv['COORDS'][0][3]['X'] = aSplit[2]['X'] + nRadius * math.cos(aSplit[6])
                                    aEnv['COORDS'][0][3]['Y'] = aSplit[2]['Y'] - nRadius * math.sin(aSplit[6])
                                aEnv['SHAPESTATUS'] = "new"
                                aPosSizeParm = dict([(k, aEnv[k]) for k in aEnv['POSSIZEPARM']])
                                aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                                aEnv['SHAPE'].Style = aStyle
                                aEnv['SHAPE'].setName("")
                                aEnv['SHAPE'] = None
                            if aSplit[1].count("Centre") == 0:
                                i = i + 1
                # --------------------------------------------------
                elif aType in ("PolyLineShape", "PolyPolygonShape"):
                    idx = 0
                    aEnv['COORDS'] = []
                    bLeftBorder = False
                    # ------------------------------------
                    for aPolygon in aShape.PolyPolygon[:]:
                        aEnv['COORDS'].append([])
                        # ----------------------------
                        for i in range(len(aPolygon)-1):
                            aEnv['COORDS'][-1].append({'X': 0, 'Y': 0})
                            idx = idx + 1
                            # ---------------------------------
                            if aEnv['SPOTTEDSHAPE'][-1] == idx:
                                # ============= Left border ===============
                                if aEnv['BORDERLIST']['IOB']['DELTA'] >= 0:
                                    aEnv['COORDS'][-1][-1]['X'] = aPolygon[i].X
                                    aEnv['COORDS'][-1][-1]['Y'] = aPolygon[i].Y
                                    aEnv['COORDS'][-1].append({'X': 0, 'Y': 0})
                                    aEnv['COORDS'][-1][-1]['X'] = aEnv['BORDERLIST']['IOB']['X']
                                    aEnv['COORDS'][-1][-1]['Y'] = aEnv['BORDERLIST']['IOB']['Y']
                                    bLeftBorder = True
                                # ============== Right border =============
                                if aEnv['BORDERLIST']['IEB']['DELTA'] >= 0:
                                    if bLeftBorder:
                                        aEnv['COORDS'].append([{'X': 0, 'Y': 0}])
                                    elif i > 0:
                                        aEnv['COORDS'][-1][-1]['X'] = aPolygon[i].X
                                        aEnv['COORDS'][-1][-1]['Y'] = aPolygon[i].Y
                                        aEnv['COORDS'].append([{'X': 0, 'Y': 0}])
                                    aEnv['COORDS'][-1][-1]['X'] = aEnv['BORDERLIST']['IEB']['X']
                                    aEnv['COORDS'][-1][-1]['Y'] = aEnv['BORDERLIST']['IEB']['Y']
                                # ===============
                                elif bLeftBorder:
                                    if i < len(aPolygon)-2:
                                        aEnv['COORDS'].append([])
                                    else:
                                        break
                                else:
                                    if i == 0:
                                        if i== len(aPolygon)-2:
                                            del aEnv['COORDS'][-1]
                                            break
                                        else:
                                            del aEnv['COORDS'][-1][-1]
                                    aEnv['COORDS'][-1][-1]['X'] = aPolygon[i].X
                                    aEnv['COORDS'][-1][-1]['Y'] = aPolygon[i].Y
                                    if i < len(aPolygon)-2:
                                        aEnv['COORDS'].append([])
                                    else:
                                        break
                            else:
                                aEnv['COORDS'][-1][-1]['X'] = aPolygon[i].X
                                aEnv['COORDS'][-1][-1]['Y'] = aPolygon[i].Y
                        else:
                            aEnv['COORDS'][-1].append({'X':0, 'Y': 0})
                            aEnv['COORDS'][-1][-1]['X'] = aPolygon[-1].X
                            aEnv['COORDS'][-1][-1]['Y'] = aPolygon[-1].Y
                    aEnv['UNOTYPE'] = "PolyLineShape"
                    aEnv['ENTITYPE'] = "POLYGON"
                    aEnv['STEP'] = 1
                    aEnv['MODE'] = (aEnv['MODE'][0],) + ("VERTEX",)
                    aEnv['SHAPESTATUS'] = "new"
                    aPosSizeParm = dict([(k, aEnv[k]) for k in aEnv['POSSIZEPARM']])
                    aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                    aEnv['SHAPE'].Style = aStyle
                    aEnv['SHAPE'].setName("")
                    aEnv['SHAPE'] = None
                aEnv['GROUPSHAPE'].remove(aShape)
                # ----------------------------
                if aEnv['REPEATMODE']: # repeat mode on ?
                    aEnv['VALIDLIST'] = False
                    aEnv['SHAPE'] = None
                    aEnv['GROUPSHAPE'] = aEnv['CONTROLLER'].getCurrentPage()
                else:
                    aEnv['STOPJOB'] = True
            else:
                aEnv['STOPJOB'] = True
        return aEnv
