#
# -*- coding: latin-1 -*-
## ********************************************************************************
## created jeudi 23 avril 2009, 13:55:24 (UTC+0200)

## Copyright (C) 2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper, os
    from com.sun.star.awt import XActionListener, XItemListener
    from types import *
except ImportError:
    print "probleme d'import"
# 000000000000000000000000000000000000000000
# a class to prepare export toward calc
# un classe pour prparer l'export vers calc
# 000000000000000000000000000000000000000000
class CalcDataExport(unohelper.Base, XActionListener, XItemListener):
    """Prepare export toward calc
    Prparer l'export vers calc"""
    # 1111111111111111111111
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.msgl10n
        self.ctx = ctx
        self.bOK = False
        self.smgr = self.ctx.ServiceManager
        self.theDesktop = self.smgr.createInstanceWithContext( "com.sun.star.frame.Desktop",self.ctx)
        self.xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
        sTextList = ["dce%d" % i for i in range(9)]
        self.aText = dict(zip(sTextList, self.xMsgL10n.getText(sTextList)))
        self.aCalcList = [self.aText['dce8']]
        self.aSheetList = [(self.aText['dce8'],)]
    # 1111111111111111111111
    def getComponentsAndSheets(self):
        aRuntimeUIDList = [c.RuntimeUID for c in self.aCalcList if not isinstance(c, StringTypes)]
        aCompList = self.theDesktop.getComponents()
        aEnum = aCompList.createEnumeration()
        while aEnum.hasMoreElements():
            aComponent = aEnum.nextElement()
            if hasattr(aComponent, "supportsService"):
                if aComponent.supportsService("com.sun.star.sheet.SpreadsheetDocument"):
                    if not aComponent.RuntimeUID in aRuntimeUIDList:
                        self.aCalcList.append(aComponent)
                        self.aSheetList.append(aComponent.getSheets().getElementNames())
        return
    # 11111111111111111111111
    def execute(self, aArgs):
        aEnv = {}
        aEnv.update(aArgs)
        self.getComponentsAndSheets()
        # Box dimensions
        aBox = {'X':0, 'Y':0, 'Width':256, 'Height':100}
        aBox['X'] = (aEnv['COMPONENTWINDOW'].PosSize.X + (aEnv['COMPONENTWINDOW'].PosSize.Width - aBox['Width']) / 2) / 25e-1
        aBox['Y'] = (aEnv['COMPONENTWINDOW'].PosSize.Y + (aEnv['COMPONENTWINDOW'].PosSize.Height - aBox['Height']) / 2) / 25e-1
        # create the dialog model and set the properties
        aDialogModel = self.smgr.createInstanceWithContext( "com.sun.star.awt.UnoControlDialogModel", self.ctx)
        aDialogModel.PositionX = aBox['X']
        aDialogModel.PositionY = aBox['Y']
        aDialogModel.Width = aBox['Width']
        aDialogModel.Height = aBox['Height']
        aDialogModel.Title = self.aText['dce0']
        # create the OK button model and set the properties
        OKButtonModel = aDialogModel.createInstance( "com.sun.star.awt.UnoControlButtonModel" )
        OKButtonModel.PositionX = 200
        OKButtonModel.PositionY = 48
        OKButtonModel.Width = 50
        OKButtonModel.Height = 15
        OKButtonModel.Name = "OKButton"
        OKButtonModel.TabIndex = 1
        OKButtonModel.Label = self.aText['dce1']
        OKButtonModel.DefaultButton = True
        # create the New button model and set the properties
        NewButtonModel = aDialogModel.createInstance( "com.sun.star.awt.UnoControlButtonModel" )
        NewButtonModel.PositionX = 146
        NewButtonModel.PositionY = 85
        NewButtonModel.Width = 50
        NewButtonModel.Height = 15
        NewButtonModel.Name = "NewButton"
        NewButtonModel.TabIndex = 2
        NewButtonModel.Label = self.aText['dce2']
        # create the Open button model and set the properties
        OpenButtonModel = aDialogModel.createInstance( "com.sun.star.awt.UnoControlButtonModel" )
        OpenButtonModel.PositionX = 201
        OpenButtonModel.PositionY = 85
        OpenButtonModel.Width = 50
        OpenButtonModel.Height = 15
        OpenButtonModel.Name = "OpenButton"
        OpenButtonModel.TabIndex = 3
        OpenButtonModel.Label = self.aText['dce3']
        aDialogModel.insertByName("OKButton", OKButtonModel)
        aDialogModel.insertByName("NewButton", NewButtonModel)
        aDialogModel.insertByName("OpenButton", OpenButtonModel)
        # --------------- open document ------------------
        # create the label model and set the properties
        OpenDocLabelModel = aDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        OpenDocLabelModel.PositionX = 5
        OpenDocLabelModel.PositionY = 5
        OpenDocLabelModel.Width = 80
        OpenDocLabelModel.Height = 15
        OpenDocLabelModel.Name = "LabelOpenDoc"
        OpenDocLabelModel.TabIndex = 6
        OpenDocLabelModel.MultiLine = False
        OpenDocLabelModel.Label = self.aText['dce4']
        # create the listbox model and set the properties
        OpenDocListBoxModel = aDialogModel.createInstance( "com.sun.star.awt.UnoControlListBoxModel" )
        OpenDocListBoxModel.PositionX = 5
        OpenDocListBoxModel.PositionY = 25
        OpenDocListBoxModel.Width = 190
        OpenDocListBoxModel.Height = 15
        OpenDocListBoxModel.Name = "ListOpenDoc"
        OpenDocListBoxModel.TabIndex = 4
        OpenDocListBoxModel.Dropdown = True
        OpenDocListBoxModel.HelpText = self.aText['dce5']
        OpenDocListBoxModel.LineCount = 3
        OpenDocListBoxModel.MultiSelection = False
        OpenDocListBoxModel.ReadOnly = False
        OpenDocListBoxModel.StringItemList = (self.aCalcList[0],) + tuple([c.Title for c in self.aCalcList if not isinstance(c, StringTypes)])
        OpenDocListBoxModel.SelectedItems = (0,)
        # insert the control models into the dialog model
        aDialogModel.insertByName("LabelOpenDoc", OpenDocLabelModel)
        aDialogModel.insertByName("ListOpenDoc", OpenDocListBoxModel)
        # --------------- sheet ------------------
        # create the label model and set the properties
        SheetLabelModel = aDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        SheetLabelModel.PositionX = 5
        SheetLabelModel.PositionY = 45
        SheetLabelModel.Width = 80
        SheetLabelModel.Height = 15
        SheetLabelModel.Name = "LabelSheet"
        SheetLabelModel.TabIndex = 7
        SheetLabelModel.MultiLine = False
        SheetLabelModel.Label = self.aText['dce6']
        # create the listbox model and set the properties
        SheetListBoxModel = aDialogModel.createInstance( "com.sun.star.awt.UnoControlListBoxModel" )
        SheetListBoxModel.PositionX = 5
        SheetListBoxModel.PositionY = 65
        SheetListBoxModel.Width = 190
        SheetListBoxModel.Height = 15
        SheetListBoxModel.Name = "ListSheet"
        SheetListBoxModel.TabIndex = 5
        SheetListBoxModel.Dropdown = True
        SheetListBoxModel.HelpText = self.aText['dce7']
        SheetListBoxModel.LineCount = 3
        SheetListBoxModel.MultiSelection = False
        SheetListBoxModel.ReadOnly = False
        SheetListBoxModel.StringItemList = self.aSheetList[0]
        SheetListBoxModel.SelectedItems = (0,)
        # insert the control models into the dialog model
        aDialogModel.insertByName("LabelSheet", SheetLabelModel)
        aDialogModel.insertByName("ListSheet", SheetListBoxModel)
        # create the dialog control and set the model 
        self.DCEDialogControl = self.smgr.createInstanceWithContext( "com.sun.star.awt.UnoControlDialog", self.ctx)
        self.DCEDialogControl.setModel(aDialogModel)
        OpenDocListBoxControl = self.DCEDialogControl.getControl("ListOpenDoc")
        OpenDocListBoxControl.makeVisible(0)
        OpenDocListBoxControl.selectItem(self.aCalcList[0], True)
        SheetListBoxControl = self.DCEDialogControl.getControl("ListSheet")
        SheetListBoxControl.makeVisible(0)
        SheetListBoxControl.selectItem(self.aSheetList[0][0], True)
        # add an action listener to the ok button control 
        aDialogOKButton = self.DCEDialogControl.getControl("OKButton")
        aDialogOKButton.setActionCommand("ok")
        aDialogOKButton.addActionListener(self)
        # add an action listener to the new button control 
        aDialogNewButton = self.DCEDialogControl.getControl("NewButton")
        aDialogNewButton.setActionCommand("new")
        aDialogNewButton.addActionListener(self)
        # add an action listener to the open button control 
        aDialogOpenButton = self.DCEDialogControl.getControl("OpenButton")
        aDialogOpenButton.setActionCommand("open")
        aDialogOpenButton.addActionListener(self)
        # add a listener to component list
        aItemList = self.DCEDialogControl.getControl("ListOpenDoc")
        aItemList.addItemListener(self)
        #create a peer 
        aToolkit = self.smgr.createInstanceWithContext( "com.sun.star.awt.Toolkit", self.ctx)
        self.DCEDialogControl.setVisible(0)
        self.DCEDialogControl.createPeer(aToolkit, aToolkit.getDesktopWindow())
        #execute the dialog 
        self.DCEDialogControl.execute()
        if self.bOK:
            aListBoxControl = self.DCEDialogControl.getControl("ListOpenDoc")
            nIndxC = aListBoxControl.getSelectedItemPos()
            aEnv['CALCCOMP'] = self.aCalcList[nIndxC]
            aListBoxControl = self.DCEDialogControl.getControl("ListSheet")
            nIndxS = aListBoxControl.getSelectedItemPos()
            aEnv['SHEET'] = self.aSheetList[nIndxC][nIndxS]
        else:
            aEnv['CALCCOMP'] = None
            aEnv['SHEET'] = None
        # remove an action listener to the ok button control 
        aDialogOKButton.removeActionListener(self)
        # remove an action listener to the new button control 
        aDialogNewButton.removeActionListener(self)
        # remove an action listener to the open button control 
        aDialogOpenButton.removeActionListener(self)
        aItemList.removeItemListener(self)
        return aEnv
    # XEventListener
    def disposing(self, eventObject):
        self.DCEDialogControl = None
    # XActionListener
    def actionPerformed(self, actionEvent):
        lProperties = (uno.createUnoStruct("com.sun.star.beans.PropertyValue"),)
        if actionEvent.ActionCommand == "ok":
            OpenDocListBoxControl = self.DCEDialogControl.getControl("ListOpenDoc")
            nIndxC = OpenDocListBoxControl.getSelectedItemPos()
            if self.aText['dce8'] == self.aCalcList[nIndxC]:
                self.bOK = False
            else:
                self.bOK = True
            self.DCEDialogControl.endExecute()
        elif actionEvent.ActionCommand == "new":
            aCalcComp = self.theDesktop.loadComponentFromURL("private:factory/scalc", "_blank", 0, lProperties)
            if not aCalcComp is None:
                self.aCalcList.append(aCalcComp)
                self.aSheetList.append(aCalcComp.getSheets().getElementNames())
                OpenDocListBoxControl = self.DCEDialogControl.getControl("ListOpenDoc")
                OpenDocListBoxControl.addItem(self.aCalcList[-1].Title, OpenDocListBoxControl.getItemCount())
                OpenDocListBoxControl.makeVisible(OpenDocListBoxControl.getItemCount()-1)
                OpenDocListBoxControl.selectItem(self.aCalcList[-1].Title, True)
        else:
            aFilePicker = self.smgr.createInstanceWithContext("com.sun.star.ui.dialogs.FilePicker", self.ctx)
            aFilePicker.appendFilter("ODF Spreadsheet", "calc8")
            aFilePicker.setCurrentFilter("ODF Spreadsheet")
            aFilePicker.setDisplayDirectory(unohelper.systemPathToFileUrl( os.getcwd()))
            aFilePicker.setMultiSelectionMode(False)
            if aFilePicker.execute():
                lProperties = (uno.createUnoStruct("com.sun.star.beans.PropertyValue"),)
                aCalcComp = self.theDesktop.loadComponentFromURL(aFilePicker.getFiles()[0], "_blank", 0, lProperties)
                if not aCalcComp is None:
                    self.aCalcList.append(aCalcComp)
                    self.aSheetList.append(aCalcComp.getSheets().getElementNames())
                    OpenDocListBoxControl = self.DCEDialogControl.getControl("ListOpenDoc")
                    OpenDocListBoxControl.addItem(self.aCalcList[-1].Title, OpenDocListBoxControl.getItemCount())
                    OpenDocListBoxControl.makeVisible(OpenDocListBoxControl.getItemCount()-1)
                    OpenDocListBoxControl.selectItem(self.aCalcList[-1].Title, True)
    # item listener
    def itemStateChanged(self, aItemEvent):
        aListBoxControl = aItemEvent.Source
        if aListBoxControl.Model.Name == u"ListOpenDoc":
            nIndx = aListBoxControl.getSelectedItemPos()
            SheetListBoxControl = self.DCEDialogControl.getControl("ListSheet")
            SheetListBoxControl.removeItems(0, SheetListBoxControl.getItemCount())
            SheetListBoxControl.addItems(self.aSheetList[nIndx],0)
            SheetListBoxControl.makeVisible(0)
            SheetListBoxControl.selectItem(self.aSheetList[nIndx][0], True)
