#  $Id:$
# -*- coding: latin-1 -*-
## ********************************************************************************
## data_inputbox.py jeudi 12 mars 2009, 11:26:18 (UTC+0100)

## Copyright (C) 2004 - 2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import unohelper
    import math
    from types import *
    from com.sun.star.awt import XActionListener
except ImportError, e:
    print e

#=============================================================
# a class to iput dimensional or positional datas
# une classe pour des donnees de dimensions ou positions
#=============================================================
class DataInputBox(unohelper.Base, XActionListener):
    def __init__(self, aContext):
        from fr.free.deneux.gerard.cadooo.compute import Compute
        from fr.free.deneux.gerard.cadooo.msgl10n import MsgL10n
        self.ctx = aContext
        xMsgL10n = MsgL10n(self.ctx)
        aTextList = tuple(["d%d" % i for i in range(13)])
        self.sMsg = xMsgL10n.getText(aTextList)
        self.bOK = False
        self.smgr = self.ctx.ServiceManager
        self.xCompute = Compute(self.ctx)
    # ******************************
    def execute(self, aNamedValues):
        aEnv = {}
        aEnv.update(aNamedValues)
        sUnits = [l for l in aEnv['UNITS'] if not l is None]
        nUnit = sUnits.index(aEnv['UNITS'][aEnv['MEASUREUNIT']])
        aBox = {'X': 0, 'Y': 0, 'Width': 0, 'Height': 0}
        aBox['Width'], aBox['Height'] = 130, 150
        aBox['X'] = (aEnv['COMPONENTWINDOW'].PosSize.X + (aEnv['COMPONENTWINDOW'].PosSize.Width - aBox['Width']) / 2) / 25e-1
        aBox['Y'] = (aEnv['COMPONENTWINDOW'].PosSize.Y + (aEnv['COMPONENTWINDOW'].PosSize.Height - aBox['Height']) / 2) / 25e-1
        # create the dialog model and set the properties
        DataDialogModel = self.smgr.createInstanceWithContext( "com.sun.star.awt.UnoControlDialogModel", self.ctx)
        DataDialogModel.PositionX = aBox['X']
        DataDialogModel.PositionY = aBox['Y']
        DataDialogModel.Width = aBox['Width']
        DataDialogModel.Height = aBox['Height']
        DataDialogModel.Title = aEnv['TITLE']
        # create the label model and set the properties
        CommentDialogLabelModel = DataDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        CommentDialogLabelModel.PositionX = 10
        CommentDialogLabelModel.PositionY = 10
        CommentDialogLabelModel.Width = 110
        CommentDialogLabelModel.Height = 20
        CommentDialogLabelModel.Name = "LabelComment"
        CommentDialogLabelModel.TabIndex = 8
        CommentDialogLabelModel.MultiLine = True
        CommentDialogLabelModel.Label = aEnv['COMMENT']
        # create the button model and set the properties
        DataDialogButtonModel1 = DataDialogModel.createInstance( "com.sun.star.awt.UnoControlButtonModel" )
        DataDialogButtonModel1.PositionX = 25
        DataDialogButtonModel1.PositionY = 125
        DataDialogButtonModel1.Width = 30
        DataDialogButtonModel1.Height = 15
        DataDialogButtonModel1.Name = "Button1"
        DataDialogButtonModel1.TabIndex = 6
        DataDialogButtonModel1.Label = self.sMsg[0]
        DataDialogButtonModel1.DefaultButton = True
        # create the button model and set the properties
        DataDialogButtonModel2 = DataDialogModel.createInstance( "com.sun.star.awt.UnoControlButtonModel" )
        DataDialogButtonModel2.PositionX = 75
        DataDialogButtonModel2.PositionY = 125
        DataDialogButtonModel2.Width = 30
        DataDialogButtonModel2.Height = 15
        DataDialogButtonModel2.Name = "Button2"
        DataDialogButtonModel2.TabIndex = 7
        DataDialogButtonModel2.Label = self.sMsg[1]
        DataDialogModel.insertByName("Comment", CommentDialogLabelModel)
        DataDialogModel.insertByName("Button1", DataDialogButtonModel1)
        DataDialogModel.insertByName("Button2", DataDialogButtonModel2)
        # flag values of 6 have no meaning, 4 is for angle input
        if aEnv['FLAG'] not in (4, 6):
            # create the label model and set the properties
            DXDialogLabelModel = DataDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
            DXDialogLabelModel.PositionX = 10
            DXDialogLabelModel.PositionY = 40
            DXDialogLabelModel.Width = 25
            DXDialogLabelModel.Height = 15
            DXDialogLabelModel.Name = "LabelDX"
            DXDialogLabelModel.TabIndex = 9
            DXDialogLabelModel.MultiLine = False
            # flag 0 <=> distance input
            # flag 2 <=> 2 distances input
            # flag 5 <=> global polar coordinates input
            # flag 7 <=> relative polar coordinates input
            if aEnv['FLAG'] in (0, 2, 5, 7):
                DXDialogLabelModel.Label = self.sMsg[2]
            # flag 1 <=> global rectangular coordinates input
            # flag 3 <=> relative rectangular coordinates input
            elif aEnv['FLAG'] in (1, 3):
                DXDialogLabelModel.Label = "X"
            # create the edit model and set the properties
            DXDialogEditModel = DataDialogModel.createInstance( "com.sun.star.awt.UnoControlEditModel" )
            DXDialogEditModel.PositionX = 40
            DXDialogEditModel.PositionY = 40
            DXDialogEditModel.Width = 45
            DXDialogEditModel.Height = 15
            DXDialogEditModel.Name = "NumfDX"
            DXDialogEditModel.TabIndex = 0
            DXDialogEditModel.Text = aEnv['X']
            DXDialogEditModel.MultiLine = False
            DXDialogEditModel.Align = 2
            DXDialogEditModel.ReadOnly = False
            DXDialogEditModel.HelpText = self.sMsg[3]
            # create the listbox model and set the properties
            DXDialogListBoxModel = DataDialogModel.createInstance( "com.sun.star.awt.UnoControlListBoxModel" )
            DXDialogListBoxModel.PositionX = 90
            DXDialogListBoxModel.PositionY = 40
            DXDialogListBoxModel.Width = 30
            DXDialogListBoxModel.Height = 15
            DXDialogListBoxModel.Name = "ListDUnit"
            DXDialogListBoxModel.TabIndex = 1
            DXDialogListBoxModel.Dropdown = True
            DXDialogListBoxModel.HelpText = self.sMsg[4]
            DXDialogListBoxModel.LineCount = 3
            DXDialogListBoxModel.MultiSelection = False
            DXDialogListBoxModel.ReadOnly = False
            DXDialogListBoxModel.StringItemList = tuple(sUnits)
            DXDialogListBoxModel.SelectedItems = (nUnit,)
            # insert the control models into the dialog model
            DataDialogModel.insertByName("LabelDX", DXDialogLabelModel)
            DataDialogModel.insertByName("NumfDX", DXDialogEditModel)
            DataDialogModel.insertByName("ListDUnit", DXDialogListBoxModel)
        if aEnv['FLAG'] != 0:
            # create the label model and set the properties
            AYDialogLabelModel = DataDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
            AYDialogLabelModel.PositionX = 10
            AYDialogLabelModel.PositionY = 65
            AYDialogLabelModel.Width = 25
            AYDialogLabelModel.Height = 15
            AYDialogLabelModel.Name = "LabelAY"
            AYDialogLabelModel.TabIndex = 10
            AYDialogLabelModel.MultiLine = False
            # flag 4 <=> angle input
            # flag 5 <=> global polar coordinates input
            # flag 7 <=> relative polar coordinates input
            if aEnv['FLAG'] in (4, 5, 7):
                AYDialogLabelModel.Label = self.sMsg[5]
            # flag 1 <=> global rectangular coordinates input
            # flag 3 <=> relative rectangular coordinates input
            elif aEnv['FLAG'] in (1, 3):
                AYDialogLabelModel.Label = "Y"
            # flag 2 <=> 2 distances input
            elif aEnv['FLAG'] in (2,):
                AYDialogLabelModel.Label = self.sMsg[2]
            # create the edit model and set the properties
            AYDialogEditModel = DataDialogModel.createInstance( "com.sun.star.awt.UnoControlEditModel" )
            AYDialogEditModel.PositionX = 40
            AYDialogEditModel.PositionY = 65
            AYDialogEditModel.Width = 45
            AYDialogEditModel.Height = 15
            AYDialogEditModel.Name = "NumfAY"
            AYDialogEditModel.TabIndex = 2
            AYDialogEditModel.Text = aEnv['Y']
            AYDialogEditModel.MultiLine = False
            AYDialogEditModel.Align = 2
            AYDialogEditModel.ReadOnly = False
            AYDialogEditModel.HelpText = self.sMsg[6]
            # create the listbox model and set the properties
            AYDialogListBoxModel = DataDialogModel.createInstance( "com.sun.star.awt.UnoControlListBoxModel" )
            AYDialogListBoxModel.PositionX = 90
            AYDialogListBoxModel.PositionY = 65
            AYDialogListBoxModel.Width = 30
            AYDialogListBoxModel.Height = 15
            AYDialogListBoxModel.Name = "ListAUnit"
            AYDialogListBoxModel.TabIndex = 3
            AYDialogListBoxModel.Dropdown = True
            AYDialogListBoxModel.HelpText = self.sMsg[4]
            if aEnv['FLAG'] in (1, 2, 3):
                AYDialogListBoxModel.LineCount = 3
                AYDialogListBoxModel.MultiSelection = False
                AYDialogListBoxModel.ReadOnly = False
                AYDialogListBoxModel.StringItemList = tuple(sUnits)
                AYDialogListBoxModel.SelectedItems = (nUnit,)
            elif aEnv['FLAG'] in (4, 5, 7):
                AYDialogListBoxModel.LineCount = 3
                AYDialogListBoxModel.MultiSelection = False
                AYDialogListBoxModel.ReadOnly = False
                AYDialogListBoxModel.StringItemList = tuple(self.sMsg[10:13])
                AYDialogListBoxModel.SelectedItems = (1,)
            # insert the control models into the dialog model
            DataDialogModel.insertByName("LabelAY", AYDialogLabelModel)
            DataDialogModel.insertByName("NumfAY", AYDialogEditModel)
            DataDialogModel.insertByName("ListAUnit", AYDialogListBoxModel)
        if aEnv['FLAG'] in (1, 3, 5, 7):
            # create the groupbox model and set the properties
            DAXYDialogGroupBoxModel = DataDialogModel.createInstance( "com.sun.star.awt.UnoControlGroupBoxModel" )
            DAXYDialogGroupBoxModel.PositionX = 10
            DAXYDialogGroupBoxModel.PositionY = 85
            DAXYDialogGroupBoxModel.Width = 110
            DAXYDialogGroupBoxModel.Height = 25
            DAXYDialogGroupBoxModel.Name = "Group"
            DAXYDialogGroupBoxModel.TabIndex = 11
            DAXYDialogGroupBoxModel.Label = self.sMsg[7]
            # create the radio button model and set the properties
            AbsDialogRadioButtonModel = DataDialogModel.createInstance("com.sun.star.awt.UnoControlRadioButtonModel")
            AbsDialogRadioButtonModel.PositionX = 25
            AbsDialogRadioButtonModel.PositionY = 95
            AbsDialogRadioButtonModel.Width = 30
            AbsDialogRadioButtonModel.Height = 15
            AbsDialogRadioButtonModel.Name = "RadioA"
            AbsDialogRadioButtonModel.TabIndex = 4
            AbsDialogRadioButtonModel.State = False
            AbsDialogRadioButtonModel.Label = self.sMsg[8]
            # create the radio button model and set the properties
            RelDialogRadioButtonModel = DataDialogModel.createInstance("com.sun.star.awt.UnoControlRadioButtonModel")
            RelDialogRadioButtonModel.PositionX = 75
            RelDialogRadioButtonModel.PositionY = 95
            RelDialogRadioButtonModel.Width = 30
            RelDialogRadioButtonModel.Height = 15
            RelDialogRadioButtonModel.Name = "RadioR"
            RelDialogRadioButtonModel.TabIndex = 5
            RelDialogRadioButtonModel.State = True
            RelDialogRadioButtonModel.Label = self.sMsg[9]
            DataDialogModel.insertByName("Group", DAXYDialogGroupBoxModel)
            DataDialogModel.insertByName("RadioA", AbsDialogRadioButtonModel)
            DataDialogModel.insertByName("RadioR", RelDialogRadioButtonModel)
        # create the dialog control and set the model 
        self.DataDialogControl = self.smgr.createInstanceWithContext( "com.sun.star.awt.UnoControlDialog", self.ctx)
        self.DataDialogControl.setModel(DataDialogModel)
        if aEnv['FLAG'] not in (4, 6):
            DXDialogListBoxControl = self.DataDialogControl.getControl("ListDUnit")
            DXDialogListBoxControl.makeVisible(aEnv['MEASUREUNIT'])
            DXDialogListBoxControl.selectItem(aEnv['UNITS'][aEnv['MEASUREUNIT']], True)
        if aEnv['FLAG'] in (1, 2, 3):
            AYDialogListBoxControl = self.DataDialogControl.getControl("ListAUnit")
            AYDialogListBoxControl.makeVisible(aEnv['MEASUREUNIT'])
            AYDialogListBoxControl.selectItem(aEnv['UNITS'][aEnv['MEASUREUNIT']], True)
        elif aEnv['FLAG'] in (4, 5, 7):
            AYDialogListBoxControl = self.DataDialogControl.getControl("ListAUnit")
            AYDialogListBoxControl.makeVisible(0)
            AYDialogListBoxControl.selectItem(self.sMsg[11], True)
        # add an action listener to the button1 control 
        aDataDialogButton1 = self.DataDialogControl.getControl("Button1")
        aDataDialogButton1.setActionCommand("ok")
        aDataDialogButton1.addActionListener(self)
        # add an action listener to the button2 control 
        aDataDialogButton2 = self.DataDialogControl.getControl("Button2")
        aDataDialogButton2.setActionCommand("cancel")
        aDataDialogButton2.addActionListener(self)
        #create a peer 
        aToolkit = self.smgr.createInstanceWithContext( "com.sun.star.awt.Toolkit", self.ctx)
        self.DataDialogControl.setVisible(0)
        self.DataDialogControl.createPeer(aToolkit, aToolkit.getDesktopWindow())
        #execute the dialog 
        self.DataDialogControl.execute()
        if self.bOK:
            if aEnv['FLAG'] in (1, 3, 5, 7):
                DAXYDialogRadionButtonControl = self.DataDialogControl.getControl("RadioA")
                if DAXYDialogRadionButtonControl.getState():
                    aEnv['FLAG'] = aEnv['FLAG'] & 0x5
                else:
                    aEnv['FLAG'] = aEnv['FLAG'] | 0x2
            if aEnv['FLAG'] not in (4, 6):
                aEnv['RETURN'] = True
                aEnv['XUNIT'] = list(aEnv['UNITS']).index(DXDialogListBoxControl.getSelectedItem())
                aEnv['X'] = self.xCompute.transform2SystemUnit(self.DataDialogControl.getControl("NumfDX").getText(), aEnv['UNITS'], aEnv['UNITSRATIO'], aEnv['XUNIT'], aEnv['DRAWSCALE'])
            if aEnv['FLAG'] in (1, 2, 3):
                aEnv['RETURN'] = True
                aEnv['YUNIT'] = list(aEnv['UNITS']).index(AYDialogListBoxControl.getSelectedItem())
                aEnv['Y'] = self.xCompute.transform2SystemUnit(self.DataDialogControl.getControl("NumfAY").getText(), aEnv['UNITS'], aEnv['UNITSRATIO'], aEnv['YUNIT'], aEnv['DRAWSCALE'])
                if aEnv['FLAG'] in (1,3):
                    fX = aEnv['UCS'][0][0] * aEnv['X'] + aEnv['UCS'][0][1] * aEnv['Y']
                    fY = aEnv['UCS'][1][0] * aEnv['X'] + aEnv['UCS'][1][1] * aEnv['Y']
                    aEnv['X'] = long(round(fX))
                    aEnv['Y'] = long(round(fY))
                if aEnv['FLAG'] in (1,):
                    aEnv['X'] += aEnv['UCS'][0][2]
                    aEnv['Y'] += aEnv['UCS'][1][2]
            elif aEnv['FLAG'] in (4, 5, 7):
                aEnv['RETURN'] = True
                aEnv['YUNIT'] = AYDialogListBoxControl.getSelectedItem()
                sAngle= self.DataDialogControl.getControl("NumfAY").getText()
                if sAngle.count(",") > 0:
                    sAngle = sAngle.replace(',', '.')
                if aEnv['YUNIT'] == self.sMsg[10]:
                    aEnv['Y'] = float(sAngle)
                elif aEnv['YUNIT'] == self.sMsg[11]:
                    aEnv['Y'] = float(sAngle) * math.pi / 180
                else:
                    aEnv['Y'] = float(sAngle) * math.pi / 200
                if aEnv['FLAG'] in (5, 7):
                    fX = math.cos(aEnv['Y']) * aEnv['UCS'][0][0] + math.sin(aEnv['Y']) * aEnv['UCS'][0][1]
                    fY = math.cos(aEnv['Y']) * aEnv['UCS'][1][0] - math.sin(aEnv['Y']) * aEnv['UCS'][1][1]
                    aEnv['Y'] = -math.atan2(fY, fX)
        # remove an action listener to the button1 control 
        aDataDialogButton1.removeActionListener(self)
        # remove an action listener to the button2 control 
        aDataDialogButton2.removeActionListener(self)
        return aEnv
    # XEventListener 
    def disposing(self, eventObject):
        self.DataDialogControl = None
    # XActionListener 
    def actionPerformed(self, actionEvent):
        if actionEvent.ActionCommand == "ok":
            self.bOK = True
        else:
            self.bOK = False
        self.DataDialogControl.endExecute()
