#	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## 
## Copyright (C) 2007-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math
    from com.sun.star.drawing.CircleKind import ARC, FULL
except ImportError:
    print "probleme d'import"
#======================================================
# a class to draw dimensions
# une classe pour le trac de cotes
#======================================================
class DimDraw():
    """Trace une cote
    Draws a dimension"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.entitiespot
        import fr.free.deneux.gerard.cadooo.compute
        import fr.free.deneux.gerard.cadooo.msgl10n
        self.ctx = ctx
        self.xEntitySpot = fr.free.deneux.gerard.cadooo.entitiespot.EntitieSpot( self.ctx)
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute( self.ctx)
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
        sTextList = tuple(["dim%d" % i for i in range(1,5)])
        self.sDim = xMsgL10n.getText(sTextList)
        self.nDimState = self.nDimPState = 0
        self.bRedraw = False
    # ******************************
    # Main method
    # ******************************
    def execute(self, aNamedValues):
        self.aEnv = {}
        self.aEnv.update(aNamedValues)
        if self.bRedraw:
            self.xEntitySpot.bValidList = False
            self.bRedraw = False
        aMouseParm = self.aEnv.fromkeys(self.aEnv['MOUSEPARM'])
        for aKey in aMouseParm.iterkeys():
            aMouseParm[aKey] = self.aEnv[aKey]
        aSpotParm = self.aEnv.fromkeys(self.aEnv['SPOTPARM'])
        for aKey in aSpotParm.iterkeys():
            aSpotParm[aKey] = self.aEnv[aKey]
        aSpotParm.update(aMouseParm)
        self.aEnv.update(self.xEntitySpot.execute(aSpotParm))
        self.aEnv['COORDS'] = [[]]
        nDimState = 0
        self.aEnv['SPOTTEDSHAPE'] = self.xEntitySpot.aSpottedShape
        # ++++++++++++++++++++++++++++++++++++
        if not self.aEnv['SPOTTEDID'] is None:
            nDimState += 1
        # +++++++++++++++++++++++++++++++++++++++
        if not self.aEnv['SPOTTEDSHAPE'] is None:
            nDimState += 2
        # +++++++++++++++++++++++++++++++++++++
        if not self.aEnv['DIMLIST'][0] is None:
            nDimState += 4
        # +++++++++++++++++++++++++++++++++++++
        if not self.aEnv['DIMLIST'][1] is None:
            nDimState += 8
        # print "transition %d => %d" % (self.nDimPState, nDimState)
        # ++++++++++++++++++++++
        if nDimState >= 12:
            # print "2 entities stored"
            # -----------------------
            if nDimState in (13, 15):
                self.removeTempShapes(True, False)
            self.setDimEnvAndCoord(self.aEnv['DIMLIST'][0], self.aEnv['DIMLIST'][1])
        # +++++++++++++++++++++
        if nDimState == 0:
            # print "0 stored 0 spotted 0 previous"
            pass
        # +++++++++++++++++++++
        if nDimState == 1:
            # print "0 stored 0 spotted 1 previous"
            self.removeTempShapes()
        # +++++++++++++++++++++
        if nDimState == 2:
            # print "0 stored 1 spotted 0 previous"
            self.setDimEnvAndCoord(self.aEnv['SPOTTEDSHAPE'])
            self.aEnv['COORDS'] = self.setEntityEnvAndCoord(self.aEnv['SPOTTEDSHAPE'])
            self.aEnv['SPOTTEDID'] = self.aEnv['SPOTTEDSHAPE'][0][:] + (self.aEnv['SPOTTEDSHAPE'][-1],)
        # +++++++++++++++++++++
        if nDimState == 3:
            # print "0 stored 1 spotted 1 previous"
            aNewSpotID = self.aEnv['SPOTTEDSHAPE'][0]+(self.aEnv['SPOTTEDSHAPE'][-1],)
            # -------------------------------------
            if aNewSpotID == self.aEnv['SPOTTEDID']:
                # print "0 stored 1 spotted == 1 previous"
                self.aEnv['STEP'] = 0
            else:
                # print "0 stored 1 spotted != 1 previous"
                self.removeTempShapes()
                self.aEnv['COORDS'] = self.setEntityEnvAndCoord(self.aEnv['SPOTTEDSHAPE'])
                self.aEnv['SPOTTEDID'] = self.aEnv['SPOTTEDSHAPE'][0][:] + (self.aEnv['SPOTTEDSHAPE'][-1],)
            self.setDimEnvAndCoord(self.aEnv['SPOTTEDSHAPE'])
        # +++++++++++++++++++++
        if nDimState == 4:
            # print "1 stored 0 spotted 0 previous"
            self.setDimEnvAndCoord(self.aEnv['DIMLIST'][0])
        # +++++++++++++++++++++
        if nDimState == 5:
            # print "1 stored 0 spotted 1 previous"
            aStoredID = self.aEnv['DIMLIST'][0][0] + (self.aEnv['DIMLIST'][0][-1],)
            if aStoredID == self.aEnv['SPOTTEDID']:
                # print "1 stored = 0 spotted = 1 previous"
                self.removeTempShapes(True, False)
            else:
                # print "1 stored ! 0 spotted = 1 previous"
                self.removeTempShapes()
            self.setDimEnvAndCoord(self.aEnv['DIMLIST'][0])
        # +++++++++++++++++++++
        if nDimState == 6:
            # print "1 stored 1 spotted 0 previous"
            aStoredID = self.aEnv['DIMLIST'][0][0] + (self.aEnv['DIMLIST'][0][-1],)
            aNewSpotID = self.aEnv['SPOTTEDSHAPE'][0] + (self.aEnv['SPOTTEDSHAPE'][-1],)
            # -------------------------
            if aStoredID != aNewSpotID:
                # print "1 stored != 1 spotted 0 previous"
                self.removeTempShapes(False, True)
                self.setDimEnvAndCoord(self.aEnv['DIMLIST'][0], self.aEnv['SPOTTEDSHAPE'])
            self.aEnv['COORDS'] = self.setEntityEnvAndCoord(self.aEnv['SPOTTEDSHAPE'])
            self.aEnv['SPOTTEDID'] = self.aEnv['SPOTTEDSHAPE'][0][:] + (self.aEnv['SPOTTEDSHAPE'][-1],)
        # +++++++++++++++++++++
        if nDimState == 7:
            # print "1 stored 1 spotted 1 previous"
            aStoredID = self.aEnv['DIMLIST'][0][0] + (self.aEnv['DIMLIST'][0][-1],)
            aNewSpotID = self.aEnv['SPOTTEDSHAPE'][0] + (self.aEnv['SPOTTEDSHAPE'][-1],)
            # =========================
            if aStoredID == aNewSpotID:
                # print "1 stored == 1 spotted 1 previous"
                # ......................................
                if aNewSpotID == self.aEnv['SPOTTEDID']:
                    self.aEnv['STEP'] = 0
                else:
                    self.removeTempShapes()
                    self.setDimEnvAndCoord(self.aEnv['DIMLIST'][0])
                    self.aEnv['COORDS'] = self.setEntityEnvAndCoord(self.aEnv['SPOTTEDSHAPE'])
                    self.aEnv['SPOTTEDID'] = self.aEnv['SPOTTEDSHAPE'][0][:] + (self.aEnv['SPOTTEDSHAPE'][-1],)
            else:
                # print "1 stored != 1 spotted 1 previous"
                # ......................................
                if aNewSpotID == self.aEnv['SPOTTEDID']:
                    # print "1 stored != 1 spotted == 1 previous"
                    self.aEnv['STEP'] = 0
                else:
                    self.removeTempShapes()
                    self.setDimEnvAndCoord(self.aEnv['DIMLIST'][0], self.aEnv['SPOTTEDSHAPE'])
                    self.aEnv['COORDS'] = self.setEntityEnvAndCoord(self.aEnv['SPOTTEDSHAPE'])
                    self.aEnv['SPOTTEDID'] = self.aEnv['SPOTTEDSHAPE'][0][:] + (self.aEnv['SPOTTEDSHAPE'][-1],)
        self.nDimPState = nDimState
        # ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        if self.aEnv['DIMTYPE'] in ('LINEAR', 'ANGULAR', 'RADIAL', 'DIAMETRAL'):
            sType = self.sDim[["LINEAR", "RADIAL", "DIAMETRAL", "ANGULAR"].index(self.aEnv['DIMTYPE'])]
        else:
            sType = self.aEnv['DIMTYPE']
        sText = "%s ==> %s" % (self.aEnv['COMMENT'][0], sType)
        aInfoCtrl = self.aEnv['STATUSBARCONTROL']['INFOCTRL']
        aInfoCtrl.setText(sText)
        if not self.aEnv['COORDS'] is None:
            self.aEnv['SHAPESTATUS'] = "transient"
        else:
            self.aEnv['COORDS'] = None
        return self.aEnv
    # *****************************************************
    # remove temporary shapes
    # *****************************************************
    def removeTempShapes(self, bShape = True, bDim = True):
        if not self.aEnv['SHAPE'] is None and bShape:
            aGroupShape = self.aEnv['CONTROLLER'].getCurrentPage()
            if len(self.aEnv['SPOTTEDID']) > 2:
                for i in self.aEnv['SPOTTEDID'][:-2]:
                    aGroupShape = aGroupShape.getByIndex(i)
            aGroupShape.remove(self.aEnv['SHAPE'])
            self.aEnv['SHAPE'] = None
            self.aEnv['STEP'] = 0
            self.aEnv['COORDS'] = None
            self.aEnv['SPOTTEDID'] = None
        if self.aEnv['DIMTYPE'] in ('LINEAR', 'ANGULAR', 'RADIAL', 'DIAMETRAL') and bDim:
            aShape = self.aEnv['%sDIMSHAPE' % self.aEnv['DIMTYPE']]
            if not aShape is None and self.aEnv['DIMVISIBLE']:
                self.aEnv['CONTROLLER'].getCurrentPage().remove(aShape)
            self.aEnv['%sDIMSHAPE' % self.aEnv['DIMTYPE']] = None
            self.aEnv['DIMTYPE'] = "----"
            self.aEnv['DIMCOORDS'] = None
            self.aEnv['DIMVISIBLE'] = False
        return
    # *********************************************
    # set dim env and coordinates
    # *********************************************
    def setDimEnvAndCoord(self, dim1, dim2 = None):
        aDimCoords = [{'X': 0, 'Y': 0} for i in range(4)]
        aMouseCoord = {'X': 0, 'Y': 0}
        aMouseParm = self.aEnv.fromkeys(self.aEnv['MOUSEPARM'])
        for aKey in aMouseParm.iterkeys():
            aMouseParm[aKey] = self.aEnv[aKey]
        aMouseCoord.update( self.xCompute.transformMouseCoord( aMouseParm))
        # ++++++++++++++
        if dim2 is None:
            # ---------------------------
            if dim1[1] in ('LineShape',):
                aDimCoords = self.setLinearDimCoords(dim1[2], dim1[3], aMouseCoord)
            # -------------------------------
            elif dim1[1] in ('CircleShape',):
                self.aEnv['DIMTYPE'] = "DIAMETRAL"
                self.aEnv['DIMVALUE'] = "D %s" % self.xCompute.transform2UserUnit( float(2 * dim1[3]['Width']), self.aEnv['UNITS'], self.aEnv['UNITSRATIO'], self.aEnv['MEASUREUNIT'], self.aEnv['DRAWSCALE'])
                aDimCoords[0]['X'], aDimCoords[0]['Y'] = dim1[2]['X'], dim1[2]['Y']
                ret = self.xCompute.getCoordFromAbsOrd( dim1[2],  aMouseCoord, dim1[3]['Width'], 0)
                aDimCoords[1]['X'], aDimCoords[1]['Y'] = ret['X'], ret['Y']
                aDimCoords[2]['X'], aDimCoords[2]['Y'] = aMouseCoord['X'], aMouseCoord['Y']
                nDist, fAngle = self.xCompute.toPolarCoord( aDimCoords[1], aDimCoords[2])
                # :::::::::::::::::::::::::::::::::::::::::::::::::::::
                if fAngle <= math.pi / 2 or fAngle >= 3 * math.pi / 2:
                    aDimCoords[3]['X'], aDimCoords[3]['Y'] = aMouseCoord['X'] + nDist, aMouseCoord['Y']
                else:
                    aDimCoords[3]['X'], aDimCoords[3]['Y'] = aMouseCoord['X'] - nDist, aMouseCoord['Y']
            # ---------------------------------
            elif dim1[1] in ('ArcCircleShape',):
                # :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                if self.aEnv['L2OSTATE'][0] and not self.aEnv['L2OSTATE'][2]:
                    aCoords =  [{'X': 0, 'Y': 0}, {'X': 0, 'Y': 0}]
                    aCoords[0]['X'] = dim1[2]['X'] + long(round(dim1[3]['Width'] * math.cos(-dim1[5])))
                    aCoords[0]['Y'] = dim1[2]['Y'] + long(round(dim1[3]['Width'] * math.sin(-dim1[5])))
                    aCoords[1]['X'] = dim1[2]['X'] + long(round(dim1[3]['Width'] * math.cos(-dim1[6])))
                    aCoords[1]['Y'] = dim1[2]['Y'] + long(round(dim1[3]['Width'] * math.sin(-dim1[6])))
                    aDimCoords = self.setLinearDimCoords(aCoords[0], aCoords[1], aMouseCoord)
                # :::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                elif self.aEnv['L2OSTATE'][0] and self.aEnv['L2OSTATE'][2]:
                    self.aEnv['DIMTYPE'] = "ANGULAR"
                    self.aEnv['DIMVALUE'] = u"%6.2f" % (round(math.degrees(((dim1[6] - dim1[5]) < 0) * 2 * math.pi + (dim1[6] - dim1[5])), 2),)
                    aDimCoords[0]['X'], aDimCoords[0]['Y'] = dim1[2]['X'], dim1[2]['Y']
                    aDimCoords[1]['X'], aDimCoords[1]['Y'] = aMouseCoord['X'], aMouseCoord['Y']
                    aDimCoords[2]['X'] = dim1[2]['X'] + long(round(dim1[3]['Width'] * math.cos(-dim1[5])))
                    aDimCoords[2]['Y'] = dim1[2]['Y'] + long(round(dim1[3]['Width'] * math.sin(-dim1[5])))
                    aDimCoords[3]['X'] = dim1[2]['X'] + long(round(dim1[3]['Width'] * math.cos(-dim1[6])))
                    aDimCoords[3]['Y'] = dim1[2]['Y'] + long(round(dim1[3]['Width'] * math.sin(-dim1[6])))
                # :::
                else:
                    self.aEnv['DIMTYPE'] = "RADIAL"
                    self.aEnv['DIMVALUE'] = "R %s" % self.xCompute.transform2UserUnit( float(dim1[3]['Width']), self.aEnv['UNITS'], self.aEnv['UNITSRATIO'], self.aEnv['MEASUREUNIT'], self.aEnv['DRAWSCALE'])
                    aDimCoords[0]['X'], aDimCoords[0]['Y'] = dim1[2]['X'], dim1[2]['Y']
                    ret = self.xCompute.getCoordFromAbsOrd(dim1[2],  aMouseCoord, dim1[3]['Width'], 0)
                    aDimCoords[1]['X'], aDimCoords[1]['Y'] = ret['X'], ret['Y']
                    aDimCoords[2]['X'], aDimCoords[2]['Y'] = aMouseCoord['X'], aMouseCoord['Y']
                    nDist, fAngle = self.xCompute.toPolarCoord( aDimCoords[1], aDimCoords[2])
                    # .....................................................
                    if fAngle <= math.pi / 2 or fAngle >= 3 * math.pi / 2:
                        aDimCoords[3]['X'], aDimCoords[3]['Y'] = aMouseCoord['X'] + nDist, aMouseCoord['Y']
                    else:
                        aDimCoords[3]['X'], aDimCoords[3]['Y'] = aMouseCoord['X'] - nDist, aMouseCoord['Y']
            else:
                self.aEnv['DIMTYPE'] = "---"
                aDimCoords = None
        else:
            # ---------------------------------------------------------
            if dim1[1] in ('LineShape',) and dim2[1] in ('LineShape',):
                aPointA, aPointB, aPointC, aPointD = [{'X': 0, 'Y': 0} for i in range(4)]
                aPointA['X'], aPointA['Y'], aPointB['X'], aPointB['Y'] = dim1[2]['X'], dim1[2]['Y'], dim1[3]['X'], dim1[3]['Y']
                aPointC['X'], aPointC['Y'], aPointD['X'], aPointD['Y'] = dim2[2]['X'], dim2[2]['Y'], dim2[3]['X'], dim2[3]['Y']
                ret = self.xCompute.getInterLines2( aPointA, aPointB, aPointC, aPointD, 0, 0)
                aCoords =  [{'X': 0, 'Y': 0}, {'X': 0, 'Y': 0}]
                # :::::::::::::::::
                if not ret is None:
                    self.aEnv['DIMTYPE'] = "ANGULAR"
                    aDimCoords[0]['X'], aDimCoords[0]['Y'] = ret[2:]
                    aDimCoords[1]['X'], aDimCoords[1]['Y'] = aMouseCoord['X'], aMouseCoord['Y']
                    nAbsABI = self.xCompute.getDist2Line( aPointA, aPointB, aDimCoords[0])[0]
                    if nAbsABI <= 5:
                        # print "negative absisse ABI"
                        aPointA['X'], aPointA['Y'] = 2 * aDimCoords[0]['X'] - aPointB['X'], 2 * aDimCoords[0]['Y'] - aPointB['Y']
                    nAbsCDI = self.xCompute.getDist2Line( aPointC, aPointD, aDimCoords[0])[0]
                    if nAbsCDI <= 5:
                        # print "negative absisse CDI"
                        aPointC['X'], aPointC['Y'] = 2 * aDimCoords[0]['X'] - aPointD['X'], 2 * aDimCoords[0]['Y'] - aPointD['Y']
                    nOrdCDA = 1 - 2 * (((aPointD['X'] - aPointC['X']) * (aPointA['Y'] - aPointC['Y']) - (aPointD['Y'] - aPointC['Y']) * (aPointA['X'] - aPointC['X'])) < 0)
                    nOrdABC = 1 - 2 * (((aPointB['X'] - aPointA['X']) * (aPointC['Y'] - aPointA['Y']) - (aPointB['Y'] - aPointA['Y']) * (aPointC['X'] - aPointA['X'])) < 0)
                    nOrdABM = 1 - 2 * (((aPointB['X'] - aPointA['X']) * (aMouseCoord['Y'] - aPointA['Y']) - (aPointB['Y'] - aPointA['Y']) * (aMouseCoord['X'] - aPointA['X'])) < 0)
                    nOrdCDM = 1 - 2 * (((aPointD['X'] - aPointC['X']) * (aMouseCoord['Y'] - aPointC['Y']) - (aPointD['Y'] - aPointC['Y']) * (aMouseCoord['X'] - aPointC['X'])) < 0)
                    aPolar1 = self.xCompute.toPolarCoord( aPointA, aPointB)
                    aPolar2 = self.xCompute.toPolarCoord( aPointC, aPointD)
                    # .............................
                    if nOrdCDA * nOrdCDM > 0:
                        fAngle1 = aPolar1[1] + ((aPolar1[1] <= math.pi) - (aPolar1[1] > math.pi)) * math.pi
                        aCoords[0]['X'] = aDimCoords[0]['X'] + long( round(aPolar1[0] * math.cos(fAngle1)))
                        aCoords[0]['Y'] = aDimCoords[0]['Y'] - long( round(aPolar1[0] * math.sin(fAngle1)))
                    else:
                        fAngle1 = aPolar1[1]
                        aCoords[0]['X'] = aDimCoords[0]['X'] + long( round(aPolar1[0] * math.cos(aPolar1[1])))
                        aCoords[0]['Y'] = aDimCoords[0]['Y'] - long( round(aPolar1[0] * math.sin(aPolar1[1])))
                    # .............................
                    if nOrdABC * nOrdABM > 0:
                        fAngle2 = aPolar2[1] + ((aPolar2[1] <= math.pi) - (aPolar2[1] > math.pi)) * math.pi
                        aCoords[1]['X'] = aDimCoords[0]['X'] + long( round(aPolar2[0] * math.cos(fAngle2)))
                        aCoords[1]['Y'] = aDimCoords[0]['Y'] - long( round(aPolar2[0] * math.sin(fAngle2)))
                    else:
                        fAngle2 = aPolar2[1]
                        aCoords[1]['X'] = aDimCoords[0]['X'] + long( round(aPolar2[0] * math.cos(aPolar2[1])))
                        aCoords[1]['Y'] = aDimCoords[0]['Y'] - long( round(aPolar2[0] * math.sin(aPolar2[1])))
                    fAngle = (2 * ((fAngle2 - fAngle1) < 0) - 1) * ((abs(fAngle2 - fAngle1) > math.pi) * 2 * math.pi - abs(fAngle2 - fAngle1))
                    if fAngle >= 0:
                        aDimCoords[2]['X'], aDimCoords[2]['Y'] = aCoords[0]['X'], aCoords[0]['Y']
                        aDimCoords[3]['X'], aDimCoords[3]['Y'] = aCoords[1]['X'], aCoords[1]['Y']
                    else:
                        aDimCoords[2]['X'], aDimCoords[2]['Y'] = aCoords[1]['X'], aCoords[1]['Y']
                        aDimCoords[3]['X'], aDimCoords[3]['Y'] = aCoords[0]['X'], aCoords[0]['Y']
                    self.aEnv['DIMVALUE'] = "%6.2f" % (round(math.degrees(abs(fAngle)),2),)
                else:
                    nDist1 = self.xCompute.getDist2Line( aPointA, aPointB,  aMouseCoord)
                    nDist2 = self.xCompute.getDist2Line( aPointA, aPointB,  aPointC)
                    aCoords[0] = self.xCompute.getCoordFromAbsOrd(  aPointA,  aPointB, nDist1[0]-400, 0)
                    aCoords[1] = self.xCompute.getCoordFromAbsOrd(  aPointA,  aPointB, nDist1[0]-400, nDist2[1])
                    aDimCoords = self.setLinearDimCoords(aCoords[0], aCoords[1], aMouseCoord)
            else:
                # -----------------------------
                if dim1[1] in ("LineShape",):
                    nDist1 = self.xCompute.getDist2Line( dim1[2], dim1[3],  dim2[2])
                    aDimCoords = self.setLinearDimCoords(nDist1[3], dim2[2], aMouseCoord)
                # ----------------------------
                elif dim2[1] in ('LineShape',):
                    nDist1 = self.xCompute.getDist2Line( dim2[2], dim2[3],  dim1[2])
                    aDimCoords = self.setLinearDimCoords(dim1[2], nDist1[3], aMouseCoord)
                # --
                else:
                    aDimCoords = self.setLinearDimCoords(dim1[2], dim2[2], aMouseCoord)
        if not aDimCoords is None:
            self.aEnv['DIMCOORDS'] = [{'X':l['X'], 'Y':l['Y']} for l in aDimCoords]
        else:
            self.aEnv['DIMCOORDS'] = None
        return
    # ******************************************
    # set coordinates for linear dimension
    # ******************************************
    def setLinearDimCoords(self, aStartPoint, aEndPoint, aMousePoint):
        aCoords = [{'X': 0, 'Y': 0} for i in range(7)]
        self.aEnv['DIMTYPE'] = "LINEAR"
        fAngle = self.xCompute.toPolarCoord( aStartPoint, aEndPoint)[1]
        # ::::::::::::::::::::::::::::::::::::::::::::
        if fAngle > (math.pi/2) and fAngle <= (3*math.pi/2):
            aPoint = aStartPoint
            aStartPoint = aEndPoint
            aEndPoint = aPoint
            # print "swap vertices order"
        else:
            # print "keep vertices order"
            pass
        nDist1 = self.xCompute.getDist2Line( aStartPoint, aEndPoint,  aMousePoint)
        # ::::::::::::::::::::::::
        if self.aEnv['ORTHOMODE']:
            aCoords[0]['X'], aCoords[0]['Y'] = aStartPoint['X'], aEndPoint['Y']
            aCoords[1]['X'], aCoords[1]['Y'] = aEndPoint['X'], aStartPoint['Y']
            nDist2 = self.xCompute.getDist2Line( aCoords[0], aCoords[1], aMousePoint)
            # ............................
            if nDist1[1] * nDist2[1] >= 0:
                self.aEnv['DIMVALUE'] = self.xCompute.transform2UserUnit( float(abs(aEndPoint['X'] - aStartPoint['X'])), self.aEnv['UNITS'], self.aEnv['UNITSRATIO'], self.aEnv['MEASUREUNIT'], self.aEnv['DRAWSCALE'])
                aCoords[2]['X'], aCoords[2]['Y'] = aStartPoint['X'], aMousePoint['Y']
                aCoords[3]['X'], aCoords[3]['Y'] = aEndPoint['X'], aMousePoint['Y']
                ret = self.xCompute.getCoordFromAbsOrd(  aStartPoint,  aCoords[2], 200, 0)
                aCoords[0]['X'], aCoords[0]['Y'] = aStartPoint['X'], ret['Y']
                aCoords[1]['X'], aCoords[1]['Y'] = aStartPoint['X'], aCoords[0]['Y'] + aMousePoint['Y'] - aStartPoint['Y']
                ret = self.xCompute.getCoordFromAbsOrd(  aEndPoint,  aCoords[3], 200, 0)
                aCoords[5]['X'], aCoords[5]['Y'] = aEndPoint['X'], ret['Y']
                aCoords[4]['X'], aCoords[4]['Y'] = aEndPoint['X'], aCoords[5]['Y'] + aMousePoint['Y'] - aEndPoint['Y']
            else:
                self.aEnv['DIMVALUE'] = self.xCompute.transform2UserUnit( float(abs(aEndPoint['Y'] - aStartPoint['Y'])), self.aEnv['UNITS'], self.aEnv['UNITSRATIO'], self.aEnv['MEASUREUNIT'], self.aEnv['DRAWSCALE'])
                aCoords[2]['X'], aCoords[2]['Y'] = aMousePoint['X'], aStartPoint['Y']
                aCoords[3]['X'], aCoords[3]['Y'] = aMousePoint['X'], aEndPoint['Y']
                ret = self.xCompute.getCoordFromAbsOrd(  aStartPoint,  aCoords[2], 200, 0)
                aCoords[0]['X'], aCoords[0]['Y'] = ret['X'], aStartPoint['Y']
                aCoords[1]['X'], aCoords[1]['Y'] = aCoords[0]['X'] + aMousePoint['X'] - aStartPoint['X'], aStartPoint['Y']
                ret = self.xCompute.getCoordFromAbsOrd(  aEndPoint,  aCoords[3], 200, 0)
                aCoords[5]['X'], aCoords[5]['Y'] = ret['X'], aEndPoint['Y']
                aCoords[4]['X'], aCoords[4]['Y'] = aCoords[5]['X'] + aMousePoint['X'] - aEndPoint['X'], aEndPoint['Y']
        else:
            self.aEnv['DIMVALUE'] = self.xCompute.transform2UserUnit( float(nDist1[2]), self.aEnv['UNITS'], self.aEnv['UNITSRATIO'], self.aEnv['MEASUREUNIT'], self.aEnv['DRAWSCALE'])
            ret = self.xCompute.getCoordFromAbsOrd(  aStartPoint,  aEndPoint, 0, nDist1[1])
            aCoords[2]['X'], aCoords[2]['Y'] = ret['X'], ret['Y']
            ret = self.xCompute.getCoordFromAbsOrd(  aStartPoint,  aEndPoint, nDist1[2], nDist1[1])
            aCoords[3]['X'], aCoords[3]['Y'] = ret['X'], ret['Y']
            ret = self.xCompute.getCoordFromAbsOrd(  aStartPoint,  aCoords[2], 200, 0)
            aCoords[0]['X'], aCoords[0]['Y'] = ret['X'], ret['Y']
            ret = self.xCompute.getCoordFromAbsOrd(  aCoords[0],  aCoords[2], abs(nDist1[1]), 0)
            aCoords[1]['X'], aCoords[1]['Y'] = ret['X'], ret['Y']
            ret = self.xCompute.getCoordFromAbsOrd(  aEndPoint,  aCoords[3], 200, 0)
            aCoords[5]['X'], aCoords[5]['Y'] = ret['X'], ret['Y']
            ret = self.xCompute.getCoordFromAbsOrd(  aCoords[5],  aCoords[3], abs(nDist1[1]), 0)
            aCoords[4]['X'], aCoords[4]['Y'] = ret['X'], ret['Y']
        aCoords[6]['X'], aCoords[6]['Y'] = aMousePoint['X'], aMousePoint['Y']
        return aCoords
    # ******************************************
    # set entity env and get coordinates
    # ******************************************
    def setEntityEnvAndCoord(self, cadoooShape):
        aCoords = [[]]
        # ...........................................
        if cadoooShape[1] in ('LineShape',):
            self.aEnv['UNOTYPE'] = "LineShape"
            self.aEnv['ENTITYPE'] = "LINE"
            self.aEnv['STEP'] = 1
            self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("VERTEX",)
            aCoords[0].extend([{'X': 0, 'Y': 0} for i in range(2)])
            aCoords[0][0]['X'], aCoords[0][0]['Y'] = cadoooShape[2]['X'], cadoooShape[2]['Y']
            aCoords[0][1]['X'], aCoords[0][1]['Y'] = cadoooShape[3]['X'], cadoooShape[3]['Y']
            # ........................................
        elif cadoooShape[1] in ('CircleShape',):
            self.aEnv['CIRCLEKIND'] = FULL
            self.aEnv['UNOTYPE'] = "EllipseShape"
            self.aEnv['ENTITYPE'] = "CIRCLE"
            self.aEnv['STEP'] = 1
            self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("RADIUS",)
            aCoords[0].extend([{'X': 0, 'Y': 0} for i in range(2)])
            aCoords[0][0]['X'] = cadoooShape[2]['X']
            aCoords[0][0]['Y'] = cadoooShape[2]['Y']
            aPoint = self.xCompute.getPointOnEllipse( None, math.pi/4, *cadoooShape[2:5])[0]
            aCoords[0][1]['X'] = aPoint['X']
            aCoords[0][1]['Y'] = aPoint['Y']
            # .........................................................
        elif cadoooShape[1] in ("ArcCircleShape",):
            self.aEnv['CIRCLEKIND'] = ARC
            self.aEnv['UNOTYPE'] = "EllipseShape"
            self.aEnv['ENTITYPE'] = "ARC"
            self.aEnv['STEP'] = 3
            self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("RADIUS", "STARTANGLE", "ENDANGLE")
            aCoords[0].extend([{'X': 0, 'Y': 0} for i in range(4)])
            aCoords[0][0]['X'] = cadoooShape[2]['X']
            aCoords[0][0]['Y'] = cadoooShape[2]['Y']
            aPoint = self.xCompute.getPointOnEllipse( None, math.pi/4, *cadoooShape[2:5])[0]
            aCoords[0][1]['X'] = aPoint['X']
            aCoords[0][1]['Y'] = aPoint['Y']
            aPoint = self.xCompute.getPointOnEllipse( None, cadoooShape[5], *cadoooShape[2:5])[0]
            aCoords[0][2]['X'] = aPoint['X']
            aCoords[0][2]['Y'] = aPoint['Y']
            aPoint = self.xCompute.getPointOnEllipse( None, cadoooShape[6], *cadoooShape[2:5])[0]
            aCoords[0][3]['X'] = aPoint['X']
            aCoords[0][3]['Y'] = aPoint['Y']
        else:
            aCoords = None
        return aCoords
