# 	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## dimkeyhandler mar fv 13 14:07:47 CET 2007
## Copyright (C) 2007-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno
    from com.sun.star.awt.KeyModifier import SHIFT
except ImportError:
    print "probleme d'import"
#===============================
# gestion des evenements clavier
# handling keyboard events
#===============================
class DimKeyHandler():
    """gestion des evenements clavier
    handling keyboard events"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.compute
        self.ctx = ctx
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute(self.ctx)
    # ==================================
    # actions clavier - keyboard actions
    # aNamedValues as tuple of NamedValue
    #   Name         Value
    # KEYCODE     integer
    # L2OSTATE    tuple of 5 integers (0 or 1)
    # SHAPE
    # ==================================
    def execute(self, aArgs):
        aEnv = {}
        aEnv.update(aArgs)
        lKey = aEnv['MAGNETKEY'].keys()
        lKey.sort()
        # ----------------------------------------------------------------------------------------------------
        if aEnv['KEYEVENT']['COD'] in lKey and not aEnv['KEYEVENT']['MOD']:
            # e,   i,   m,   p,   t => link 2 entities
            i = lKey.index(aEnv['KEYEVENT']['COD'])
            bKHState = list(aEnv['L2OSTATE'])
            bKHState[i] = not bKHState[i]
            aEnv['L2OSTATE'] = tuple(bKHState)
            aStatusBarCheckBox = aEnv['STATUSBARCONTROL'][aEnv['KEYEVENT']['COD']]
            if aStatusBarCheckBox.getState() != aEnv['L2OSTATE'][i]:
                aStatusBarCheckBox.setState(aEnv['L2OSTATE'][i])
            if aEnv['DIMVISIBLE']:
                aShape = aEnv['%sDIMSHAPE' % aEnv['DIMTYPE']]
                for i in range(aShape.getCount()):
                    aShape.remove(aShape.getByIndex(0))
                aEnv['CONTROLLER'].getCurrentPage().remove(aShape)
                aEnv['DIMTYPE'] = "----"
                aEnv['DIMCOORDS'] = None
                aEnv['DIMVISIBLE'] = False
        # --------------------------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('CAR', ) and aEnv['KEYEVENT']['MOD'] == SHIFT:
            # ..............................c + shift => close measure
            if not aEnv['SHAPE'] is None:
                aGroupShape = aEnv['CONTROLLER'].getCurrentPage()
                for i in aEnv['SPOTTEDID'][:-2]:
                    aGroupShape = aGroupShape.getByIndex(i)
                aGroupShape.remove(aEnv['SHAPE'])
                aEnv['SHAPE'] = None
                aEnv['STEP'] = 0
                aEnv['COORDS'] = None
            if self.aEnv['DIMTYPE'] in ("LINEAR",):
                try:
                    aStyle = self.aEnv['MODEL'].StyleFamilies.getByIndex(0).getByName("measure")
                except DisposedException:
                    aStyle = self.aEnv['LINEARDIMSHAPE'].Style
                aSize = uno.createUnoStruct("com.sun.star.awt.Size")
                aPoint = uno.createUnoStruct("com.sun.star.awt.Point")
                aSize.Width, aSize.Height = abs(aEnv['DIMCOORDS'][2]['X'] - aEnv['DIMCOORDS'][3]['X']), abs(aEnv['DIMCOORDS'][2]['Y'] - aEnv['DIMCOORDS'][3]['Y'])
                aShape = self.aEnv['MODEL'].createInstance("com.sun.star.drawing.MeasureShape")
                aPoint.X, aPoint.Y = aEnv['DIMCOORDS'][2]['X'], aEnv['DIMCOORDS'][2]['Y']
                aShape.Position = aPoint
                aShape.Size = aSize
                aShape.RotateAngle = -long(round(math.degrees(math.atan2(aEnv['DIMCOORDS'][3]['Y'] - aEnv['DIMCOORDS'][2]['Y'], aEnv['DIMCOORDS'][3]['X'] - aEnv['DIMCOORDS'][2]['X']))*100))
                self.aEnv['CONTROLLER'].CurrentPage.add(aShape)
                aShape.StartPosition = aPoint
                aPoint.X, aPoint.Y = aEnv['DIMCOORDS'][3]['X'], aEnv['DIMCOORDS'][3]['Y']
                aShape.EndPosition = aPoint
                aShape.MeasureLineDistance = 0
                aShape.MeasureHelpLineDistance = 0
                aShape.MeasureHelpLine1Length = self.xCompute.getDist2Line( aEnv['DIMCOORDS'][2], aEnv['DIMCOORDS'][3], aEnv['DIMCOORDS'][0])[1]
                aShape.MeasureHelpLine2Length = self.xCompute.getDist2Line( aEnv['DIMCOORDS'][2], aEnv['DIMCOORDS'][3], aEnv['DIMCOORDS'][5])[1]
                aShape.Style = aStyle
                self.aEnv['CONTROLLER'].CurrentPage.remove(self.aEnv['LINEARDIMSHAPE'])
            aEnv['DIMCOORDS'] = None
            aEnv['DIMTYPE'] = "---"
            aEnv['DIMLIST'] = [None, None]
            aEnv['DIMVISIBLE'] = False
            for t in ('LINEAR', 'ANGULAR', 'RADIAL', 'DIAMETRAL'):
                aEnv['%sDIMSHAPE' % t] = None
            # -----------------------
            if aEnv['REPEATMODE']:
                aEnv['STEP'] = 0
                aEnv['VALIDORIGIN'] = False
                aEnv['GROUPSHAPE'] = None
                aEnv['SHAPE'] = None
                aEnv['VALIDLIST'] = False
                aEnv['COORDS'] = None
            else:
                aEnv['STOPJOB'] = True
        # --------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('ESC',) and not aEnv['KEYEVENT']['MOD']:
            #                                 Esc => kill job
            aEnv['CANCELJOB'] = True
            if not aEnv['SHAPE'] is None:
                aGroupShape = aEnv['CONTROLLER'].getCurrentPage()
                for i in aEnv['SPOTTEDID'][:-2]:
                    aGroupShape = aGroupShape.getByIndex(i)
                aGroupShape.remove(aEnv['SHAPE'])
                aEnv['SHAPE'] = None
                aEnv['STEP'] = 0
                aEnv['COORDS'] = None
            if aEnv['DIMVISIBLE']:
                aShape = aEnv['%sDIMSHAPE' % aEnv['DIMTYPE']]
                for i in range(aShape.getCount()):
                    aShape.remove(aShape.getByIndex(0))
                aEnv['CONTROLLER'].getCurrentPage().remove(aShape)
                aEnv['DIMTYPE'] = "----"
                aEnv['DIMCOORDS'] = None
                aEnv['DIMVISIBLE'] = False
        # -------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('AXOCTRL',) and not aEnv['KEYEVENT']['MOD']:
            #                               a => axonometric mode
            aEnv['ORTHOMODE'] = not aEnv['ORTHOMODE']
            aStatusBarCheckBox = dict(aEnv['STATUSBARCONTROL'])['AXOCTRL']
            if aStatusBarCheckBox.getState() != aEnv['ORTHOMODE']:
                aStatusBarCheckBox.setState(aEnv['ORTHOMODE'])
        # --------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('MULTICTRL',) and not aEnv['KEYEVENT']['MOD']:
            #                                * => repeat mode
            aEnv['REPEATMODE'] = not aEnv['REPEATMODE']
            aStatusBarCheckBox = dict(aEnv['STATUSBARCONTROL'])['MULTICTRL']
            if aStatusBarCheckBox.getState() != aEnv['REPEATMODE']:
                aStatusBarCheckBox.setState(aEnv['REPEATMODE'])
        return aEnv
