#	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## 
## Copyright (C) 2007-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno
    import math
    from com.sun.star.lang import DisposedException
except ImportError:
    print "probleme d'import"
# ===================================================
# Gerer les saisies de points et validation d'entites
# Handle points inputs and entities validation
# ===================================================
class DimMouseHandler():
    """Gere les saisies de points et validation d'entite
    Handles points inputs and entities validation"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.compute
        self.ctx = ctx
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute( self.ctx)
    # **********************************
    # Handles mouse clicks
    # MOUSEEVENT  struct MouseEvent
    # VALIDL2O    integer (0 or 1)
    # L2OCOORD    tuple of 2 integers
    # CANCELJOB   integer (0 or 1)
    # STEP
    # COORDS
    # REPEATMODE
    # SHAPE
    # **********************************
    def execute(self, aArgs):
        self.aEnv = {}
        self.aEnv.update(aArgs)
        # +++++++++++++++++++++++++++++++++++++
        if self.aEnv['MOUSEEVENT'].Buttons > 1: # don't handle mouse buttons but left
            return aArgs
        # ++++++++++++++++++++++++++++++++
        if not self.aEnv['DIMLIST'][0] is None:
            aSpotID = self.aEnv['DIMLIST'][0][0] + (self.aEnv['DIMLIST'][0][-1],)
        else:
            aSpotID = ()
        # ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        if self.aEnv['MOUSEEVENT'].ClickCount == 2 or not self.aEnv['DIMLIST'][1] is None or self.aEnv['SPOTTEDSHAPE'] is None or self.aEnv['SPOTTEDID'] == aSpotID:
            self.removeTempShapes(True, False)
            if self.aEnv['DIMTYPE'] in ("LINEAR",):
                try:
                    aStyle = self.aEnv['MODEL'].StyleFamilies.getByIndex(0).getByName("measure")
                except DisposedException:
                    aStyle = self.aEnv['LINEARDIMSHAPE'].Style
                aSize = uno.createUnoStruct("com.sun.star.awt.Size")
                aPoint = uno.createUnoStruct("com.sun.star.awt.Point")
                aSize.Width, aSize.Height = abs(self.aEnv['DIMCOORDS'][2]['X'] - self.aEnv['DIMCOORDS'][3]['X']), abs(self.aEnv['DIMCOORDS'][2]['Y'] - self.aEnv['DIMCOORDS'][3]['Y'])
                aShape = self.aEnv['MODEL'].createInstance("com.sun.star.drawing.MeasureShape")
                aPoint.X, aPoint.Y = self.aEnv['DIMCOORDS'][2]['X'], self.aEnv['DIMCOORDS'][2]['Y']
                aShape.Position = aPoint
                aShape.Size = aSize
                aShape.RotateAngle = -long(round(math.degrees(math.atan2(self.aEnv['DIMCOORDS'][3]['Y'] - self.aEnv['DIMCOORDS'][2]['Y'], self.aEnv['DIMCOORDS'][3]['X'] - self.aEnv['DIMCOORDS'][2]['X']))*100))
                self.aEnv['CONTROLLER'].CurrentPage.add(aShape)
                aShape.StartPosition = aPoint
                aPoint.X, aPoint.Y = self.aEnv['DIMCOORDS'][3]['X'], self.aEnv['DIMCOORDS'][3]['Y']
                aShape.EndPosition = aPoint
                aShape.MeasureLineDistance = 0
                aShape.MeasureHelpLineDistance = 0
                aShape.MeasureHelpLine1Length = self.xCompute.getDist2Line(self.aEnv['DIMCOORDS'][2], self.aEnv['DIMCOORDS'][3], self.aEnv['DIMCOORDS'][0])[1]
                aShape.MeasureHelpLine2Length = self.xCompute.getDist2Line(self.aEnv['DIMCOORDS'][2], self.aEnv['DIMCOORDS'][3], self.aEnv['DIMCOORDS'][5])[1]
                aShape.Style = aStyle
                self.aEnv['CONTROLLER'].CurrentPage.remove(self.aEnv['LINEARDIMSHAPE'])
            # print "dimension finished"
            if self.aEnv['DIMTYPE'] in ('ANGULAR', 'RADIAL', 'DIAMETRAL'):
                for i in range(self.aEnv['%sDIMSHAPE' % (self.aEnv['DIMTYPE'])].getCount()):
                    aShape = self.aEnv['%sDIMSHAPE' % (self.aEnv['DIMTYPE'])].getByIndex(i)
                    aShape.LineColor = self.aEnv['STANDARDSTYLE'].LineColor
                    aShape.LineWidth = self.aEnv['STANDARDSTYLE'].LineWidth
            self.aEnv['DIMCOORDS'] = None
            self.aEnv['DIMTYPE'] = "---"
            self.aEnv['DIMLIST'] = [None, None]
            self.aEnv['DIMVISIBLE'] = False
            for t in ('LINEAR', 'ANGULAR', 'RADIAL', 'DIAMETRAL'):
                self.aEnv['%sDIMSHAPE' % t] = None
            # ----------------------------
            if self.aEnv['REPEATMODE']: # repeat mode on ?
                self.aEnv['VALIDORIGIN'] = False
                self.aEnv['VALIDLIST'] = False
                self.aEnv['GROUPSHAPE'] = self.aEnv['CONTROLLER'].getCurrentPage()
            else:
                self.aEnv['STOPJOB'] = True
            return self.aEnv
        if self.aEnv['DIMLIST'][0] is None:
            self.aEnv['DIMLIST'][0] = self.aEnv['SPOTTEDSHAPE']
        else:
            self.aEnv['DIMLIST'][1] = self.aEnv['SPOTTEDSHAPE']
        return aArgs
    # *****************************************************
    # remove temporary shapes
    # *****************************************************
    def removeTempShapes(self, bShape = True, bDim = True):
        if not self.aEnv['SHAPE'] is None and bShape:
            aGroupShape = self.aEnv['CONTROLLER'].getCurrentPage()
            if len(self.aEnv['SPOTTEDID']) > 2:
                for i in self.aEnv['SPOTTEDID'][:-2]:
                    aGroupShape = aGroupShape.getByIndex(i)
            aGroupShape.remove(self.aEnv['SHAPE'])
            self.aEnv['SHAPE'] = None
            self.aEnv['STEP'] = 0
            self.aEnv['COORDS'] = ((),)
            self.aEnv['SPOTTEDID'] = None
        if self.aEnv['DIMTYPE'] in ('LINEAR', 'ANGULAR', 'RADIAL', 'DIAMETRAL') and bDim:
            aShape = self.aEnv['%sDIMSHAPE' % self.aEnv['DIMTYPE']]
            if self.aEnv['DIMTYPE'] in ('ANGULAR', 'RADIAL', 'DIAMETRAL'):
                for i in range(aShape.getCount()):
                    aShape.remove(aShape.getByIndex(i))
            self.aEnv['CONTROLLER'].getCurrentPage().remove(aShape)
            self.aEnv['DIMTYPE'] = "----"
            self.aEnv['DIMCOORDS'] = None
            self.aEnv['DIMVISIBLE'] = False
        return
