# 	$Id$	
# -*- coding: latin-1 -*-
## ********************************************************************************
## dimpossize 
## Copyright (C) 2007-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno
    import math
    from com.sun.star.drawing.CircleKind import ARC, FULL
except ImportError:
    print "probleme d'import"
# =====================================
# dessin de cotes
# drawing of measure
# =====================================
class DimPosSize():
    """dessin de cote
    drawing of measure"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.compute
        self.ctx = ctx
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute(self.ctx)
    # =============================
    # needed from dict env
    # DIMTYPE
    # DIMSHAPE
    # DIMCOORDS
    # DIMVISIBLE
    # CONTROLLER
    # MODEL
    # ==============================
    def execute(self, aNamedValues):
        aEnv = {}
        aEnv.update(aNamedValues)
        aBiPoint = ((uno.createUnoStruct("com.sun.star.awt.Point"), uno.createUnoStruct("com.sun.star.awt.Point")),)
        aULCCoord = uno.createUnoStruct("com.sun.star.awt.Point")
        aSize = uno.createUnoStruct("com.sun.star.awt.Size")
        aGroupShape = aEnv['%sDIMSHAPE' % aEnv['DIMTYPE']]
        # +++++++++++++++++++++++++++++++++++++++++++++++
        if not aEnv['DIMVISIBLE'] or aGroupShape is None:
            # ---------------------
            if aGroupShape is None:
                aGroupShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.GroupShape")
            aEnv['CONTROLLER'].CurrentPage.add(aGroupShape)
            aEnv['DIMVISIBLE'] = True
        # +++++++++++++++++++++++++++++++
        if aEnv['DIMTYPE'] == 'LINEAR': # drawing a linear measure
            # ------------------------ help line 1
            if aGroupShape.Count == 0:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.LineShape")
                aGroupShape.add(aShape)
                aShape.setName("helpline1")
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(0)
            aBiPoint[0][0].X, aBiPoint[0][0].Y, aBiPoint[0][1].X, aBiPoint[0][1].Y = aEnv['DIMCOORDS'][0]['X'], aEnv['DIMCOORDS'][0]['Y'], aEnv['DIMCOORDS'][1]['X'], aEnv['DIMCOORDS'][1]['Y']
            aShape.PolyPolygon = aBiPoint
            # ------------------------ base line
            if aGroupShape.Count == 1:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.LineShape")
                aShape.setName("baseline")
                aGroupShape.add(aShape)
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(1)
            aBiPoint[0][0].X, aBiPoint[0][0].Y, aBiPoint[0][1].X, aBiPoint[0][1].Y = aEnv['DIMCOORDS'][2]['X'], aEnv['DIMCOORDS'][2]['Y'], aEnv['DIMCOORDS'][3]['X'], aEnv['DIMCOORDS'][3]['Y']
            aShape.PolyPolygon = aBiPoint
            aShape.LineStartName = aShape.LineEndName = "Arrow"
            aShape.LineStartWidth = aShape.LineEndWidth = 200
            # ------------------------ help line 2
            if aGroupShape.Count == 2:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.LineShape")
                aShape.setName("helpline2")
                aGroupShape.add(aShape)
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(2)
            aBiPoint[0][0].X, aBiPoint[0][0].Y, aBiPoint[0][1].X, aBiPoint[0][1].Y = aEnv['DIMCOORDS'][4]['X'], aEnv['DIMCOORDS'][4]['Y'], aEnv['DIMCOORDS'][5]['X'], aEnv['DIMCOORDS'][5]['Y']
            aShape.PolyPolygon = aBiPoint
            # ------------------------ text
            if aGroupShape.Count == 3:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.TextShape")
                aShape.setName("value")
                aGroupShape.add(aShape)
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(3)
            fAngle1 = self.xCompute.toPolarCoord( aEnv['DIMCOORDS'][2], aEnv['DIMCOORDS'][3])[1]
            aSize.Width = 150 * len(aEnv['DIMVALUE'])
            aSize.Height = 250
            aShape.setSize(aSize)
            nDist2 = self.xCompute.getDist2Line( aEnv['DIMCOORDS'][2], aEnv['DIMCOORDS'][3], aEnv['DIMCOORDS'][6])
            aPoint = self.xCompute.getCoordFromAbsOrd(  aEnv['DIMCOORDS'][2],  aEnv['DIMCOORDS'][3], nDist2[0] - aSize.Width / 2, -500)
            aULCCoord.X, aULCCoord.Y = aPoint['X'], aPoint['Y']
            aShape.setPosition(aULCCoord)
            aShape.TextAutoGrowHeight = True
            aShape.TextAutoGrowWidth = True
            aShape.CharHeight = 8
            aShape.RotateAngle = long(fAngle1 * 18000 / math.pi)
            aTextCursor = aShape.createTextCursor()
            aTextCursor.gotoEnd(False)
            aTextCursor.gotoStart(True)
            aShape.insertString(aTextCursor, aEnv['DIMVALUE'], True)
        # ++++++++++++++++++++++++++++++++
        elif aEnv['DIMTYPE'] == 'ANGULAR': # drawing an angular measure 
            # ------------------------ arc baseline
            if aGroupShape.Count == 0:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.EllipseShape")
                aGroupShape.add(aShape)
                aShape.setName("baseline")
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(0)
            fAngle1 = self.xCompute.toPolarCoord( aEnv['DIMCOORDS'][0], aEnv['DIMCOORDS'][2])[1]
            fAngle2 = self.xCompute.toPolarCoord( aEnv['DIMCOORDS'][0], aEnv['DIMCOORDS'][3])[1]
            nRadius, fAngle3 = self.xCompute.toPolarCoord( aEnv['DIMCOORDS'][0], aEnv['DIMCOORDS'][1])
            aULCCoord.X = aEnv['DIMCOORDS'][0]['X'] - nRadius
            aULCCoord.Y = aEnv['DIMCOORDS'][0]['Y'] - nRadius
            aSize.Width = aSize.Height = 2 * nRadius
            aShape.CircleKind = ARC
            aShape.CircleStartAngle = long(math.degrees(fAngle1) * 100)
            aShape.CircleEndAngle = long(math.degrees(fAngle2) * 100)
            aShape.LineStartName = aShape.LineEndName = "Arrow"
            aShape.LineStartWidth = aShape.LineEndWidth = 200
            aShape.setPosition(aULCCoord)
            aShape.setSize(aSize)
            # ------------------------ value
            if aGroupShape.Count == 1:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.TextShape")
                aGroupShape.add(aShape)
                aShape.setName("Value")
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(1)
            # ------------
            aSize.Width = 150 * len(aEnv['DIMVALUE'])
            aSize.Height = 250
            aShape.setSize(aSize)
            if fAngle3 <= math.pi:
                nSign = 1
            else:
                nSign = -1
            aPoint = self.xCompute.getCoordFromAbsOrd(  aEnv['DIMCOORDS'][0],  aEnv['DIMCOORDS'][1], nRadius + nSign * 500, -nSign * aSize.Width / 2)
            aULCCoord.X, aULCCoord.Y = aPoint['X'], aPoint['Y']
            aShape.setPosition(aULCCoord)
            aShape.TextAutoGrowHeight = True
            aShape.TextAutoGrowWidth = True
            aShape.CharHeight = 8
            aShape.RotateAngle = long(math.degrees(fAngle3 - nSign * math.pi / 2) * 100) % 36000
            aTextCursor = aShape.createTextCursor()
            aTextCursor.gotoEnd(False)
            aTextCursor.gotoStart(True)
            aShape.insertString(aTextCursor, aEnv['DIMVALUE'], True)
        # +++++++++++++++++++++++++++++++++++++++++++++++
        elif aEnv['DIMTYPE'] in ("RADIAL",  "DIAMETRAL"):
            nRadius = self.xCompute.toPolarCoord( aEnv['DIMCOORDS'][0], aEnv['DIMCOORDS'][1])[0]
            # ------------------------ 1st helpline
            if aGroupShape.Count == 0:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.LineShape")
                aGroupShape.add(aShape)
                aShape.setName("helpline1")
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(0)
            aBiPoint[0][0].X, aBiPoint[0][0].Y, aBiPoint[0][1].X, aBiPoint[0][1].Y = aEnv['DIMCOORDS'][1]['X'], aEnv['DIMCOORDS'][1]['Y'], aEnv['DIMCOORDS'][2]['X'], aEnv['DIMCOORDS'][2]['Y']
            aShape.PolyPolygon = aBiPoint
            aShape.LineStartName = "Arrow"
            aShape.LineStartWidth = 200
            # ------------------------ baseline
            if aGroupShape.Count == 1:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.LineShape")
                aGroupShape.add(aShape)
                aShape.setName("baseline")
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(1)
            # -------------------------------------------------
            if aEnv['DIMCOORDS'][3]['X'] > aEnv['DIMCOORDS'][2]['X']:
                aEnv['DIMCOORDS'][3]['X'] = aEnv['DIMCOORDS'][2]['X'] + len(aEnv['DIMVALUE']) * 125
            else:
                aEnv['DIMCOORDS'][3]['X'] = aEnv['DIMCOORDS'][2]['X'] - len(aEnv['DIMVALUE']) * 125
            aBiPoint[0][0].X, aBiPoint[0][0].Y, aBiPoint[0][1].X, aBiPoint[0][1].Y = aEnv['DIMCOORDS'][2]['X'], aEnv['DIMCOORDS'][2]['Y'], aEnv['DIMCOORDS'][3]['X'], aEnv['DIMCOORDS'][3]['Y']
            aShape.PolyPolygon = aBiPoint
            # ------------------------ value
            if aGroupShape.Count == 2:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.TextShape")
                aGroupShape.add(aShape)
                aShape.setName("value")
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(2)
            # -------------------------------------------------
            if aEnv['DIMCOORDS'][3]['X'] > aEnv['DIMCOORDS'][2]['X']:
                aULCCoord.X = aEnv['DIMCOORDS'][2]['X']
                aULCCoord.Y = aEnv['DIMCOORDS'][2]['Y'] - 500
            else:
                aULCCoord.X = aEnv['DIMCOORDS'][3]['X']
                aULCCoord.Y = aEnv['DIMCOORDS'][3]['Y'] - 500
            aSize.Width = 150 * len(aEnv['DIMVALUE'])
            aSize.Height = 250
            aShape.setPosition(aULCCoord)
            aShape.setSize(aSize)
            aShape.TextAutoGrowHeight = True
            aShape.TextAutoGrowWidth = True
            aShape.CharHeight = 8
            aTextCursor = aShape.createTextCursor()
            aTextCursor.gotoEnd(False)
            aTextCursor.gotoStart(True)
            aShape.insertString(aTextCursor, aEnv['DIMVALUE'], True)
            aShape.setName("Value")
        aGroupShape.setPropertyValue("SizeProtect", True)
        aGroupShape.setPropertyValue("MoveProtect", True)
        aGroupShape.setName("dimension")
        aEnv['%sDIMSHAPE' % aEnv['DIMTYPE']] = aGroupShape
        return aEnv
