#	$Id: divein.py,v 1.2 2007/03/05 15:33:37 gerard Exp $
# -*- coding: latin-1 -*-
## ********************************************************************************
## 
## Copyright (C) 2005-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper
    import traceback, StringIO, os, array
    from com.sun.star.awt import XActionListener, XItemListener
    from com.sun.star.beans.MethodConcept import ALL as METHOD_CONCEPT_ALL
    from com.sun.star.beans.PropertyConcept import ALL as PROPERTY_CONCEPT_ALL
    from com.sun.star.ui.dialogs.TemplateDescription import FILESAVE_SIMPLE

    from com.sun.star.reflection.ParamMode import \
         IN as PARAM_MODE_IN, \
         OUT as PARAM_MODE_OUT, \
         INOUT as PARAM_MODE_INOUT

    from com.sun.star.beans.PropertyAttribute import \
         MAYBEVOID as PROP_ATTR_MAYBEVOID, \
         BOUND as PROP_ATTR_BOUND, \
         CONSTRAINED as PROP_ATTR_CONSTRAINED, \
         TRANSIENT as PROP_ATTR_TRANSIENT, \
         READONLY as PROP_ATTR_READONLY, \
         MAYBEAMBIGUOUS as PROP_ATTR_MAYBEAMBIGUOUS, \
         MAYBEDEFAULT as PROP_ATTR_MAYBEDEFAULT, \
         REMOVEABLE as PROP_ATTR_REMOVEABLE
except ImportError:
    print "probleme d'import"
##
## Introspection function
##
def writeObjectInfo(sFileName, object):
    f = StringIO.StringIO()
    unohelper.inspect(object, f)
    fp=open(sFileName,'w')
    fp.write(f.getvalue())
    fp.close()
    f.close()
# ===============================================
# a class to dive in uno object
# une classe pour naviguer au sein d'un objet uno
# ===============================================
class DiveIn(unohelper.Base, XActionListener, XItemListener):
    """Navigation au sein d'objets uno
    Diving in uno objects"""
    def __init__(self, ctx):
        self.ctx = ctx
        self.bOK = False
        self.smgr = self.ctx.ServiceManager
    # ******************************
    def execute(self, aObject):
        import fr.free.deneux.gerard.cadooo.msgl10n
        self.aObjects = [aObject]
        if hasattr(self.aObjects[-1], "getImplementationName"):
            self.aHistory = [self.aObjects[-1].getImplementationName().split(".")[-1]]
        else:
            self.aHistory = ["Base"]
        # translation module
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
        self.aArgs = xMsgL10n.getText(["di%d" % i for i in range(16)])
        # Box dimensions
        aBox = uno.createUnoStruct("com.sun.star.awt.Rectangle")
        aBox.Width, aBox.Height = 256, 256
        aBox.X = 0
        aBox.Y = 0
        # create the dialog model and set the properties
        DiveInDialogModel = self.ctx.ServiceManager.createInstanceWithContext( "com.sun.star.awt.UnoControlDialogModel", self.ctx)
        DiveInDialogModel.setPropertyValue("PositionX", aBox.X)
        DiveInDialogModel.setPropertyValue("PositionY", aBox.Y)
        DiveInDialogModel.setPropertyValue("Width", aBox.Width)
        DiveInDialogModel.setPropertyValue("Height", aBox.Height)
        DiveInDialogModel.setPropertyValue("Title", self.aArgs[0])
        # create the close button model and set the properties
        ButtonModel1 = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlButtonModel" )
        ButtonModel1.setPropertyValue("PositionX", 9)
        ButtonModel1.setPropertyValue("PositionY", 236)
        ButtonModel1.setPropertyValue("Width", 50)
        ButtonModel1.setPropertyValue("Height", 15)
        ButtonModel1.setPropertyValue("Name", "Button1")
        ButtonModel1.setPropertyValue("TabIndex", 6)
        ButtonModel1.setPropertyValue("Label", self.aArgs[1])
        ButtonModel1.setPropertyValue("DefaultButton", True)
        # create the save button model and set the properties
        ButtonModel2 = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlButtonModel" )
        ButtonModel2.setPropertyValue("PositionX", 71)
        ButtonModel2.setPropertyValue("PositionY", 236)
        ButtonModel2.setPropertyValue("Width", 50)
        ButtonModel2.setPropertyValue("Height", 15)
        ButtonModel2.setPropertyValue("Name", "Button2")
        ButtonModel2.setPropertyValue("TabIndex", 7)
        ButtonModel2.setPropertyValue("Label", self.aArgs[2])
        # create the inspect button model and set the properties
        ButtonModel3 = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlButtonModel" )
        ButtonModel3.setPropertyValue("PositionX", 133)
        ButtonModel3.setPropertyValue("PositionY", 236)
        ButtonModel3.setPropertyValue("Width", 50)
        ButtonModel3.setPropertyValue("Height", 15)
        ButtonModel3.setPropertyValue("Name", "Button3")
        ButtonModel3.setPropertyValue("TabIndex", 8)
        ButtonModel3.setPropertyValue("Label", self.aArgs[14])
        # create the previous button model and set the properties
        ButtonModel4 = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlButtonModel" )
        ButtonModel4.setPropertyValue("PositionX", 195)
        ButtonModel4.setPropertyValue("PositionY", 236)
        ButtonModel4.setPropertyValue("Width", 50)
        ButtonModel4.setPropertyValue("Height", 15)
        ButtonModel4.setPropertyValue("Name", "Button4")
        ButtonModel4.setPropertyValue("TabIndex", 9)
        ButtonModel4.setPropertyValue("Label", self.aArgs[15])
        DiveInDialogModel.insertByName("Button1", ButtonModel1)
        DiveInDialogModel.insertByName("Button2", ButtonModel2)
        DiveInDialogModel.insertByName("Button3", ButtonModel3)
        DiveInDialogModel.insertByName("Button4", ButtonModel4)
        # --------------- Supported services ------------------
        # create the label model and set the properties
        ServiceLabelModel = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        ServiceLabelModel.setPropertyValue("PositionX", 10)
        ServiceLabelModel.setPropertyValue("PositionY", 40)
        ServiceLabelModel.setPropertyValue("Width", 40)
        ServiceLabelModel.setPropertyValue("Height", 15)
        ServiceLabelModel.setPropertyValue("Name", "LabelService")
        ServiceLabelModel.setPropertyValue("TabIndex", 8)
        ServiceLabelModel.setPropertyValue("MultiLine", False)
        ServiceLabelModel.setPropertyValue("Label", self.aArgs[4])
        # create the listbox model and set the properties
        ServiceListBoxModel = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlListBoxModel" )
        ServiceListBoxModel.setPropertyValue("PositionX", 60)
        ServiceListBoxModel.setPropertyValue("PositionY", 40)
        ServiceListBoxModel.setPropertyValue("Width", 190)
        ServiceListBoxModel.setPropertyValue("Height", 15)
        ServiceListBoxModel.setPropertyValue("Name", "ListService")
        ServiceListBoxModel.setPropertyValue("TabIndex", 1)
        ServiceListBoxModel.setPropertyValue("Dropdown", True)
        ServiceListBoxModel.setPropertyValue("HelpText", self.aArgs[5])
        # insert the control models into the dialog model
        DiveInDialogModel.insertByName("LabelService", ServiceLabelModel)
        DiveInDialogModel.insertByName("ListService", ServiceListBoxModel)
        # --------------- Supported interfaces ------------------
        # create the label model and set the properties
        InterfaceLabelModel = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        InterfaceLabelModel.setPropertyValue("PositionX", 10)
        InterfaceLabelModel.setPropertyValue("PositionY", 70)
        InterfaceLabelModel.setPropertyValue("Width", 40)
        InterfaceLabelModel.setPropertyValue("Height", 15)
        InterfaceLabelModel.setPropertyValue("Name", "LabelInterface")
        InterfaceLabelModel.setPropertyValue("TabIndex", 9)
        InterfaceLabelModel.setPropertyValue("MultiLine", False)
        InterfaceLabelModel.setPropertyValue("Label", self.aArgs[6])
        # create the listbox model and set the properties
        InterfaceListBoxModel = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlListBoxModel" )
        InterfaceListBoxModel.setPropertyValue("PositionX", 60)
        InterfaceListBoxModel.setPropertyValue("PositionY", 70)
        InterfaceListBoxModel.setPropertyValue("Width", 190)
        InterfaceListBoxModel.setPropertyValue("Height", 15)
        InterfaceListBoxModel.setPropertyValue("Name", "ListInterface")
        InterfaceListBoxModel.setPropertyValue("TabIndex", 2)
        InterfaceListBoxModel.setPropertyValue("Dropdown", True)
        InterfaceListBoxModel.setPropertyValue("HelpText", self.aArgs[7])
        # insert the control models into the dialog model
        DiveInDialogModel.insertByName("LabelInterface", InterfaceLabelModel)
        DiveInDialogModel.insertByName("ListInterface", InterfaceListBoxModel)
        # --------------- Supported methods ------------------
        # create the label model and set the properties
        MethodLabelModel = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        MethodLabelModel.setPropertyValue("PositionX", 10)
        MethodLabelModel.setPropertyValue("PositionY", 100)
        MethodLabelModel.setPropertyValue("Width", 40)
        MethodLabelModel.setPropertyValue("Height", 15)
        MethodLabelModel.setPropertyValue("Name", "LabelMethod")
        MethodLabelModel.setPropertyValue("TabIndex", 10)
        MethodLabelModel.setPropertyValue("MultiLine", False)
        MethodLabelModel.setPropertyValue("Label", self.aArgs[8])
        # create the listbox model and set the properties
        MethodListBoxModel = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlListBoxModel" )
        MethodListBoxModel.setPropertyValue("PositionX", 60)
        MethodListBoxModel.setPropertyValue("PositionY", 100)
        MethodListBoxModel.setPropertyValue("Width", 190)
        MethodListBoxModel.setPropertyValue("Height", 15)
        MethodListBoxModel.setPropertyValue("Name", "ListMethod")
        MethodListBoxModel.setPropertyValue("TabIndex", 3)
        MethodListBoxModel.setPropertyValue("Dropdown", True)
        MethodListBoxModel.setPropertyValue("HelpText", self.aArgs[9])
        # insert the control models into the dialog model
        DiveInDialogModel.insertByName("LabelMethod", MethodLabelModel)
        DiveInDialogModel.insertByName("ListMethod", MethodListBoxModel)
        # --------------- Supported properties ------------------
        # create the label model and set the properties
        PropertyLabelModel = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        PropertyLabelModel.setPropertyValue("PositionX", 10)
        PropertyLabelModel.setPropertyValue("PositionY", 130)
        PropertyLabelModel.setPropertyValue("Width", 40)
        PropertyLabelModel.setPropertyValue("Height", 15)
        PropertyLabelModel.setPropertyValue("Name", "LabelProperty")
        PropertyLabelModel.setPropertyValue("TabIndex", 11)
        PropertyLabelModel.setPropertyValue("MultiLine", False)
        PropertyLabelModel.setPropertyValue("Label", self.aArgs[10])
        # create the listbox model and set the properties
        PropertyListBoxModel = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlListBoxModel" )
        PropertyListBoxModel.setPropertyValue("PositionX", 60)
        PropertyListBoxModel.setPropertyValue("PositionY", 130)
        PropertyListBoxModel.setPropertyValue("Width", 190)
        PropertyListBoxModel.setPropertyValue("Height", 15)
        PropertyListBoxModel.setPropertyValue("Name", "ListProperty")
        PropertyListBoxModel.setPropertyValue("TabIndex", 4)
        PropertyListBoxModel.setPropertyValue("Dropdown", True)
        PropertyListBoxModel.setPropertyValue("HelpText", self.aArgs[11])
        # insert the control models into the dialog model
        DiveInDialogModel.insertByName("LabelProperty", PropertyLabelModel)
        DiveInDialogModel.insertByName("ListProperty", PropertyListBoxModel)
        # --------------- Supported values ------------------
        # create the label model and set the properties
        ValueLabelModel = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        ValueLabelModel.setPropertyValue("PositionX", 10)
        ValueLabelModel.setPropertyValue("PositionY", 160)
        ValueLabelModel.setPropertyValue("Width", 40)
        ValueLabelModel.setPropertyValue("Height", 15)
        ValueLabelModel.setPropertyValue("Name", "LabelValue")
        ValueLabelModel.setPropertyValue("TabIndex", 12)
        ValueLabelModel.setPropertyValue("MultiLine", False)
        ValueLabelModel.setPropertyValue("Label", self.aArgs[12])
        # create the listbox model and set the properties
        ValueListBoxModel = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlListBoxModel" )
        ValueListBoxModel.setPropertyValue("PositionX", 60)
        ValueListBoxModel.setPropertyValue("PositionY", 160)
        ValueListBoxModel.setPropertyValue("Width", 190)
        ValueListBoxModel.setPropertyValue("Height", 15)
        ValueListBoxModel.setPropertyValue("Name", "ListValue")
        ValueListBoxModel.setPropertyValue("TabIndex", 5)
        ValueListBoxModel.setPropertyValue("Dropdown", True)
        ValueListBoxModel.setPropertyValue("HelpText", self.aArgs[13])
        # insert the control models into the dialog model
        DiveInDialogModel.insertByName("LabelValue", ValueLabelModel)
        DiveInDialogModel.insertByName("ListValue", ValueListBoxModel)
        # create the history label model and set the properties
        HistoryLabelModel = DiveInDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        HistoryLabelModel.setPropertyValue("PositionX", 10)
        HistoryLabelModel.setPropertyValue("PositionY", 190)
        HistoryLabelModel.setPropertyValue("Width", 236)
        HistoryLabelModel.setPropertyValue("Height", 30)
        HistoryLabelModel.setPropertyValue("Name", "LabelHistory")
        HistoryLabelModel.setPropertyValue("TabIndex", 12)
        HistoryLabelModel.setPropertyValue("MultiLine", False)
        HistoryLabelModel.setPropertyValue("Label", self.aHistory[-1])
        DiveInDialogModel.insertByName("LabelHistory", HistoryLabelModel)
        # create the dialog control and set the model
        self.DiveInDialogControl = self.ctx.ServiceManager.createInstanceWithContext( "com.sun.star.awt.UnoControlDialog", self.ctx)
        self.DiveInDialogControl.setModel(DiveInDialogModel)
        # add items in lists
        self.getDataInspection()
        # add an action listener to the button1 control 
        aButton1 = self.DiveInDialogControl.getControl("Button1")
        aButton1.setActionCommand("close")
        aButton1.addActionListener(self)
        # add an action listener to the button2 control 
        aButton2 = self.DiveInDialogControl.getControl("Button2")
        aButton2.setActionCommand("save")
        aButton2.addActionListener(self)
        # add an action listener to the button3 control 
        aButton3 = self.DiveInDialogControl.getControl("Button3")
        aButton3.setActionCommand("inspect")
        aButton3.addActionListener(self)
        # add an action listener to the button4 control 
        aButton4 = self.DiveInDialogControl.getControl("Button4")
        aButton4.setActionCommand("previous")
        aButton4.addActionListener(self)
        # add a listener to the item list
        aItemList = self.DiveInDialogControl.getControl("ListProperty")
        aItemList.addItemListener(self)
        # create a peer 
        aToolkit = self.ctx.ServiceManager.createInstanceWithContext( "com.sun.star.awt.Toolkit", self.ctx)
        self.DiveInDialogControl.setVisible(0)
        self.DiveInDialogControl.createPeer(aToolkit, aToolkit.getDesktopWindow())
        # execute the dialog 
        self.DiveInDialogControl.execute()
        # remove an action listener to the button1 control 
        aButton1.removeActionListener(self)
        # remove an action listener to the button2 control 
        aButton2.removeActionListener(self)
        aItemList.removeItemListener(self)
        return aObject
    # --------------------------------
    def convertMode2Str( self, mode ):
        ret = "[]"
        if mode == PARAM_MODE_INOUT:
            ret = "[inout]"
        elif mode == PARAM_MODE_OUT:
            ret = "[out]"
        elif mode == PARAM_MODE_IN:
            ret = "[in]"
        return ret
    # ------------------------------------
    def convertPropMode2Str( self, mode ):
        ret = ""
        if PROP_ATTR_REMOVEABLE & mode:
            ret = ret + "removeable "
        if PROP_ATTR_MAYBEDEFAULT & mode:
            ret = ret + "maybedefault "
        if PROP_ATTR_MAYBEAMBIGUOUS & mode:
            ret = ret + "maybeambigous "
        if PROP_ATTR_READONLY & mode:
            ret = ret + "readonly "
        if PROP_ATTR_TRANSIENT & mode:
            ret = ret + "transient "
        if PROP_ATTR_CONSTRAINED & mode:
            ret = ret + "constrained "
        if PROP_ATTR_BOUND & mode:
            ret = ret + "bound "
        if PROP_ATTR_MAYBEVOID & mode:
            ret = ret + "maybevoid "
        return ret.rstrip()
    # XEventListener 
    def disposing(self, eventObject):
        self.DiveInDialogControl = None
    # XActionListener 
    def actionPerformed(self, actionEvent):
        if actionEvent.ActionCommand == "close":
            self.DiveInDialogControl.endExecute()
        elif actionEvent.ActionCommand == "inspect" :
            sItem = self.DiveInDialogControl.getControl("ListProperty").getSelectedItem().split()
            if hasattr(self.aObjects[-1], sItem[-1]):
                self.aObjects.append(getattr(self.aObjects[-1], sItem[-1]))
                self.aHistory.append(sItem[-1])
                if self.aObjects[-1] is None:
                    self.aObjects.pop()
                    self.aHistory.pop()
                self.getDataInspection()
                self.DiveInDialogControl.getControl("LabelHistory").setText("==>".join(self.aHistory))
            else:
                print "This object has no attribute %s" % sItem[-1]
        elif actionEvent.ActionCommand == "previous":
            if len(self.aObjects) > 1:
                self.aObjects.pop()
                self.aHistory.pop()
                self.DiveInDialogControl.getControl("LabelHistory").setText("==>".join(self.aHistory))
            self.getDataInspection()
        # saving in file
        else:
            aFilePicker = self.smgr.createInstanceWithArgumentsAndContext("com.sun.star.ui.dialogs.FilePicker", (FILESAVE_SIMPLE,), self.ctx)
            aFilePicker.appendFilter("All files (*.*)", "*.*")
            aFilePicker.setCurrentFilter("All files (*.*)")
            aFilePicker.setDisplayDirectory(unohelper.systemPathToFileUrl( os.getcwd()))
            aFilePicker.setMultiSelectionMode(False)
            if aFilePicker.execute():
                writeObjectInfo(unohelper.fileUrlToSystemPath( aFilePicker.getFiles()[0]), self.aObjects[-1])
    # XItemListener
    def itemStateChanged(self, aItemEvent):
        sItem = self.DiveInDialogControl.getControl("ListProperty").getSelectedItem().split()
        aListControl = self.DiveInDialogControl.getControl("ListValue")
        sPropValue = []
        if hasattr(self.aObjects[-1], sItem[-1]):
            aPropValue = getattr(self.aObjects[-1], sItem[-1])
            if sItem[-2] in ('string',) or aPropValue is None:
                sPropValue.append("%s" % repr(aPropValue))
            elif sItem[-2] in ('long', 'short', 'boolean'):
                sPropValue.append("%d" % aPropValue)
            elif sItem[-2] in ('float',):
                sPropValue.append("%f" % aPropValue)
            elif sItem[-2][0] == "[":
                if "byte" in sItem[-2]:
                    try:
                        aPropValue = repr(aPropValue)
                        sPropValue.append("size %d" % len(aPropValue))
                        sPropValue.append("".join(["%02x" % ord(aPropValue[p]) for p in range(len(aPropValue))]))
                    except:
                        traceback.print_exc()
                else:
                    sPropValue.append("size %d" % len(aPropValue))
                    if sItem[-2] in ('[]long', '[]short', '[]boolean'):
                        for p in aPropValue:
                            sPropValue.append("%d" % p)
                    elif sItem[-2] in ('[]float',):
                        for p in aPropValue:
                            sPropValue.append("%f" % p)
                    else:
                        for p in aPropValue:
                            sPropValue.append("%s" % repr(p))
            elif sItem[-3].lower() in ('struct',):
                sPropValue.append("%s" % aPropValue.value)
                sPropValue[0] = sPropValue[0].split("{")[1]
                sPropValue[0] = sPropValue[0].strip("}")
                for m in [s.split("=") for s in sPropValue[0].split(",")]:
                    sPropValue.append("%s = %s" % (m[0], getattr(aPropValue, m[0].strip())))
                del sPropValue[0]
            else:
                sPropValue.append(id(aPropValue))
            aListControl.removeItems(0, aListControl.getItemCount())
            for i in range(len(sPropValue)):
                aListControl.addItem(sPropValue[i], i)
    # data from inspection
    def getDataInspection(self):
        # introspection service
        aIntrospection = self.ctx.ServiceManager.createInstanceWithContext("com.sun.star.beans.Introspection", self.ctx)
        # --------------- Supported services ------------------
        if hasattr( self.aObjects[-1], "getSupportedServiceNames" ):
            aServices = self.aObjects[-1].getSupportedServiceNames()
        else:
            aServices = (self.aArgs[3],)
        # --------------- Supported interfaces ------------------
        if hasattr( self.aObjects[-1], "getTypes" ):
            aInterfaces = self.aObjects[-1].getTypes()
            aInterfaces = tuple([i.typeName for i in aInterfaces])
        else:
            aInterfaces = (self.aArgs[3],)
        # --------------- Supported methods ------------------
        aAccess = aIntrospection.inspect( self.aObjects[-1] )
        if not aAccess is None:
            aMethods = aAccess.getMethods( METHOD_CONCEPT_ALL )
            sMethods = []
            for m in aMethods:
                sMethods.append(m.ReturnType.Name + " " + m.Name + " ( ")
                args = m.ParameterTypes
                infos = m.ParameterInfos
                for i in range( len( args ) ):
                    sMethods[-1] = sMethods[-1] + self.convertMode2Str( infos[i].aMode ) + " " + args[i].Name + " " + infos[i].aName + ", "
                if len(args):
                    sMethods[-1] = sMethods[-1][:-2]
                sMethods[-1] = sMethods[-1] + " )" 
            sMethods = tuple(sMethods)
        else:
            sMethods = (self.aArgs[3],)
        # --------------- Supported properties ------------------
        if not aAccess is None:
            aProps = aAccess.getProperties( PROPERTY_CONCEPT_ALL )
            sProps = tuple(["(%s) %s %s %s" % (self.convertPropMode2Str(i.Attributes), i.Type.typeClass.value, i.Type.typeName, i.Name) for i in aProps])
        else:
            sProps = (self.aArgs[3],)
        # add items in lists
        for aList in (("ListService", aServices), ("ListInterface",aInterfaces), ("ListMethod", sMethods), ("ListProperty", sProps)):
            aListControl = self.DiveInDialogControl.getControl(aList[0])
            aListControl.removeItems(0, aListControl.getItemCount())
            for i in range(len(aList[1])):
                aListControl.addItem(aList[1][i], i)

