# $Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## entityposize mer fv 16 20:24:21 CET 2005
## Copyright (C) 2005-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno
    import math
    from types import *
    from com.sun.star.drawing.CircleKind import ARC
except ImportError:
    print "probleme d'import"
# =============================
# dessin des entites graphiques
# drawing of graphical entities
# =============================
class EntityPosSize():
    """dessin des entites graphique
    drawing of graphical entities"""
    def __init__(self, ctx):
        self.ctx = ctx
        from fr.free.deneux.gerard.cadooo.compute import Compute
        self.xCompute = Compute(self.ctx)
    # =====================
    # needed from dict env
    # UNOTYPE MODE COORDS ORIGINCOORD SHAPE STEP GROUPSHAPE MODEL MAGNETSIZE DEVICEXSCALE CIRCLEKIND
    # =====================
    def execute(self, aParms):
        aEnv = {}
        aEnv.update(aParms)
        if isinstance(aEnv['COORDS'], StringTypes) or aEnv['COORDS'] is None:
            return aEnv
        aULCCoord = {"X": 0, "Y": 0}
        aSize = {"Width": 0, "Height": 0}
        idx = aEnv['STEP']
        bPosSizeFlag = True
        sShapeName = "new"
        # ------------------
        if aEnv['SHAPE'] is None:
            aEnv['SHAPE'] = aEnv['MODEL'].createInstance("com.sun.star.drawing.%s" % aEnv['UNOTYPE'])
            aEnv['GROUPSHAPE'].add(aEnv['SHAPE'])
        # ----------------------------------
        if aEnv['MODE'][idx] == 'RADIUS': # drawing a circle or ellipse (centre and radius)
            nRadius1 = self.xCompute.toPolarCoord(aEnv['COORDS'][0][0], aEnv['COORDS'][0][1])[0]
            aULCCoord["X"] = aEnv['COORDS'][0][0]['X'] - nRadius1
            aULCCoord["Y"] = aEnv['COORDS'][0][0]['Y'] - nRadius1
            aSize["Width"] = aSize["Height"] = 2 * nRadius1
        # -----------------------------------
        elif aEnv['MODE'][idx] in ('XAXIS', 'YAXIS'): # drawing a ucs
            aCoords = tuple([tuple([uno.createUnoStruct("com.sun.star.awt.Point") for c in range(2)]) for l in range(6)])
            aCoords[0][0].X, aCoords[0][0].Y = aCoords[1][0].X, aCoords[1][0].Y = aEnv['COORDS'][0][0]['X'], aEnv['COORDS'][0][0]['Y']
            nLength = aEnv['MAGNETSIZE'] * 2.5 * aEnv['DEVICEXSCALE']
            nOffset = 250 * 100 / aEnv['ZOOMVALUE']
            fAngle = -math.atan2(aEnv['COORDS'][0][1]['Y'] - aEnv['COORDS'][0][0]['Y'], aEnv['COORDS'][0][1]['X'] - aEnv['COORDS'][0][0]['X'])
            # X axis
            aCoords[0][1].X = aEnv['COORDS'][0][0]['X'] + nLength * math.cos(fAngle)
            aCoords[0][1].Y = aEnv['COORDS'][0][0]['Y'] - nLength * math.sin(fAngle)
            # X character drawing
            aCoords[2][0].X = aEnv['COORDS'][0][0]['X'] + (nLength - nOffset) * math.cos(fAngle) + nOffset * math.sin(fAngle)
            aCoords[2][0].Y = aEnv['COORDS'][0][0]['Y'] - (nLength - nOffset) * math.sin(fAngle) + nOffset * math.cos(fAngle)
            aCoords[2][1].X = aEnv['COORDS'][0][0]['X'] + (nLength + nOffset) * math.cos(fAngle) - nOffset * math.sin(fAngle)
            aCoords[2][1].Y = aEnv['COORDS'][0][0]['Y'] - (nLength + nOffset) * math.sin(fAngle) - nOffset * math.cos(fAngle)
            aCoords[3][0].X = aEnv['COORDS'][0][0]['X'] + (nLength - nOffset) * math.cos(fAngle) - nOffset * math.sin(fAngle)
            aCoords[3][0].Y = aEnv['COORDS'][0][0]['Y'] - (nLength - nOffset) * math.sin(fAngle) - nOffset * math.cos(fAngle)
            aCoords[3][1].X = aEnv['COORDS'][0][0]['X'] + (nLength + nOffset) * math.cos(fAngle) + nOffset * math.sin(fAngle)
            aCoords[3][1].Y = aEnv['COORDS'][0][0]['Y'] - (nLength + nOffset) * math.sin(fAngle) + nOffset * math.cos(fAngle)
            # ..............................
            if aEnv['MODE'][idx] == 'XAXIS':
                nOrd = 1
            else:
                nOrd = 1 - 2 * (self.xCompute.getDist2Line(aEnv['COORDS'][0][0], aEnv['COORDS'][0][1], aEnv['COORDS'][1][1])[1] < 0)
            # Y axis
            aCoords[1][1].X = aEnv['COORDS'][0][0]['X'] + nOrd * nLength * math.sin(fAngle)
            aCoords[1][1].Y = aEnv['COORDS'][0][0]['Y'] + nOrd * nLength * math.cos(fAngle)
            # Y character drawing
            aCoords[4][0].X = aEnv['COORDS'][0][0]['X'] + nOrd * nLength * math.sin(fAngle)
            aCoords[4][0].Y = aEnv['COORDS'][0][0]['Y'] + nOrd * nLength * math.cos(fAngle)
            aCoords[4][1].X = aEnv['COORDS'][0][0]['X'] + nOrd * (nLength + nOffset) * math.sin(fAngle) - nOffset * math.cos(fAngle)
            aCoords[4][1].Y = aEnv['COORDS'][0][0]['Y'] + nOrd * (nLength + nOffset) * math.cos(fAngle) + nOffset * math.sin(fAngle)
            aCoords[5][0].X = aEnv['COORDS'][0][0]['X'] + nOrd * (nLength - nOffset) * math.sin(fAngle) - nOffset * math.cos(fAngle)
            aCoords[5][0].Y = aEnv['COORDS'][0][0]['Y'] + nOrd * (nLength - nOffset) * math.cos(fAngle) + nOffset * math.sin(fAngle)
            aCoords[5][1].X = aEnv['COORDS'][0][0]['X'] + nOrd * (nLength + nOffset) * math.sin(fAngle) + nOffset * math.cos(fAngle)
            aCoords[5][1].Y = aEnv['COORDS'][0][0]['Y'] + nOrd * (nLength + nOffset) * math.cos(fAngle) - nOffset * math.sin(fAngle)
            aEnv['SHAPE'].PolyPolygon = aCoords
            bPosSizeFlag = False
        # -----------------------------------
        elif aEnv['MODE'][idx] == 'WIDTH': # drawing a rectangle
            nRadius, fAngle1 = self.xCompute.toPolarCoord(aEnv['COORDS'][0][0], aEnv['COORDS'][0][1])
            fCosW = nRadius * math.cos(fAngle1 + math.pi)
            fSinW = -nRadius * math.sin(fAngle1 + math.pi)
            fCosH = nRadius * math.cos(fAngle1 + math.pi / 2)
            fSinH = -nRadius * math.sin(fAngle1 + math.pi / 2)
            aULCCoord["X"] = aEnv['COORDS'][0][0]['X'] + fCosW + fCosH
            aULCCoord["Y"] = aEnv['COORDS'][0][0]['Y'] + fSinW + fSinH
            aSize["Width"] = aSize["Height"] = 2 * nRadius
            aEnv['SHAPE'].RotateAngle = long(round(math.degrees(fAngle1) * 100.0))
        # -----------------------------------
        elif aEnv['MODE'][idx] == 'HEIGHT': # drawing a rectangle
            nRadius1, fAngle1 = self.xCompute.toPolarCoord(aEnv['COORDS'][0][0], aEnv['COORDS'][0][1])
            nRadius2 = self.xCompute.toPolarCoord(aEnv['COORDS'][0][0], aEnv['COORDS'][0][2])[0]
            fCosW = nRadius1 * math.cos(fAngle1+ math.pi)
            fSinW = -nRadius1 * math.sin(fAngle1 + math.pi)
            fCosH = nRadius2 * math.cos(fAngle1 + math.pi / 2)
            fSinH = -nRadius2 * math.sin(fAngle1 + math.pi / 2)
            aULCCoord["X"] = aEnv['COORDS'][0][0]['X'] + fCosW + fCosH
            aULCCoord["Y"] = aEnv['COORDS'][0][0]['Y'] + fSinW + fSinH
            aSize["Width"], aSize["Height"] = 2 * nRadius1, 2 * nRadius2
            aEnv['SHAPE'].CornerRadius = aEnv['CORNERRADIUS']
            aEnv['SHAPE'].RotateAngle = long(round(math.degrees(fAngle1) * 100.0))
        # --------------------------------------
        elif aEnv['MODE'][idx] == 'DIAMETER': # drawing a circle (centre and diameter)
            nRadius = self.xCompute.toPolarCoord(aEnv['COORDS'][0][0], aEnv['COORDS'][0][1])[0] / 2
            aEnv['ORIGINCOORD']['X'] = (aEnv['COORDS'][0][0]['X'] + aEnv['COORDS'][0][1]['X']) / 2
            aEnv['ORIGINCOORD']['Y'] = (aEnv['COORDS'][0][0]['Y'] + aEnv['COORDS'][0][1]['Y']) / 2
            aULCCoord["X"] = aEnv['ORIGINCOORD']['X'] - nRadius
            aULCCoord["Y"] = aEnv['ORIGINCOORD']['Y'] - nRadius
            aSize["Width"] = aSize["Height"] = 2 * nRadius
        # --------------------------------------
        elif aEnv['MODE'][idx] == '3RDPOINT': # drawing a circle (three points)
            aULCCoord["X"], aULCCoord["Y"], nRadius = self.xCompute.getCircle3P(*aEnv['COORDS'][0])
            aEnv['ORIGINCOORD'].update(aULCCoord)
            aULCCoord["X"] = aULCCoord["X"] - nRadius
            aULCCoord["Y"] = aULCCoord["Y"] - nRadius
            aSize["Width"] = aSize["Height"] = 2 * nRadius
        # ------------------------------------
        elif aEnv['MODE'][idx] == 'VERTEX': # drawing a line, polyline or polygon (two points)
            aCoords = tuple([tuple([uno.createUnoStruct("com.sun.star.awt.Point") for c in l]) for l in aEnv['COORDS']])
            for i in range(len(aCoords)):
                for j in range(len(aCoords[i])):
                    aCoords[i][j].X, aCoords[i][j].Y = aEnv['COORDS'][i][j]['X'], aEnv['COORDS'][i][j]['Y']
            aEnv['SHAPE'].PolyPolygon = aCoords
            bPosSizeFlag = False
        # ----------------------------------
        elif aEnv['MODE'][idx] == 'RADIUS2': # drawing an ellipse (centre, first radius, second radius)
            aULCCoord, aSize, fAngle1 = self.getULCAndAngleOfEllipse(aEnv['COORDS'][0])
            aSize["Width"], aSize["Height"] = 2 * aSize["Width"], 2 * aSize["Height"]
            aEnv['SHAPE'].RotateAngle = long(round(math.degrees(fAngle1) * 100.0))
        # ---------------------------------------
        elif aEnv['MODE'][idx] == 'STARTANGLE': # drawing an arc of circle or ellipse (centre, radius, radius2, start angle)
            aEnv['ORIGINCOORD'].update(aEnv['COORDS'][0][0])
            fAngle2 = self.xCompute.toPolarCoord(aEnv['COORDS'][0][0], aEnv['COORDS'][0][-1])[1]
            if aEnv['ENTITYPE'] == "ARC":
                nRadius1 = self.xCompute.toPolarCoord(aEnv['COORDS'][0][0], aEnv['COORDS'][0][1])[0]
                aULCCoord["X"] = aEnv['COORDS'][0][0]['X'] - nRadius1
                aULCCoord["Y"] = aEnv['COORDS'][0][0]['Y'] - nRadius1
                aSize["Width"] = aSize["Height"] = 2 * nRadius1
                fAngle1 = float(0)
            else:
                aULCCoord, aSize, fAngle1 = self.getULCAndAngleOfEllipse(aEnv['COORDS'][0][:-1])
                fAngle2 = self.xCompute.getPointOnEllipse(fAngle2, None, aEnv['COORDS'][0][0], aSize, fAngle1)[1]
                aSize["Width"], aSize["Height"] = 2 * aSize["Width"], 2 * aSize["Height"]
            aEnv['SHAPE'].CircleKind = ARC
            aEnv['SHAPE'].RotateAngle = long(round(math.degrees(fAngle1) * 100.0))
            aEnv['SHAPE'].CircleStartAngle = long(round(math.degrees(fAngle2) * 100.0))
            aEnv['SHAPE'].CircleEndAngle = 36000
        # -------- # drawing an arc of circle or ellipse (centre, radius, radius2, start angle, end angle)---------
        elif aEnv['MODE'][idx] == 'ENDANGLE':
            aEnv['ORIGINCOORD'].update(aEnv['COORDS'][0][0])
            fAngle2 = self.xCompute.toPolarCoord(aEnv['COORDS'][0][0], aEnv['COORDS'][0][-2])[1]
            fAngle3 = self.xCompute.toPolarCoord(aEnv['COORDS'][0][0], aEnv['COORDS'][0][-1])[1]
            if aEnv['ENTITYPE'] == "ARC":
                nRadius1 = self.xCompute.toPolarCoord(aEnv['COORDS'][0][0], aEnv['COORDS'][0][1])[0]
                aULCCoord["X"] = aEnv['COORDS'][0][0]['X'] - nRadius1
                aULCCoord["Y"] = aEnv['COORDS'][0][0]['Y'] - nRadius1
                aSize["Width"] = aSize["Height"] = 2 * nRadius1
                fAngle1 = float(0)
            else:
                aULCCoord, aSize, fAngle1 = self.getULCAndAngleOfEllipse(aEnv['COORDS'][0][:-2])
                fAngle2 = self.xCompute.getPointOnEllipse(fAngle2, None, aEnv['COORDS'][0][0], aSize, fAngle1)[1]
                fAngle3 = self.xCompute.getPointOnEllipse(fAngle3, None, aEnv['COORDS'][0][0], aSize, fAngle1)[1]
                aSize["Width"], aSize["Height"] = 2 * aSize["Width"], 2 * aSize["Height"]
            aEnv['SHAPE'].CircleKind = aEnv['CIRCLEKIND']
            aEnv['SHAPE'].CircleStartAngle = long(round(math.degrees(fAngle2) * 100.0))
            aEnv['SHAPE'].CircleEndAngle = long(round(math.degrees(fAngle3) * 100.0))
            aEnv['SHAPE'].RotateAngle = long(round(math.degrees(fAngle1) * 100.0))
        if bPosSizeFlag:
            uULCCoord = uno.createUnoStruct("com.sun.star.awt.Point")
            uSize = uno.createUnoStruct("com.sun.star.awt.Size")
            uULCCoord.X, uULCCoord.Y = aULCCoord['X'], aULCCoord['Y']
            uSize.Width, uSize.Height = aSize['Width'], aSize['Height']
            aEnv['SHAPE'].setPosition(uULCCoord)
            aEnv['SHAPE'].setSize(uSize)
        aEnv['SHAPE'].setPropertyValue("SizeProtect", True)
        aEnv['SHAPE'].setPropertyValue("MoveProtect", True)
        aEnv['SHAPE'].setName(sShapeName)
        if aEnv['SHAPESTATUS'] == "transient":
            aEnv['SHAPE'].LineColor = 0xFF00FF
            aEnv['SHAPE'].LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
        return aEnv
    # ========================================
    def getULCAndAngleOfEllipse(self, aCoords):
        aPoint = {"X": 0, "Y": 0}
        aSize = {"Width": 0, "Height": 0}
        aSize["Width"], fAngle1 = self.xCompute.toPolarCoord(aCoords[0], aCoords[1])
        aPoint["X"], aPoint["Y"], aSize["Height"] = self.xCompute.getDist2Line(*aCoords)[:-1]
        aPoint["X"] = abs(aPoint["X"]) % aSize["Width"]
        if abs(aPoint["Y"]):
            aSize["Height"] = long(abs(aPoint["Y"]) / math.sqrt(1E0 - (float(aPoint["X"]) / aSize["Width"]) ** 2)) 
        aPoint["X"] = aCoords[0]['X'] - aSize["Width"] * math.cos(fAngle1) - aSize["Height"] * math.sin(fAngle1)
        aPoint["Y"] = aCoords[0]['Y']+ aSize["Width"] * math.sin(fAngle1) - aSize["Height"] * math.cos(fAngle1)
        return aPoint, aSize, fAngle1