# $Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## samedi 4 avril 2009, 15:49:13 (UTC+0200)
## last modified lundi 20 avril 2009, 15:46:45 (UTC+0200)
## Copyright (C) 2007 - 2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    from com.sun.star.drawing.CircleKind import FULL, SECTION, CUT, ARC
    import math
except ImportError,e:
    print "probleme d'import",e
DEBUG = False
# ********************************************************************************
# a class to join two entities directly, or with a chamfer, or with a fillet
# une classe pour joindre deux entits directement, ou par chanfrein, ou par cong
# ********************************************************************************
class JoinDraw():
    """joint deux entits directement, ou par chanfrein, ou par cong
    joins two entities directly, or with a chamfer, or with a fillet"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.compute
        import fr.free.deneux.gerard.cadooo.entitiespot
        import fr.free.deneux.gerard.cadooo.msgl10n
        self.ctx = ctx
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute( self.ctx)
        self.xEntitySpot = fr.free.deneux.gerard.cadooo.entitiespot.EntitieSpot( self.ctx)
        self.xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
        sTextList = ('j1', 'j2', 'j3')
        self.aTranslation = self.xMsgL10n.getText(sTextList)
        self.bRedraw = False
    # ******************************
    # Main method
    # ******************************
    def execute(self, aNamedValues):
        self.aEnv = {}
        self.aEnv.update(aNamedValues)
        if self.bRedraw:
            self.xEntitySpot.bValidList = False
            self.bRedraw = False
        aSpotParm = self.aEnv.fromkeys(self.aEnv['SPOTPARM'] + self.aEnv['MOUSEPARM'])
        for aKey in aSpotParm.iterkeys():
            aSpotParm[aKey] = self.aEnv[aKey]
        self.aEnv.update(self.xEntitySpot.execute(aSpotParm))
        self.aEnv['SPOTTEDSHAPE'] = self.xEntitySpot.aSpottedShape
        self.aEnv['SPLITTEDSHAPE'] = self.xEntitySpot.aSplittedShape
        aCoords = [[]]
        nJoinState = 0
        # ++++++++++++++++++++++++++++++++++++
        if not self.aEnv['SPOTTEDID'] is None:
            nJoinState += 1
        # +++++++++++++++++++++++++++++++++++++++
        if not self.aEnv['SPOTTEDSHAPE'] is None:
            if not self.aEnv['SPOTTEDSHAPE'][1] in ("CircleShape", "EllipseShape"):
                nJoinState += 2
        # +++++++++++++++++++++++++++++++++++++
        if not self.aEnv['SELECTEDLIST'][0] is None:
            nJoinState += 4
        # +++++++++++++++++++++++++++++++++++++
        if not self.aEnv['SELECTEDLIST'][1] is None:
            nJoinState += 8
        # +++++++++++++++++++++++++++++++++++++++
        if self.aEnv['JOINVISIBLE']:
            nJoinState += 16
        sState = "state %d = " % nJoinState
        # +++++++++++++++++++++++++++++++++++++++
        if nJoinState == 0:
            if DEBUG:
                sDebug = sState + "no entity spotted, no entity stored, no junction displayed"
        # +++++++++++++++++++++++++++++++++++++++
        elif nJoinState >= 28 or nJoinState in (12, 13, 14, 15):
            if DEBUG:
                sDebug = sState + "2 entities stored 1 displayed"
            if nJoinState in (29, 31): # 31 - 29 - 28 ou 23 - 31 - 28
                self.removeTempShapes(True, False)
            self.setJoinEnvAndCoord(self.aEnv['SELECTEDLIST'][0], self.aEnv['SELECTEDLIST'][1])
        # +++++++++++++++++
        elif nJoinState == 4: # 1 entity stored
            if DEBUG:
                sDebug = sState + "1 stored 0 spotted 0 highlighted 0 displayed"
        # +++++++++++++++++
        elif nJoinState == 5:
            aStoredID = self.aEnv['SELECTEDLIST'][0][0] + (self.aEnv['SELECTEDLIST'][0][-1],)
            if aStoredID == self.aEnv['SPOTTEDID']: # 7 - 5 - 4
                if DEBUG:
                    sDebug = sState + "1 stored = 0 spotted = 1 highlighted 0 displayed"
                self.removeTempShapes(True, False)
            else: # Dead branch ?
                if DEBUG:
                    sDebug = sState + "1 stored ! 0 spotted = 1 highlighted 0 displayed"
                self.removeTempShapes(True, False)
        # +++++++++++++++++++
        elif nJoinState == 6:
            aStoredID = self.aEnv['SELECTEDLIST'][0][0] + (self.aEnv['SELECTEDLIST'][0][-1],)
            aNewSpotID = self.aEnv['SPOTTEDSHAPE'][0] + (self.aEnv['SPOTTEDSHAPE'][-1],)
            # =========================
            if aStoredID != aNewSpotID: # 4 - 6 - 23
                if DEBUG:
                    sDebug = sState + "1 stored != 1 spotted 0 highlighted 0 displayed"
                self.setJoinEnvAndCoord(self.aEnv['SELECTEDLIST'][0], self.aEnv['SPOTTEDSHAPE'])
            else: # 4 - 6 - 7
                if DEBUG:
                    sDebug = sState + "1 stored == 1 spotted 0 highlighted 0 displayed"
            self.aEnv.update(self.xEntitySpot.aEntityEnvAndCoord)
            self.aEnv['SPOTTEDID'] = self.aEnv['SPOTTEDSHAPE'][0][:] + (self.aEnv['SPOTTEDSHAPE'][-1],)
        # +++++++++++++++++
        elif nJoinState == 7:
            aStoredID = self.aEnv['SELECTEDLIST'][0][0] + (self.aEnv['SELECTEDLIST'][0][-1],)
            aNewSpotID = self.aEnv['SPOTTEDSHAPE'][0] + (self.aEnv['SPOTTEDSHAPE'][-1],)
            # =========================
            if aStoredID == aNewSpotID:
                # --------------------------------------
                if aNewSpotID == self.aEnv['SPOTTEDID']: # 7 - 7
                    if DEBUG:
                        sDebug = sState + "1 stored == 1 spotted == 1 highlighted 0 displayed"
                    self.aEnv['STEP'] = 0
                else: # 23 - 7 - 7
                    if DEBUG:
                        sDebug = sState + "1 stored == 1 spotted != 1 highlighted 0 displayed"
                    self.removeTempShapes()
                    self.aEnv.update(self.xEntitySpot.aEntityEnvAndCoord)
                    self.aEnv['SPOTTEDID'] = self.aEnv['SPOTTEDSHAPE'][0][:] + (self.aEnv['SPOTTEDSHAPE'][-1],)
            # ===
            else: # dead branch ?
                # --------------------------------------
                if aNewSpotID == self.aEnv['SPOTTEDID']:
                    if DEBUG:
                        sDebug = sState + "1 stored != 1 spotted == 1 highlighted 0 displayed"
                    self.aEnv['STEP'] = 0
                else:
                    if DEBUG:
                        sDebug = sState + "1 stored != 1 spotted != 1 highlighted 0 displayed"
                    self.removeTempShapes(True, False)
                    self.setJoinEnvAndCoord(self.aEnv['SELECTEDLIST'][0], self.aEnv['SPOTTEDSHAPE'])
                    self.aEnv.update(self.xEntitySpot.aEntityEnvAndCoord)
                    self.aEnv['SPOTTEDID'] = self.aEnv['SPOTTEDSHAPE'][0][:] + (self.aEnv['SPOTTEDSHAPE'][-1],)
        # +++++++++++++++++
        elif nJoinState == 23:
            aStoredID = self.aEnv['SELECTEDLIST'][0][0] + (self.aEnv['SELECTEDLIST'][0][-1],)
            aNewSpotID = self.aEnv['SPOTTEDSHAPE'][0] + (self.aEnv['SPOTTEDSHAPE'][-1],)
            # =========================
            if aStoredID == aNewSpotID:
                # --------------------------------------
                if aNewSpotID == self.aEnv['SPOTTEDID']: # dead branch
                    if DEBUG:
                        sDebug = sState + "1 stored == 1 spotted == 1 highlighted 1 displayed ***dead branch***"
                    self.aEnv['STEP'] = 0
                else: # 23 - 23 - 7
                    if DEBUG:
                        sDebug = sState + "1 stored == 1 spotted != 1 highlighted 1 displayed"
                    self.removeTempShapes()
                    self.aEnv.update(self.xEntitySpot.aEntityEnvAndCoord)
                    self.aEnv['SPOTTEDID'] = self.aEnv['SPOTTEDSHAPE'][0][:] + (self.aEnv['SPOTTEDSHAPE'][-1],)
            # ===
            else:
                # --------------------------------------
                if aNewSpotID == self.aEnv['SPOTTEDID']: # 23 - 23
                    if DEBUG:
                        sDebug = sState + "1 stored != 1 spotted == 1 highlighted 1 displayed"
                    self.aEnv['STEP'] = 0
                else: # 7 - 23 - 23
                    if DEBUG:
                        sDebug = sState + "1 stored != 1 spotted != 1 highlighted 1 displayed"
                    self.removeTempShapes()
                    self.setJoinEnvAndCoord(self.aEnv['SELECTEDLIST'][0], self.aEnv['SPOTTEDSHAPE'])
                    self.aEnv.update(self.xEntitySpot.aEntityEnvAndCoord)
                    self.aEnv['SPOTTEDID'] = self.aEnv['SPOTTEDSHAPE'][0][:] + (self.aEnv['SPOTTEDSHAPE'][-1],)
        # +++++++++++++++++
        elif nJoinState == 21:
            if DEBUG:
                sDebug = sState + "1 stored 0 spotted 1 highlighted 1 displayed"
            self.removeTempShapes()
        # +++++++++++++++++
        elif nJoinState == 2:
            if DEBUG:
                sDebug = sState + "0 stored 1 spotted 0 highlighted 0 displayed"
            self.aEnv.update(self.xEntitySpot.aEntityEnvAndCoord)
            self.aEnv['SPOTTEDID'] = self.aEnv['SPOTTEDSHAPE'][0][:] + (self.aEnv['SPOTTEDSHAPE'][-1],)
        # +++++++++++++++++
        elif nJoinState == 3:
            aNewSpotID = self.aEnv['SPOTTEDSHAPE'][0]+(self.aEnv['SPOTTEDSHAPE'][-1],)
            # ======================================
            if aNewSpotID == self.aEnv['SPOTTEDID']:
                if DEBUG:
                    sDebug = sState + "0 stored 1 spotted == 1 highlighted 0 displayed"
                self.aEnv['STEP'] = 0
            # ===
            else:
                if DEBUG:
                    sDebug = sState + "0 stored 1 spotted != 1 highlighted 0 displayed"
                self.removeTempShapes(True, False)
                self.aEnv.update(self.xEntitySpot.aEntityEnvAndCoord)
                self.aEnv['SPOTTEDID'] = self.aEnv['SPOTTEDSHAPE'][0][:] + (self.aEnv['SPOTTEDSHAPE'][-1],)
        # +++++++++++++++++
        elif nJoinState == 1:
            if DEBUG:
                sDebug = sState + "0 stored 0 spotted 1 highlighted 0 displayed"
            self.removeTempShapes(True, False)
        sText = "%s ==> %s " % (self.aEnv['COMMENT'][0], self.aTranslation[["DIRECT", "FILLET", "CHAMFER"].index(self.aEnv['JOINKIND'])])
        if DEBUG:
            sText = sText + sDebug
        aInfoCtrl = dict(self.aEnv['STATUSBARCONTROL'])['INFOCTRL']
        aInfoCtrl.setText(sText)
        if not self.aEnv['COORDS'] is None:
            self.aEnv['SHAPESTATUS'] = "transient"
        return self.aEnv
    # *****************************************************
    # remove temporary shapes
    # *****************************************************
    def removeTempShapes(self, bShape = True, bJoin = True):
        if self.aEnv['SHAPE'] and bShape:
            aGroupShape = self.aEnv['CONTROLLER'].getCurrentPage()
            if len(self.aEnv['SPOTTEDID']) > 2:
                for i in self.aEnv['SPOTTEDID'][:-2]:
                    aGroupShape = aGroupShape.getByIndex(i)
            aGroupShape.remove(self.aEnv['SHAPE'])
            self.aEnv['SHAPE'] = None
            self.aEnv['STEP'] = 0
            self.aEnv['COORDS'] = None
            self.aEnv['SPOTTEDID'] = None
        if self.aEnv['JOINVISIBLE'] and bJoin:
            aShape = self.aEnv['%s%sJOINSHAPE' % (self.aEnv['JOINKIND'], self.aEnv['JOINTYPE'])]
            for i in range(aShape.getCount()):
                aShape.remove(aShape.getByIndex(0))
            self.aEnv['CONTROLLER'].getCurrentPage().remove(aShape)
            self.aEnv['JOINCOORDS'] = None
            self.aEnv['JOINVISIBLE'] = False
            self.aEnv['%s%sJOINSHAPE' % (self.aEnv['JOINKIND'], self.aEnv['JOINTYPE'])] = None
            self.aEnv['JOINTYPE'] = None
        return
    # *********************************************
    # Setting borders
    # *********************************************
    def setBorder(self, bReverse, aMouseRelPos, nDistBorder):
        aBorderList = [[None, None, None] for i in range(4)]
        if bReverse > 0:
            aReverseBorderList = [[None, None, None] for i in range(4)]
            nFullLength = bReverse
        for i in range(len(nDistBorder)):
            nDelta =  nDistBorder[i] - aMouseRelPos[0]
            # -------------------------------------------------------------
            if (nDistBorder[i] >= 0 and nDistBorder[i] <= aMouseRelPos[2]): # within segment limits ?
                # -------------
                if nDelta >= 0: # is this a right border ?
                    # -----------------------
                    if aBorderList[1][0] is None: # not yet initialized ?
                        aBorderList[1][0] = abs(nDelta)
                    # ---------------------------------------
                    if abs(nDelta) <= abs(aBorderList[1][0]):
                        aBorderList[1][0], aBorderList[1][1], aBorderList[1][2] = abs(nDelta), i, "IRB"
                    if bReverse > 0:
                        nReverseDelta = nDelta - nFullLength
                        if aReverseBorderList[1][0] is None:
                            aReverseBorderList[1][0] = abs(nReverseDelta)
                        if abs(nReverseDelta) <= abs(aReverseBorderList[1][0]):
                            aReverseBorderList[1][0] = abs(nReverseDelta)
                            aReverseBorderList[1][1] = i
                            aReverseBorderList[1][2] = "ILB"
                # ---
                else: # is this a left Border ?
                    # -----------------------
                    if aBorderList[0][0] is None: # not yet initialized ?
                        aBorderList[0][0] = abs(nDelta)
                    # ---------------------------------------
                    if abs(nDelta) <= abs(aBorderList[0][0]):
                        aBorderList[0][0], aBorderList[0][1], aBorderList[0][2] = abs(nDelta), i, "ILB"
                    if bReverse > 0:
                        nReverseDelta = nFullLength + nDelta
                        if aReverseBorderList[0][0] is None:
                            aReverseBorderList[0][0] = abs(nReverseDelta)
                        if abs(nReverseDelta) <= abs(aReverseBorderList[0][0]):
                            aReverseBorderList[0][0] = abs(nReverseDelta)
                            aReverseBorderList[0][1] = i
                            aReverseBorderList[0][2] = "IRB"
            # ----------------------
            elif nDistBorder[i] < 0: # is this the second left border ?
                # -----------------------
                if aBorderList[2][0] is None: # not yet initialized ?
                    aBorderList[2][0] = abs(nDelta)
                if abs(nDelta) <= abs(aBorderList[2][0]):
                    aBorderList[2][0], aBorderList[2][1], aBorderList[2][2] = abs(nDelta), i, "OLB"
                if bReverse > 0:
                    nReverseDelta = nFullLength + nDistBorder[i]
                    if aReverseBorderList[2][0] is None:
                        aReverseBorderList[2][0] = abs(nReverseDelta)
                    if abs(nReverseDelta) <= abs(aReverseBorderList[2][0]):
                        aReverseBorderList[2][0] = abs(nReverseDelta)
                        aReverseBorderList[2][1] = i
                        aReverseBorderList[2][2] = "ORB"
            # ------------------------------------
            elif nDistBorder[i] > aMouseRelPos[2]: # is this the second right border ?
                # -----------------------
                if aBorderList[3][0] is None: # not yet initialized ?
                    aBorderList[3][0] = abs(nDelta)
                if abs(nDelta) <= abs(aBorderList[3][0]):
                    aBorderList[3][0], aBorderList[3][1], aBorderList[3][2] = abs(nDelta), i, "ORB"
                if bReverse > 0:
                    nReverseDelta = nFullLength - nDistBorder[i]
                    if aReverseBorderList[3][0] is None:
                        aReverseBorderList[3][0] = abs(nReverseDelta)
                    if abs(nReverseDelta) <= abs(aReverseBorderList[3][0]):
                        aReverseBorderList[3][0] = abs(nReverseDelta)
                        aReverseBorderList[3][1] = i
                        aReverseBorderList[3][2] = "OLB"
        # =============
        if bReverse > 0:
            # ------------------------------------------------------------
            if aBorderList[0][0] is None and not aBorderList[1][0] is None:
                aBorderList[0][0] = aReverseBorderList[1][0]
                aBorderList[0][1] = aReverseBorderList[1][1]
                aBorderList[0][2] = aReverseBorderList[1][2]
            # --------------------------------------------------------------
            elif not aBorderList[0][0] is None and aBorderList[1][0] is None:
                aBorderList[1][0] = aReverseBorderList[0][0]
                aBorderList[1][1] = aReverseBorderList[0][1]
                aBorderList[1][2] = aReverseBorderList[0][2]
            # ------------------------------------------------------------
            if aBorderList[2][0] is None and not aBorderList[3][0] is None:
                aBorderList[2][0] = aReverseBorderList[3][0]
                aBorderList[2][1] = aReverseBorderList[3][1]
                aBorderList[2][2] = aReverseBorderList[3][2]
            # --------------------------------------------------------------
            elif not aBorderList[2][0] is None and aBorderList[3][0] is None:
                aBorderList[3][0] = aReverseBorderList[2][0]
                aBorderList[3][1] = aReverseBorderList[2][1]
                aBorderList[3][2] = aReverseBorderList[2][2]
        aBorderList = [aBorderList[i] for i in range(4) if not aBorderList[i][0] is None]
        aDistList = [aBorderList[i][0] for i in range(len(aBorderList))]
        nIndx = aDistList.index(min(aDistList))
        return aBorderList[nIndx][1:]
    # *********************************************
    # set join env and coordinates
    # *********************************************
    def setJoinEnvAndCoord(self, join1, join2):
        aJoinCoords = [{'X': 0, 'Y': 0} for i in range(4)]
        aMouseCoord = {'X': 0, 'Y': 0}
        aMouseParm = self.aEnv.fromkeys(self.aEnv['MOUSEPARM'])
        for aKey in aMouseParm.iterkeys():
            aMouseParm[aKey] = self.aEnv[aKey]
        aMouseCoord =  self.xCompute.transformMouseCoord( aMouseParm)
        # ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        if join1[1] in ('LineShape',) and join2[1] in ('LineShape'):
            aPointA, aPointB = join1[2:4]
            aPointC, aPointD = join2[2:4]
            ret = self.xCompute.getInterLines2( aPointA, aPointB, aPointC, aPointD, 0, 0)
            # =================
            if not ret is None:
                self.aEnv['JOINTYPE'] = "LINE2LINE"
                aMouseRelPosAB = self.xCompute.getDist2Line( aPointA, aPointB, aMouseCoord)
                aBorderAB = self.setBorder(-1, aMouseRelPosAB, (ret[0],))
                # --------------------------------
                if aBorderAB[1] in ("ILB", "OLB"):
                    aJoinCoords[0]['X'], aJoinCoords[0]['Y'] = aPointB['X'], aPointB['Y']
                # -----------------------------------
                elif aBorderAB[1] in ("IRB", "ORB") :
                    aJoinCoords[0]['X'], aJoinCoords[0]['Y'] = aPointA['X'], aPointA['Y']
                aMouseRelPosCD = self.xCompute.getDist2Line( aPointC, aPointD, aMouseCoord)
                aBorderCD = self.setBorder(-1, aMouseRelPosCD, (ret[1],))
                # --------------------------------
                if aBorderCD[1] in ("ILB", "OLB"):
                    aJoinCoords[3]['X'], aJoinCoords[3]['Y'] = aPointD['X'], aPointD['Y']
                # ----------------------------------
                elif aBorderCD[1] in ("IRB", "ORB"):
                    aJoinCoords[3]['X'], aJoinCoords[3]['Y'] = aPointC['X'], aPointC['Y']
                aJoinCoords[1]['X'], aJoinCoords[1]['Y'] = aJoinCoords[2]['X'], aJoinCoords[2]['Y'] = ret[2:]
            else:
                self.aEnv['JOINTYPE'] = None
        # +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        elif join1[1] in ('ArcCircleShape', 'ArcEllipseShape') and join2[1] in ('ArcCircleShape', 'ArcEllipseShape'):
            aCenterA, aSizeA, fRotationA, fStartAngleA, fEndAngleA = join1[2:7]
            aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC = join2[2:7]
            ret = self.xCompute.getInterEllipses( aCenterA, aSizeA, fRotationA, aCenterC, aSizeC, fRotationC)
            # =================
            if not ret is None:
                self.aEnv['JOINTYPE'] = "ARC2ARC"
                aJoinCoords.insert(1, self.xCompute.getPointOnEllipse( None, fStartAngleA, aCenterA, aSizeA, fRotationA)[0])
                aJoinCoords.insert(1, self.xCompute.getPointOnEllipse( None, math.pi/2, aCenterA, aSizeA, fRotationA)[0])
                aJoinCoords.insert(1, self.xCompute.getPointOnEllipse( None, float(0), aCenterA, aSizeA, fRotationA)[0])
                aJoinCoords[4] = self.xCompute.getPointOnEllipse( None, fEndAngleA, aCenterA, aSizeA, fRotationA)[0]
                aJoinCoords.insert(-1, self.xCompute.getPointOnEllipse( None, fStartAngleC, aCenterC, aSizeC, fRotationC)[0])
                aJoinCoords.insert(-2, self.xCompute.getPointOnEllipse( None, math.pi/2, aCenterC, aSizeC, fRotationC)[0])
                aJoinCoords.insert(-3, self.xCompute.getPointOnEllipse( None, float(0), aCenterC, aSizeC, fRotationC)[0])
                aJoinCoords[-1] = self.xCompute.getPointOnEllipse( None, fEndAngleC, aCenterC, aSizeC, fRotationC)[0]
                # first arc ***********************************************************************************************************
                nDist = []
                aJoinCoords[0]['X'], aJoinCoords[0]['Y'] = ret[:2]
                nDist.append(self.xCompute.getDist2Arc( aCenterA, aSizeA, fRotationA, fStartAngleA, fEndAngleA, aJoinCoords[0])[0])
                if len(ret) > 2:
                    aJoinCoords[0]['X'], aJoinCoords[0]['Y'] = ret[2:4]
                    nDist.append(self.xCompute.getDist2Arc( aCenterA, aSizeA, fRotationA, fStartAngleA, fEndAngleA, aJoinCoords[0])[0])
                if len(ret) > 4:
                    aJoinCoords[0]['X'], aJoinCoords[0]['Y'] = ret[4:6]
                    nDist.append(self.xCompute.getDist2Arc( aCenterA, aSizeA, fRotationA, fStartAngleA, fEndAngleA, aJoinCoords[0])[0])
                if len(ret) > 6:
                    aJoinCoords[0]['X'], aJoinCoords[0]['Y'] = ret[6:]
                    nDist.append(self.xCompute.getDist2Arc( aCenterA, aSizeA, fRotationA, fStartAngleA, fEndAngleA, aJoinCoords[0])[0])
                aMouseRelPosAB = self.xCompute.getDist2Arc( aCenterA, aSizeA, fRotationA, fStartAngleA, fEndAngleA, aMouseCoord)
                aBorderAB = self.setBorder(long(round(math.sqrt(aSizeA['Width'] * aSizeA['Height']) * 2 * math.pi)), aMouseRelPosAB, nDist)
                if aBorderAB[1] in ("ILB", "OLB"):
                    aJoinCoords[3]['X'], aJoinCoords[3]['Y'] = ret[2*aBorderAB[0]], ret[2*aBorderAB[0]+1]
                else:
                    aJoinCoords[4]['X'], aJoinCoords[4]['Y'] = ret[2*aBorderAB[0]], ret[2*aBorderAB[0]+1]
                aJoinCoords[0]['X'], aJoinCoords[0]['Y'] = aCenterA['X'], aCenterA['Y']
                # Second arc ***********************************************************************************************************
                nDist = []
                aJoinCoords[-5]['X'], aJoinCoords[-5]['Y'] = ret[:2]
                nDist.append(self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aJoinCoords[-5])[0])
                if len(ret) > 2:
                    aJoinCoords[-5]['X'], aJoinCoords[-5]['Y'] = ret[2:4]
                    nDist.append(self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aJoinCoords[-5])[0])
                if len(ret) > 4:
                    aJoinCoords[-5]['X'], aJoinCoords[-5]['Y'] = ret[4:6]
                    nDist.append(self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aJoinCoords[-5])[0])
                if len(ret) > 6:
                    aJoinCoords[-5]['X'], aJoinCoords[-5]['Y'] = ret[6:]
                    nDist.append(self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aJoinCoords[-5])[0])
                aMouseRelPosCD = self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aMouseCoord)
                aBorderCD = self.setBorder(long(round(math.sqrt(aSizeC['Width'] * aSizeC['Height']) * 2 * math.pi)), aMouseRelPosCD, nDist)
                if aBorderCD[1] in ("ILB", "OLB"):
                    aJoinCoords[-2]['X'], aJoinCoords[-2]['Y'] = ret[2*aBorderCD[0]], ret[2*aBorderCD[0]+1]
                else:
                    aJoinCoords[-1]['X'], aJoinCoords[-1]['Y'] = ret[2*aBorderCD[0]], ret[2*aBorderCD[0]+1]
                aJoinCoords[-5]['X'], aJoinCoords[-5]['Y'] = aCenterC['X'], aCenterC['Y']
            else:
                self.aEnv['JOINTYPE'] = None
        # +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        elif not (join1[1] in ('CircleShape', 'EllipseShape') or join2[1] in ('CircleShape', 'EllipseShape')):
            # ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            if join1[1] in ('LineShape',) and join2[1] in ('ArcCircleShape', 'ArcEllipseShape'):
                aPointA, aPointB = join1[2:4]
                aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC = join2[2:7]
            else:
                aPointA, aPointB = join2[2:4]
                aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC = join1[2:7]
            fAngle = self.xCompute.toPolarCoord( aPointA, aPointB)[1]
            ret = self.xCompute.getInterLineEllipse( aPointA, fAngle, aCenterC, aSizeC, fRotationC)
            # =================
            if not ret is None:
                self.aEnv['JOINTYPE'] = "LINE2ARC"
                # Line ******************************************************************
                aMouseRelPosAB = self.xCompute.getDist2Line( aPointA, aPointB, aMouseCoord)
                aBorderAB = self.setBorder(-1, aMouseRelPosAB, ret[:2])
                # --------------------------------
                if aBorderAB[1] in ("ILB", "OLB"):
                    aJoinCoords[0]['X'], aJoinCoords[0]['Y'] = aPointB['X'], aPointB['Y']
                # -----------------------------------
                elif aBorderAB[1] in ("IRB", "ORB") :
                    aJoinCoords[0]['X'], aJoinCoords[0]['Y'] = aPointA['X'], aPointA['Y']
                aJoinCoords[1]['X'], aJoinCoords[1]['Y'] = ret[2*aBorderAB[0]+2], ret[2*aBorderAB[0]+3]
                # arc *******************************************************************************************************************************
                aJoinCoords.insert(-1, self.xCompute.getPointOnEllipse( None, fStartAngleC, aCenterC, aSizeC, fRotationC)[0])
                aJoinCoords.insert(-2, self.xCompute.getPointOnEllipse( None, math.pi/2, aCenterC, aSizeC, fRotationC)[0])
                aJoinCoords.insert(-3, self.xCompute.getPointOnEllipse( None, float(0), aCenterC, aSizeC, fRotationC)[0])
                aJoinCoords[-1] = self.xCompute.getPointOnEllipse( None, fEndAngleC, aCenterC, aSizeC, fRotationC)[0]
                nDist = []
                aJoinCoords[-5]['X'], aJoinCoords[-5]['Y'] = ret[2:4]
                nDist.append(self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aJoinCoords[-5])[0])
                aJoinCoords[-5]['X'], aJoinCoords[-5]['Y'] = ret[4:]
                nDist.append(self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aJoinCoords[-5])[0])
                aMouseRelPosCD = self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aMouseCoord)
                aBorderCD = self.setBorder(long(round(math.sqrt(aSizeC['Width'] * aSizeC['Height']) * 2 * math.pi)), aMouseRelPosCD, nDist)
                # ................................
                if aBorderCD[1] in ("ILB", "OLB"):
                    aJoinCoords[-2]['X'], aJoinCoords[-2]['Y'] = ret[2*aBorderCD[0]+2], ret[2*aBorderCD[0]+3]
                else:
                    aJoinCoords[-1]['X'], aJoinCoords[-1]['Y'] = ret[2*aBorderCD[0]+2], ret[2*aBorderCD[0]+3]
                aJoinCoords[-5]['X'], aJoinCoords[-5]['Y'] = aCenterC['X'], aCenterC['Y']
            else:
                self.aEnv['JOINTYPE'] = None
        else:
            self.aEnv['JOINTYPE'] = None
        # ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        if self.aEnv['JOINKIND'] in ('FILLET',) and not self.aEnv['JOINTYPE'] is None:
            nOrdAI = nOrdCI = self.aEnv['JOINDATA'][0]
            aPoint = {'X': 0, 'Y': 0}
            # =========================================
            if self.aEnv['JOINTYPE'] in ("LINE2LINE",):
                aMouseRelPosAB = self.xCompute.getDist2Line( aJoinCoords[1], aJoinCoords[0], aMouseCoord)
                aMouseRelPosCD = self.xCompute.getDist2Line( aJoinCoords[-2], aJoinCoords[-1], aMouseCoord)
                nOrdAI = nOrdAI * (1 - 2 * (aMouseRelPosAB[1] < 0))
                nOrdCI = nOrdCI * (1 - 2 * (aMouseRelPosCD[1] < 0))
                ret = self.xCompute.getInterLines2( aJoinCoords[1], aJoinCoords[0], aJoinCoords[2], aJoinCoords[3], nOrdAI, nOrdCI)
                if not ret is None and (aMouseRelPosAB[0] > 0 and aMouseRelPosCD[0] > 0):
                    aJoinCoords.insert(1, self.xCompute.getCoordFromAbsOrd( aJoinCoords[1], aJoinCoords[0], ret[0], 0))
                    aJoinCoords.insert(-1, self.xCompute.getCoordFromAbsOrd( aJoinCoords[-2], aJoinCoords[-1], ret[1], 0))
                    aJoinCoords.insert(3, {'X': 0, 'Y': 0})
                    aJoinCoords[3]['X'], aJoinCoords[3]['Y'] = ret[2:]
                    # -----------------------------------------------------------------------------------------------------------------------------
                    if (aJoinCoords[1]['X'] - ret[2]) * (aJoinCoords[-2]['Y'] - ret[3]) - (aJoinCoords[1]['Y'] - ret[3]) * (aJoinCoords[-2]['X'] - ret[2]) < 0:
                        aJoinCoords[2]['X'], aJoinCoords[2]['Y'] = aJoinCoords[1]['X'], aJoinCoords[1]['Y']
                        aJoinCoords[-3]['X'], aJoinCoords[-3]['Y'] = aJoinCoords[-2]['X'], aJoinCoords[-2]['Y']
                    else:
                        aJoinCoords[-3]['X'], aJoinCoords[-3]['Y'] = aJoinCoords[1]['X'], aJoinCoords[1]['Y']
                        aJoinCoords[2]['X'], aJoinCoords[2]['Y'] = aJoinCoords[-2]['X'], aJoinCoords[-2]['Y']
                else:
                    self.aEnv['JOINTYPE'] = None
            # ==========================================
            elif self.aEnv['JOINTYPE'] in ("LINE2ARC",):
                aMouseRelPosAB = self.xCompute.getDist2Line( aJoinCoords[1], aJoinCoords[0], aMouseCoord)
                nOrdAI = nOrdAI * (1 - 2 * (aMouseRelPosAB[1] < 0))
                fAngle = -math.atan2(aJoinCoords[0]['Y'] - aJoinCoords[1]['Y'], aJoinCoords[0]['X'] - aJoinCoords[1]['X'])
                aPointA = self.xCompute.getCoordFromAbsOrd( aJoinCoords[1], aJoinCoords[0], 0, nOrdAI)
                aMouseRelPosCD = self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aMouseCoord)
                nOrdCI = nOrdCI * (1 - 2 * (aMouseRelPosCD[1] < 0))
                aFilletSize = {'Width': 0, 'Height': 0}
                aFilletSize['Width'] = aSizeC['Width'] + nOrdCI
                aFilletSize['Height'] = aSizeC['Height'] + nOrdCI
                ret = self.xCompute.getInterLineEllipse( aPointA, fAngle, aCenterC, aFilletSize, fRotationC)
                if not ret is None:
                    # ----------------------------
                    if abs(ret[0]) <= abs(ret[1]):
                        aPoint['X'], aPoint['Y'] = ret[2:4]
                    else:
                        aPoint['X'], aPoint['Y'] = ret[4:]
                    ret = self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aPoint)
                    # --------------------------
                    if abs(ret[1] - nOrdCI) > 0:
                        fAngle1 = self.xCompute.getTangentAngle( aCenterC, aSizeC, fRotationC, ret[3])
                        if not fAngle1 is None:
                            ret = self.xCompute.getInterLines3( aPointA, fAngle, aPoint, fAngle1, 0.0, nOrdCI - ret[1])
                            if not ret is None:
                                aPoint['X'], aPoint['Y'] = ret[2:]
                    aJoinCoords.insert(2, aPoint)
                    aPoint = self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aPoint)[3]
                    # -------------------------------------------------------------------------------------------------
                    if abs(aJoinCoords[1]['X'] - aJoinCoords[-1]['X']) < 5 and abs(aJoinCoords[1]['Y'] - aJoinCoords[-1]['Y']) < 5:
                        nI = -1
                    else:
                        nI = -2
                    aJoinCoords[nI]['X'], aJoinCoords[nI]['Y'] = aPoint['X'], aPoint['Y']
                    aPoint = self.xCompute.getDist2Line( aJoinCoords[0], aJoinCoords[1], aJoinCoords[2])[3]
                    aJoinCoords[1]['X'], aJoinCoords[1]['Y'] = aPoint['X'], aPoint['Y']
                    # -----------------------------------------------------------------------------------------------------------------------------
                    if (aJoinCoords[1]['X'] - aJoinCoords[2]['X']) * (aJoinCoords[nI]['Y'] - aJoinCoords[2]['Y']) - (aJoinCoords[1]['Y'] - aJoinCoords[2]['Y']) * (aJoinCoords[nI]['X'] - aJoinCoords[2]['X']) < 0:
                        aJoinCoords.insert(2, aJoinCoords[1])
                        aJoinCoords.insert(-5, aJoinCoords[nI])
                    else:
                        aJoinCoords.insert(-5, aJoinCoords[1])
                        aJoinCoords.insert(2, aJoinCoords[nI])
                else:
                    self.aEnv['JOINTYPE'] = None
            # =========================================
            elif self.aEnv['JOINTYPE'] in ("ARC2ARC",):
                aMouseRelPosAB = self.xCompute.getDist2Arc( aCenterA, aSizeC, fRotationA, fStartAngleA, fEndAngleA, aMouseCoord)
                nOrdAI = nOrdAI * (1 - 2 * (aMouseRelPosAB[1] < 0))
                aMouseRelPosCD = self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aMouseCoord)
                nOrdCI = nOrdCI * (1 - 2 * (aMouseRelPosCD[1] < 0))
                aSize1 = {'Width': 0, 'Height': 0}
                aSize2 = {'Width': 0, 'Height': 0}
                aSize1['Width'] = aSizeA['Width'] + nOrdAI
                aSize1['Height'] = aSizeA['Height'] + nOrdAI
                aSize2['Width'] = aSizeC['Width'] + nOrdCI
                aSize2['Height'] = aSizeC['Height'] + nOrdCI
                ret = self.xCompute.getInterEllipses( aCenterA, aSize1, fRotationA, aCenterC, aSize2, fRotationC)
                if not ret is None:
                    nAbsAI = nAbsCI = None
                    nI = 0
                    for i in range(len(ret)/2):
                        # ----------------
                        if nAbsAI is None:
                            nAbsAI = long(round(math.hypot(ret[2*i] - aMouseCoord['X'], ret[2*i+1] - aMouseCoord['Y'])))
                        nAbsCI = long(round(math.hypot(ret[2*i] - aMouseCoord['X'], ret[2*i+1] - aMouseCoord['Y'])))
                        # ------------------------------------------------------
                        if nAbsCI <= nAbsAI:
                            nAbsAI = nAbsCI
                            nI = i
                    aPoint['X'], aPoint['Y'] = ret[2*nI], ret[2*nI+1]
                    aIRelPosAB = self.xCompute.getDist2Arc( aCenterA, aSizeA, fRotationA, fStartAngleA, fEndAngleA, aPoint)
                    aIRelPosCD = self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aPoint)
                    if abs(aIRelPosAB[1]-nOrdAI) > 0 or abs(aIRelPosCD[1]-nOrdCI) > 0:
                        fAngle1 = self.xCompute.getTangentAngle( aCenterA, aSizeA, fRotationA, aIRelPosAB[3])
                        fAngle2 = self.xCompute.getTangentAngle( aCenterC, aSizeC, fRotationC, aIRelPosCD[3])
                        if not fAngle1 is None or not fAngle2 is None:
                            ret = self.xCompute.getInterLines3( aPoint, fAngle1, aPoint, fAngle2, nOrdAI - aIRelPosAB[1], nOrdCI - aIRelPosCD[1])
                            if not ret is None:
                                aPoint['X'], aPoint['Y'] = ret[2:]
                    aJoinCoords.insert(5, aPoint)
                    # --------------------------------------------------------------------------------------------------
                    if abs(aJoinCoords[3]['X'] - aJoinCoords[-1]['X']) < 5 and abs(aJoinCoords[3]['Y'] - aJoinCoords[-1]['Y']) < 5:
                        nI1, nI2 = 3, -1
                    # ---------------------------------------------------------------------------------------------------
                    elif abs(aJoinCoords[3]['X'] - aJoinCoords[-2]['X']) < 5 and abs(aJoinCoords[3]['Y'] - aJoinCoords[-2]['Y']) < 5:
                        nI1, nI2 = 3, -2
                    # ---------------------------------------------------------------------------------------------------
                    elif abs(aJoinCoords[4]['X'] - aJoinCoords[-1]['X']) < 5 and abs(aJoinCoords[4]['Y'] - aJoinCoords[-1]['Y']) < 5:
                        nI1, nI2 = 4, -1
                    else:
                        nI1, nI2 = 4, -2
                    aPoint = self.xCompute.getDist2Arc( aCenterA, aSizeA, fRotationA, fStartAngleA, fEndAngleA, aJoinCoords[5])[3]
                    aJoinCoords[nI1]['X'], aJoinCoords[nI1]['Y'] = aPoint['X'], aPoint['Y']
                    aPoint = self.xCompute.getDist2Arc( aCenterC, aSizeC, fRotationC, fStartAngleC, fEndAngleC, aJoinCoords[5])[3]
                    aJoinCoords[nI2]['X'], aJoinCoords[nI2]['Y'] = aPoint['X'], aPoint['Y']
                    # -----------------------------------------------------------------------------------------------------------------------------
                    if (aJoinCoords[nI1]['X'] - aJoinCoords[5]['X']) * (aJoinCoords[nI2]['Y'] - aJoinCoords[5]['Y']) - (aJoinCoords[nI1]['Y'] - aJoinCoords[5]['Y']) * (aJoinCoords[nI2]['X'] - aJoinCoords[5]['X']) < 0:
                        aJoinCoords.insert(-5, aJoinCoords[nI2])
                        aJoinCoords.insert(5, aJoinCoords[nI1])
                    else:
                        aJoinCoords.insert(-5, aJoinCoords[nI1])
                        aJoinCoords.insert(5, aJoinCoords[nI2])
                else:
                    self.aEnv['JOINTYPE'] = None
        # +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        elif self.aEnv['JOINKIND'] in ('CHAMFER',) and not self.aEnv['JOINTYPE'] is None:
            nAbsAI = self.aEnv['JOINDATA'][0]
            nAbsCI = self.aEnv['JOINDATA'][1]
            aIPoint = {'X': 0, 'Y': 0}
            # ====================================================
            if self.aEnv['JOINTYPE'] in ("LINE2LINE", "LINE2ARC"):
                aIPoint['X'], aIPoint['Y'] = aJoinCoords[1]['X'], aJoinCoords[1]['Y']
            # ====================================================================================================
            elif abs(aJoinCoords[3]['X'] - aJoinCoords[-1]['X']) < 5 and abs(aJoinCoords[3]['Y'] - aJoinCoords[-1]['Y']) < 5:
                aIPoint['X'], aIPoint['Y'] = aJoinCoords[3]['X'], aJoinCoords[3]['Y']
            # ===================================================================================================
            elif abs(aJoinCoords[3]['X'] - aJoinCoords[-2]['X']) < 5 and abs(aJoinCoords[3]['Y'] - aJoinCoords[-2]['Y']) < 5:
                aIPoint['X'], aIPoint['Y'] = aJoinCoords[3]['X'], aJoinCoords[3]['Y']
            else:
                aIPoint['X'], aIPoint['Y'] = aJoinCoords[4]['X'], aJoinCoords[4]['Y']
            # ====================================================
            if self.aEnv['JOINTYPE'] in ("LINE2LINE", "LINE2ARC"):
                aJoinCoords[1] = self.xCompute.getCoordFromAbsOrd( aIPoint, aJoinCoords[0], nAbsAI, 0)
                aJoinCoords.insert(2, aJoinCoords[1])
            # ====================================================
            if self.aEnv['JOINTYPE'] in ("LINE2LINE",):
                aJoinCoords[-2] = self.xCompute.getCoordFromAbsOrd( aIPoint, aJoinCoords[-1], nAbsCI, 0)
                aJoinCoords.insert(-2, aJoinCoords[-2])
            # ==================================================
            if self.aEnv['JOINTYPE'] in ("LINE2ARC", "ARC2ARC"):
                aPoint = {'X': 0, 'Y': 0}
                aSize = {'Width': 0, 'Height': 0}
                aSize['Width'] = nAbsCI
                aSize['Height'] = nAbsCI
                ret = self.xCompute.getInterEllipses( aIPoint, aSize, 0.0, aCenterC, aSizeC, fRotationC)
                # :::::::::::::::::
                if not ret is None:
                    nAbsA = nAbsC = None
                    nI = 0
                    for i in range(len(ret)/2):
                        # ----------------
                        if nAbsA is None:
                            nAbsA = long(round(math.hypot(ret[2*i] - aMouseCoord['X'], ret[2*i+1] - aMouseCoord['Y'])))
                        nAbsC = long(round(math.hypot(ret[2*i] - aMouseCoord['X'], ret[2*i+1] - aMouseCoord['Y'])))
                        # ------------------------------------------------------
                        if nAbsC <= nAbsA:
                            nAbsA = nAbsC
                            nI = i
                    aPoint['X'], aPoint['Y'] = ret[2*nI], ret[2*nI+1]
                    # -----------------------------------------------------------------------------------
                    if abs(aIPoint['X'] - aJoinCoords[-1]['X']) < 5 and abs(aIPoint['Y'] - aJoinCoords[-1]['Y']) < 5:
                        nI = -1
                    else:
                        nI = -2
                    aJoinCoords.insert(-5, aPoint)
                    aJoinCoords[nI]['X'], aJoinCoords[nI]['Y'] = aPoint['X'], aPoint['Y']
                else:
                    self.aEnv['JOINTYPE'] = None
            # ==================================================
            if self.aEnv['JOINTYPE'] in ("ARC2ARC",):
                aPoint = {'X': 0, 'Y': 0}
                aSize = {'Width': 0, 'Height': 0}
                aSize['Width'] = nAbsAI
                aSize['Height'] = nAbsAI
                ret = self.xCompute.getInterEllipses( aIPoint, aSize, 0.0, aCenterA, aSizeA, fRotationA)
                # :::::::::::::::::
                if not ret is None:
                    nAbsA = nAbsC = None
                    nI = 0
                    for i in range(len(ret)/2):
                        # ----------------
                        if nAbsA is None:
                            nAbsA = long(round(math.hypot(ret[2*i] - aMouseCoord['X'], ret[2*i+1] - aMouseCoord['Y'])))
                        nAbsC = long(round(math.hypot(ret[2*i] - aMouseCoord['X'], ret[2*i+1] - aMouseCoord['Y'])))
                        # ------------------------------------------------------
                        if nAbsC <= nAbsA:
                            nAbsA = nAbsC
                            nI = i
                    aPoint['X'], aPoint['Y'] = ret[2*nI], ret[2*nI+1]
                    # ---------------------------------------------------------------------------------
                    if abs(aIPoint['X'] - aJoinCoords[3]['X']) < 5 and abs(aIPoint['Y'] - aJoinCoords[3]['Y']) < 5:
                        nI = 3
                    else:
                        nI = 4
                    aJoinCoords[nI]['X'], aJoinCoords[nI]['Y'] = aPoint['X'], aPoint['Y']
                    aJoinCoords.insert(5, aPoint)
                else:
                    self.aEnv['JOINTYPE'] = None
        # +++++++++++++++++++++++++++++++++++
        if not self.aEnv['JOINTYPE'] is None:
            self.aEnv['JOINCOORDS'] = [{'X':c['X'], 'Y':c['Y']} for c in aJoinCoords]
        else:
            self.aEnv['JOINCOORDS'] = None
        return
