# 	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## joinkeyhandler mardi 24 avril 2007, 11:31:11 (UTC+0200)
## Copyright (C) 2007-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    from com.sun.star.awt.KeyModifier import SHIFT
except ImportError:
    print "probleme d'import"
#===============================
# gestion des evenements clavier
# handling keyboard events
#===============================
class JoinKeyHandler():
    """gestion des evenements clavier
    handling keyboard events"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.compute
        self.ctx = ctx
        # Datum needed by coordinates input form
        self.aCoordData = {}
        self.aCoordData["TITLE"]  = "No Title"
        self.aCoordData["FLAG"] = 0
        self.aCoordData["COMMENT"] = "No comment"
        self.aCoordData["X"] = 0
        self.aCoordData["XUNIT"] = "m"
        self.aCoordData["Y"] = 0
        self.aCoordData["YUNIT"] = "m"
        self.aCoordData["RETURN"] = False
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute( self.ctx)
    # ==================================
    # actions clavier - keyboard actions
    # aNamedValues as tuple of NamedValue
    #   Name         Value
    # KEYCODE     integer
    # L2OSTATE    tuple of 5 integers (0 or 1)
    # SHAPE
    # ==================================
    def execute(self, aArgs):
        aEnv = {}
        aEnv.update(aArgs)
        lKey = aEnv['MAGNETKEY'].keys()
        lKey.sort()
        lJkey = aEnv['JOINKEY'].keys()
        # -----------------------------------------------------------------
        if aEnv['KEYEVENT']['COD'] in lKey and not aEnv['KEYEVENT']['MOD']:
            # e,   i,   m,   p,   t => link 2 entities
            i = lKey.index(aEnv['KEYEVENT']['COD'])
            bKHState = list(aEnv['L2OSTATE'])
            bKHState[i] = not bKHState[i]
            aEnv['L2OSTATE'] = tuple(bKHState)
            aStatusBarCheckBox = aEnv['STATUSBARCONTROL'][aEnv['KEYEVENT']['COD']]
            if aStatusBarCheckBox.getState() != aEnv['L2OSTATE'][i]:
                aStatusBarCheckBox.setState(aEnv['L2OSTATE'][i])
        # --------------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in lJkey and not aEnv['KEYEVENT']['MOD']:
            # 4,   5,   6 => join kind
            if aEnv['KEYEVENT']['COD'] in ('FILLETCTRL', 'CHAMFERCTRL'):
                import fr.free.deneux.gerard.cadooo.msgl10n
                import fr.free.deneux.gerard.cadooo.datainputbox
                xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
                sTextList = ("k0", "k1")
                sTextList = xMsgL10n.getText(sTextList)
                xCoordInput = fr.free.deneux.gerard.cadooo.datainputbox.DataInputBox( self.ctx)
                self.aCoordData["TITLE"]  = sTextList[0]
                if aEnv['KEYEVENT']['COD'] == 'FILLETCTRL':
                    self.aCoordData["FLAG"] = 0
                else:
                    self.aCoordData["FLAG"] = 2
                    if not aEnv['JOINDATA'][1] is None:
                        self.aCoordData["Y"] = self.xCompute.transform2UserUnit( aEnv['JOINDATA'][1], aEnv['UNITS'], aEnv['UNITSRATIO'], aEnv['MEASUREUNIT'], aEnv['DRAWSCALE'])
                self.aCoordData["COMMENT"] = sTextList[1]
                self.aCoordData["RETURN"] = False
                if not aEnv['JOINDATA'][0] is None:
                    self.aCoordData["X"] = self.xCompute.transform2UserUnit( aEnv['JOINDATA'][0], aEnv['UNITS'], aEnv['UNITSRATIO'], aEnv['MEASUREUNIT'], aEnv['DRAWSCALE'])
                aInputData = aEnv.fromkeys(aEnv['INPUTDATAPARM'])
                for aKey in aInputData.iterkeys():
                    aInputData[aKey] = aEnv[aKey]
                self.aCoordData.update(aInputData)
                self.aCoordData.update(xCoordInput.execute(self.aCoordData))
                # ---------------------------
                if self.aCoordData["RETURN"]:
                    if self.aCoordData['X'] == 0 and self.aCoordData['Y'] == 0:
                        aEnv['KEYEVENT']['COD'] = aEnv['JOINKIND'] + 'CTRL'
                    else:
                        if self.aCoordData['X'] == 0:
                            self.aCoordData['X'] = self.aCoordData['Y']
                        if aEnv['KEYEVENT']['COD'] == 'FILLETCTRL':
                            aEnv['JOINDATA'] = (long(round(self.aCoordData['X'])), None)
                        else:
                            if self.aCoordData['Y'] == 0:
                                self.aCoordData['Y'] = self.aCoordData['X']
                            aEnv['JOINDATA'] = (long(round(self.aCoordData['X'])), long(round(self.aCoordData['Y'])))
                        if not aEnv['SHAPE'] is None:
                            aGroupShape = aEnv['CONTROLLER'].getCurrentPage()
                            if not aEnv['SPOTTEDID'] is None and len(aEnv['SPOTTEDID']) > 2:
                                for i in aEnv['SPOTTEDID'][:-2]:
                                    aGroupShape = aGroupShape.getByIndex(i)
                            aGroupShape.remove(aEnv['SHAPE'])
                            aEnv['SHAPE'] = None
                            aEnv['STEP'] = 0
                            aEnv['COORDS'] = None
                            aEnv['SPOTTEDID'] = None
                        aEnv['JOINCOORDS'] = None
                        if aEnv['JOINVISIBLE']:
                            aShape = aEnv['%s%sJOINSHAPE' % (aEnv['JOINKIND'], aEnv['JOINTYPE'])]
                            for i in range(aShape.getCount()):
                                aShape.remove(aShape.getByIndex(0))
                            aEnv['CONTROLLER'].getCurrentPage().remove(aShape)
                        aEnv['JOINVISIBLE'] = False
                        aEnv['JOINKIND'] = aEnv['KEYEVENT']['COD'][:-4]
                else:
                    aEnv['KEYEVENT']['COD'] = aEnv['JOINKIND'] + 'CTRL'
            else:
                aEnv['JOINDATA'] = (None, None)
                if not aEnv['SHAPE'] is None:
                    aGroupShape = aEnv['CONTROLLER'].getCurrentPage()
                    if not aEnv['SPOTTEDID'] is None and len(aEnv['SPOTTEDID']) > 2:
                        for i in aEnv['SPOTTEDID'][:-2]:
                            aGroupShape = aGroupShape.getByIndex(i)
                    aGroupShape.remove(aEnv['SHAPE'])
                    aEnv['SHAPE'] = None
                    aEnv['STEP'] = 0
                    aEnv['SPOTTEDID'] = None
                    aEnv['COORDS'] = None
                aEnv['JOINCOORDS'] = None
                if aEnv['JOINVISIBLE']:
                    aShape = aEnv['%s%sJOINSHAPE' % (aEnv['JOINKIND'], aEnv['JOINTYPE'])]
                    for i in range(aShape.getCount()):
                        aShape.remove(aShape.getByIndex(0))
                    aEnv['CONTROLLER'].getCurrentPage().remove(aShape)
                    aEnv['JOINVISIBLE'] = False
                aEnv['JOINKIND'] = aEnv['KEYEVENT']['COD'][:-4]
            aEnv['STATUSBARCONTROL'][aEnv['KEYEVENT']['COD']].setState(True)
        # --------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('ESC',) and not aEnv['KEYEVENT']['MOD']:
            #                                 Esc => kill job
            aEnv['CANCELJOB'] = True
            if aEnv['SHAPE']:
                aGroupShape = aEnv['CONTROLLER'].getCurrentPage()
                if len(aEnv['SPOTTEDID']) > 2:
                    for i in aEnv['SPOTTEDID'][:-2]:
                        aGroupShape = aGroupShape.getByIndex(i)
                aGroupShape.remove(aEnv['SHAPE'])
                aEnv['SHAPE'] = None
                aEnv['STEP'] = 0
                aEnv['COORDS'] = None
                aEnv['SPOTTEDID'] = None
            if aEnv['JOINVISIBLE']:
                aShape = aEnv['%s%sJOINSHAPE' % (aEnv['JOINKIND'], aEnv['JOINTYPE'])]
                for i in range(aShape.getCount()):
                    aShape.remove(aShape.getByIndex(0))
                aEnv['CONTROLLER'].getCurrentPage().remove(aShape)
                aEnv['JOINTYPE'] = None
                aEnv['JOINCOORDS'] = None
                aEnv['JOINVISIBLE'] = False
                aEnv['JOINDATA'] = [None, None]
        # -------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('AXOCTRL',) and not aEnv['KEYEVENT']['MOD']:
            #                               a => axonometric mode
            aEnv['ORTHOMODE'] = not aEnv['ORTHOMODE']
            aStatusBarCheckBox = aEnv['STATUSBARCONTROL']['AXOCTRL']
            if aStatusBarCheckBox.getState() != aEnv['ORTHOMODE']:
                aStatusBarCheckBox.setState(aEnv['ORTHOMODE'])
        # --------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('MULTICTRL',) and not aEnv['KEYEVENT']['MOD']:
            #                                * => repeat mode
            aEnv['REPEATMODE'] = not aEnv['REPEATMODE']
            aStatusBarCheckBox = aEnv['STATUSBARCONTROL']['MULTICTRL']
            if aStatusBarCheckBox.getState() != aEnv['REPEATMODE']:
                aStatusBarCheckBox.setState(aEnv['REPEATMODE'])
        return aEnv
