#	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## 
## Copyright (C) 2007-2009 Grard Deneux lun avr  9 16:32:02 CEST 2007
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math
except ImportError:
    print "probleme d'import"
# ===================================================
# Grer les validations d'entits
# Handle entities validation
# ===================================================
class JoinMouseHandler():
    """Gere les validations d'entits
    Handles entities validation"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.entitiespot
        import fr.free.deneux.gerard.cadooo.entityposize
        self.ctx = ctx
        self.xEntitySpot = fr.free.deneux.gerard.cadooo.entitiespot.EntitieSpot( self.ctx)
        self.xEntityPosSize = fr.free.deneux.gerard.cadooo.entityposize.EntityPosSize( self.ctx)
    # **********************************
    # Handles mouse clicks
    # MOUSEEVENT  struct MouseEvent
    # CANCELJOB   integer (0 or 1)
    # REPEATMODE
    # SHAPE
    # SELECTEDLIST
    # SPOTTEDSHAPE
    # SPOTTEDID
    # CONTROLLER
    # VALIDLIST
    # GROUPSHAPE
    # JOINSHAPE
    # UNOTYPE
    # ENTITYPE
    # STEP
    # MODE
    # COORDS
    # JOINTYPE
    # JOINCOORDS
    # STOPJOB
    # VALIDORIGIN
    # **********************************
    def execute(self, aArgs):
        self.aEnv = {}
        self.aEnv.update(aArgs)
        # +++++++++++++++++++++++++++++++++++++
        if self.aEnv['MOUSEEVENT'].Buttons > 1: # don't handle mouse buttons but left
            return aArgs
        # ++++++++++++++++++++++++++++++++++++++++++
        if not self.aEnv['SELECTEDLIST'][1] is None:
            self.removeTempShapes()
            aCoords = [{'X': 0, 'Y': 0} for i in range(2)]
            aShape = []
            nNBShape = 2 - (self.aEnv['SELECTEDLIST'][0][0] == self.aEnv['SELECTEDLIST'][1][0])
            nIdx = (self.aEnv['SELECTEDLIST'][0][-1], self.aEnv['SELECTEDLIST'][1][-1])
            for aSelected in self.aEnv['SELECTEDLIST'][:nNBShape]:
                aShape.append([self.aEnv['CONTROLLER'].getCurrentPage()])
                for j in aSelected[0]:
                    aShape[-1].append(aShape[-1][-1].getByIndex(j))
                aType = aShape[-1][-1].getShapeType().split('.')[-1]
                aStyle = aShape[-1][-1].Style
                aLineWidth = aShape[-1][-1].LineWidth
                aLineColor = aShape[-1][-1].LineColor
                # ------------------------------------------------------------------
                if aType in ("PolyLineShape", "PolyPolygonShape", "RectangleShape"):
                    aSplittedShape = self.xEntitySpot.getSplittedEntity(xShape=aShape[-1][-1], aSpottedShape=aSelected)
                    i = 1
                    # ---------------------------
                    for aSplit in aSplittedShape:
                        # ---------------------------------------------------------------
                        if not i in nIdx[:3-nNBShape] and aSplit[1].count("Centre") == 0: # to do ?
                            # --------------------------
                            if aSplit[1] == "LineShape":
                                self.aEnv['UNOTYPE'] = "LineShape"
                                self.aEnv['ENTITYPE'] = "LINE"
                                self.aEnv['STEP'] = 1
                                self.aEnv['MODE'] = ("CREATE", "VERTEX")
                                aShapeCoords = [[aSplit[2], aSplit[3]]]
                            else:
                                self.aEnv['UNOTYPE'] = "EllipseShape"
                                self.aEnv['ENTITYPE'] = "ARC"
                                self.aEnv['STEP'] = 3
                                self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("RADIUS", "STARTANGLE", "ENDANGLE")
                                aShapeCoords = [[{'X': 0, 'Y': 0} for j in range(4)]]
                                aShapeCoords[0][0]['X'], aShapeCoords[0][0]['Y'] = aSplit[2]['X'], aSplit[2]['Y']
                                nRadius = aSplit[3].Width
                                aShapeCoords[0][1]['X'], aShapeCoords[0][1]['Y'] = aSplit[2]['X'] + nRadius, aSplit[2]['Y']
                                aShapeCoords[0][2]['X'] = aSplit[2]['X'] + long(round(nRadius * math.cos(aSplit[5])))
                                aShapeCoords[0][2]['Y'] = aSplit[2]['Y'] - long(round(nRadius * math.sin(aSplit[5])))
                                aShapeCoords[0][3]['X'] = aSplit[2]['X'] + long(round(nRadius * math.cos(aSplit[6])))
                                aShapeCoords[0][3]['Y'] = aSplit[2]['Y'] - long(round(nRadius * math.sin(aSplit[6])))
                            self.aEnv['COORDS'] = [[{'X':c['X'], 'Y':c['Y']} for c in l] for l in aShapeCoords]
                            self.aEnv['SHAPESTATUS'] ="new"
                            aPosSizeParm = self.aEnv.fromkeys(self.aEnv['POSSIZEPARM'])
                            for aKey in aPosSizeParm.iterkeys():
                                aPosSizeParm[aKey] = self.aEnv[aKey]
                            self.aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                            self.aEnv['SHAPE'].Style = aStyle
                            self.aEnv['SHAPE'].setName("")
                            self.aEnv['SHAPE'] = None
                        i = i + (aSplit[1].count("Centre") == 0)
                nIdx = (nIdx[1], nIdx[0])
            for i in range(nNBShape):
                aShape[i].reverse()
                aShape[i][1].remove(aShape[i][0])
                for j in range(1, len(aShape[i]) - 1):
                    if aShape[i][j].getCount() == 0:
                        aShape[i][j+1].remove(aShape[i][j])
            for i in range(self.aEnv['%s%sJOINSHAPE' % (self.aEnv['JOINKIND'], self.aEnv['JOINTYPE'])].getCount()):
                aShape = self.aEnv['%s%sJOINSHAPE' % (self.aEnv['JOINKIND'], self.aEnv['JOINTYPE'])].getByIndex(i)
                aShape.Style = aStyle
                aShape.LineColor = aLineColor
                aShape.LineWidth = aLineWidth
            self.aEnv['%s%sJOINSHAPE' % (self.aEnv['JOINKIND'], self.aEnv['JOINTYPE'])] = None
            self.aEnv['JOINCOORDS'] = None
            self.aEnv['JOINTYPE'] = None
            self.aEnv['SELECTEDLIST'] = [None, None]
            self.aEnv['JOINVISIBLE'] = False
            # ----------------------------
            if self.aEnv['REPEATMODE']: # repeat mode on ?
                self.aEnv['VALIDORIGIN'] = False
                self.aEnv['VALIDLIST'] = False
                self.aEnv['GROUPSHAPE'] = self.aEnv['CONTROLLER'].getCurrentPage()
            else:
                self.aEnv['STOPJOB'] = True
            return self.aEnv
        if self.aEnv['SPOTTEDSHAPE'] is None:
            return self.aEnv
        aNewSpotID = self.aEnv['SPOTTEDSHAPE'][0] + (self.aEnv['SPOTTEDSHAPE'][-1],)
        if not self.aEnv['SELECTEDLIST'][0] is None:
            aStoredSpotID = self.aEnv['SELECTEDLIST'][0][0] + (self.aEnv['SELECTEDLIST'][0][-1],)
        else:
            aStoredSpotID = None
        if aStoredSpotID == aNewSpotID:
            return self.aEnv
        if self.aEnv['SELECTEDLIST'][0] is None:
            self.aEnv['SELECTEDLIST'][0] = self.aEnv['SPOTTEDSHAPE']
        else:
            self.aEnv['SELECTEDLIST'][1] = self.aEnv['SPOTTEDSHAPE']
        return self.aEnv
    # *****************************************************
    # remove temporary shapes
    # *****************************************************
    def removeTempShapes(self):
        if not self.aEnv['SHAPE'] is None:
            aGroupShape = self.aEnv['CONTROLLER'].getCurrentPage()
            if len(self.aEnv['SPOTTEDSHAPE'][0]) > 1:
                for i in self.aEnv['SPOTTEDSHAPE'][0][:-1]:
                    aGroupShape = aGroupShape.getByIndex(i)
            aGroupShape.remove(self.aEnv['SHAPE'])
            self.aEnv['SHAPE'] = None
            self.aEnv['STEP'] = 0
            self.aEnv['COORDS'] = None
            self.aEnv['SPOTTEDID'] = None
        return
