# 	$Id$	
# -*- coding: latin-1 -*-
## ********************************************************************************
## joinpossize 
## Copyright (C) 2007-2009 Grard Deneux dim avr  1 11:44:56 CEST 2007
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math, uno
    from com.sun.star.drawing.CircleKind import ARC
except ImportError:
    print "probleme d'import"
# =====================================
# dessin de jonction
# drawing of junction
# =====================================
class JoinPosSize():
    """dessin de jonction
    drawing of junction"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.compute
        self.ctx = ctx
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute( self.ctx)
    # =============================
    # needed from dict env
    # JOINSHAPE
    # JOINVISIBLE
    # CONTROLLER
    # MODEL
    # JOINCOORDS
    # JOINTYPE
    # SELECTEDLIST
    # SPOTTEDSHAPE
    # JOINKIND
    # ==============================
    def execute(self, aNamedValues):
        aEnv = {}
        aEnv.update(aNamedValues)
        if aEnv['JOINCOORDS'] is None:
            return aNamedValues
        aBiPoint = ((uno.createUnoStruct("com.sun.star.awt.Point"), uno.createUnoStruct("com.sun.star.awt.Point")),)
        aULCCoord = uno.createUnoStruct("com.sun.star.awt.Point")
        aSize = uno.createUnoStruct("com.sun.star.awt.Size")
        aGroupShape = aEnv['%s%sJOINSHAPE' % (aEnv['JOINKIND'], aEnv['JOINTYPE'])]
        # ++++++++++++++++++++++++++++++++++++++++++++++++
        if not aEnv['JOINVISIBLE'] or aGroupShape is None:
            # ---------------------
            if aGroupShape is None:
                aGroupShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.GroupShape")
            aEnv['CONTROLLER'].CurrentPage.add(aGroupShape)
            aEnv['JOINVISIBLE'] = True
        # +++++++++++++++++++++++++++++++++++++++++++++++
        if aEnv['JOINTYPE'] in ('LINE2LINE', 'LINE2ARC'): # drawing a line
            # ------------------------ line 1
            if aGroupShape.Count == 0:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.LineShape")
                aGroupShape.add(aShape)
                aShape.setName("line1")
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(0)
            aBiPoint[0][0].X, aBiPoint[0][0].Y, aBiPoint[0][1].X, aBiPoint[0][1].Y = aEnv['JOINCOORDS'][0]['X'], aEnv['JOINCOORDS'][0]['Y'], aEnv['JOINCOORDS'][1]['X'], aEnv['JOINCOORDS'][1]['Y']
            aShape.PolyPolygon = aBiPoint
        # +++++++++++++++++++++++++++++++++++++++++++++++
        if aEnv['JOINTYPE'] in ('LINE2LINE',): # drawing a line
            # ------------------------- line 2
            if aGroupShape.Count == 1 :
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.LineShape")
                aShape.setName("line2")
                aGroupShape.add(aShape)
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(1)
            aBiPoint[0][0].X, aBiPoint[0][0].Y, aBiPoint[0][1].X, aBiPoint[0][1].Y = aEnv['JOINCOORDS'][-2]['X'], aEnv['JOINCOORDS'][-2]['Y'], aEnv['JOINCOORDS'][-1]['X'], aEnv['JOINCOORDS'][-1]['Y']
            aShape.PolyPolygon = aBiPoint
        # ++++++++++++++++++++++++++++++++++
        if aEnv['JOINTYPE'] in ('ARC2ARC',): # drawing an arc
            # ------------------------ arc1
            if aGroupShape.Count == 0:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.EllipseShape")
                aGroupShape.add(aShape)
                aShape.setName("arc1")
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(0)
            fAngle1 = self.xCompute.toPolarCoord( aEnv['JOINCOORDS'][0], aEnv['JOINCOORDS'][3])[1]
            fAngle2 = self.xCompute.toPolarCoord( aEnv['JOINCOORDS'][0], aEnv['JOINCOORDS'][4])[1]
            fAngle3 = self.xCompute.toPolarCoord( aEnv['JOINCOORDS'][0], aEnv['JOINCOORDS'][1])[1]
            aSize.Height, aSize.Width = map(abs, self.xCompute.getDist2Line( aEnv['JOINCOORDS'][0], aEnv['JOINCOORDS'][1], aEnv['JOINCOORDS'][2])[1:-1])
            fAngle1 = math.atan2(aSize.Width * math.sin(fAngle1 - fAngle3), aSize.Height * math.cos(fAngle1 - fAngle3))
            if fAngle1 <0:
                fAngle1 = fAngle1 + 2 * math.pi
            fAngle2 = math.atan2(aSize.Width * math.sin(fAngle2 - fAngle3), aSize.Height * math.cos(fAngle2 - fAngle3))
            if fAngle2 <0:
                fAngle2 = fAngle2 + 2 * math.pi
            aULCCoord.X = aEnv['JOINCOORDS'][0]['X'] - aSize.Width * math.cos(fAngle3) - aSize.Height * math.sin(fAngle3)
            aULCCoord.Y = aEnv['JOINCOORDS'][0]['Y'] + aSize.Width * math.sin(fAngle3) - aSize.Height * math.cos(fAngle3)
            aSize.Height, aSize.Width = 2 * aSize.Height, 2 * aSize.Width
            aShape.CircleKind = ARC
            aShape.CircleStartAngle = long(round(math.degrees(fAngle1) * 100))
            aShape.CircleEndAngle = long(round(math.degrees(fAngle2) * 100))
            aShape.setPosition(aULCCoord)
            aShape.setSize(aSize)
            aShape.RotateAngle = long(round(math.degrees(fAngle3) * 100))
        # +++++++++++++++++++++++++++++++++++++++++++++
        if aEnv['JOINTYPE'] in ('LINE2ARC', 'ARC2ARC'): # drawing an arc
            # ------------------------ arc2
            if aGroupShape.Count == 1:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.EllipseShape")
                aGroupShape.add(aShape)
                aShape.setName("arc2")
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(1)
            fAngle1 = self.xCompute.toPolarCoord( aEnv['JOINCOORDS'][-5], aEnv['JOINCOORDS'][-2])[1]
            fAngle2 = self.xCompute.toPolarCoord( aEnv['JOINCOORDS'][-5], aEnv['JOINCOORDS'][-1])[1]
            fAngle3 = self.xCompute.toPolarCoord( aEnv['JOINCOORDS'][-5], aEnv['JOINCOORDS'][-4])[1]
            aSize.Height, aSize.Width = map(abs, self.xCompute.getDist2Line( aEnv['JOINCOORDS'][-5], aEnv['JOINCOORDS'][-4], aEnv['JOINCOORDS'][-3])[1:-1])
            fAngle1 = math.atan2(aSize.Width * math.sin(fAngle1 - fAngle3), aSize.Height * math.cos(fAngle1 - fAngle3))
            if fAngle1 <0:
                fAngle1 = fAngle1 + 2 * math.pi
            fAngle2 = math.atan2(aSize.Width * math.sin(fAngle2 - fAngle3), aSize.Height * math.cos(fAngle2 - fAngle3))
            if fAngle2 <0:
                fAngle2 = fAngle2 + 2 * math.pi
            aULCCoord.X = aEnv['JOINCOORDS'][-5]['X'] - aSize.Width * math.cos(fAngle3) - aSize.Height * math.sin(fAngle3)
            aULCCoord.Y = aEnv['JOINCOORDS'][-5]['Y'] + aSize.Width * math.sin(fAngle3) - aSize.Height * math.cos(fAngle3) 
            aSize.Height, aSize.Width = 2 * aSize.Height, 2 * aSize.Width
            aShape.CircleKind = ARC
            aShape.CircleStartAngle = long(round(math.degrees(fAngle1) * 100))
            aShape.CircleEndAngle = long(round(math.degrees(fAngle2) * 100))
            aShape.setPosition(aULCCoord)
            aShape.setSize(aSize)
            aShape.RotateAngle = long(round(math.degrees(fAngle3) * 100))
        # +++++++++++++++++++++++++++++++++
        if aEnv['JOINKIND'] in ('FILLET',):
            # ------------------------ arc3
            if aGroupShape.Count == 2:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.EllipseShape")
                aGroupShape.add(aShape)
                aShape.setName("arc3")
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(2)
            # -----------------------------------------------
            if aEnv['JOINTYPE'] in ('LINE2LINE', 'LINE2ARC'):
                aSize.Width, fAngle1 = self.xCompute.toPolarCoord( aEnv['JOINCOORDS'][3], aEnv['JOINCOORDS'][2])
                fAngle2 = self.xCompute.toPolarCoord( aEnv['JOINCOORDS'][3], aEnv['JOINCOORDS'][4])[1]
                aULCCoord.X = aEnv['JOINCOORDS'][3]['X'] - aSize.Width
                aULCCoord.Y = aEnv['JOINCOORDS'][3]['Y'] - aSize.Width
            else:
                aSize.Width, fAngle1 = self.xCompute.toPolarCoord( aEnv['JOINCOORDS'][6], aEnv['JOINCOORDS'][5])
                fAngle2 = self.xCompute.toPolarCoord( aEnv['JOINCOORDS'][6], aEnv['JOINCOORDS'][7])[1]
                aULCCoord.X = aEnv['JOINCOORDS'][6]['X'] - aSize.Width
                aULCCoord.Y = aEnv['JOINCOORDS'][6]['Y'] - aSize.Width
            aSize.Height = aSize.Width = 2 * aSize.Width
            aShape.CircleKind = ARC
            aShape.CircleStartAngle = long(math.degrees(fAngle1) * 100)
            aShape.CircleEndAngle = long(math.degrees(fAngle2) * 100)
            aShape.setPosition(aULCCoord)
            aShape.setSize(aSize)
        # +++++++++++++++++++++++++++++++++
        if aEnv['JOINKIND'] in ('CHAMFER',):
            # ------------------------ Line3
            if aGroupShape.Count == 2:
                aShape = aEnv['MODEL'].createInstance("com.sun.star.drawing.LineShape")
                aGroupShape.add(aShape)
                aShape.setName("line3")
                if aEnv['SHAPESTATUS'] == "transient":
                    aShape.LineColor = 0xFF00FF
                    aShape.LineWidth = long(50 * 100 / aEnv['ZOOMVALUE'])
            else:
                aShape = aGroupShape.getByIndex(2)
            # -----------------------------------------------
            if aEnv['JOINTYPE'] in ('LINE2LINE', 'LINE2ARC'):
                aBiPoint[0][0].X, aBiPoint[0][0].Y, aBiPoint[0][1].X, aBiPoint[0][1].Y = aEnv['JOINCOORDS'][2]['X'], aEnv['JOINCOORDS'][2]['Y'], aEnv['JOINCOORDS'][3]['X'], aEnv['JOINCOORDS'][3]['Y']
                aShape.PolyPolygon = aBiPoint
            else:
                aBiPoint[0][0].X, aBiPoint[0][0].Y, aBiPoint[0][1].X, aBiPoint[0][1].Y = aEnv['JOINCOORDS'][5]['X'], aEnv['JOINCOORDS'][5]['Y'], aEnv['JOINCOORDS'][6]['X'], aEnv['JOINCOORDS'][6]['Y']
                aShape.PolyPolygon = aBiPoint
        aGroupShape.setPropertyValue("SizeProtect", True)
        aGroupShape.setPropertyValue("MoveProtect", True)
        aGroupShape.setName("junction")
        aEnv['%s%sJOINSHAPE' % (aEnv['JOINKIND'], aEnv['JOINTYPE'])] = aGroupShape
        return aEnv
