# $Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## magneticpoleshape jeu jan 26 20:18:45 CET 2005
## Copyright (C) 2005 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math
    from com.sun.star.drawing.FillStyle import NONE
except ImportError:
    print "probleme d'import"
# =========================
# Gerer la marque d'ancrage
# Handle the anchor
# =========================
class MagneticPoleShape():
    def __init__(self, ctx):
        self.ctx = ctx
        self.smgr = ctx.ServiceManager
        # translation component
        import fr.free.deneux.gerard.cadooo.msgl10n
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n(ctx)
        self.aTextList = tuple(["st%d" % i for i in range(5)])
        self.aText = xMsgL10n.getText(self.aTextList)
    # ========================================
    # sets the shape of the magnetic pole
    # and draws it at L2OCOORD
    # the dictionary args must contain
    # MAGNETKIND a character in (e, i, m, p, t)
    # MAGNETVISIBLE a flag as boolean
    # MAGNETSIZE a size as long integer
    # L2OCOORD a struct com.sun.star.awt.Point
    # ========================================
    def execute(self, aNamedValues):
        aEnv = {}
        aEnv.update(aNamedValues)
        aSize = {'Width': aEnv['MAGNETSIZE'], 'Height': aEnv['MAGNETSIZE']}
        aCoord = {'X': 0, 'Y': 0}
        aCoord['X'] = (dict(aEnv['L2OCOORD'])['X'] - dict(aEnv['VISIBLEAREA'])['X']) / aEnv['DEVICEXSCALE'] - aSize['Width']/2
        aCoord['Y'] = (dict(aEnv['L2OCOORD'])['Y'] - dict(aEnv['VISIBLEAREA'])['Y']) / aEnv['DEVICEYSCALE'] - aSize['Height']/2
        if aEnv['MAGNETVISIBLE']:
            if aEnv['MAGNETKIND'] == "0":
                aEnv['MAGNETVISIBLE'] = False
                aPeer = aEnv['MAGNETSHAPE'].getPeer()
                aPeer.dispose()
                aEnv['MAGNETSHAPE'].setModel(None)
                aEnv['MAGNETSHAPE'] = None
                del aEnv['WINID']['MAGP']
                return aEnv
        elif aEnv['MAGNETKIND'] == "0":
            return aEnv
        else:
            aButtonModel = self.smgr.createInstance("com.sun.star.awt.UnoControlButtonModel")
            aButtonModel.BackgroundColor = 0xff0000
            aButtonModel.Label = ""
            aButtonModel.HelpText = self.aText[['e', 'i', 'm', 'p', 't'].index(aEnv['MAGNETKIND'])]
            aEnv['MAGNETSHAPE'] = self.smgr.createInstance("com.sun.star.awt.UnoControlButton")
            aEnv['MAGNETSHAPE'].setModel(aButtonModel)
            aEnv['MAGNETSHAPE'].createPeer(aEnv['PANEWINDOW'].Toolkit, aEnv['PANEWINDOW'])
            aEnv['MAGNETSHAPE'].setDesignMode(False)
            aEnv['MAGNETSHAPE'].setEnable(True)
        aPeer = aEnv['MAGNETSHAPE'].getPeer()
        aPeer.setPosSize(aCoord['X'], aCoord['Y'], aSize['Width'], aSize['Height'], 15)
        aPeer.setBackground(0xff0000)
        aPeer.setVisible(True)
        sWId = repr(aPeer.ImplementationId)
        sWId = "".join(["%02x" % ord(sWId[p]) for p in range(len(sWId))])
        aEnv['WINID']['MAGP'] = sWId
        aEnv['MAGNETVISIBLE'] = True
        aEnv['MAGNETSHAPE'].Model.HelpText = self.aText[['e', 'i', 'm', 'p', 't'].index(aEnv['MAGNETKIND'])]
        aEnv['MAGNETSHAPE'].setLabel(aEnv['MAGNETSHAPE'].Model.HelpText[0])
        aEnv['MAGNETSHAPE'].setVisible(True)
        return aEnv
