# $Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## message_box ven fv 11 15:07:47 CET 2005
## Copyright (C) 2004-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************

try:
    import uno
except ImportError:
    print "import impossible de uno et unohelper"

try:
    from com.sun.star.awt.MessageBoxButtons import BUTTONS_OK
except ImportError:
    print "import impossible de MessageBoxButtons"

class MessageBox():
    """Boite de dialogue contenant un message"""
    def __init__(self, aContext):
        """MessageBox initialization"""
        self.ctx = aContext
        desktop = self.ctx.ServiceManager.createInstanceWithContext( "com.sun.star.frame.Desktop",self.ctx)
        aEnum = desktop.getComponents().createEnumeration()
        while aEnum.hasMoreElements():
            aComponent = aEnum.nextElement()
            if hasattr(aComponent, "supportsService"):
                if aComponent.supportsService("com.sun.star.drawing.DrawingDocument"):
                    self.aController = aComponent.getCurrentController()
                    break
    # ******************************
    def execute(self, sMsg, sType):
        """Display and management of the message box
        Affichage et gestion de la boite de message"""
        import fr.free.deneux.gerard.cadooo.msgl10n
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n(self.ctx)
        aTextList = ("m0", "m1")
        aText = xMsgL10n.getText(aTextList)
        aBox = uno.createUnoStruct("com.sun.star.awt.Rectangle")
        aMessageBoxToolkit = self.ctx.ServiceManager.createInstanceWithContext( "com.sun.star.awt.Toolkit", self.ctx)
        aMessageBox = aMessageBoxToolkit.createMessageBox(self.aController.Frame.ComponentWindow, aBox, sType, BUTTONS_OK, aText[0], sMsg)
        ret = aMessageBox.execute()
