#	$Id:$
# -*- coding: latin-1 -*-
## ********************************************************************************
## 
## Copyright (C) 2005-2009 Grard Deneux mercredi 25 fvrier 2009, 14:30:57 (UTC+0100)
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
#=====================================================
# a class to localize all messages
# une classe pour traduire tous messages
# uma classe para traduzir todas as mensagens
#=====================================================
import uno
class MsgL10n():
    """All messages l10n
    Traduction de tous messages"""
    def __init__(self, ctx):
        aPropertyValues = (uno.createUnoStruct("com.sun.star.beans.PropertyValue"),)
        aConfigProvider = ctx.ServiceManager.createInstanceWithContext("com.sun.star.configuration.ConfigurationProvider", ctx)
        aPropertyValues[0].Name = "nodepath"
        aPropertyValues[0].Value = "/org.openoffice.Setup/L10N"
        aSettings = aConfigProvider.createInstanceWithArguments("com.sun.star.configuration.ConfigurationAccess", aPropertyValues )
        OOLangue = aSettings.getByName("ooLocale")
        self.aLocale = OOLangue[:2]
        # add new language in the following list
        aLocaleList = ("fr", "en", "pt", "de")
        if self.aLocale not in aLocaleList:
            self.aLocale = "en"
        # add translated messages in the following list
        self.aMessages = {"l0":{"fr":"Tracer un segment ",
                                "en":"Drawing a line ",
                                "pt":"Traar uma linha ",
                                "de":"Linie Zeichnen "},
                          "l1":{"fr":"==> point 1 ",
                                "en":"==> point 1 ",
                                "pt":"==> ponto 1 ",
                                "de":"==> Punkt 1 "},
                          "l2":{"fr":"==> point 2 ",
                                "en":"==> point 2 ",
                                "pt":"==> ponto 2 ",
                                "de":"==> Punkt 2 "},
                          "sq0":{"fr":"Tracer un carr ",
                                 "en":"Drawing a square ",
                                 "pt":"Traar um quadrado ",
                                 "de":"Quadrat zeichnen "},
                          "sq1":{"fr":"==> centre ",
                                 "en":"==> centre ",
                                 "pt":"==> centro ",
                                 "de":"==> Zentrum "},
                          "sq2":{"fr":"==> demi cot ",
                                 "en":"==> half width ",
                                 "pt":"==> semicota ",
                                 "de":"==> halbieren "},
                          "rec0":{"fr":"Tracer un rectangle ",
                                  "en":"Drawing a rectangle ",
                                  "pt":"Traar um retangulo ",
                                  "de":"Rechteck zeichnen "},
                          "rec1":{"fr":"==> centre ",
                                  "en":"==> centre ",
                                  "pt":"==> centro ",
                                  "de":"==> Zentrum "},
                          "rec2":{"fr":"==> demi cot 1 ",
                                  "en":"==> half width ",
                                  "pt":"==> semicota 1 ",
                                  "de":"==> Breite halbieren "},
                         "rec3":{"fr":"==> demi cot 2 ",
                                 "en":"==> half height ",
                                 "pt":"==> semicota 2 ",
                                 "de":"==> Hhe halbieren "},
                          "c0":{"fr":"Tracer un cercle ",
                                "en":"Drawing a circle ",
                                "pt":"Traar um circulo ",
                                "de":"Kreis zeichnen "},
                          "c1":{"fr":"==> centre",
                                "en":"==> centre",
                                "pt":"==> centro",
                                "de":"==> Zentrum"},
                          "c2":{"fr":"==> rayon",
                                "en":"==> radius",
                                "pt":"==> raio",
                                "de":"==> Radius"},
                          "c3p0":{"fr":"Tracer un cercle par 3 points",
                                  "en":"Drawing a circle with 3 points",
                                  "pt":"Traar um circulo por 3 pontos",
                                  "de":"Kreis ber 3 Punkte"},
                          "c3p1":{"fr":"==> point 1 ",
                                  "en":"==> point 1 ",
                                  "pt":"==> ponto 1 ",
                                  "de":"==> Punkt 1 "},
                          "c3p2":{"fr":"==> point 2 ",
                                  "en":"==> point 2 ",
                                  "pt":"==> ponto 2 ",
                                  "de":"==> Punkt 2 "},
                          "c3p3":{"fr":"==> point 3 ",
                                  "en":"==> point 3 ",
                                  "pt":"==> ponto 3 ",
                                  "de":"==> Punkt 3 "},
                          "p0":{"fr":"Tracer un polygone ",
                                "en":"Drawing a polygon",
                                "pt":"Traar um polgono",
                                "de":"Polygon zeichnen"},
                          "p1":{"fr":"==> point 1 ",
                                "en":"==> point 1 ",
                                "pt":"==> ponto 1 ",
                                "de":"==> Punkt 1 "},
                          "p2":{"fr":"==> point suivant",
                                "en":"==> next point",
                                "pt":"==> prximo ponto",
                                "de":"==> naechster Punkt"},
                          "e0":{"fr":"Tracer une ellipse ",
                                "en":"Drawing an ellipse ",
                                "pt":"Traar uma elipse ",
                                "de":"Ellipse zeichnen "},
                          "e1":{"fr":"==> centre",
                                "en":"==> centre",
                                "pt":"==> centro",
                                "de":"==> Zentrum"},
                          "e2":{"fr":"==> rayon 1 et orientation",
                                "en":"==> radius 1 and orientation",
                                "pt":"==> raio 1 e orientao",
                                "de":"==> Radius 1 und Richtung"},
                          "e3":{"fr":"==> rayon 2",
                                "en":"==> radius 2",
                                "pt":"==> raio 2",
                                "de":"==> Radius 2"},
                          "ea0":{"fr":"Tracer un arc d'ellipse ",
                                 "en":"Drawing an elliptical arc ",
                                 "pt":"Traar um arco de elipse ",
                                 "de":"Ellipsenfrmiger Bogen "},
                          "ea1":{"fr":"==> centre",
                                 "en":"==> centre",
                                 "pt":"==> centro",
                                 "de":"==> Zentrum"},
                          "ea2":{"fr":"==> rayon 1 et orientation",
                                 "en":"==> radius 1 and orientation",
                                "pt":"==> raio 1 e orientao",
                                "de":"==> Radius 1 und Richtung"},
                          "ea3":{"fr":"==> rayon 2",
                                 "en":"==> radius 2",
                                 "pt":"==> raio 2",
                                 "de":"==> Radius 2"},
                          "ea4":{"fr":"==> angle initial",
                                 "en":"==> start angle",
                                 "pt":"==> ngulo inicial",
                                 "de":"==> Startwinkel"},
                          "ea5":{"fr":"==> angle final",
                                 "en":"==> end angle",
                                 "pt":"==> ngulo final",
                                 "de":"==> Endwinkel"},
                          "a0":{"fr":"Tracer un arc ",
                                "en":"Drawing an arc ",
                                "pt":"Traar um arco ",
                                "de":"Bogen zeichnen"},
                          "a1":{"fr":"==> centre",
                                "en":"==> centre",
                                "pt":"==> centro",
                                "de":"==> Zentrum"},
                          "a2":{"fr":"==> rayon",
                                "en":"==> radius",
                                "pt":"==> raio",
                                "de":"==> Radius"},
                          "a3":{"fr":"==> angle initial",
                                "en":"==> start angle",
                                "pt":"==> ngulo inicial",
                                "de":"==> Startwinkel"},
                          "a4":{"fr":"==> angle final",
                                "en":"==> end angle",
                                "pt":"==> ngulo final",
                                "de":"==> Endwinkel"},
                          "t0":{"fr":"Prolonger",
                                "en":"Extend",
                                "pt":"extenso",
                                "de":"Verlaengern"},
                          "cu0":{"fr":"Couper",
                                 "en":"Cut",
                                 "pt":"Cortar",
                                 "de":"Schneiden"},
                          "o0":{"fr":"Copie dcale d'entit",
                                "en":"Entity offset copy",
                                "pt":"copiar ao longo de",
                                "de":"Kopieren und verschieben"},
                          "o1":{"fr":"Saisie de distance",
                                "en":"Distance input",
                                "pt":"posio inicial",
                                "de":"Einfuegen mit Versatz"},
                          "o2":{"fr":"Dcalage",
                                "en":"Offset",
                                "pt":"extender at",
                                "de":"Verschieben"},
                          "o3":{"fr":"Au revoir !",
                                "en":"Bye !",
                                "pt":"At logo",
                                "de":"Tschuess"},
                          "o4":{"fr":"Angle nul interdit \nAu revoir !",
                                "en":"Null angle forbidden \nBye !",
                                "pt":"ngulo nulo invlido \nAt logo !",
                                "de":"Winkel Null unzulaessig \nTschuess"},
                          "o5":{"fr":"Segments parallles ou colinaires \nAu revoir !",
                                "en":"parallel or colinear segments\nBye !",
                                "pt":"segmentos paralelos ou colineares \nAt logo !",
                                "de":"Parallele oder ausgerichtete Segmente \nTschuess "},
                          "s0":{"fr":"Slectionner un contour.\nAu revoir !",
                                "en":"Select a contour \nBye !",
                                "pt":"selecione um contorno \nAt logo !",
                                "de":"Kontur waehlen \nTschuess"},
                          "s1":{"fr":"Au revoir !",
                                "en":"Bye !",
                                "pt":"At logo",
                                "de":"Tschuess"},
                          "s2":{"fr":"Nombre de segments (6, 7 ou 8)\nAu revoir !",
                                "en":"Segments count must be 6, 7 or 8\nBye !",
                                "pt":"Contagem de segmentos (6, 7 ou 8)\nAt logo !",
                                "de":"Anzahl Segmente (6, 7 ou 8)\nTschuess !"},
                          "s3":{"fr":"Le contour n'est pas un segment\nAu revoir !",
                                "en":"Contour is not a line \nBye !",
                                "pt":"Contorno no linear \nAt logo !",
                                "de":"Kontur ist keine Linie \nTschuess"},
                          "s4":{"fr":"Le segment doit appartenir au contour",
                                "en":"The line must belong to the contour",
                                "pt":"O segmento deve pertencer ao contorno",
                                "de":"The line must belong to the contour"},
                          "s5":{"fr":"La marche ci-contre\n est la 1ere",
                                "en":"Is this first step",
                                "pt":"Primeiro passo",
                                "de":"Erste Treppenstufe"},
                          "s6":{"fr":"Deux segments parallles \nAu revoir !",
                                "en":"Two parallel segments \nBye !",
                                "pt":"Dois segmentos paralelos \nAt logo !",
                                "de":"Zwei parallele Segmente \nTschuess!"},
                          "s7":{"fr":"Escalier balanc",
                                "en":"Balanced stairway",
                                "pt":"Escala balanceada",
                                "de":"Balanced stairway"},
                          "s8":{"fr":"Slection du contour : nombre de segments =",
                                "en":"Select contour : segment count =",
                                "pt":"Seleo do contorno : nmero de segmentos =",
                                "de":"Kontur Auswahl : Anzahl Segmente ="},
                          "s9":{"fr":"Saisie des donnes",
                                "en":"Input data",
                                "pt":"Dado inicial",
                                "de":"Datum Eingabe"},
                          "s10":{"fr":"Slection de la marche",
                                 "en":"Select rise",
                                 "pt":"Selecione o passo inicial",
                                 "de":"Erste Treppenstufe Auswahl"},
                          "s11":{"fr":"Trac des marches",
                                 "en":"Drawing steps",
                                 "pt":"Traado dos passos",
                                 "de":"Treppenstufe zeichnen"},
                          "m0":{"fr":"Attention !",
                                "en":"Warning !",
                                "pt":"Ateno !",
                                "de":"Achtung !"},
                          "m1":{"fr":"Valider",
                                "en":"OK",
                                "pt":"Certo",
                                "de":"OK"},
                          "q0":{"fr":"Question",
                                "en":"Question",
                                "pt":"Questo",
                                "de":"Frage"},
                          "q1":{"fr":"Oui",
                                "en":"Yes",
                                "pt":"Sim",
                                "de":"Ja"},
                          "q2":{"fr":"Non",
                                "en":"No",
                                "pt":"No",
                                "de":"Nein"},
                          "d0":{"fr":"Valider",
                                "en":"OK",
                                "pt":"Certo",
                                "de":"OK"},
                          "d1":{"fr":"Annuler",
                                "en":"Cancel",
                                "pt":"Cancelar",
                                "de":"Abbrechen"},
                          "d2":{"fr":"Distance",
                                "en":"Distance",
                                "pt":"Distncia",
                                "de":"Distanz"},
                          "d3":{"fr":"Saisir la distance ou la coordonne X",
                                "en":"Input distance or X coordinate",
                                "pt":"Distncia inicial ou coordenada X",
                                "de":"Distanz oder X-Koordinate eingeben"},
                          "d4":{"fr":"Choisir les units",
                                "en":"Select units",
                                "pt":"Selecione unidades",
                                "de":"Einheiten waehlen"},
                          "d5":{"fr":"Angle",
                                "en":"Angle",
                                "pt":"ngulo",
                                "de":"Winkel"},
                          "d6":{"fr":"Saisir l'angle ou la coordonne Y",
                                "en":"Input angle or Y coordinate",
                                "pt":"ngulo inicial ou coordenada Y",
                                "de":"Winkel oder Y-Koordinate eingeben"},
                          "d7":{"fr":"Repre",
                                "en":"Reference",
                                "pt":"Referncia",
                                "de":"Referenz"},
                          "d8":{"fr":"Absolu",
                                "en":"Absolute",
                                "pt":"Absoluto",
                                "de":"Absolut"},
                          "d9":{"fr":"Relatif",
                                "en":"Relative",
                                "pt":"Relativo",
                                "de":"Relativ"},
                          "d10":{"fr":u"radian",
                                 "en":u"radian",
                                 "pt":u"radianos",
                                 "de":u"radian"},
                          "d11":{"fr":u"degrs",
                                 "en":u"degree",
                                 "pt":u"graus",
                                 "de":u"DEG"},
                          "d12":{"fr":u"grade",
                                 "en":u"grade",
                                 "pt":u"grados",
                                 "de":u"GRAD"},
                          "k0":{"fr":"Donnes de dimension",
                                "en":"Dimension data",
                                "pt":"Dados de dimenso",
                                "de":"Zahlen-Einheit"},
                          "k1":{"fr":"Saisie de distance",
                                "en":"Distance input",
                                "pt":"Entrada de distncia",
                                "de":"Laenge / Distanz eingeben"},
                          "k2":{"fr":"Donnes de position",
                                "en":"Position data",
                                "pt":"Dados de posio",
                                "de":"Positions-Daten"},
                          "k3":{"fr":"Saisie de coordonnes rectangulaires",
                                "en":"rectangular coordinates input",
                                "pt":"Entrada de coordenadas retangulares",
                                "de":"Rechtwinklige (Orthagonale) Koordinaten-Eingabe"},
                          "k4":{"fr":"Saisie de coordonnes polaires",
                                "en":"polar coordinates input",
                                "pt":"Entrada de coordenadas polares",
                                "de":"Polarkoordinaten-Eingabe"},
                          "k5":{"fr":"saisie d'un angle",
                                "en":"angle input",
                                "pt":"Entrada angular",
                                "de":"Winkel-Eingabe"},
                          "st0":{"fr":"Extrmit",
                                 "en":"End",
                                 "pt":"Extremidade",
                                 "de":"Ende"},
                          "st1":{"fr":"Intersection",
                                 "en":"Intersection",
                                 "pt":"Interseco",
                                 "de":"Unterbrechen"},
                          "st2":{"fr":"Milieu",
                                 "en":"Middle",
                                 "pt":"Meio",
                                 "de":"Mitte"},
                          "st3":{"fr":"Perpendiculaire",
                                 "en":"Perpendicular",
                                 "pt":"Perpendicular",
                                 "de":"Rechtwinklig"},
                          "st4":{"fr":"Tangent",
                                 "en":"Tangent",
                                 "pt":"Tangente",
                                 "de":"Tangential"},
                          "st5":{"fr":"type d'aimantation",
                                 "en":"magnet type",
                                 "pt":"Magntico",
                                 "de":"magnetisch / Fang"},
                          "st6":{"fr":"Axonomtrie",
                                 "en":"Axonometric",
                                 "pt":"Axonomtrico",
                                 "de":"Axonometrisch"},
                          "st7":{"fr":"* multiple",
                                 "en":"* multiple",
                                 "pt":"* mltiplo",
                                 "de":"* mehrfach"},
                          "st8":{"fr":"Directe",
                                 "en":"Straight",
                                 "pt":"Reto",
                                 "de":"Gerade"},
                          "st9":{"fr":"Cong",
                                 "en":"Fillet",
                                 "pt":"filete",
                                 "de":"Scheibe"},
                          "st10":{"fr":"Chanfrein",
                                  "en":"Chamfer",
                                  "pt":"Chamfrar",
                                  "de":"Fase"},
                          "st11":{"fr":"type de jonction",
                                  "en":"junction type",
                                  "pt":"tipo juno",
                                  "de":"Verbindungs-Typ"},
                          "sw0":{"fr":"Nombre de marche et balancement",
                                 "en":"Number of steps and balancing",
                                 "pt":"Nmero de passos e balanceamento",
                                 "de":"Anzahl Stufen und Wangen"},
                          "sw1":{"fr":"Valider",
                                 "en":"OK",
                                 "pt":"Certo",
                                 "de":"OK"},
                          "sw2":{"fr":"Annuler",
                                 "en":"Cancel",
                                 "pt":"Cancelar",
                                 "de":"Abbrechen"},
                          "sw3":{"fr":"Saisir le nombre de marches",
                                 "en":"Input steps count",
                                 "pt":"Contagem de passos",
                                 "de":"Anzahl Stufen eingeben"},
                          "sw4":{"fr":"Distance ligne de foule/collet",
                                 "en":"Stride line distance",
                                 "pt":"Largura de passo",
                                 "de":"Distanz Anschluss/Auflager"},
                          "sw5":{"fr":"Saisir la distance",
                                 "en":"Input distance",
                                 "pt":"Entrada de distncia",
                                 "de":"Distanz eingeben"},
                          "sw6":{"fr":"Choisir les units",
                                 "en":"Select units",
                                 "pt":"Selecionar unidade",
                                 "de":"Einheit waehlen"},
                          "sw7":{"fr":"Nombre de marches",
                                 "en":"Steps count",
                                 "pt":"Nmero de passos",
                                 "de":"Anzahl Stufen"},
                          "sw8":{"fr":"Saisir le n de la 1re marche balance",
                                 "en":"Input 1st balanced step number",
                                 "pt":"Primeiro passo das entradas balanceadas",
                                 "de":"Erste Stufe eingeben"},
                          "sw9":{"fr":"1re marche balance ou 0 pour automatique",
                                 "en":"1st balanced step or 0 for automatic",
                                 "pt":"Primeiro passo balanceado ou 0 para automtico",
                                 "de":"Erste Stufe oder 0 fr automatische Bestimmung"},
                          "sw10":{"fr":"Saisir le n de la dernire marche balance",
                                  "en":"Input last balanced step number",
                                  "pt":"ltimo passo balanceado",
                                  "de":"Nummer der letzten Stufe"},
                          "sw11":{"fr":"Dernire marche balance ou 0 pour automatique",
                                  "en":"Last balanced step or 0 for automatic",
                                  "pt":"ltimo passo balanceado ou 0 para automtico",
                                  "de":"Nummer der letzten Stufe oder 0  fr automatische Bestimmung"},
                          "di0":{"fr":"Inspection d'objet",
                                 "en":"Diving in object",
                                 "pt":"Inspeo no objeto",
                                 "de":"Objekt untersuchen"},
                          "di1":{"fr":"Fermer",
                                 "en":"Close",
                                 "pt":"Fechar",
                                 "de":"Schliessen"},
                          "di2":{"fr":"Enregistrer",
                                 "en":"Save",
                                 "pt":"Salvar",
                                 "de":"Speichern"},
                          "di3":{"fr":"Inconnu",
                                 "en":"Unknown",
                                 "pt":"Desconhecido",
                                 "de":"Unbekannt"},
                          "di4":{"fr":"Services supports",
                                 "en":"Supported services",
                                 "pt":"Servios suportados",
                                 "de":"Unterstuetzte Dienste"},
                          "di5":{"fr":"Liste des services supports",
                                 "en":"List of supported services",
                                 "pt":"Lista de servios suportados",
                                 "de":"Liste unterstuetzter Dienste"},
                          "di6":{"fr":"Interfaces",
                                 "en":"Interfaces",
                                 "pt":"Interfaces",
                                 "de":"Schnittstellen"},
                          "di7":{"fr":"Liste des interfaces",
                                 "en":"Interfaces list",
                                 "pt":"Lista de interfaces",
                                 "de":"Schnittstellen-Liste"},
                          "di8":{"fr":"Mthodes",
                                 "en":"Methods",
                                 "pt":"Mtodos",
                                 "de":"Methoden"},
                          "di9":{"fr":"Liste des mthodes",
                                 "en":"List of methods",
                                 "pt":"Lista de Mtodos",
                                 "de":"Methodenliste"},
                          "di10":{"fr":"Proprits",
                                  "en":"Properties",
                                  "pt":"Propriedades",
                                  "de":"Eigenschaften"},
                          "di11":{"fr":"Liste de proprits",
                                  "en":"List of properties",
                                  "pt":"Lista de propriedades",
                                  "de":"Eigenschaftenliste"},
                          "di12":{"fr":"Valeur(s)",
                                  "en":"Value(s)",
                                  "pt":"Valor(es)",
                                  "de":"Werte"},
                          "di13":{"fr":"Valeur(s) de la proprit ci-dessus",
                                  "en":"Above property value(s)",
                                  "pt":"Sobre o valor(es) da propriedade",
                                  "de":"Eigenschaften obiger Werte"},
                          "di14":{"fr":"inspecter",
                                  "en":"inspect",
                                  "pt":"inspecionar",
                                  "de":"untersuchen"},
                          "di15":{"fr":"prcdent",
                                  "en":"previous",
                                  "pt":"precedente",
                                  "de":"zurck"},
                          "dim0":{"fr":"cotation",
                                  "en":"dimension",
                                  "pt":"cota",
                                  "de":"Kotierung / Hoehenkote"},
                          "dim1":{"fr":"cote linaire",
                                  "en":"linear dimension",
                                  "pt":"cota linear",
                                  "de":"Laenge"},
                          "dim2":{"fr":"cote radiale",
                                  "en":"radial dimension",
                                  "pt":"cota radial",
                                  "de":"Radialmass"},
                          "dim3":{"fr":"cote diamtrale",
                                  "en":"diametral dimension",
                                  "pt":"dimetro",
                                  "de":"Durchmesser"},
                          "dim4":{"fr":"cote angulaire",
                                  "en":"angular dimension",
                                  "pt":"cota angular",
                                  "de":"Winkelmass"},
                          "j0":{"fr":"jonction",
                                "en":"junction",
                                "pt":"juno",
                                "de":"Verbindung"},
                          "j1":{"fr":"directe",
                                "en":"direct",
                                "pt":"direto",
                                "de":"direkt"},
                          "j2":{"fr":"cong",
                                "en":"fillet",
                                "pt":"filete",
                                "de":"Scheibe"},
                          "j3":{"fr":"chanfrein",
                                "en":"chamfer",
                                "pt":"chamfrar",
                                "de":"Fase"},
                          "u0":{"fr":"Aucun fichier,\nCADOO.o n\'a pas bessoin d\'tre dverrouill",
                                "en":"No file found, \nCADOO.o don\'t need to be unlocked",
                                "pt":"Arquivo no encontrado, \nCADOO.o no precisa ser destravado",
                                "de":"Keine Datei gefunden \nCADOO.o muss nicht entsperrt werden"},
                          "u1":{"fr":"Aucune clef de verrou, \nCADOO.o n\'est pas verrouill",
                                "en":"No lock key, \nCADOO.o is unlocked",
                                "pt":"Sem cadeado, \nCADOO.o  destravado",
                                "de":"Kein Passwortschutz, \nCADOO:o ist frei"},
                          "u2":{"fr":"CADOO.o n\'est pas verrouill",
                                "en":"CADOO.o is unlocked",
                                "pt":"CADOO.o  destravado",
                                "de":"CADOO.o ist freigeschaltet"},
                          "u3":{"fr":"Attention ! Dverrouiller pendant l\'excution d'une commande de CADOO.o \npeut avoir des rsultats imprvisibles",
                                "en":"Warning ! Unlocking while a CADOO.o command is running \nmay lead to impredictable effects",
                                "pt":"Cuidado ! Destravamento pendente durante execuo de comando \npodem ocorrer resultados imprevistos",
                                "de":"Achtung ! Freischalten whrend ein CADOO.o Befehl ausgefhrt wird \nkann zu unvorhersehbaren Ereignissen fhren"},
                          "u4":{"fr":"CADOO.o a t dverrouill",
                                "en":"CADOO.o has been unlocked",
                                "pt":"CADOO.o foi destravado",
                                "de":"CADOO.o wurde freigeschaltet"},
                          "u5":{"fr":u"Arrt prcdent anormal de CADOO.o\nVous pouvez envoyer une copie de ce message",
                                "en":"Abnormal previous end of CADOO.o\nYou can send a copy of this message",
                                "en":"Abnormal previous end of CADOO.o\nYou can send a copy of this message",
                                "en":"Abnormal previous end of CADOO.o\nYou can send a copy of this message"},
                          "gp0":{"fr":"Ligne",
                                 "en":"Line",
                                 "pt":"Linha",
                                 "de":"Linie"},
                          "gp1":{"fr":"Cercle",
                                 "en":"Circle",
                                 "pt":"Crculo",
                                 "de":"Kreis"},
                          "gp2":{"fr":"Arc de cercle",
                                 "en":"Arc of circle",
                                 "pt":"Arco circular",
                                 "de":"Kreisbogen"},
                          "gp3":{"fr":"Ellipse",
                                 "en":"Ellipse",
                                 "pt":"Elipse",
                                 "de":"Ellipse"},
                          "gp4":{"fr":"Arc d'ellipse",
                                 "en":"Arc of ellipse",
                                 "pt":"Arco de Elipse",
                                 "de":"Ellipsenbogen"},
                          "gp5":{"fr":"Rectangle",
                                 "en":"Rectangle",
                                 "pt":"Retngulo",
                                 "de":"Rechteck"},
                          "gp6":{"fr":"Polygone ouvert",
                                 "en":"open polygon",
                                 "pt":"Polgono aberto",
                                 "de":"Polygon offen"},
                          "gp7":{"fr":"Polygone ferm",
                                 "en":"closed polygon",
                                 "pt":"Polgono fechado",
                                 "de":"Polygon geschlossen"},
                          "gp8":{"fr":"chelle",
                                 "en":"Scale",
                                 "pt":"Escala",
                                 "de":"Masstab"},
                          "gp9":{"fr":"Curseur",
                                 "en":"Cursor",
                                 "pt":"Cursor",
                                 "de":"Kreuz"},
                          "gp10":{"fr":"Dsignation",
                                  "en":"Designation",
                                  "pt":"Designation",
                                  "de":"Bezeichnung"},
                          "ucs0":{"fr":"SCU ",
                                  "en":"UCS ",
                                  "pt":"U.C.S.",
                                  "de":"Benutzer Koordinatensystems"},
                          "ucs1":{"fr":"Origine",
                                  "en":"Origin",
                                  "pt":"Origem",
                                  "de":"Ausgangspunkt"},
                          "ucs2":{"fr":"Axe x",
                                  "en":"x Axis",
                                  "pt":"Eixo X",
                                  "de":"X-Achse"},
                          "ucs3":{"fr":"Axe y",
                                  "en":"y Axis",
                                  "pt":"Eixo Y",
                                  "de":"Y-Achse"},
                           "area0":{"fr":u"Aire :",
                                    "en":u"Area :",
                                    "pt":u"Superfcie",
                                    "de":u"Flchenraum"},
                           "area1":{"fr":u"Traitement de la slection",
                                    "en":u"Scanning the selection",
                                    "pt":u"a escolha do tratamento",
                                    "de":u"Scannen der Auswahl"},
                           "area2":{"fr":u"Slection du contour",
                                    "en":u"Selecting the contour",
                                    "pt":u"selecionando o contorno",
                                    "de":u"Auswahl die Aussenlinie"},
                           "area3":{"fr":u"Selection de la jonction",
                                    "en":u"Selecting the junction",
                                    "de":u"Auswahl die Verbindung",
                                    "pt":u"Selecione o juno"},
                           "area4":{"fr":u"Calcul de l'aire",
                                    "en":u"Computing area",
                                    "pt":u"Computing area",
                                    "de":u"Computing area"},
                           "area5":{"fr":"La selection comporte des figures fermes",
                                    "en":"Selection has closed shapes in",
                                    "pt":"Selection has closed shapes in",
                                    "de":"Selection has closed shapes in"},
                           "area6":{"fr":"Selection du contour",
                                    "en":"Select the contour",
                                    "pt":"Select the contour",
                                    "de":"Select the contour"},
                           "area7":{"fr":"Voulez-vous conserver \nle trac du contour ?",
                                    "en":"Do you want to keep \nthe contour ?",
                                    "pt":"Do you want to keep \nthe contour ?",
                                    "de":"Do you want to keep \nthe contour ?"},
                           "area8":{"fr":"Voulez-vous exporter le contour ?",
                                    "en":"Do you want to export the contour ?",
                                    "pt":"Do you want to export the contour ?",
                                    "de":"Do you want to export the contour ?"},
                           "area9":{"fr":u"Mlange de figures fermes et ouvertes non support,\nvoulez-vous remplacer la prcdente slection ?",
                                    "en":"Mixing of closed and open shapes not supported,\ndo you want to replace previous selection ?",
                                    "pt":"Mixing of closed and open shapes not supported,\ndo you want to replace previous selection ?",
                                    "de":"Mixing of closed and open shapes not supported,\ndo you want to replace previous selection ?"},
                           "area10":{"fr":"Polygone ou rectangle : \nvoulez-vous ajouter tous les autres segments ?",
                                    "en":"Polygon or rectangle : \ndo you want to add all other sides ?",
                                    "pt":"Polygon or rectangle : \ndo you want to add all other sides ?",
                                    "de":"Polygon or rectangle : \ndo you want to add all other sides ?"},
                           "dce0":{"fr":"Export vers Calc",
                                   "en":"Export to Calc",
                                   "pt":"Export to Calc",
                                   "de":"Export to Calc"},
                           "dce1":{"fr":"Valider",
                                   "en":"OK",
                                   "pt":"OK",
                                   "de":"OK"},
                           "dce2":{"fr":"Nouveau",
                                   "en":"New",
                                   "pt":"New",
                                   "de":"Neu"},
                           "dce3":{"fr":"Ouvrir",
                                   "en":"Open",
                                   "pt":"Open",
                                   "de":"Offnen"},
                           "dce4":{"fr":"Documents ouverts",
                                   "en":"Open documents",
                                   "pt":"Open documents",
                                   "de":"Open documents"},
                           "dce5":{"fr":"Liste des documents Calc ouverts",
                                   "en":"Calc open documents list",
                                   "pt":"Calc open documents list",
                                   "de":"Calc open documents list"},
                           "dce6":{"fr":"Feuilles",
                                   "en":"Sheets",
                                   "pt":"Sheets",
                                   "de":"Sheets"},
                           "dce7":{"fr":"Feuilles du document slectionn",
                                   "en":"Sheets of selected document",
                                   "pt":"Sheets of selected document",
                                   "de":"Sheets of selected document"},
                           "dce8":{"fr":"Aucun",
                                   "en":"None",
                                   "pt":"None",
                                   "de":"Nicht"}}
    # *****************************
    # Called from other components
    # *****************************
    def getText(self, aListText):
        return tuple([self.aMessages[aMsg][self.aLocale] for aMsg in aListText])
