# $Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## 
## Copyright (C) 2005-2009 Grard Deneux lundi 2 mars 2009, 17:45:52 (UTC+0100)
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    from types import *
    from com.sun.star.drawing.CircleKind import FULL, SECTION, CUT, ARC
    import math
except ImportError:
    print "probleme d'import"
#======================================================
# a class to draw an offset copy of an entity
# une classe pour tracer une copie dcale d'une entit
#======================================================
class OffsetDraw():
    """Trace une copie dcale  d'une entite graphique
    Draws an offset copy of a graphical entity"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.entitiespot
        import fr.free.deneux.gerard.cadooo.compute
        import fr.free.deneux.gerard.cadooo.msgl10n
        self.ctx = ctx
        self.xEntitySpot = fr.free.deneux.gerard.cadooo.entitiespot.EntitieSpot(self.ctx)
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute(self.ctx)
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n(self.ctx)
        aTextList = tuple(["gp%d" % i for i in range(8)])
        self.sEntity = xMsgL10n.getText(aTextList)
        self.bRedraw = False
    # ==============================
    def execute(self, aNamedValues):
        self.aEnv = {}
        self.aEnv.update(aNamedValues)
        if self.aEnv['OFFSET'] is None:
            self.xEntitySpot.bValidList = False
            self.aEnv['KEYEVENT'] = {'COD':'LEN', 'MOD':0}
            self.aEnv.update(self.aEnv['KEYHANDLER'].execute(self.aEnv))
            if self.aEnv['OFFSET'] is None:
                return self.aEnv
        if self.bRedraw:
            self.xEntitySpot.bValidList = False
            self.bRedraw = False
        aMouseParm = dict([(k, self.aEnv[k]) for k in self.aEnv['MOUSEPARM']])
        aSpotParm = dict([(k, self.aEnv[k]) for k in self.aEnv['SPOTPARM']])
        aSpotParm.update(aMouseParm)
        self.aEnv.update(self.xEntitySpot.execute(aSpotParm))
        # -----------------------------------
        if not self.xEntitySpot.aSpottedShape is None: # entity has been spotted ?
            # ..................................................................................................
            if self.aEnv['SPOTTEDID'] == self.xEntitySpot.aSpottedShape[0]+(self.xEntitySpot.aSpottedShape[-1],):
                self.aEnv['STEP'] = 0
                return self.aEnv
            self.removeTempShape()
            self.aEnv['SPOTTEDID'] = self.xEntitySpot.aSpottedShape[0][:] + (self.xEntitySpot.aSpottedShape[-1],)
            aGroupShape = self.aEnv['CONTROLLER'].getCurrentPage()
            for i in self.aEnv['SPOTTEDID'][:-2]:
                aGroupShape = aGroupShape.getByIndex(i)
            i = self.aEnv['SPOTTEDID'][-2]
            aShape = aGroupShape.getByIndex(i)
            aType = aShape.getShapeType().split('.')[-1]
            if self.xEntitySpot.aMouseRelPos[1] != 0:
                nSign = self.xEntitySpot.aMouseRelPos[1] / abs(self.xEntitySpot.aMouseRelPos[1])
            else:
                nSign = 1
            self.aEnv['COORDS'] = []
            # .........................
            if aType in ('LineShape',):
                sType = self.sEntity[0]
                self.aEnv['UNOTYPE'] = "LineShape"
                self.aEnv['ENTITYPE'] = "LINE"
                self.aEnv['STEP'] = 1
                self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("VERTEX",)
                aShapeCoords = [{'X': aShape.PolyPolygon[0][0].X, 'Y': aShape.PolyPolygon[0][0].Y}, {'X': aShape.PolyPolygon[0][1].X, 'Y': aShape.PolyPolygon[0][1].Y}]
                self.aEnv['COORDS'].append([])
                self.aEnv['COORDS'][0].append(self.xCompute.getCoordFromAbsOrd(aShapeCoords[0], aShapeCoords[1], 0, nSign * self.aEnv['OFFSET']))
                self.aEnv['COORDS'][0].append(self.xCompute.getCoordFromAbsOrd(aShapeCoords[0], aShapeCoords[1], self.xEntitySpot.aMouseRelPos[2], nSign * self.aEnv['OFFSET']))
            # .............................
            elif aType in ('PolyLineShape',):
                sType = self.sEntity[6]
                self.aEnv['UNOTYPE'] = "PolyLineShape"
                self.aEnv['ENTITYPE'] = "LINE"
                self.aEnv['STEP'] = 1
                self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("VERTEX",)
                aShapeCoords = [[{'X': c.X, 'Y': c.Y} for c in l] for l in aShape.PolyPolygon]
                for aPolygon in aShapeCoords:
                    self.aEnv['COORDS'].append([])
                    self.aEnv['COORDS'][-1].append(self.xCompute.getCoordFromAbsOrd(aPolygon[0], aPolygon[1], 0, nSign * self.aEnv['OFFSET']))
                    for i in range(len(aPolygon)-2):
                        self.aEnv['COORDS'][-1].append({'X': 0, 'Y': 0})
                        self.aEnv['COORDS'][-1][-1]['X'], self.aEnv['COORDS'][-1][-1]['Y'] = self.xCompute.getInterLines2(aPolygon[i],\
                                                                                                aPolygon[i+1],\
                                                                                                aPolygon[i+1],\
                                                                                                aPolygon[i+2],\
                                                                                                nSign * self.aEnv['OFFSET'],\
                                                                                                nSign * self.aEnv['OFFSET'])[2:]
                    aDist = self.xCompute.toPolarCoord(aPolygon[-2], aPolygon[-1])[0]
                    self.aEnv['COORDS'][-1].append(self.xCompute.getCoordFromAbsOrd(aPolygon[-2], aPolygon[-1], aDist, nSign * self.aEnv['OFFSET']))
            # ................................
            elif aType in ('PolyPolygonShape',):
                sType = self.sEntity[7]
                self.aEnv['UNOTYPE'] = "PolyPolygonShape"
                self.aEnv['ENTITYPE'] = "LINE"
                self.aEnv['STEP'] = 1
                self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("VERTEX",)
                aShapeCoords = [[{'X': c.X, 'Y': c.Y} for c in l] for l in aShape.PolyPolygon]
                for aPolygon in aShapeCoords:
                    self.aEnv['COORDS'].append([])
                    self.aEnv['COORDS'][-1].append({'X': 0, 'Y': 0})
                    self.aEnv['COORDS'][-1][-1]['X'], self.aEnv['COORDS'][-1][-1]['Y'] = self.xCompute.getInterLines2(aPolygon[-2],\
                                                                                                aPolygon[-1],\
                                                                                                aPolygon[0],\
                                                                                                aPolygon[1],\
                                                                                                nSign * self.aEnv['OFFSET'],\
                                                                                                nSign * self.aEnv['OFFSET'])[2:]
                    for i in range(len(aPolygon)-2):
                        self.aEnv['COORDS'][-1].append({'X': 0, 'Y': 0})
                        self.aEnv['COORDS'][-1][-1]['X'], self.aEnv['COORDS'][-1][-1]['Y'] = self.xCompute.getInterLines2(aPolygon[i],\
                                                                                                    aPolygon[i+1],\
                                                                                                    aPolygon[i+1],\
                                                                                                    aPolygon[i+2],\
                                                                                                    nSign * self.aEnv['OFFSET'],\
                                                                                                    nSign * self.aEnv['OFFSET'])[2:]
                    self.aEnv['COORDS'][-1].append({'X': self.aEnv['COORDS'][-1][0]['X'], 'Y': self.aEnv['COORDS'][-1][0]['Y']})
            # ........................................
            elif aType in ('EllipseShape',):
                sType = self.sEntity[["LineShape", "CircleShape", "ArcCircleShape", "EllipseShape", "ArcEllipseShape"].index(self.xEntitySpot.aSpottedShape[1])]
                self.aEnv['COORDS'].append([])
                self.aEnv['CIRCLEKIND'] = aShape.CircleKind
                self.aEnv['UNOTYPE'] = "EllipseShape"
                self.aEnv['COORDS'][0].extend([{'X': 0, 'Y': 0} for i in range(2)])
                self.aEnv['COORDS'][0][0].update(self.xEntitySpot.aSpottedShape[2])
                aSize = {'Width':0, 'Height':0}
                aSize['Width'] = self.xEntitySpot.aSpottedShape[3]['Width'] + nSign * self.aEnv['OFFSET']
                aSize['Height'] = self.xEntitySpot.aSpottedShape[3]['Height'] + nSign * self.aEnv['OFFSET']
                # .........................................................................................................
                if self.xEntitySpot.aSpottedShape[1] in ("CircleShape", "EllipseShape", "ArcCircleShape", "ArcEllipseShape"):
                    self.aEnv['ENTITYPE'] = "CIRCLE"
                    self.aEnv['STEP'] = 1
                    self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("RADIUS",)
                    aPoint = self.xCompute.getPointOnEllipse(None, float(0), self.xEntitySpot.aSpottedShape[2], aSize, self.xEntitySpot.aSpottedShape[4])[0]
                    self.aEnv['COORDS'][0][1].update(aPoint)
                # .........................................................
                if self.xEntitySpot.aSpottedShape[1] in ("EllipseShape", "ArcCircleShape", "ArcEllipseShape"):
                    self.aEnv['COORDS'][0].extend([{'X': 0, 'Y': 0} for i in range(1)])
                    self.aEnv['ENTITYPE'] = "ELLIPSE"
                    self.aEnv['STEP'] = 2
                    self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("RADIUS", "RADIUS2")
                    aPoint = self.xCompute.getPointOnEllipse(None, math.pi/2, self.xEntitySpot.aSpottedShape[2], aSize, self.xEntitySpot.aSpottedShape[4])[0]
                    self.aEnv['COORDS'][0][2].update(aPoint)
                # ..........................................................................
                if self.xEntitySpot.aSpottedShape[1] in ("ArcCircleShape", "ArcEllipseShape"):
                    self.aEnv['COORDS'][0].extend([{'X': 0, 'Y': 0} for i in range(2)])
                    self.aEnv['ENTITYPE'] = "ELLARC"
                    self.aEnv['STEP'] = 4
                    self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("RADIUS", "RADIUS2", "STARTANGLE", "ENDANGLE")
                    aPoint = self.xCompute.getPointOnEllipse(None, self.xEntitySpot.aSpottedShape[5], self.xEntitySpot.aSpottedShape[2], aSize, self.xEntitySpot.aSpottedShape[4])[0]
                    self.aEnv['COORDS'][0][3].update(aPoint)
                    aPoint = self.xCompute.getPointOnEllipse(None, self.xEntitySpot.aSpottedShape[6], self.xEntitySpot.aSpottedShape[2], aSize, self.xEntitySpot.aSpottedShape[4])[0]
                    self.aEnv['COORDS'][0][4].update(aPoint)
                # .......................................................
                if self.xEntitySpot.aSpottedShape[1] in ("ArcCircleShape",):
                    del self.aEnv['COORDS'][0][2]
                    self.aEnv['ENTITYPE'] = "ARC"
                    self.aEnv['STEP'] = 3
                    self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("RADIUS", "STARTANGLE", "ENDANGLE")
            # ..............................
            elif aType in ('RectangleShape',):
                sType = self.sEntity[5]
                self.aEnv['COORDS'].append([])
                self.aEnv['UNOTYPE'] = "RectangleShape"
                self.aEnv['COORDS'][0].extend([{'X': 0, 'Y': 0} for i in range(3)])
                self.aEnv['ENTITYPE'] = "RECTANGLE"
                self.aEnv['STEP'] = 2
                self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("WIDTH", "HEIGHT")
                aSize = aShape.getSize()
                aSize.Width = aSize.Width - 2 * nSign * self.aEnv['OFFSET']
                aSize.Height = aSize.Height - 2 * nSign * self.aEnv['OFFSET']
                if aSize.Width < 0 or aSize.Height < 0:
                    self.aEnv['STEP'] = 0
                else:
                    aULCCoord = aShape.getPosition()
                    fAngle1 = aShape.RotateAngle * math.pi / 18000
                    aULCCoord.X = aULCCoord.X + nSign * self.aEnv['OFFSET'] * (math.cos(fAngle1) + math.cos(fAngle1 - math.pi / 2))
                    aULCCoord.Y = aULCCoord.Y - nSign * self.aEnv['OFFSET'] * (math.sin(fAngle1) + math.sin(fAngle1 - math.pi / 2))
                    fCosW = aSize.Width * math.cos(fAngle1) / 2
                    fSinW = -aSize.Width * math.sin(fAngle1) / 2
                    fCosH = aSize.Height * math.cos(fAngle1 - math.pi / 2) / 2
                    fSinH = -aSize.Height * math.sin(fAngle1 - math.pi / 2) / 2
                    self.aEnv['COORDS'][0][0]['X'], self.aEnv['COORDS'][0][0]['Y'] = aULCCoord.X + fCosW + fCosH, aULCCoord.Y + fSinW + fSinH
                    self.aEnv['COORDS'][0][1]['X'], self.aEnv['COORDS'][0][1]['Y'] = aULCCoord.X + 2 * fCosW + fCosH, aULCCoord.Y + 2 * fSinW + fSinH
                    self.aEnv['COORDS'][0][2]['X'], self.aEnv['COORDS'][0][2]['Y'] = aULCCoord.X + fCosW, aULCCoord.Y + fSinW
                    if aShape.CornerRadius:
                        self.aEnv['CORNERRADIUS'] = aShape.CornerRadius - nSign * self.aEnv['OFFSET']
                        if self.aEnv['CORNERRADIUS'] < 0:
                            self.aEnv['CORNERRADIUS'] = 0
                    else:
                        self.aEnv['CORNERRADIUS'] = 0
        else:
            sType = "----"
            self.aEnv['STEP'] = 0
            self.removeTempShape()
            self.aEnv['SPOTTEDID'] = None
            self.aEnv['COORDS'] = [[]]
        sOffset = self.xCompute.transform2UserUnit(self.aEnv['OFFSET'], self.aEnv['UNITS'], self.aEnv['UNITSRATIO'], self.aEnv['MEASUREUNIT'], self.aEnv['DRAWSCALE'])
        sText = "%s ==> %s : %s" % (self.aEnv['COMMENT'][0], sType, sOffset)
        aInfoCtrl = self.aEnv['STATUSBARCONTROL']['INFOCTRL']
        aInfoCtrl.setText(sText)
        self.aEnv['SHAPESTATUS'] = "transient"
        return self.aEnv
    # ----------------------
    # remove temporary shape
    # ----------------------
    def removeTempShape(self):
        if not self.aEnv['SHAPE'] is None:
            aGroupShape = self.aEnv['CONTROLLER'].getCurrentPage()
            for i in self.aEnv['SPOTTEDID'][:-2]:
                aGroupShape = aGroupShape.getByIndex(i)
            aGroupShape.remove(self.aEnv['SHAPE'])
            self.aEnv['SHAPE'] = None
            self.aEnv['SPOTTEDID'] = None
        return
