#
# -*- coding: latin-1 -*-
## ********************************************************************************
##
## Copyright (C) 2006-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math, traceback
except ImportError:
    print "probleme d'import"
# ===================================================
# Gerer les saisies de points et validation d'entites
# Handle points inputs and entities validation
# ===================================================
class OffsetMouseHandler():
    """Gere les saisies de points et validation d'entite
    Handles points inputs and entities validation"""
    def __init__(self, ctx):
        self.ctx = ctx
    # **********************************
    # Handles mouse clicks
    # MOUSEEVENT  struct MouseEvent
    # STOPJOB   integer (0 or 1)
    # STEP
    # COORDS
    # REPEATMODE
    # SHAPE
    # **********************************
    def execute(self, aArgs):
        aEnv = {}
        aEnv.update(aArgs)
        # ----------------------------------------
        if aEnv['MOUSEEVENT'].Buttons > 1: # don't handle mouse buttons but left
            return aArgs
        # --------------------------------------------
        if aEnv['MOUSEEVENT'].ClickCount == 1: # one click ?
            # -----------------------------------
            if not aEnv['SPOTTEDID'] is None: # entity has been spotted ?
                aGroupShape = aEnv['CONTROLLER'].getCurrentPage()
                if len(aEnv['SPOTTEDID']) > 2:
                    for i in aEnv['SPOTTEDID'][:-2]:
                        aGroupShape = aGroupShape.getByIndex(i)
                i = aEnv['SPOTTEDID'][-2]
                aShape = aGroupShape.getByIndex(i)
                aEnv['SHAPE'].Style = aShape.Style
                aEnv['SHAPE'].LineColor = aShape.LineColor
                aEnv['SHAPE'].LineWidth = aShape.LineWidth
                aEnv['SHAPE'].setName("")
                aEnv['SHAPE'] = None
            # ----------------------------
            if aEnv['REPEATMODE']: # repeat mode on ?
                aEnv['OFFSET'] = None
                aEnv['SHAPE'] = None
                aEnv['GROUPSHAPE'] = aEnv['CONTROLLER'].getCurrentPage()
            else:
                aEnv['STOPJOB'] = True
        # --------------------------------------------
        elif aEnv['MOUSEEVENT'].ClickCount == 2:
            aEnv['STOPJOB'] = True
        return aEnv
