# $Id$
#  -*- coding: latin-1 -*-
## ********************************************************************************
##
## Copyright (C) 2005-2009 Gerard Deneux
## gerard.deneux@free.fr last modified mardi 7 juillet 2009, 17:05:49 (UTC+0200)

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
#======================================================
# a class to draw an entity
# une classe pour tracer une entite
#======================================================
class ShapeDraw():
    """Trace une entite graphique
    Draws a graphical entity"""
    def __init__(self, ctx):
        from fr.free.deneux.gerard.cadooo.compute import Compute
        from fr.free.deneux.gerard.cadooo.link2obj import Link2Obj
        self.ctx = ctx
        self.xCompute = Compute(ctx)
        self.xLink2Obj = Link2Obj(ctx)
        self.bRedraw = False
    # ==============================
    def execute(self, aArgs):
        aEnv = {}
        aEnv.update(aArgs)
        if self.bRedraw:
            self.xLink2Obj.bRedraw = True
            self.bRedraw = False
        sText = aEnv['COMMENT'][0] + aEnv['COMMENT'][aEnv['STEP']+1]
        aInfoCtrl = aEnv['STATUSBARCONTROL']['INFOCTRL']
        aInfoCtrl.setText(sText)
        if aEnv['COORDS'] is None:
            self.xLink2Obj.bRedraw = True
            aEnv['COORDS'] = [[{'X':0, 'Y':0}],]
        # a single mouse move => check link to object
        aMouseParm = aEnv.fromkeys(aEnv['MOUSEPARM'])
        for aKey in aMouseParm.iterkeys():
            aMouseParm[aKey] = aEnv[aKey]
        aMouseCoord = self.xCompute.transformMouseCoord(aMouseParm)
        aEnv['COORDS'][-1][-1]['X'] = aMouseCoord['X']
        aEnv['COORDS'][-1][-1]['Y'] = aMouseCoord['Y']
        if list(aEnv['L2OSTATE']).count(0) != 5:
            aEnv.update(self.xLink2Obj.execute(aEnv))
        # first step => create a graphical entity
        if aEnv['VALIDL2O']:
            aEnv['COORDS'][-1][-1]['X'] = aEnv['L2OCOORD']['X']
            aEnv['COORDS'][-1][-1]['Y'] = aEnv['L2OCOORD']['Y']
        aEnv['GROUPSHAPE'] = aEnv['CONTROLLER'].getCurrentPage()
        aEnv['SHAPESTATUS'] = "transient"
        return aEnv
