# $Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## keyhandler jeudi 12 mars 2009, 15:46:35 (UTC+0100)

## Copyright (C) 2004-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math
    from com.sun.star.awt.KeyModifier import SHIFT
except ImportError:
    print "probleme d'import"
#===============================
# gestion des evenements clavier
# handling keyboard events
#===============================
class ShapeKeyHandler():
    """gestion des evenements clavier
    handling keyboard events"""
    def __init__(self, ctx):
        from fr.free.deneux.gerard.cadooo.datainputbox import DataInputBox
        from fr.free.deneux.gerard.cadooo.entityposize import EntityPosSize
        from fr.free.deneux.gerard.cadooo.compute import Compute
        from fr.free.deneux.gerard.cadooo.msgl10n import MsgL10n
        self.ctx = ctx
        # Datum needed by coordinates input form
        self.aCoordData = {}
        self.aCoordData["TITLE"]  = "No Title"
        self.aCoordData["FLAG"] = 0
        self.aCoordData["COMMENT"] = "No comment"
        self.aCoordData["X"] = 0
        self.aCoordData["XUNIT"] = "m"
        self.aCoordData["Y"] = 0
        self.aCoordData["YUNIT"] = "m"
        self.aCoordData["RETURN"] = False
        self.xCoordInput = DataInputBox(self.ctx)
        self.xEntityPosSize = EntityPosSize(self.ctx)
        self.xCompute = Compute(self.ctx)
        self.xMsgL10n = MsgL10n(self.ctx)
    # ==================================
    # actions clavier - keyboard actions
    # aNamedValues as tuple of NamedValue
    #   Name         Value
    # KEYCODE     integer
    # L2OSTATE    tuple of 5 integers (0 or 1)
    # DRAWSCALE
    # COORDS
    # STEP
    # VALIDORIGIN
    # DRAWSCALE
    # ORIGINCOORD
    # BORDERCOORD
    # CANCELJOB
    # ORTHOMODE
    # SHAPE
    # ==================================
    def execute(self, aArgs):
        aEnv = {}
        aEnv.update(aArgs)
        lKey = aEnv['MAGNETKEY'].keys()
        lKey.sort()
        # ----------------------------------------------------------------------------------------------------
        if aEnv['KEYEVENT']['COD'] in lKey and not aEnv['KEYEVENT']['MOD']:
            # e,   i,   m,   p,   t => link 2 entities
            i = lKey.index(aEnv['KEYEVENT']['COD'])
            bKHState = list(aEnv['L2OSTATE'])
            bKHState[i] = not bKHState[i]
            aEnv['L2OSTATE'] = tuple(bKHState)
            aStatusBarCheckBox = aEnv['STATUSBARCONTROL'][aEnv['KEYEVENT']['COD']]
            if aStatusBarCheckBox.getState() != aEnv['L2OSTATE'][i]:
                aStatusBarCheckBox.setState(aEnv['L2OSTATE'][i])
        # --------------------------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in aEnv['INPUTDATAKEY'].keys() and not aEnv['KEYEVENT']['MOD']:
            # ..............................c, ..d, ..k, ..l, ..r
            # ---------------------------------------------------------------------------
            if aEnv['KEYEVENT']['COD'] in ('DIA', 'LEN', 'RAD') and aEnv['VALIDORIGIN']:
                # ............................d,...l or r => diameter, length or radius requested
                aMouseParm = dict([(k, aEnv[k]) for k in aEnv['MOUSEPARM']])
                aMouseCoord = self.xCompute.transformMouseCoord(aMouseParm)
                aPolarCoord = self.xCompute.toPolarCoord(aEnv['ORIGINCOORD'], aMouseCoord)
                aTextList= ("k0", "k1")
                aText = self.xMsgL10n.getText(aTextList)
                self.aCoordData["TITLE"]  = aText[0]
                self.aCoordData["FLAG"] = 0
                self.aCoordData["COMMENT"] = aText[1]
                self.aCoordData["RETURN"] = False
                self.aCoordData["X"] = self.xCompute.transform2UserUnit(aPolarCoord[0], aEnv['UNITS'], aEnv['UNITSRATIO'], aEnv['MEASUREUNIT'], aEnv['DRAWSCALE'])
                aInputData = dict([(k, aEnv[k]) for k in aEnv['INPUTDATAPARM']])
                self.aCoordData.update(aInputData)
                self.aCoordData.update(self.xCoordInput.execute(self.aCoordData))
                # ---------------------------
                if self.aCoordData["RETURN"]:
                    # ------------------------------------
                    if aEnv['KEYEVENT']["COD"] == 'DIA':
                        self.aCoordData['X'] = long(round(float(self.aCoordData['X'])/2))
                    nDist = self.xCompute.toPolarCoord(aEnv['ORIGINCOORD'], aEnv['COORDS'][-1][-1])[0]
                    # ------
                    if nDist:
                        fK = float(self.aCoordData['X']) / nDist
                        aEnv['COORDS'][-1][-1]['X'] = aEnv['ORIGINCOORD']['X'] + long(round(fK * (aEnv['COORDS'][-1][-1]['X'] - aEnv['ORIGINCOORD']['X'])))
                        aEnv['COORDS'][-1][-1]['Y'] = aEnv['ORIGINCOORD']['Y'] + long(round(fK * (aEnv['COORDS'][-1][-1]['Y'] - aEnv['ORIGINCOORD']['Y'])))
            # -----------------------------------------
            elif aEnv['KEYEVENT']['COD'] in ('CAR',):
                #                               c => rectangular coordinates requested
                aMouseParm = dict([(k, aEnv[k]) for k in aEnv['MOUSEPARM']])
                aMouseCoord = self.xCompute.transformMouseCoord(aMouseParm)
                aMouseCoord = self.xCompute.transform2UCS(aMouseCoord, aEnv['UCS'])
                aTextList = ("k2", "k3")
                aText = self.xMsgL10n.getText(aTextList)
                self.aCoordData["TITLE"]  = aText[0]
                self.aCoordData["FLAG"] = 1
                self.aCoordData["COMMENT"] = aText[1]
                self.aCoordData["RETURN"] = False
                self.aCoordData["X"] = self.xCompute.transform2UserUnit(aMouseCoord['X'], aEnv['UNITS'], aEnv['UNITSRATIO'], aEnv['MEASUREUNIT'], aEnv['DRAWSCALE'])
                self.aCoordData["Y"] = self.xCompute.transform2UserUnit(aMouseCoord['Y'], aEnv['UNITS'], aEnv['UNITSRATIO'], aEnv['MEASUREUNIT'], aEnv['DRAWSCALE'])
                aInputData = dict([(k, aEnv[k]) for k in aEnv['INPUTDATAPARM']])
                self.aCoordData.update(aInputData)
                self.aCoordData.update(self.xCoordInput.execute(self.aCoordData))
                # ---------------------------
                if self.aCoordData["RETURN"]:
                    # -------------------------------
                    if self.aCoordData["FLAG"] & 0x2 and aEnv['VALIDORIGIN']: # Delta coordinates ?
                        self.aCoordData['X'] = self.aCoordData['X'] + aEnv['ORIGINCOORD']['X']
                        self.aCoordData['Y'] = self.aCoordData['Y'] + aEnv['ORIGINCOORD']['Y']
                    aEnv['COORDS'][-1][-1].update({'X': self.aCoordData['X'], 'Y': self.aCoordData['Y']})
            # -----------------------------------------
            elif aEnv['KEYEVENT']['COD'] in ('POL',):
                #                               k => polar coordinates requested
                aMouseParm = dict([(k, aEnv[k]) for k in aEnv['MOUSEPARM']])
                aMouseCoord = self.xCompute.transformMouseCoord(aMouseParm)
                aPolarCoord = self.xCompute.toPolarCoord({'X': aEnv['UCS'][0][2], 'Y': aEnv['UCS'][1][2]}, aMouseCoord)
                aTextList = ("k2", "k4")
                aText = self.xMsgL10n.getText(aTextList)
                self.aCoordData["TITLE"]  = aText[0]
                self.aCoordData["FLAG"] = 5
                self.aCoordData["COMMENT"] = aText[1]
                self.aCoordData["RETURN"] = False
                self.aCoordData["X"] = self.xCompute.transform2UserUnit(aPolarCoord[0], aEnv['UNITS'], aEnv['UNITSRATIO'], aEnv['MEASUREUNIT'], aEnv['DRAWSCALE'])
                self.aCoordData["Y"] = "%7.2f" % math.degrees(aPolarCoord[1] + math.atan2(aEnv['UCS'][0][1], aEnv['UCS'][0][0]))
                aInputData = dict([(k, aEnv[k]) for k in aEnv['INPUTDATAPARM']])
                self.aCoordData.update(aInputData)
                self.aCoordData.update(self.xCoordInput.execute(self.aCoordData))
                # ---------------------------
                if self.aCoordData["RETURN"]:
                    fX = self.aCoordData['X'] * math.cos(self.aCoordData["Y"])
                    fY = self.aCoordData['X'] * math.sin(-self.aCoordData["Y"])
                    self.aCoordData['X'] = long(round(fX * aEnv['UCS'][0][0] + fY * aEnv['UCS'][0][1]))
                    self.aCoordData['Y'] = long(round(fX * aEnv['UCS'][1][0] + fY * aEnv['UCS'][1][1]))
                    # -------------------------------
                    if self.aCoordData["FLAG"] & 0x2 and aEnv['VALIDORIGIN']: # delta coordinates ?
                        self.aCoordData['X'] = self.aCoordData['X'] + aEnv['ORIGINCOORD']['X']
                        self.aCoordData['Y'] = self.aCoordData['Y'] + aEnv['ORIGINCOORD']['Y']
                    else:
                         self.aCoordData['X'] = self.aCoordData['X'] + aEnv['UCS'][0][2]
                         self.aCoordData['Y'] = self.aCoordData['Y'] + aEnv['UCS'][1][2]
                    aEnv['COORDS'][-1][-1].update({'X': self.aCoordData['X'], 'Y': self.aCoordData['Y']})
            # ---------------------
            if aEnv['STEP'] != 0:
                aPosSizeParm = dict([(k, aEnv[k]) for k in aEnv['POSSIZEPARM']])
                aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
            if aEnv['MODE'][aEnv['STEP']] in ('VERTEX', 'CREATE'):
                aEnv['ORIGINCOORD'].update(aEnv['COORDS'][-1][-1])
            aEnv['VALIDORIGIN'] = True
            aEnv['STEP'] = aEnv['STEP'] % aEnv['STEPS'] + 1
            # -------------------------------------
            if aEnv['STEP'] == aEnv['STEPS']:
                aEnv['SHAPE'].setName("")
                aEnv['SHAPE'].Style = aEnv['STANDARDSTYLE']
                aEnv['SHAPE'].LineColor = aEnv['STANDARDSTYLE'].LineColor
                aEnv['SHAPE'].LineWidth = aEnv['STANDARDSTYLE'].LineWidth
                # -----------------------
                if aEnv['REPEATMODE']:
                    aEnv['STEP'] = 0
                    aEnv['VALIDORIGIN'] = False
                    aEnv['GROUPSHAPE'] = None
                    aEnv['SHAPE'] = None
                    aEnv['COORDS'] = None
                else:
                    aEnv['STOPJOB'] = True
            else:
                aEnv['COORDS'][-1].append({'X': 0, 'Y': 0})
        # --------------------------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('CAR', ) and aEnv['KEYEVENT']['MOD'] == SHIFT:
            # .................................c + shift => close polygon
            if not (len(aEnv['COORDS']) > 0 and len(aEnv['COORDS'][0]) > 2):
                self.aEnv['CANCELJOB'] = True
            else:
                if len(aEnv['COORDS']) < 2:
                    aEnv['GROUPSHAPE'].remove(aEnv['SHAPE'])
                    aEnv['SHAPE'] = None
                    aEnv['UNOTYPE'] = "PolyPolygonShape"
                    del aEnv['COORDS'][-1][-1]
                elif sum([len(c) for c in aEnv['COORDS']]) > 2: # is this trully a polygon ?
                    aEnv['COORDS'][-1][-1].update(aEnv['COORDS'][0][0])
                else:
                    if aEnv['VALIDL2O']: # valid link to entity ?
                        aEnv['COORDS'][-1][-1].update(aEnv['L2OCOORD'])
                aPosSizeParm = dict([(k, aEnv[k]) for k in aEnv['POSSIZEPARM']])
                aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                aEnv['SHAPE'].Style = aEnv['STANDARDSTYLE']
                aEnv['SHAPE'].LineColor = aEnv['STANDARDSTYLE'].LineColor
                aEnv['SHAPE'].LineWidth = aEnv['STANDARDSTYLE'].LineWidth
                aEnv['SHAPE'].setName("")
                # -----------------------
                if aEnv['REPEATMODE']:
                    aEnv['STEP'] = 0
                    aEnv['VALIDORIGIN'] = False
                    aEnv['GROUPSHAPE'] = None
                    aEnv['SHAPE'] = None
                    aEnv['COORDS'] = None
                else:
                    aEnv['STOPJOB'] = True
        # --------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('ESC',) and not aEnv['KEYEVENT']['MOD']:
            #                                 Esc => kill job
            aEnv['CANCELJOB'] = True
        # -------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('AXOCTRL',) and not aEnv['KEYEVENT']['MOD']:
            #                                  a => axonometric mode
            aEnv['ORTHOMODE'] = not aEnv['ORTHOMODE']
            aStatusBarCheckBox = aEnv['STATUSBARCONTROL']['AXOCTRL']
            if aStatusBarCheckBox.getState() != aEnv['ORTHOMODE']:
                aStatusBarCheckBox.setState(aEnv['ORTHOMODE'])
        # --------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('MULTICTRL',) and not aEnv['KEYEVENT']['MOD']:
            #                                  * => repeat mode
            aEnv['REPEATMODE'] = not aEnv['REPEATMODE']
            aStatusBarCheckBox = aEnv['STATUSBARCONTROL']['MULTICTRL']
            if aStatusBarCheckBox.getState() != aEnv['REPEATMODE']:
                aStatusBarCheckBox.setState(aEnv['REPEATMODE'])
        return aEnv
