# $Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
##
## Copyright (C) 2005-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math
except ImportError, e:
    print "probleme d'import", e
# ===================================================
# Gerer les saisies de points et validation d'entites
# Handle points inputs and entities validation
# ===================================================
class ShapeMouseHandler():
    """Gere les saisies de points et validation d'entite
    Handles points inputs and entities validation"""
    def __init__(self, ctx):
        from fr.free.deneux.gerard.cadooo.entityposize import EntityPosSize
        from fr.free.deneux.gerard.cadooo.compute import Compute
        self.ctx = ctx
        self.xEntityPosSize = EntityPosSize(self.ctx)
        self.xCompute = Compute(self.ctx)
    # **********************************
    # Handles mouse clicks
    # MOUSEEVENT  struct MouseEvent
    # VALIDL2O    integer (0 or 1)
    # L2OCOORD    tuple of 2 integers
    # CANCELJOB   integer (0 or 1)
    # STEP
    # COORDS%s
    # REPEATMODE
    # SHAPE
    # **********************************
    def execute(self, aArgs):
        aEnv = {}
        aEnv.update(aArgs)
        # ----------------------------------------
        if aEnv['MOUSEEVENT'].Buttons > 1: # don't handle mouse buttons but left
            return aEnv
        if aEnv['COORDS'] is None:
            aEnv['COORDS'] = [[{'X': 0, 'Y': 0}]]
        # --------------------------------------------
        if aEnv['MOUSEEVENT'].ClickCount == 1: # one click ?
            aMouseParm = dict([(k, aEnv[k]) for k in aEnv['MOUSEPARM']])
            aMouseCoord = self.xCompute.transformMouseCoord(aMouseParm)
            # --------------------------
            if aEnv['VALIDL2O']: # valid link to entity ?
                aMouseCoord.update(aEnv['L2OCOORD'])
            aEnv['COORDS'][-1][-1].update(aMouseCoord)
            aEnv['ORIGINCOORD'].update(aMouseCoord)
            aEnv['VALIDORIGIN'] = True
            # --------------------------
            if aEnv['STEP'] != 0: # is it 1st point ?
                aPosSizeParm = dict([(k, aEnv[k]) for k in aEnv['POSSIZEPARM']])
                aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
            aEnv['STEP'] = aEnv['STEP'] % aEnv['STEPS'] + 1
            # -----------------------------------------------
            if aEnv['STEP'] == aEnv['STEPS']: # is it the last point ?
                aEnv['SHAPE'].setName("")
                aEnv['SHAPE'].Style = aEnv['STANDARDSTYLE']
                aEnv['SHAPE'].LineColor = aEnv['STANDARDSTYLE'].LineColor
                aEnv['SHAPE'].LineWidth = aEnv['STANDARDSTYLE'].LineWidth
                # ----------------------------
                if aEnv['REPEATMODE']: # repeat mode on ?
                    aEnv['STEP'] = 0
                    aEnv['VALIDORIGIN'] = False
                    aEnv['SHAPE'] = None
                    aEnv['GROUPSHAPE'] = aEnv['CONTROLLER'].getCurrentPage()
                    aEnv['COORDS'] = None
                else:
                    aEnv['STOPJOB'] = True
            else:
                aEnv['COORDS'][-1].append({'X': 0, 'Y': 0})
        # --------------------------------------------
        elif aEnv['MOUSEEVENT'].ClickCount == 2:
            aEnv['STEP'] = aEnv['STEP'] % aEnv['STEPS'] - 1
            del aEnv['COORDS'][-1][-2:]
            if not (len(aEnv['COORDS']) > 0 and len(aEnv['COORDS'][0]) > 1):
                aEnv['CANCELJOB'] = True
            else:
                aPosSizeParm = dict([(k, aEnv[k]) for k in aEnv['POSSIZEPARM']])
                aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                aEnv['SHAPE'].setName("")
                aEnv['SHAPE'].Style = aEnv['STANDARDSTYLE']
                aEnv['SHAPE'].LineColor = aEnv['STANDARDSTYLE'].LineColor
                aEnv['SHAPE'].LineWidth = aEnv['STANDARDSTYLE'].LineWidth
                # ----------------------------
                if aEnv['REPEATMODE']: # repeat mode on ?
                    aEnv['STEP'] = 0
                    aEnv['VALIDORIGIN'] = False
                    aEnv['SHAPE'] = None
                    aEnv['GROUPSHAPE'] = aEnv['CONTROLLER'].getCurrentPage()
                    aEnv['COORD'] = None
                    aEnv['COORDS'] = None
                else:
                    aEnv['STOPJOB'] = True
        return aEnv
