# 	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## stairskeyhandler lundi 12 mai 2008, 11:16:46 (UTC+0200)

## Copyright (C) 2008-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math
    from com.sun.star.awt.KeyModifier import SHIFT
except ImportError:
    print "probleme d'import"
#===============================
# gestion des evenements clavier
# handling keyboard events
#===============================
class StairsKeyHandler():
    """gestion des evenements clavier
    handling keyboard events"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.messagebox
        import fr.free.deneux.gerard.cadooo.msgl10n
        self.ctx = ctx
        self.xMessage = fr.free.deneux.gerard.cadooo.messagebox.MessageBox( self.ctx)
        self.xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
        self.aTranslation = self.xMsgL10n.getText(["s%d" % i for i in range(8)])
    # ==================================
    # actions clavier - keyboard actions
    # ==================================
    def execute(self, aArgs):
        aEnv = {}
        aEnv.update(aArgs)
        lKey = aEnv['MAGNETKEY'].keys()
        lKey.sort()
        # ----------------------------------------------------------------------------------------------------
        if aEnv['KEYEVENT']['COD'] in lKey and not aEnv['KEYEVENT']['MOD']:
            # e,   i,   m,   p,   t => link 2 entities
            i = lKey.index(aEnv['KEYEVENT']['COD'])
            bKHState = list(aEnv['L2OSTATE'])
            bKHState[i] = not bKHState[i]
            aEnv['L2OSTATE'] = tuple(bKHState)
            aStatusBarCheckBox = aEnv['STATUSBARCONTROL'][aEnv['KEYEVENT']['COD']]
            if aStatusBarCheckBox.getState() != aEnv['L2OSTATE'][i]:
                aStatusBarCheckBox.setState(aEnv['L2OSTATE'][i])
        # --------------------------------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('CAR', ) and aEnv['KEYEVENT']['MOD'] != SHIFT:
            # ..............................c  => close selection
            if aEnv['STAGE'] == 1:
                if len(aEnv['CONTOURLIST']) > 5 and len(aEnv['CONTOURLIST']) < 9:
                    aEnv['STAGE'] = 2
                else:
                    self.xMessage.execute(self.aTranslation[2], "errorbox")
                    return aEnv
        # --------------------------------------------------------------------------
        elif aEnv['KEYEVENT']['COD'] in ('ESC',) and not aEnv['KEYEVENT']['MOD']:
            #                                 Esc => kill job
            aEnv['CANCELJOB'] = True
        return aEnv
