#	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## stairsmousehandler dimanche 27 avril 2008, 17:38:01 (UTC+0200)

## Copyright (C) 2008-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math
except ImportError:
    print "probleme d'import"
# ===================================================
# Gerer les saisies de points et validation d'entites
# Handle points inputs and entities validation
# ===================================================
class StairsMouseHandler():
    """Gere les saisies de points et validation d'entite
    Handles points inputs and entities validation"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.compute
        import fr.free.deneux.gerard.cadooo.messagebox
        import fr.free.deneux.gerard.cadooo.msgl10n
        self.ctx = ctx
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute( self.ctx)
        self.xMessage = fr.free.deneux.gerard.cadooo.messagebox.MessageBox( self.ctx)
        self.xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
        self.aTranslation = self.xMsgL10n.getText(["s%d" % i for i in range(8)])
    # **********************************
    # Handles mouse clicks
    # SHAPE
    # **********************************
    def execute(self, aArgs):
        self.aEnv = {}
        self.aEnv.update(aArgs)
        bStop = False
        # -------------------------------------
        if self.aEnv['MOUSEEVENT'].Buttons > 1: # don't handle mouse buttons but left
            return aArgs
        # ----------------------------------------------------------------------------------------
        if self.aEnv['MOUSEEVENT'].ClickCount in (1, 2) and not self.aEnv['DRAWJOB'].xEntitySpot.aSpottedShape is None: # one click ?
            # -----------------------------------------
            if self.aEnv['MOUSEEVENT'].ClickCount == 2:
                bStop = True
            aGroupShape = self.aEnv['CONTROLLER'].getCurrentPage()
            aNewSpottedId = self.aEnv['DRAWJOB'].xEntitySpot.aSpottedShape[0] + (self.aEnv['DRAWJOB'].xEntitySpot.aSpottedShape[-1],)
            # ........................
            if len(aNewSpottedId) > 2:
                for i in aNewSpottedId[:-2]:
                    aGroupShape = aGroupShape.getByIndex(i)
            aShape = aGroupShape.getByIndex(aNewSpottedId[-2])
            aType = aShape.getShapeType().split('.')[-1]
            # +++++++++++++++++++++++++++++
            if self.aEnv['STAGE'] == 1:
                # .................................................................
                if not aType in ("LineShape", "PolyPolygonShape", "PolyLineShape"):
                    self.xMessage.execute(self.aTranslation[3], "errorbox")
                    return self.aEnv
                # ................................................
                if aType in ("PolyLineShape", "PolyPolygonShape"):
                    nSide = sum([len(aShape.PolyPolygon[i]) - 1 for i in range(len(aShape.PolyPolygon))])
                    if not self.aEnv['CONTOURLIST'] is None:
                        nSide += len(self.aEnv['CONTOURLIST'])
                    if nSide > 8:
                        self.xMessage.execute(self.aTranslation[2], "errorbox")
                        return self.aEnv
                self.removeTempShapes()
                if self.aEnv['CONTOURLIST'] is None:
                    self.aEnv['CONTOURLIST'] = []
                self.aEnv['CONTOURLIST'].extend([c for c in self.aEnv['DRAWJOB'].xEntitySpot.aSplittedShape if c[1].count("Centre") == 0])
                if (bStop and len(self.aEnv['CONTOURLIST']) > 5) or len(self.aEnv['CONTOURLIST']) == 8:
                    self.aEnv['STAGE'] = 2
            # +++++++++++++++++++++++++++
            elif self.aEnv['STAGE'] == 3:
                # ....................................................
                if not self.aEnv['DRAWJOB'].xEntitySpot.aSpottedShape[1] in ("LineShape",):
                    self.xMessage.execute(self.aTranslation[3], "errorbox")
                    return self.aEnv
                nIndx = 0
                nDistList = [self.xCompute.getDist2Line(aBorder[2], aBorder[3], self.aEnv['DRAWJOB'].xEntitySpot.aMouseRelPos[3])[:3] for aBorder in self.aEnv['CONTOURLIST']]
                for nDist in nDistList:
                    if abs(nDist[1]) < 2 and nDist[0] >= 0 and nDist[0] < self.aEnv['DRAWJOB'].xEntitySpot.aMouseRelPos[2]:
                        break
                    nIndx += 1
                else:
                    nIndx = -1
                if nIndx < 0:
                    self.xMessage.execute(self.aTranslation[4], "errorbox")
                    return self.aEnv
##                 print "\n".join(["%s %s %s %s" % (l[0], l[1], l[2], l[3]) for l in aContourList])
                while nIndx > 0:
                    self.aEnv['CONTOURLIST'].append(self.aEnv['CONTOURLIST'].pop(0))
                    nDistList.append(nDistList.pop(0))
                    nIndx -= 1
                if nDistList[1][2] > nDistList[-1][2]:
                    self.aEnv['CONTOURLIST'].reverse()
                    self.aEnv['CONTOURLIST'].insert(0, self.aEnv['CONTOURLIST'].pop())
                for i in range(len(self.aEnv['CONTOURLIST'])):
                    nDist1 = self.xCompute.getDist2Line(self.aEnv['CONTOURLIST'][i-1][2], self.aEnv['CONTOURLIST'][i-1][3], self.aEnv['CONTOURLIST'][i][2])[1]
                    nDist2 = self.xCompute.getDist2Line(self.aEnv['CONTOURLIST'][i-1][2], self.aEnv['CONTOURLIST'][i-1][3], self.aEnv['CONTOURLIST'][i][3])[1]
                    if abs(nDist1) > abs(nDist2):
                        self.aEnv['CONTOURLIST'][i].insert(2, self.aEnv['CONTOURLIST'][i].pop(3))
                self.aEnv['STAGE'] = 4
                self.removeTempShapes()
##                 print "\n", "\n".join(["%s %s %s %s" % (l[0], l[1], l[2], l[3]) for l in aContourList])
        return self.aEnv
    # *****************************************************
    # remove temporary shapes
    # *****************************************************
    def removeTempShapes(self):
        if not self.aEnv['SPOTTEDID'] is None:
            aGroupShape = self.aEnv['CONTROLLER'].getCurrentPage()
            if len(self.aEnv['SPOTTEDID']) > 2:
                for i in self.aEnv['SPOTTEDID'][:-2]:
                    aGroupShape = aGroupShape.getByIndex(i)
            aGroupShape.remove(self.aEnv['SHAPE'])
            self.aEnv['SHAPE'] = None
            self.aEnv['STEP'] = 0
            self.aEnv['COORDS'] = ((),)
            self.aEnv['SPOTTEDID'] = None
        return
