# 	$Id: stairway_inputbox.py,v 1.1 2006-07-16 10:02:14 gerard Exp $	
# -*- coding: latin-1 -*-
## ********************************************************************************
## stairway_inputbox jeu fv 10 20:19:31 CET 2005
## Copyright (C) 2004-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************

try:
    import unohelper
    from com.sun.star.awt import XActionListener
except ImportError:
    print "import impossible"

class StairwayInputBox(unohelper.Base, XActionListener):
    """Saisie des paramtres de l'escalier balanc
    input of balanced stairway parameters"""
    def __init__(self, aContext):
        import fr.free.deneux.gerard.cadooo.compute
        self.ctx = aContext
        self.bOK = False
        self.smgr = self.ctx.ServiceManager
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute( self.ctx)
    # ******************************
    def execute(self, aNamedValues):
        import fr.free.deneux.gerard.cadooo.msgl10n
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
        sTextList = ["sw%d" % i for i in range(12)]
        sTTList = xMsgL10n.getText(sTextList)
        sUnits = [l for l in aNamedValues['UNITS'] if not l is None]
        nUnit = sUnits.index(aNamedValues['UNITS'][aNamedValues['MEASUREUNIT']])
        aBox = {'X': 0, 'Y': 0, 'Width': 0, 'Height': 0}
        aBox['Width'], aBox['Height'] = 190, 150
        aBox['X'] = (aNamedValues['WINDOW'].PosSize.X + (aNamedValues['WINDOW'].PosSize.Width - aBox['Width']) / 2) / 25e-1
        aBox['Y'] = (aNamedValues['WINDOW'].PosSize.Y + (aNamedValues['WINDOW'].PosSize.Height - aBox['Height']) / 2) / 25e-1
        aStairwayDialogModel = self.smgr.createInstanceWithContext( "com.sun.star.awt.UnoControlDialogModel", self.ctx)
        # -----------------------------------------------------
        aStairwayDialogModel.PositionX = aBox['X']
        aStairwayDialogModel.PositionY = aBox['Y']
        aStairwayDialogModel.Width = aBox['Width']
        aStairwayDialogModel.Height = aBox['Height']
        aStairwayDialogModel.Title = sTTList[0]
        # create the button OK
        aStairwayDialogButtonModel1 = aStairwayDialogModel.createInstance( "com.sun.star.awt.UnoControlButtonModel" )
        aStairwayDialogButtonModel1.PositionX = 25
        aStairwayDialogButtonModel1.PositionY = 130
        aStairwayDialogButtonModel1.Width = 30
        aStairwayDialogButtonModel1.Height = 15
        aStairwayDialogButtonModel1.Name = "Button1"
        aStairwayDialogButtonModel1.TabIndex =  5
        aStairwayDialogButtonModel1.Label =  sTTList[1]
        aStairwayDialogButtonModel1.DefaultButton =  True
        # create the button Cancel
        aStairwayDialogButtonModel2 = aStairwayDialogModel.createInstance( "com.sun.star.awt.UnoControlButtonModel" )
        aStairwayDialogButtonModel2.PositionX =  135
        aStairwayDialogButtonModel2.PositionY =  130
        aStairwayDialogButtonModel2.Width =  30
        aStairwayDialogButtonModel2.Height =  15
        aStairwayDialogButtonModel2.Name =  "Button2"
        aStairwayDialogButtonModel2.TabIndex =  6
        aStairwayDialogButtonModel2.Label =  sTTList[2]
        # create the step number field
        aStairwayDialogEditModel1 = aStairwayDialogModel.createInstance( "com.sun.star.awt.UnoControlNumericFieldModel" )
        aStairwayDialogEditModel1.PositionX =  130
        aStairwayDialogEditModel1.PositionY =  10
        aStairwayDialogEditModel1.Width =  50
        aStairwayDialogEditModel1.Height =  15
        aStairwayDialogEditModel1.Name =  "Numf1"
        aStairwayDialogEditModel1.TabIndex =  0
        aStairwayDialogEditModel1.Value =  17
        aStairwayDialogEditModel1.Spin =  True
        aStairwayDialogEditModel1.HelpText =  sTTList[3]
        # ...................................
        # input field of stride line distance
        # ...................................
        # create the label model set the properties for label
        DXDialogLabelModel = aStairwayDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        DXDialogLabelModel.PositionX =  10
        DXDialogLabelModel.PositionY =  40
        DXDialogLabelModel.Width =  85
        DXDialogLabelModel.Height =  15
        DXDialogLabelModel.Name =  "LabelDX"
        DXDialogLabelModel.TabIndex =  8
        DXDialogLabelModel.MultiLine =  False
        DXDialogLabelModel.Label =  sTTList[4]
        # create the edit model and set the properties for input field
        DXDialogEditModel = aStairwayDialogModel.createInstance( "com.sun.star.awt.UnoControlEditModel" )
        DXDialogEditModel.PositionX =  100
        DXDialogEditModel.PositionY =  40
        DXDialogEditModel.Width =  45
        DXDialogEditModel.Height =  15
        DXDialogEditModel.Name =  "NumfDX"
        DXDialogEditModel.TabIndex =  1
        DXDialogEditModel.Text =  aNamedValues['STRIDELINEDIST']
        DXDialogEditModel.Align =  2
        DXDialogEditModel.MultiLine = False
        DXDialogEditModel.ReadOnly = False
        DXDialogEditModel.HelpText =  sTTList[5]
        # create the listbox model and set the properties for units
        DXDialogListBoxModel = aStairwayDialogModel.createInstance( "com.sun.star.awt.UnoControlListBoxModel" )
        DXDialogListBoxModel.PositionX =  150
        DXDialogListBoxModel.PositionY =  40
        DXDialogListBoxModel.Width =  30
        DXDialogListBoxModel.Height =  15
        DXDialogListBoxModel.Name =  "ListDUnit"
        DXDialogListBoxModel.TabIndex =  2
        DXDialogListBoxModel.Dropdown =  True
        DXDialogListBoxModel.HelpText =  sTTList[6]
        DXDialogListBoxModel.LineCount = 3
        DXDialogListBoxModel.MultiSelection = False
        DXDialogListBoxModel.ReadOnly = False
        DXDialogListBoxModel.StringItemList = tuple(sUnits) # aEnv['UNITS']
        DXDialogListBoxModel.SelectedItems = (nUnit,) # (aEnv['MEASUREUNIT'],)
        # create the listbox model and set the properties 
        aStairwayDialogLabelModel1 = aStairwayDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        aStairwayDialogLabelModel1.PositionX =  10
        aStairwayDialogLabelModel1.PositionY =  10
        aStairwayDialogLabelModel1.Width =  110
        aStairwayDialogLabelModel1.Height =  20
        aStairwayDialogLabelModel1.Name =  "Label1"
        aStairwayDialogLabelModel1.TabIndex =  7
        aStairwayDialogLabelModel1.MultiLine =  True
        aStairwayDialogLabelModel1.Label =  sTTList[7]
        # ...................................
        # input field of 1st step balanced
        # ...................................
        # create the edit model and set the properties - cree le modele d'edition et fixe les proprietes
        aStairwayDialogEditModel2 = aStairwayDialogModel.createInstance( "com.sun.star.awt.UnoControlNumericFieldModel" )
        aStairwayDialogEditModel2.PositionX =  130
        aStairwayDialogEditModel2.PositionY =  65
        aStairwayDialogEditModel2.Width =  50
        aStairwayDialogEditModel2.Height =  15
        aStairwayDialogEditModel2.Name =  "Numf2"
        aStairwayDialogEditModel2.TabIndex =  3
        aStairwayDialogEditModel2.Value =  2
        aStairwayDialogEditModel2.Spin =  True
        aStairwayDialogEditModel2.HelpText =  sTTList[8]
        # create the listbox model and set the properties - cree le modele de liste et fixe les proprietes
        aStairwayDialogLabelModel2 = aStairwayDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        aStairwayDialogLabelModel2.PositionX =  10
        aStairwayDialogLabelModel2.PositionY =  65
        aStairwayDialogLabelModel2.Width =  110
        aStairwayDialogLabelModel2.Height =  20
        aStairwayDialogLabelModel2.Name =  "Label2"
        aStairwayDialogLabelModel2.TabIndex =  9
        aStairwayDialogLabelModel2.MultiLine =  True
        aStairwayDialogLabelModel2.Label =  sTTList[9]
        # ...................................
        # input field of last step balanced
        # ...................................
        # create the edit model and set the properties - cree le modele d'edition et fixe les proprietes
        aStairwayDialogEditModel3 = aStairwayDialogModel.createInstance( "com.sun.star.awt.UnoControlNumericFieldModel" )
        aStairwayDialogEditModel3.PositionX =  130
        aStairwayDialogEditModel3.PositionY =  100
        aStairwayDialogEditModel3.Width =  50
        aStairwayDialogEditModel3.Height =  15
        aStairwayDialogEditModel3.Name =  "Numf3"
        aStairwayDialogEditModel3.TabIndex =  4
        aStairwayDialogEditModel3.Value =  16
        aStairwayDialogEditModel3.Spin =  True
        aStairwayDialogEditModel3.HelpText =  sTTList[10]
        # create the listbox model and set the properties - cree le modele de liste et fixe les proprietes
        aStairwayDialogLabelModel3 = aStairwayDialogModel.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        aStairwayDialogLabelModel3.PositionX =  10
        aStairwayDialogLabelModel3.PositionY =  100
        aStairwayDialogLabelModel3.Width =  110
        aStairwayDialogLabelModel3.Height =  20
        aStairwayDialogLabelModel3.Name =  "Label3"
        aStairwayDialogLabelModel3.TabIndex =  10
        aStairwayDialogLabelModel3.MultiLine =  True
        aStairwayDialogLabelModel3.Label =  sTTList[11]
        # insert the control models into the dialog model - insere les modeles de controle dans le modele de dialogue
        aStairwayDialogModel.insertByName("Button1", aStairwayDialogButtonModel1)
        aStairwayDialogModel.insertByName("Button2", aStairwayDialogButtonModel2)
        aStairwayDialogModel.insertByName("Numf1", aStairwayDialogEditModel1)
        aStairwayDialogModel.insertByName("Label1", aStairwayDialogLabelModel1)
        aStairwayDialogModel.insertByName("Numf2", aStairwayDialogEditModel2)
        aStairwayDialogModel.insertByName("Label2", aStairwayDialogLabelModel2)
        aStairwayDialogModel.insertByName("Numf3", aStairwayDialogEditModel3)
        aStairwayDialogModel.insertByName("Label3", aStairwayDialogLabelModel3)
        aStairwayDialogModel.insertByName("LabelDX", DXDialogLabelModel)
        aStairwayDialogModel.insertByName("NumfDX", DXDialogEditModel)
        aStairwayDialogModel.insertByName("ListDUnit", DXDialogListBoxModel)
        # create the dialog control and set the model - cree le control de dialogue et fixe le modele
        self.aStairwayDialogControl = self.smgr.createInstanceWithContext( "com.sun.star.awt.UnoControlDialog", self.ctx)
        self.aStairwayDialogControl.setModel(aStairwayDialogModel)
        DXDialogListBoxControl = self.aStairwayDialogControl.getControl("ListDUnit")
        DXDialogListBoxControl.makeVisible(nUnit)
        DXDialogListBoxControl.selectItem(sUnits[nUnit], True)
        aStairwayDialogButton1 = self.aStairwayDialogControl.getControl("Button1")
        aStairwayDialogButton1.setActionCommand("ok")
        aStairwayDialogButton1.addActionListener(self)
        # add an action listener to the button2 control - ajoute un audit d'action au controle button2
        aStairwayDialogButton2 = self.aStairwayDialogControl.getControl("Button2")
        aStairwayDialogButton2.setActionCommand("cancel")
        aStairwayDialogButton2.addActionListener(self)
        #create a peer - cree un port
        aToolkit = self.smgr.createInstanceWithContext( "com.sun.star.awt.Toolkit", self.ctx)
        self.aStairwayDialogControl.setVisible(0)
        self.aStairwayDialogControl.createPeer(aToolkit, aToolkit.getDesktopWindow())
        #execute the dialog - lance le dialogue
        self.aStairwayDialogControl.execute()
        if self.bOK:
            #print self.__doc__
            aNamedValues['BUTTONSTATE'] = True
            aNamedValues['STEPSCOUNT'] = int(self.aStairwayDialogControl.getControl("Numf1").getValue())
            aNamedValues['FIRSTSTEPBAL'] = int(self.aStairwayDialogControl.getControl("Numf2").getValue())
            if aNamedValues['FIRSTSTEPBAL'] <= 1:
                aNamedValues['FIRSTSTEPBAL'] = 0
            aNamedValues['LASTSTEPBAL'] = int(self.aStairwayDialogControl.getControl("Numf3").getValue())
            if aNamedValues['LASTSTEPBAL'] >= aNamedValues['STEPSCOUNT']:
                aNamedValues['LASTSTEPBAL'] = 0
            nUnit = aNamedValues['UNITS'].index(DXDialogListBoxControl.getSelectedItem())
            aNamedValues['STRIDELINEDIST'] = self.xCompute.transform2SystemUnit(self.aStairwayDialogControl.getControl("NumfDX").getText(), aNamedValues['UNITS'], aNamedValues['UNITSRATIO'], nUnit, aNamedValues['DRAWSCALE'])
        # remove an action listener to the button1 control - ote l'audit d'action de controle button1
        aStairwayDialogButton1.removeActionListener(self)
        # remove an action listener to the button2 control - ote l'audit d'action de controle button2
        aStairwayDialogButton2.removeActionListener(self)
        return aNamedValues
        ## XEventListener 
    def disposing(self, eventObject):
        self.aStairwayDialogControl = None
        ## XActionListener 
    def actionPerformed(self, actionEvent):
        if actionEvent.ActionCommand == "ok":
            self.bOK = True
        else:
            self.bOK = False
        self.aStairwayDialogControl.endExecute()
