# $Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## Copyright (C) 2005-2009 Gerard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno
    from com.sun.star.awt.WindowClass import TOP
    from com.sun.star.awt.WindowAttribute import SHOW, BORDER, MOVEABLE, SIZEABLE, CLOSEABLE
    from com.sun.star.awt.VclWindowPeerAttribute import CLIPCHILDREN
except ImportError, e:
    print e
#=============================================================
# a class to show various informations
# une classe pour afficher diverses informations
#=============================================================
class CadoooStatusBar():
    def __init__(self, aContext):
        self.ctx = aContext
        self.smgr = self.ctx.ServiceManager
    # ******************************
    def execute(self, aParm):
        aEnv = {}
        aEnv.update(aParm)
        # ---------------------
        # translation component
        from fr.free.deneux.gerard.cadooo.msgl10n import MsgL10n
        xMsgL10n = MsgL10n(self.ctx)
        aTextList = tuple(["st%d" % i for i in range(12)])
        aText = xMsgL10n.getText(aTextList)
        # ---------------------------
        # Status bar height parameter
        nStatusbarHeight = 45
        # -------------------------------
        # working in the component window
        aPosSize = aEnv['CONTROLLER'].Frame.ContainerWindow.getPosSize()
        aSBWPosSize = uno.createUnoStruct("com.sun.star.awt.Rectangle")
        aRect = {'X':0, 'Y':0, 'Width':0, 'Height':0}
        if sum(aEnv['SBWPOSSIZE']) != 0:
            aRect['X'], aRect['Y'], aRect['Width'], aRect['Height'] = aEnv['SBWPOSSIZE']
        else:
            aRect['X'], aRect['Y'], aRect['Width'], aRect['Height'] = aPosSize.X, aPosSize.Y+aPosSize.Height-nStatusbarHeight, aPosSize.Width, nStatusbarHeight
        aToolkit = self.smgr.createInstance("com.sun.star.awt.Toolkit")
        aSBWPosSize.X, aSBWPosSize.Y, aSBWPosSize.Width, aSBWPosSize.Height = aRect['X'], aRect['Y'], aRect['Width'], aRect['Height']
        # --------------------------------------
        # create a new window for the status bar
        aWindowDescriptor = uno.createUnoStruct("com.sun.star.awt.WindowDescriptor")
        aWindowDescriptor.Type = TOP
        aWindowDescriptor.WindowServiceName = "window"
        aWindowDescriptor.Parent = aToolkit.getDesktopWindow() # aEnv['CONTROLLER'].Frame.ContainerWindow
        aWindowDescriptor.ParentIndex = -1
        aWindowDescriptor.Bounds = aSBWPosSize
        aWindowDescriptor.WindowAttributes = BORDER + SHOW + MOVEABLE + SIZEABLE + CLOSEABLE # CLIPCHILDREN + BORDER + SHOW
        aWinPeer = aToolkit.createWindow(aWindowDescriptor)
        aEnv['STATUSBARFRAME'] = self.smgr.createInstance("com.sun.star.frame.Frame")
        aEnv['STATUSBARFRAME'].initialize(aWinPeer)
        aDesktop = self.smgr.createInstance("com.sun.star.frame.Desktop")
        aDesktop.Frames.append(aEnv['STATUSBARFRAME'])
        aWinPeer.setBackground(0xf0f0f0)
        aWinPeer.setPosSize(aRect['X'], aRect['Y'], aRect['Width'], aRect['Height'], 15)
        aWinPeer.setVisible(True)
        aEnv['STATUSBARFRAME'].Title = "CADOO.o"
        aEnv['STATUSBARFRAME'].setName("CADOO.o")
        aDevice = aWinPeer.Toolkit.createScreenCompatibleDevice(aRect['Width'], aRect['Height'])
        aFontDescriptors = aDevice.getFontDescriptors()
        aFontNames = ["%s %s" % (f.Name, f.StyleName) for f in aFontDescriptors]
        if aEnv['POLICE'] in aFontNames:
            aFont = aDevice.getFont(aFontDescriptors[aFontNames.index(aEnv['POLICE'])])
        else:
            aFont = aDevice.getFont(aFontDescriptors[0])
            aEnv['POLICE'] = aFontNames[0]
        # --------------------------------------
        # create a list box for the police sizes
        aWidth = []
        aListBoxControl = []
        aEnv['STATUSBARCONTROL'] = {}
        aListBox = self.smgr.createInstance( "com.sun.star.awt.UnoControlListBoxModel" )
        aListBox.Dropdown = True
        aListBox.FontDescriptor = aFont.FontDescriptor
        aListBox.FontHeight = aEnv['CHARHEIGHT']
        aListBox.LineCount = 10
        aListBox.MultiSelection = False
        aListBox.ReadOnly = False
        aListBox.StringItemList = tuple(["%3.0d" % i for i in range(6, 24)])
        aListBox.SelectedItems = (aEnv['CHARHEIGHT']-6,)
        aEnv['STATUSBARCONTROL']['CHARHEIGHTCTRL'] = self.smgr.createInstance( "com.sun.star.awt.UnoControlListBox" )
        aEnv['STATUSBARCONTROL']['CHARHEIGHTCTRL'].setModel(aListBox)
        aEnv['STATUSBARCONTROL']['CHARHEIGHTCTRL'].createPeer(aWinPeer.Toolkit, aWinPeer)
        aPeer = aEnv['STATUSBARCONTROL']['CHARHEIGHTCTRL'].getPeer()
        aWidth.append(aEnv['STATUSBARCONTROL']['CHARHEIGHTCTRL'].MinimumSize.Width)
        nStatusbarHeight = aEnv['STATUSBARCONTROL']['CHARHEIGHTCTRL'].MinimumSize.Height * 3
        aRect['Height'] =  nStatusbarHeight
        aWinPeer.setPosSize(aRect['X'], aRect['Y'], aRect['Width'], aRect['Height'], 15)
        aEnv['SBWPOSSIZE'] = (aRect['X'], aRect['Y'], aRect['Width'], aRect['Height'])
        aPeer.setPosSize(aRect['Width'] - aWidth[0], 0, aWidth[0], aEnv['STATUSBARCONTROL']['CHARHEIGHTCTRL'].MinimumSize.Height, 15)
        aPeer.setVisible(True)
        aEnv['STATUSBARCONTROL']['CHARHEIGHTCTRL'].makeVisible(aEnv['CHARHEIGHT']-6)
        aEnv['STATUSBARCONTROL']['CHARHEIGHTCTRL'].selectItem("%3.0d" % aEnv['CHARHEIGHT'], True)
        # --------------------------------------
        # create a list box for the police names
        aListBox = self.smgr.createInstance( "com.sun.star.awt.UnoControlListBoxModel" )
        aListBox.Dropdown = True
        aListBox.FontDescriptor = aFont.FontDescriptor
        aListBox.FontHeight = aEnv['CHARHEIGHT']
        aListBox.LineCount = 10
        aListBox.MultiSelection = False
        aListBox.ReadOnly = False
        aListBox.StringItemList = tuple(aFontNames)
        aListBox.SelectedItems = (aFontNames.index(aEnv['POLICE']),)
        aEnv['STATUSBARCONTROL']['POLICECTRL'] = self.smgr.createInstance( "com.sun.star.awt.UnoControlListBox" )
        aEnv['STATUSBARCONTROL']['POLICECTRL'].setModel(aListBox)
        aEnv['STATUSBARCONTROL']['POLICECTRL'].createPeer(aWinPeer.Toolkit, aWinPeer)
        aPeer = aEnv['STATUSBARCONTROL']['POLICECTRL'].getPeer()
        aWidth.append(aEnv['STATUSBARCONTROL']['POLICECTRL'].MinimumSize.Width)
        aPeer.setPosSize(aRect['Width'] - sum(aWidth), 0, aWidth[1], aEnv['STATUSBARCONTROL']['POLICECTRL'].MinimumSize.Height, 15)
        aPeer.setVisible(True)
        aEnv['STATUSBARCONTROL']['POLICECTRL'].makeVisible(aFontNames.index(aEnv['POLICE']))
        aEnv['STATUSBARCONTROL']['POLICECTRL'].selectItem(aEnv['POLICE'], True)
        # -----------------------------------------------------------------------
        # create the label model and set the properties for coordinates and scale
        aCoordLabel = self.smgr.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        aCoordLabel.Label = "scale : 123/123 X = +01234.567 Y = +01234.567 units"
        aCoordLabel.Border = 1
        aCoordLabel.BackgroundColor = 0xf0f0f0
        aEnv['STATUSBARCONTROL']['COORDCTRL'] = self.smgr.createInstance("com.sun.star.awt.UnoControlFixedText")
        aEnv['STATUSBARCONTROL']['COORDCTRL'].setModel(aCoordLabel)
        aCoordLabel.FontDescriptor = aFont.FontDescriptor
        aCoordLabel.FontHeight = aEnv['CHARHEIGHT']
        aEnv['STATUSBARCONTROL']['COORDCTRL'].createPeer(aWinPeer.Toolkit, aWinPeer)
        aPeer = aEnv['STATUSBARCONTROL']['COORDCTRL'].getPeer()
        aWidth.append(aEnv['STATUSBARCONTROL']['COORDCTRL'].MinimumSize.Width)
        aPeer.setPosSize(aRect['Width']-sum(aWidth), 0, aWidth[-1], aEnv['STATUSBARCONTROL']['COORDCTRL'].MinimumSize.Height, 15)
        aPeer.setVisible(True)
        aEnv['STATUSBARCONTROL']['COORDCTRL'].setDesignMode(False)
        # -----------------------------------------------------------
        # create the label model and set the properties for info line
        aLabel = self.smgr.createInstance( "com.sun.star.awt.UnoControlFixedTextModel" )
        aLabel.Label = "No comment"
        aLabel.Border = 1
        aLabel.BackgroundColor = 0xf0f0f0
        aEnv['STATUSBARCONTROL']['INFOCTRL'] = self.smgr.createInstance("com.sun.star.awt.UnoControlFixedText")
        aEnv['STATUSBARCONTROL']['INFOCTRL'].setModel(aLabel)
        aLabel.FontDescriptor = aFont.FontDescriptor
        aLabel.FontHeight = aEnv['CHARHEIGHT']
        aEnv['STATUSBARCONTROL']['INFOCTRL'].createPeer(aWinPeer.Toolkit, aWinPeer)
        aPeer = aEnv['STATUSBARCONTROL']['INFOCTRL'].getPeer()
        aPeer.setPosSize(0, 0, aRect['Width']-sum(aWidth), aEnv['STATUSBARCONTROL']['INFOCTRL'].MinimumSize.Height, 15)
        aPeer.setVisible(True)
        aEnv['STATUSBARCONTROL']['INFOCTRL'].setDesignMode(False)
        # create the check box
        aCheckBox = []
        aWidth = []
        # //////////////////////////////////
        for i, aKey in enumerate(aEnv['MAGNETCTRL'][:-1]):
            # create check box model
            aCheckBox.append(self.smgr.createInstance("com.sun.star.awt.UnoControlCheckBoxModel"))
            aCheckBox[-1].Label = aText[i]
            # create check box controller
            aEnv['STATUSBARCONTROL'][aKey] = self.smgr.createInstance("com.sun.star.awt.UnoControlCheckBox")
            aEnv['STATUSBARCONTROL'][aKey].setModel(aCheckBox[-1])
            aCheckBox[-1].FontDescriptor = aFont.FontDescriptor
            aCheckBox[-1].FontHeight = aEnv['CHARHEIGHT']
            aEnv['STATUSBARCONTROL'][aKey].createPeer(aWinPeer.Toolkit, aWinPeer)
            aPeer = aEnv['STATUSBARCONTROL'][aKey].getPeer()
            aPeer.setPosSize(sum(aWidth) + 5, nStatusbarHeight-aEnv['STATUSBARCONTROL'][aKey].MinimumSize.Height-2, aEnv['STATUSBARCONTROL'][aKey].MinimumSize.Width, aEnv['STATUSBARCONTROL'][aKey].MinimumSize.Height, 15)
            aPeer.setVisible(True)
            aPeer.setBackground(0xf0f0f0)
            aWidth.append(aEnv['STATUSBARCONTROL'][aKey].MinimumSize.Width)
            aEnv['STATUSBARCONTROL'][aKey].setDesignMode(False)
            aEnv['STATUSBARCONTROL'][aKey].setState(aEnv['L2OSTATE'][i])
        # create a group box for magnet type
        aKey = aEnv['MAGNETCTRL'][-1]
        aGroupBox = self.smgr.createInstance( "com.sun.star.awt.UnoControlGroupBoxModel" )
        aGroupBox.Label = aText[i+1]
        aGroupBox.FontDescriptor = aFont.FontDescriptor
        aGroupBox.FontHeight = aEnv['CHARHEIGHT']
        aEnv['STATUSBARCONTROL'][aKey] = self.smgr.createInstance( "com.sun.star.awt.UnoControlGroupBox" )
        aEnv['STATUSBARCONTROL'][aKey].setModel(aGroupBox)
        aEnv['STATUSBARCONTROL'][aKey].createPeer(aWinPeer.Toolkit, aWinPeer)
        aPeer = aEnv['STATUSBARCONTROL'][aKey].getPeer()
        aPeer.setPosSize(0, aEnv['STATUSBARCONTROL']['INFOCTRL'].MinimumSize.Height, sum(aWidth)+5, nStatusbarHeight-aEnv['STATUSBARCONTROL']['INFOCTRL'].MinimumSize.Height, 15)
        aPeer.setVisible(True)
        aEnv['STATUSBARCONTROL'][aKey].setDesignMode(False)
        i += 1
        # //////////////////////////////////
        for j, aKey in enumerate(aEnv['CHECKBOXCTRL']):
            # create check box model
            aCheckBox.append(self.smgr.createInstance("com.sun.star.awt.UnoControlCheckBoxModel"))
            aCheckBox[-1].Label = aText[i+j+1]
            # create check box controller
            aEnv['STATUSBARCONTROL'][aKey] = self.smgr.createInstance("com.sun.star.awt.UnoControlCheckBox")
            aEnv['STATUSBARCONTROL'][aKey].setModel(aCheckBox[-1])
            aCheckBox[-1].FontDescriptor = aFont.FontDescriptor
            aCheckBox[-1].FontHeight = aEnv['CHARHEIGHT']
            aEnv['STATUSBARCONTROL'][aKey].createPeer(aWinPeer.Toolkit, aWinPeer)
            aPeer = aEnv['STATUSBARCONTROL'][aKey].getPeer()
            aPeer.setPosSize(sum(aWidth) + 5, nStatusbarHeight-aEnv['STATUSBARCONTROL'][aKey].MinimumSize.Height-2, aEnv['STATUSBARCONTROL'][aKey].MinimumSize.Width, aEnv['STATUSBARCONTROL'][aKey].MinimumSize.Height, 15)
            aPeer.setVisible(True)
            aPeer.setBackground(0xf0f0f0)
            aWidth.append(aEnv['STATUSBARCONTROL'][aKey].MinimumSize.Width)
            aEnv['STATUSBARCONTROL'][aKey].setDesignMode(False)
            if aKey == "AXOCTRL":
                aEnv['STATUSBARCONTROL'][aKey].setState(aEnv['ORTHOMODE'])
            else:
                aEnv['STATUSBARCONTROL'][aKey].setState(False)
        i = i + j + 1
        if aEnv.has_key('JOINKIND'):
            for j, aKey in enumerate(aEnv['JOINCTRL'][:-1]):
                # create radio button model
                aCheckBox.append(self.smgr.createInstance("com.sun.star.awt.UnoControlRadioButtonModel"))
                aCheckBox[-1].Label = aText[i+j+1]
                # create radio button controller
                aEnv['STATUSBARCONTROL'][aKey] = self.smgr.createInstance("com.sun.star.awt.UnoControlRadioButton")
                aEnv['STATUSBARCONTROL'][aKey].setModel(aCheckBox[-1])
                aCheckBox[-1].FontDescriptor = aFont.FontDescriptor
                aCheckBox[-1].FontHeight = aEnv['CHARHEIGHT']
                aEnv['STATUSBARCONTROL'][aKey].createPeer(aWinPeer.Toolkit, aWinPeer)
                aPeer = aEnv['STATUSBARCONTROL'][aKey].getPeer()
                aPeer.setPosSize(sum(aWidth) + 10, nStatusbarHeight-aEnv['STATUSBARCONTROL'][aKey].MinimumSize.Height-2, aEnv['STATUSBARCONTROL'][aKey].MinimumSize.Width, aEnv['STATUSBARCONTROL'][aKey].MinimumSize.Height, 15)
                aPeer.setVisible(True)
                aPeer.setBackground(0xf0f0f0)
                aWidth.append(aEnv['STATUSBARCONTROL'][aKey].MinimumSize.Width)
                aEnv['STATUSBARCONTROL'][aKey].setDesignMode(False)
            aEnv['STATUSBARCONTROL']["DIRECTCTRL"].setState(True)
            # create a group box for junction type
            aKey = aEnv['JOINCTRL'][-1]
            aGroupBox = self.smgr.createInstance( "com.sun.star.awt.UnoControlGroupBoxModel" )
            aGroupBox.Label =  aText[i+j+1]
            aGroupBox.FontDescriptor = aFont.FontDescriptor
            aGroupBox.FontHeight = aEnv['CHARHEIGHT']
            aEnv['STATUSBARCONTROL'][aKey] = self.smgr.createInstance("com.sun.star.awt.UnoControlGroupBox")
            aEnv['STATUSBARCONTROL'][aKey].setModel(aGroupBox)
            aEnv['STATUSBARCONTROL'][aKey].createPeer(aWinPeer.Toolkit, aWinPeer)
            aPeer = aEnv['STATUSBARCONTROL'][aKey].getPeer()
            aPeer.setPosSize(sum(aWidth[:i]) + 5, aEnv['STATUSBARCONTROL']['INFOCTRL'].MinimumSize.Height, sum(aWidth[i:])+5, nStatusbarHeight-aEnv['STATUSBARCONTROL']['INFOCTRL'].MinimumSize.Height, 15)
            aPeer.setVisible(True)
            aEnv['STATUSBARCONTROL'][aKey].setDesignMode(False)
        aEnv['STATUSBARWINDOW'] = aWinPeer
        return aEnv