# $Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## jeudi 5 mars 2009, 16:14:58 (UTC+0100)

## Copyright (C) 2005-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    from com.sun.star.drawing.CircleKind import FULL, SECTION, CUT, ARC
    import math
except ImportError:
    print "probleme d'import"
#======================================================
# a class to trim an entity
# une classe pour prolonger une entit
#======================================================
class TrimDraw():
    """Prolonge une entite graphique
    Trims a graphical entity"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.entitiespot
        import fr.free.deneux.gerard.cadooo.compute
        import fr.free.deneux.gerard.cadooo.msgl10n
        self.ctx = ctx
        self.xEntitySpot = fr.free.deneux.gerard.cadooo.entitiespot.EntitieSpot(self.ctx)
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute(self.ctx)
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n(self.ctx)
        sTextList = tuple(["gp%d" % i for i in range(5)])
        self.sEntity = xMsgL10n.getText(sTextList)
        self.bRedraw = False
    # ==============================
    def execute(self, aNamedValues):
        self.aEnv = {}
        self.aEnv.update(aNamedValues)
        if self.bRedraw:
            self.xEntitySpot.bValidList = False
            self.bRedraw = False
        aSpotParm = dict([(k, self.aEnv[k]) for k in (self.aEnv['SPOTPARM']+self.aEnv['MOUSEPARM'])])
        self.aEnv.update(self.xEntitySpot.execute(aSpotParm))
        self.aEnv['SPOTTEDSHAPE'] = self.xEntitySpot.aSpottedShape
        self.aEnv['SPLITTEDSHAPE'] = self.xEntitySpot.aSplittedShape
        self.aEnv['BORDERLIST'] = self.xEntitySpot.aBorderList
        # +++++++++++++++++++++++++++++++++++++++
        if not self.aEnv['SPOTTEDSHAPE'] is None: # entity has been spotted ?
            aShape = self.aEnv['GROUPSHAPE'].getByIndex(self.aEnv['SPOTTEDSHAPE'][0][-1])
            aType = aShape.getShapeType().split('.')[-1]
            sType = self.sEntity[["LineShape", "CircleShape", "ArcCircleShape", "EllipseShape", "ArcEllipseShape"].index(self.aEnv['SPOTTEDSHAPE'][1])]
            # ..................................................................................................
            if self.aEnv['SPOTTEDID'] == self.aEnv['SPOTTEDSHAPE'][0]+(self.aEnv['SPOTTEDSHAPE'][-1],):
                return self.aEnv
            self.removeTempShape()
            self.aEnv['COORDS'] = [[]]
            self.aEnv['SPOTTEDID'] = self.aEnv['SPOTTEDSHAPE'][0][:] + (self.aEnv['SPOTTEDSHAPE'][-1],)
            # ---------------------------------------------------
            if self.aEnv['SPOTTEDSHAPE'][1] in ('LineShape',): # is it a line ?
                self.aEnv['UNOTYPE'] = "LineShape"
                self.aEnv['ENTITYPE'] = "LINE"
                self.aEnv['STEP'] = 1
                self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("VERTEX",)
                self.aEnv['COORDS'][0].extend([{'X': 0, 'Y': 0}, {'X': 0, 'Y': 0}])
                # -------------------------------# triming toward left ?----------------------------
                if self.aEnv['BORDERLIST']['OOB']['DELTA'] >= 0 and self.aEnv['BORDERLIST']['OOB']['RATE'] <= 75:
                    self.aEnv['COORDS'][0][0]['X'], self.aEnv['COORDS'][0][0]['Y'] = self.aEnv['BORDERLIST']['OOB']['X'], self.aEnv['BORDERLIST']['OOB']['Y']
                else:
                    self.aEnv['COORDS'][0][0]['X'], self.aEnv['COORDS'][0][0]['Y'] = self.aEnv['SPOTTEDSHAPE'][2]['X'], self.aEnv['SPOTTEDSHAPE'][2]['Y']
                # ------------------------------- # triming toward right ?---------------------------
                if self.aEnv['BORDERLIST']['OEB']['DELTA'] >= 0 and self.aEnv['BORDERLIST']['OEB']['RATE'] > 25:
                    self.aEnv['COORDS'][0][1]['X'], self.aEnv['COORDS'][0][1]['Y'] = self.aEnv['BORDERLIST']['OEB']['X'], self.aEnv['BORDERLIST']['OEB']['Y']
                else:
                    self.aEnv['COORDS'][0][1]['X'], self.aEnv['COORDS'][0][1]['Y'] = self.aEnv['SPOTTEDSHAPE'][3]['X'], self.aEnv['SPOTTEDSHAPE'][3]['Y']
            # ---------------------------------------------------
            elif self.aEnv['SPOTTEDSHAPE'][1] in ("ArcCircleShape", "ArcEllipseShape"):
                self.aEnv['CIRCLEKIND'] = aShape.CircleKind
                self.aEnv['UNOTYPE'] = "EllipseShape"
                self.aEnv['COORDS'][0].extend([{'X': 0, 'Y': 0} for i in range(4)])
                self.aEnv['COORDS'][0][0]['X'] = self.aEnv['SPOTTEDSHAPE'][2]['X']
                self.aEnv['COORDS'][0][0]['Y'] = self.aEnv['SPOTTEDSHAPE'][2]['Y']
                if self.aEnv['SPOTTEDSHAPE'][1] in ("ArcEllipseShape",):
                    self.aEnv['COORDS'][0].append({'X': 0, 'Y': 0})
                    aPoint = self.xCompute.getPointOnEllipse( None, math.pi/2, *self.aEnv['SPOTTEDSHAPE'][2:5])[0]
                    self.aEnv['COORDS'][0][2]['X'] = aPoint['X']
                    self.aEnv['COORDS'][0][2]['Y'] = aPoint['Y']
                aPoint = self.xCompute.getPointOnEllipse( None, float(0), *self.aEnv['SPOTTEDSHAPE'][2:5])[0]
                self.aEnv['COORDS'][0][1]['X'] = aPoint['X']
                self.aEnv['COORDS'][0][1]['Y'] = aPoint['Y']
                # --------------------------  any entity to treat ?--------------------------------
                if self.aEnv['BORDERLIST']['OOB']['DELTA'] < 0 and self.aEnv['BORDERLIST']['OEB']['DELTA'] < 0:
                    aPoint = self.xCompute.getPointOnEllipse( None, self.aEnv['SPOTTEDSHAPE'][6], *self.aEnv['SPOTTEDSHAPE'][2:5])[0]
                    self.aEnv['COORDS'][0][-1]['X'] = aPoint['X']
                    self.aEnv['COORDS'][0][-1]['Y'] = aPoint['Y']
                    aPoint = self.xCompute.getPointOnEllipse( None, self.aEnv['SPOTTEDSHAPE'][5], *self.aEnv['SPOTTEDSHAPE'][2:5])[0]
                    self.aEnv['COORDS'][0][-2]['X'] = aPoint['X']
                    self.aEnv['COORDS'][0][-2]['Y'] = aPoint['Y']
                else:
                    # ---------------------- # extending toward origin ?------------------------------
                    if self.aEnv['BORDERLIST']['OOB']['DELTA'] >= 0 and self.aEnv['BORDERLIST']['OOB']['RATE'] <= 75:
                        self.aEnv['COORDS'][0][-2]['X'] = self.aEnv['BORDERLIST']['OOB']['X']
                        self.aEnv['COORDS'][0][-2]['Y'] = self.aEnv['BORDERLIST']['OOB']['Y']
                    else :
                        aPoint = self.xCompute.getPointOnEllipse( None, self.aEnv['SPOTTEDSHAPE'][5], *self.aEnv['SPOTTEDSHAPE'][2:5])[0]
                        self.aEnv['COORDS'][0][-2]['X'] = aPoint['X']
                        self.aEnv['COORDS'][0][-2]['Y'] = aPoint['Y']
                    # ---------------------------- # extending toward end ?------------------------------
                    if self.aEnv['BORDERLIST']['OEB']['DELTA'] >= 0 and self.aEnv['BORDERLIST']['OEB']['RATE'] > 25:
                        self.aEnv['COORDS'][0][-1]['X'] = self.aEnv['BORDERLIST']['OEB']['X']
                        self.aEnv['COORDS'][0][-1]['Y'] = self.aEnv['BORDERLIST']['OEB']['Y']
                    else:
                        aPoint = self.xCompute.getPointOnEllipse( None, self.aEnv['SPOTTEDSHAPE'][6], *self.aEnv['SPOTTEDSHAPE'][2:5])[0]
                        self.aEnv['COORDS'][0][-1]['X'] = aPoint['X']
                        self.aEnv['COORDS'][0][-1]['Y'] = aPoint['Y']
                fDist = math.hypot(self.aEnv['COORDS'][0][-1]['X'] - self.aEnv['COORDS'][0][-2]['X'], self.aEnv['COORDS'][0][-1]['Y'] - self.aEnv['COORDS'][0][-2]['Y'])
                if fDist == 0.0:
                    self.aEnv['CIRCLEKIND'] = FULL
                if self.aEnv['SPOTTEDSHAPE'][1] in ("ArcCircleShape",):
                    if fDist == 0.0:
                        self.aEnv['ENTITYPE'] = "CIRCLE"
                        self.aEnv['STEP'] = 1
                        self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("RADIUS",)
                        del self.aEnv['COORDS'][0][2:]
                    else:
                        self.aEnv['ENTITYPE'] = "ARC"
                        self.aEnv['STEP'] = 3
                        self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("RADIUS", "STARTANGLE", "ENDANGLE")
                else:
                    if fDist == 0.0:
                        self.aEnv['ENTITYPE'] = "ELLIPSE"
                        self.aEnv['STEP'] = 2
                        self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("RADIUS", "RADIUS2")
                        del self.aEnv['COORDS'][0][3:]
                    else:
                        self.aEnv['ENTITYPE'] = "ELLARC"
                        self.aEnv['STEP'] = 4
                        self.aEnv['MODE'] = (self.aEnv['MODE'][0],) + ("RADIUS", "RADIUS2", "STARTANGLE", "ENDANGLE")
        else:
            sType = "---"
            self.removeTempShape()
            self.aEnv['STEP'] = 0
        sText = "%s ==> %s" % (self.aEnv['COMMENT'][0], sType)
        aInfoCtrl = dict(self.aEnv['STATUSBARCONTROL'])['INFOCTRL']
        aInfoCtrl.setText(sText)
        self.aEnv['SHAPESTATUS'] = "transient"
        return self.aEnv
    # ----------------------
    # remove temporary shape
    # ----------------------
    def removeTempShape(self):
        if not self.aEnv['SPOTTEDID'] is None and not self.aEnv['SHAPE'] is None:
            aGroupShape = self.aEnv['CONTROLLER'].CurrentPage
            if len(self.aEnv['SPOTTEDID']) > 2:
                for i in self.aEnv['SPOTTEDID'][:-2]:
                    aGroupShape = aGroupShape.getByIndex(i)
            aGroupShape.remove(self.aEnv['SHAPE'])
            self.aEnv['SHAPE'] = None
        self.aEnv['SPOTTEDID'] = None
        self.aEnv['COORDS'] = None
        return
