# $Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## jeudi 5 mars 2009, 16:34:46 (UTC+0100)

## Copyright (C) 2005-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math
except ImportError:
    print "probleme d'import"
# ===================================================
# Gerer les saisies de points et validation d'entites
# Handle points inputs and entities validation
# ===================================================
class TrimMouseHandler():
    """Gere les saisies de points et validation d'entite
    Handles points inputs and entities validation"""
    def __init__(self, ctx):
        import fr.free.deneux.gerard.cadooo.entityposize
        import fr.free.deneux.gerard.cadooo.compute
        self.ctx = ctx
        self.xEntityPosSize = fr.free.deneux.gerard.cadooo.entityposize.EntityPosSize( self.ctx)
        self.xCompute = fr.free.deneux.gerard.cadooo.compute.Compute( self.ctx)
    # **********************************
    # Handles mouse clicks
    # MOUSEEVENT  struct MouseEvent
    # CANCELJOB   integer (0 or 1)
    # STEP
    # COORDS
    # REPEATMODE
    # SHAPE
    # **********************************
    def execute(self, aArgs):
        aEnv = {}
        aEnv.update(aArgs)
        # ----------------------------------------
        if aEnv['MOUSEEVENT'].Buttons > 1: # don't handle mouse buttons but left
            return aEnv
        # --------------------------------------------
        if aEnv['MOUSEEVENT'].ClickCount == 1: # one click ?
            # --------------------------
            if not aEnv['SPOTTEDSHAPE'] is None:
                i = aEnv['SPOTTEDSHAPE'][0][-1]
                aShape = aEnv['GROUPSHAPE'].getByIndex(i)
                aType = aShape.getShapeType().split('.')[-1]
                aStyle = aShape.Style
                aCoords = [{'X': 0, 'Y': 0} for i in range(2)]
                aEnv['GROUPSHAPE'].remove(aEnv['SHAPE'])
                aEnv['SHAPE'] = None
                # ----------------------------------------------------------
                if aType in ("LineShape", "EllipseShape", "RectangleShape"):
                    # ---------------------------------------------------------------------------------------
                    if aEnv['SPOTTEDSHAPE'][1] in ("LineShape", "ArcCircleShape", "ArcEllipseShape"):
                        aEnv['SHAPESTATUS'] = "new"
                        aPosSizeParm = dict([(k, aEnv[k]) for k in aEnv['POSSIZEPARM']])
                        aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                        aEnv['SHAPE'].Style = aStyle
                        aEnv['SHAPE'].setName("")
                        aEnv['SHAPE'] = None
                    # ---------------------------
                    if aType == "RectangleShape": # Rectangle
                        i = 1
                        # -------------------------------------------------
                        for aSplit in aEnv['SPLITTEDSHAPE']:
                            # -----------------------------------------
                            if i != aEnv['SPOTTEDSHAPE'][-1] and aSplit[1].count("Centre") == 0: # to do ?
                                # ----------------------------------------------------
                                if aSplit[1] == "LineShape":
                                    aEnv['UNOTYPE'] = "LineShape"
                                    aEnv['ENTITYPE'] = "LINE"
                                    aEnv['STEP'] = 1
                                    aEnv['MODE'] = (aEnv['MODE'][0],) + ("VERTEX",)
                                    aEnv['COORDS'] = [[aSplit[2], aSplit[3]]]
                                else:
                                    aEnv['UNOTYPE'] = "EllipseShape"
                                    aEnv['ENTITYPE'] = "ARC"
                                    aEnv['STEP'] = 3
                                    aEnv['MODE'] = (aEnv['MODE'][0],) + ("RADIUS", "STARTANGLE", "ENDANGLE")
                                    aEnv['COORDS'] = [[{'X': 0, 'Y': 0} for j in range(4)]]
                                    aEnv['COORDS'][0][0]['X'], aEnv['COORDS'][0][0]['Y'] = aSplit[2]['X'], aSplit[2]['Y']
                                    nRadius = aSplit[3]['Width']
                                    aEnv['COORDS'][0][1]['X'], aEnv['COORDS'][0][1]['Y'] = aSplit[2]['X'] + nRadius, aSplit[2]['Y']
                                    aEnv['COORDS'][0][2]['X'] = aSplit[2]['X'] + nRadius * math.cos(aSplit[5])
                                    aEnv['COORDS'][0][2]['Y'] = aSplit[2]['Y'] - nRadius * math.sin(aSplit[5])
                                    aEnv['COORDS'][0][3]['X'] = aSplit[2]['X'] + nRadius * math.cos(aSplit[6])
                                    aEnv['COORDS'][0][3]['Y'] = aSplit[2]['Y'] - nRadius * math.sin(aSplit[6])
                                aEnv['SHAPESTATUS'] = "new"
                                aPosSizeParm = dict([(k, aEnv[k]) for k in aEnv['POSSIZEPARM']])
                                aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                                aEnv['SHAPE'].Style = aStyle
                                aEnv['SHAPE'].setName("")
                                aEnv['SHAPE'] = None
                            # --------------------------------
                            if aSplit[1].count("Centre") == 0:
                                i = i + 1
                # --------------------------------------------------
                elif aType in ("PolyLineShape", "PolyPolygonShape"):
                    idx = 0
                    aEnv['COORDS'] = []
                    bLeftBorder = False
                    # ---------------------------------
                    for aPolygon in aShape.PolyPolygon[:]:
                        aEnv['COORDS'].append([])
                        # ------------------------------
                        for i in range(len(aPolygon)-1):
                            aEnv['COORDS'][-1].append({'X': 0, 'Y': 0})
                            idx = idx + 1
                            # -----------------------------------------
                            if aEnv['SPOTTEDSHAPE'][-1] == idx:
                                #----------------------------------------------------------------------------------
                                if aEnv['BORDERLIST']['OOB']['DELTA'] > 0 and aEnv['BORDERLIST']['OOB']['RATE'] <= 75: # out origin border ?
                                    if i > 0:
                                        aEnv['COORDS'][-1][-1]['X'] = aPolygon[i].X
                                        aEnv['COORDS'][-1][-1]['Y'] = aPolygon[i].Y
                                        aEnv['COORDS'].append([{'X': 0, 'Y': 0}])
                                    aEnv['COORDS'][-1][-1]['X'] = aEnv['BORDERLIST']['OOB']['X']
                                    aEnv['COORDS'][-1][-1]['Y'] = aEnv['BORDERLIST']['OOB']['Y']
                                    bLeftBorder = True
                                #---------------------------------------------------------------------------------
                                if aEnv['BORDERLIST']['OEB']['DELTA'] > 0 and aEnv['BORDERLIST']['OEB']['RATE'] > 25: # out end border ?
                                    if not bLeftBorder:
                                        aEnv['COORDS'][-1][-1]['X'] = aPolygon[i].X
                                        aEnv['COORDS'][-1][-1]['Y'] = aPolygon[i].Y
                                    aEnv['COORDS'][-1].append({'X': 0, 'Y': 0})
                                    aEnv['COORDS'][-1][-1]['X'] = aEnv['BORDERLIST']['OEB']['X']
                                    aEnv['COORDS'][-1][-1]['Y'] = aEnv['BORDERLIST']['OEB']['Y']
                                    if i < len(aPolygon)-2:
                                        aEnv['COORDS'].append([])
                                    else:
                                        break
                            else:
                                aEnv['COORDS'][-1][-1]['X'] = aPolygon[i].X
                                aEnv['COORDS'][-1][-1]['Y'] = aPolygon[i].Y
                        else:
                            aEnv['COORDS'][-1].append({'X': 0, 'Y': 0})
                            aEnv['COORDS'][-1][-1]['X'] = aPolygon[-1].X
                            aEnv['COORDS'][-1][-1]['Y'] = aPolygon[-1].Y
                    aEnv['UNOTYPE'] = aType
                    aEnv['ENTITYPE'] = "POLYGON"
                    aEnv['STEP'] = -1
                    aEnv['MODE'] = (aEnv['MODE'][0],) + ("VERTEX",)
                    aEnv['SHAPESTATUS'] = "new"
                    aPosSizeParm = dict([(k, aEnv[k]) for k in aEnv['POSSIZEPARM']])
                    aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                    aEnv['SHAPE'].Style = aStyle
                    aEnv['SHAPE'].setName("")
                    aEnv['SHAPE'] = None
                aEnv['GROUPSHAPE'].remove(aShape)
            # ----------------------------
            if aEnv['REPEATMODE']: # repeat mode on ?
                aEnv['VALIDLIST'] = False
                aEnv['SHAPE'] = None
                aEnv['GROUPSHAPE'] = aEnv['CONTROLLER'].getCurrentPage()
                aEnv['COORDS'] = None
            else:
                aEnv['STOPJOB'] = True
        return aEnv
