#	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## ucsdraw vendredi 21 mars 2008-2009, 15:09:21 (UTC+0100)

## Copyright (C) 2008 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
#======================================================
# a class to draw UCS
# une classe pour tracer un SCU
#======================================================
class UcsDraw():
    """Trace un SCU
    Draws a UCS"""
    def __init__(self, ctx):
        from fr.free.deneux.gerard.cadooo.compute import Compute
        from fr.free.deneux.gerard.cadooo.link2obj import Link2Obj
        self.ctx = ctx
        self.xCompute = Compute(ctx)
        self.xLink2Obj = Link2Obj(ctx)
        self.bRedraw = False
    # ==============================
    def execute(self, aNamedValues):
        aEnv = {}
        aEnv.update(aNamedValues)
        if self.bRedraw:
            self.xLink2Obj.bRedraw = True
            self.bRedraw = False
        if aEnv['COORDS'] is None:
            self.xLink2Obj.bRedraw = True
            aEnv['COORDS'] = [[{'X': 0, 'Y': 0}]]
        sText = aEnv['COMMENT'][0] + aEnv['COMMENT'][aEnv['STEP']+1]
        aInfoCtrl = aEnv['STATUSBARCONTROL']['INFOCTRL']
        aInfoCtrl.setText(sText)
        # a single mouse move => check link to object
        aMouseParm = aEnv.fromkeys(aEnv['MOUSEPARM'])
        for aKey in aMouseParm.iterkeys():
            aMouseParm[aKey] = aEnv[aKey]
        aMouseCoord = self.xCompute.transformMouseCoord(aMouseParm)
        if list(aEnv['L2OSTATE']).count(0) != 5:
            aEnv.update(self.xLink2Obj.execute(aEnv))
        if aEnv['VALIDL2O']:
            aMouseCoord.update(aEnv['L2OCOORD'])
        aEnv['COORDS'][-1][-1].update(aMouseCoord)
        aEnv['GROUPSHAPE'] = aEnv['CONTROLLER'].getCurrentPage()
        return aEnv
