#	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## ucsmousehandler dimanche 28 juin 2009, 16:02:13 (UTC+0200)

## Copyright (C) 2008-2009 G�rard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import math
except ImportError:
    print "probleme d'import"
# ===================================================
# Gerer les saisies de points et validation d'entites
# Handle points inputs and entities validation
# ===================================================
class UcsMouseHandler():
    """Gere les saisies de points et validation d'entite
    Handles points inputs and entities validation"""
    def __init__(self, ctx):
        from fr.free.deneux.gerard.cadooo.entityposize import EntityPosSize
        from fr.free.deneux.gerard.cadooo.compute import Compute
        self.ctx = ctx
        self.xEntityPosSize = EntityPosSize(self.ctx)
        self.xCompute = Compute(self.ctx)
    # **********************************
    # Handles mouse clicks
    # MOUSEEVENT  struct MouseEvent
    # VALIDL2O    integer (0 or 1)
    # L2OCOORD    tuple of 2 integers
    # CANCELJOB   integer (0 or 1)
    # STEP
    # COORDS%s
    # REPEATMODE
    # SHAPE
    # **********************************
    def execute(self, aArgs):
        aEnv = {}
        aEnv.update(aArgs)
        # ----------------------------------------
        if aEnv['MOUSEEVENT'].Buttons > 1: # don't handle mouse buttons but left
            return aEnv
        if aEnv['COORDS'] is None:
            aEnv['COORDS'] = [[{'X': 0, 'Y': 0}]]
        # ------------------------------------
        if aEnv['MOUSEEVENT'].ClickCount == 1: # one click ?
            aMouseParm = aEnv.fromkeys(aEnv['MOUSEPARM'])
            for aKey in aMouseParm.iterkeys():
                aMouseParm[aKey] = aEnv[aKey]
            aMouseCoord = self.xCompute.transformMouseCoord(aMouseParm)
            # ------------------
            if aEnv['VALIDL2O']: # valid link to entity ?
                aMouseCoord.update(aEnv['L2OCOORD'])
            aEnv['COORDS'][-1][-1].update(aMouseCoord)
            # -------------------
            if aEnv['STEP'] == 0:
                aEnv['COORDS'][-1].append({'X': 0, 'Y': 0})
            # ---------------------
            elif aEnv['STEP'] == 1:
                aEnv['COORDS'].append([{'X': 0, 'Y': 0}, {'X': 0, 'Y': 0}])
                aEnv['COORDS'][1][0].update(aEnv['COORDS'][0][0])
            aEnv['ORIGINCOORD'].update(aMouseCoord)
            aEnv['VALIDORIGIN'] = True
            aPosSizeParm = aEnv.fromkeys(aEnv['POSSIZEPARM'])
            for aKey in aPosSizeParm.iterkeys():
                aPosSizeParm[aKey] = aEnv[aKey]
            aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
            aEnv['STEP'] = aEnv['STEP'] % aEnv['STEPS'] + 1
            # -----------------------------------------------
            if aEnv['STEP'] == aEnv['STEPS']: # is it the last point ?
                fAngleX = self.xCompute.toPolarCoord( aEnv['COORDS'][0][0], aEnv['COORDS'][0][1])[1]
                fAngleY = self.xCompute.toPolarCoord( aEnv['COORDS'][1][0], aEnv['COORDS'][1][1])[1]
                aEnv['UCS'] = ((math.cos(fAngleX), math.cos(fAngleY), aEnv['COORDS'][0][0]['X']), (math.sin(-fAngleX), math.sin(-fAngleY), aEnv['COORDS'][0][0]['Y']), (0.0, 0.0, 1.0))
                aEnv['GROUPSHAPE'].remove(aEnv['SHAPE'])
                aEnv['SHAPE'] = aEnv['UCSSHAPE']
                aEnv['STEP'] = 2
                aPosSizeParm = aEnv.fromkeys(aEnv['POSSIZEPARM'])
                for aKey in aPosSizeParm.iterkeys():
                    aPosSizeParm[aKey] = aEnv[aKey]
                aEnv.update(self.xEntityPosSize.execute(aPosSizeParm))
                aEnv['SHAPE'].setName("ucs")
                aEnv['SHAPE'].Style = aEnv['STANDARDSTYLE']
                aEnv['SHAPE'].LineColor = aEnv['STANDARDSTYLE'].LineColor
                aEnv['SHAPE'].LineWidth = aEnv['STANDARDSTYLE'].LineWidth
                aEnv['STOPJOB'] = True
        return aEnv
