# 	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## stairsjob dim nov  7 16:52:58 CET 2004
## new release dimanche 27 avril 2008, 10:24:21 (UTC+0200)

## Copyright (C) 2004-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************

try:
    import uno, unohelper
except ImportError:
    print "import impossible de uno et unohelper"

try:
    from com.sun.star.task import XJobExecutor
except ImportError:
    print "import impossible de XJobExecutor"

try:
    import traceback
except ImportError:
    print "import impossible de traceback"

##
## class that do the job
##
class StairsJob(unohelper.Base, XJobExecutor):
    """Trac d'escalier balanc
    balanced stairway drawing"""
    def __init__(self, ctx):
	self.ctx = ctx
    ##
    ## this function is called from within the menu or toolbox button in OpenOffice
    ## fonction appelee par le menu ou le bouton de la barre d'outils dans OpenOffice
    ##
    def trigger(self, args):
        import fr.free.deneux.gerard.cadooo.msgl10n
        import fr.free.deneux.gerard.cadooo.stairsdraw
        import fr.free.deneux.gerard.cadooo.stairskeyhandler
        import fr.free.deneux.gerard.cadooo.stairsmousehandler
        import fr.free.deneux.gerard.cadooo.cadooojob
        aEnv = {}
        aEnv['UNOTYPE'] = "LineShape"
        aEnv['ENTITYPE'] = "STAIRWAY"
        aEnv['STEPS'] = 5
        aEnv['MODE'] = ('STAIRWAY', 'CONTOUR', 'DATAINPUT', 'STEP1', 'DRAWING')
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n( self.ctx)
        aEnv['COMMENT'] = xMsgL10n.getText(["s%d" % i for i in (7,8,9,10,11)])
        aEnv['STAGE'] = 0
        try:
            aEnv['DRAWJOB'] = fr.free.deneux.gerard.cadooo.stairsdraw.StairsDraw(self.ctx)
            aEnv['KEYHANDLER'] = fr.free.deneux.gerard.cadooo.stairskeyhandler.StairsKeyHandler(self.ctx)
            aEnv['MOUSEHANDLER'] = fr.free.deneux.gerard.cadooo.stairsmousehandler.StairsMouseHandler(self.ctx)
            aEnv['EXTPOSSIZE'] = None
            xCadoooJob = fr.free.deneux.gerard.cadooo.cadooojob.CadoooJob( self.ctx)
            aEnv.update(xCadoooJob.runCadooo(aEnv))
        except:
            traceback.print_exc()
# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(StairsJob,                                 # UNO object class
                                         "fr.free.deneux.gerard.cadooo.Stairs", # implemenation name
                                         ("fr.free.cadooo.Stairs",),)    # list of implemented services
