#
# -*- coding: latin-1 -*-
## ********************************************************************************
## trimjob mar jan 11 20:05:11 CET 2005
## Copyright (C) 2005-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper
    from com.sun.star.task import XJobExecutor
    import traceback
except ImportError:
    print "probleme d'import"
#======================================================
# a class to trim graphical entities
# une classe pour prolonger une entite graphique
#======================================================
class TrimJob(unohelper.Base, XJobExecutor):
    """Prolonge une entite graphique
    Trims a graphical entity"""
    def __init__(self, ctx):
        self.ctx = ctx
    #=======================
    # Called by the GUI
    #=======================
    def trigger(self, args):
        import fr.free.deneux.gerard.cadooo.cadooojob
        import fr.free.deneux.gerard.cadooo.msgl10n
        import fr.free.deneux.gerard.cadooo.trimdraw
        import fr.free.deneux.gerard.cadooo.trimkeyhandler
        import fr.free.deneux.gerard.cadooo.trimmousehandler
        xCadoooJob = fr.free.deneux.gerard.cadooo.cadooojob.CadoooJob(self.ctx)
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n(self.ctx)
        aEnv = {}
        aEnv['EDITMODE'] = True
        aEnv['ENTITYPE'] = None
        aEnv['MODE'] = ('TRIM',)
        sTextList = ("t0",)
        aEnv['COMMENT'] = xMsgL10n.getText(sTextList)
        aEnv['CIRCLEKIND'] = uno.Enum("com.sun.star.drawing.CircleKind", "FULL")
        aEnv['DRAWJOB'] = fr.free.deneux.gerard.cadooo.trimdraw.TrimDraw(self.ctx)
        aEnv['KEYHANDLER'] = fr.free.deneux.gerard.cadooo.trimkeyhandler.TrimKeyHandler(self.ctx)
        aEnv['MOUSEHANDLER'] = fr.free.deneux.gerard.cadooo.trimmousehandler.TrimMouseHandler(self.ctx)
        aEnv['EXTPOSSIZE'] = None
        aEnv.update(xCadoooJob.runCadooo(aEnv))
# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(TrimJob,                                 # UNO object class
                                         "fr.free.deneux.gerard.cadooo.Trim", # implemenation name
                                         ("fr.free.cadooo.Trim",),)    # list of implemented services
