# 	$Id$	
# -*- coding: latin-1 -*-
## ********************************************************************************
## ucsjob jeudi 20 mars 2008, 17:46:00 (UTC+0100)

## Copyright (C) 2008-2009 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper
    import traceback
    from com.sun.star.task import XJobExecutor
except ImportError:
    print "probleme d'import"
#======================================================
# a class to manage UCS
# une classe pour grer un SCU 
#======================================================
class UcsJob(unohelper.Base, XJobExecutor):
    """Gre un SCU
    mange a UCS"""
    def __init__(self, ctx):
        self.ctx = ctx
    #=======================
    # Called by the GUI
    #=======================
    def trigger(self, args):
        import fr.free.deneux.gerard.cadooo.cadooojob
        import fr.free.deneux.gerard.cadooo.msgl10n
        import fr.free.deneux.gerard.cadooo.ucsdraw
        import fr.free.deneux.gerard.cadooo.ucskeyhandler
        import fr.free.deneux.gerard.cadooo.ucsmousehandler
        xCadoooJob = fr.free.deneux.gerard.cadooo.cadooojob.CadoooJob(self.ctx)
        xMsgL10n = fr.free.deneux.gerard.cadooo.msgl10n.MsgL10n(self.ctx)
        aEnv = {}
        aEnv['UNOTYPE'] = "PolyLineShape"
        aEnv['ENTITYPE'] = "UCS"
        aEnv['STEPS'] = 3
        aEnv['MODE'] = ('UCS', 'XAXIS', 'YAXIS')
        sTextList = ("ucs0", "ucs1", "ucs2", "ucs3")
        aEnv['COMMENT'] = xMsgL10n.getText(sTextList)
        try:
            aEnv['DRAWJOB'] = fr.free.deneux.gerard.cadooo.ucsdraw.UcsDraw(self.ctx)
            aEnv['KEYHANDLER'] = fr.free.deneux.gerard.cadooo.ucskeyhandler.UcsKeyHandler(self.ctx)
            aEnv['MOUSEHANDLER'] = fr.free.deneux.gerard.cadooo.ucsmousehandler.UcsMouseHandler(self.ctx)
            aEnv['EXTPOSSIZE'] = None
            aEnv.update(xCadoooJob.runCadooo(aEnv))
        except:
            traceback.print_exc()
# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(UcsJob,                                 # UNO object class
                                         "fr.free.deneux.gerard.cadooo.Ucs", # implemenation name
                                         ("fr.free.cadooo.Ucs",),)    # list of implemented services
